MODULE squash1;
(*
Erst die Systemmodule:
*)
FROM ChanConsts IMPORT
  OpenResults, old, raw, read, write;
FROM ConvTypes IMPORT
  ConvResults;
FROM IOChan IMPORT
  ChanId, Flush, RawRead, RawWrite, Reset;
FROM IOResult IMPORT
  ReadResult, ReadResults;
FROM ProgramArgs IMPORT
  ArgChan, IsArgPresent, NextArg;
FROM RealMath IMPORT
  sqrt;
FROM StdChans IMPORT
  StdErrChan, StdInChan, StdOutChan;
FROM Storage IMPORT
  ALLOCATE, DEALLOCATE;
FROM SysClock IMPORT
  DateTime;
FROM SYSTEM IMPORT
  ADR, ADDRESS;
FROM TextIO IMPORT
  ReadChar, ReadString, ReadToken, SkipLine, WriteChar, WriteLn, WriteString;
FROM Strings IMPORT
  Append, Assign, Compare, CompareResults, Delete, Extract, FindNext,
  Length, String1;
FROM WholeIO IMPORT
  ReadInt, WriteCard, WriteInt;
FROM WholeStr IMPORT
  CardToStr, IntToStr, StrToInt;
IMPORT SeqFile;
IMPORT StreamFile;
IMPORT STextIO;

(*
Dann was eigenes:
*)
FROM Ctv2 IMPORT
  kurzlen, mittellen, langlen,
  String_kurz, String_mittel, String_lang,
  DirEntRecPtrTyp, Handler, String, StrPtrTyp, TmRecTyp, TmRecPtrTyp;
IMPORT Unix;


CONST
  version=                      'Programmversion: GM2 05.12.2023';
  sea_version_akt=              1010;   (* Version des season-Files *)
  ueberschrift=                 'Spielbelegungsplan';
  unendlich=                    10000;
  script_nam_prog1=             'squash1';
  tabellen_anz=                 7;
  bkp_prefix=                   'bkp_';
  log_prefix=                   'log_';
  http_host_c=                  'HTTP_HOST';            (* c fr CONST *)
  server_name_c=                'SERVER_NAME';          (* c fr CONST *)
  server_software_c=            'SERVER_SOFTWARE';      (* c fr CONST *)
  content_length_c=             'CONTENT_LENGTH';       (* c fr CONST *)
  remote_addr_c=                'REMOTE_ADDR';          (* c fr CONST *)
  request_method_c=             'REQUEST_METHOD';       (* c fr CONST *)
  query_string_c=               'QUERY_STRING';         (* c fr CONST *)
  squash_base_c=                'SQUASH_BASE';          (* c fr CONST *)
  max_chat_size=                400000;
  max_log_sea_file_anz=         17;
  max_log_htm_file_anz=         500;
  log_file_sfx_len=             4;      (* Achtung: die zwei Werte sollten *)
  log_file_sfx_max=             9999;   (* aufeinander abgestimmt sein! *)
  max_zeil_anz=                 20;
  min_zeil_anz=                 1;
  max_spalt_anz=                12;
  min_spalt_anz=                1;
  max_spieler_anz=              50;
  min_spieler_anz=              2; 
  i_frei=                       0;      (* 'Spezialspieler' *)
  i_abbestellt=                 1;
  i_auswahl=                    2;
  i_chef=                       3;
  i_chefin=                     4;
  i_ein_besucher=               5;
  ssa=                          14;     (* special_spieler_anz *)
                                        (*
                                        Das mit ssa ist schon etwas ver-
                                        zwickt. Beim Lesen bzw. Schreiben
                                        von der/zur Datenbasis werden alle
                                        spieler_anz+ssa Eintrge bearbeitet.
                                        Im 'input' werden aber nur spieler_anz
                                        Eintrge verwendet. Also aufpassen!
                                        *)
  sp_art_keiner=                0;      (* Spielerarten *)
  sp_art_14t=                   1;
  sp_art_woe=                   2;
  sp_aktiv_nein=                0;
  sp_aktiv_ja=                  1;
  min_season_start_jahr=        1971;
  max_season_start_jahr=        2105;
  min_season_start_woche=       1;
  max_season_start_woche=       53;
  max_jahr_wochen_zugriff=      8;
  max_wochen_anz=               52;
  min_wochen_anz=               1;
  jahr_wochen_zugriff_default=  2;
  max_radio=                    2;
  max_check=                    1;
  max_bitleiste=                7;      (* momentan werden bits 0, 1 und 2 bedient *)
  max_basic_param_anz=          28;
  ii00=                         0;      (* input index *)
  ii01=                         1;
  ii02=                         2;
  ii03=                         3;
  ii04=                         4;
  ii05=                         5;
  ii06=                         6;
  ii07=                         7;
  ii08=                         8;
  ii09=                         9;
  ii10=                         10;
  ii11=                         11;
  ii12=                         12;
  ii13=                         13;
  ii14=                         14;
  ii15=                         15;
  ii16=                         16;
  ii17=                         17;
  ii18=                         18;
  ii19=                         19;
  ii20=                         20;
  ii21=                         21;
  ii22=                         22;
  ii23=                         23;
  ii24=                         24;
  ii25=                         25;
  ii26=                         26;
  ii27=                         27;
  max_param_anz=                max_basic_param_anz     (* Basic Parameter *)
                                + max_zeil_anz          (* Wochentage *)
                                + max_zeil_anz          (* Spielpltze *)
                                + max_spalt_anz         (* Uhrzeiten *)
                                + max_zeil_anz*max_spalt_anz  (* unsere Courts *)
                                + max_spieler_anz       (* Spielernamen *)
                                + max_spieler_anz       (* wchtl. / 14-tg. *)
                                + max_spieler_anz       (* aktiv? *)
                                + max_spieler_anz       (* neues Kennwort *)
                                + max_spieler_anz       (* Kennwort eintragen? *)
                                + max_wochen_anz        (* wieviele Wochen vorher? *)
                                + max_spieler_anz       (* Spielerpersdata *)
                                + max_spieler_anz       (* Spielerrang *)
                                + max_spieler_anz;      (* wieviele Tage vorher? *)
  max_hv_anz=                   8;      (* max Anz. hidden values *)
  sea_state0=                   0;      (* Normalzustand *)
  sea_state1=                   1;      (* In default/reset_season_data an- *)
                                        (* gelegter Startwert fr sea_state *)
  sea_state2=                   2;      (* File ist bereit fr nderung *)
                                        (* von Basisdaten *)
  sea_state3=                   3;      (* File ist bereit fr nderung *)
                                        (* der 'Zeilenberschriften', *)
                                        (* der Spaltenberschriften *)
                                        (* und unserer Spielpltze *)
  sea_state4=                   4;      (* File ist bereit fr nderung *)
                                        (* von Spielernamen, -typ, *)
                                        (* -aktivitt, -kennw. usw. *)
  sea_state5=                   5;      (* File ist bereit fr nderung *)
                                        (* von jahr_wochen_zugriff *)
  sea_state6=                   6;      (* File ist bereit fr Beendigung *)
                                        (* des Wartungsmodus *)
  max_sea_state=                sea_state6;

  (*
  action codes:
  *)
  nullac=                       000;    (* 'Nullaktion' *)
  p0ac1=                        001;    (* Betriebssystem-Werbung *)
  p0ac2=                        002;    (* Webserver-Werbung *)
  p1ac0=                        100;
  p1ac1=                        101;
  p1ac2=                        102;
  p1ac3=                        103;
  p2ac1=                        201;
  p2ac2=                        202;
  p3ac1=                        301;
  p3ac2=                        302;
  p4ac1=                        401;    (* Wir bemerken: auf page04 gibt es *)
  p4ac2=                        402;    (* nur *einen* Accept-Button, der *)
  p4ac3=                        403;    (* aber je nach Kontext unterschied- *)
  p4ac4=                        404;    (* liche Aktionen auslsen soll *)
  p4ac5=                        405;    
  p4ac6=                        406;
  p4ac7=                        407;
  p4ac8=                        408;
  p4ac9=                        409;
  p4ac10=                       410;
  p4ac11=                       411;
  p6ac1=                        601;
  p6ac2=                        602;
  p7ac1=                        701;
  p7ac2=                        702;
  p8ac1=                        801;
  p8ac2=                        802;
  p8ac3=                        803;
  p8ac4=                        804;
  p8ac5=                        805;
  p8ac6=                        806;
  p8ac7=                        807;
  p8ac8=                        808;
  p8ac9=                        809;
  p8ac10=                       810;
  p8ac11=                       811;
  p9ac1=                        901;
  p9ac2=                        902;
  p12ac1=                       1201;
  p13ac1=                       1301;
  p13ac2=                       1302;
  p14ac1=                       1401;
  p14ac2=                       1402;
  p15ac1=                       1501;
  p15ac2=                       1502;
  p16ac1=                       1601;
  p16ac2=                       1602;
  p17ac1=                       1701;
  p17ac2=                       1702;
  p19ac1=                       1901;
  p19ac2=                       1902;
  p20ac1=                       2001;
  p20ac2=                       2002;
  p21ac1=                       2101;
  p21ac2=                       2102;
  p22ac1=                       2201;
  p22ac2=                       2202;
  p23ac1=                       2301;
  p23ac2=                       2302;
  p24ac1=                       2401;
  p25ac1=                       2501;
  p25ac2=                       2502;
  p26ac1=                       2601;
  p26ac2=                       2602;
  p27ac1=                       2701;
  p27ac2=                       2702;
  p28ac1=                       2801;
  p28ac2=                       2802;
  p30ac1=                       3001;
  miwi=                         6;      (* min width bei Ausgaben *)
  dunkelgelb=                   '#F0F040';
  dunkelgruen=                  '#40F040';
  dunkelrot=                    '#F04040';
  grau=                         '#C0C0C0';
  hellblau=                     '#C0C0F0';
  hellgelb=                     '#F0F0C0';
  hellgrau=                     '#D8D8D8';
  hellgruen=                    '#C0F0C0';
  hellrot=                      '#F0C0C0';
  pink=                         '#F080F0';
  weiss=                        '#F0F0F0';
  wochentage_anz=               7;
  zehnmin_anz=                  144;
  s_pro_zehnmin=                600;
  s_pro_stunde=                 6*s_pro_zehnmin;
  s_pro_tag=                    24*s_pro_stunde;
  (*
  kurzlen=                      24;
  mittellen=                    180;
  langlen=                      2001;
  *)

TYPE
  (*
  String_kurz=                  ARRAY[0..kurzlen-1] OF CHAR;
  String_mittel=                ARRAY[0..mittellen-1] OF CHAR;
  String_lang=                  ARRAY[0..langlen-1] OF CHAR;
  *)
  str_arr_tab_typ=              ARRAY[1..tabellen_anz] OF String_kurz;
  str_arr_spieler_typ=          ARRAY[0..max_spieler_anz+ssa-1] OF String;
  int_arr_spieler_typ=          ARRAY[0..max_spieler_anz+ssa-1] OF INTEGER;
  rang_feld_typ=                ARRAY[0..max_spieler_anz-1] OF INTEGER;
  forderung_typ=                ARRAY[0..(max_zeil_anz*max_spalt_anz)-1] OF INTEGER;
  court_belegung_typ=           ARRAY[0..(2*max_zeil_anz*max_spalt_anz)-1] OF INTEGER;
  court_belegung_str_typ=       ARRAY[0..(2*max_zeil_anz*max_spalt_anz)-1] OF String_kurz;
  jahr_wochen_zugriff_typ=      ARRAY[0..max_wochen_anz-1] OF INTEGER;
  jahr_forderung_typ=           ARRAY[0..max_wochen_anz-1] OF forderung_typ;
  jahr_court_belegung_typ=      ARRAY[0..max_wochen_anz-1] OF court_belegung_typ;
  jahr_court_belegung_str_typ=  ARRAY[0..max_wochen_anz-1] OF court_belegung_str_typ;
  uns_court_typ=                ARRAY[0..(2*max_zeil_anz*max_spalt_anz)-1] OF INTEGER;
  geschrumpfter_index_typ=      ARRAY[0..(2*max_zeil_anz*max_spalt_anz)-1] OF INTEGER;
  int_arr_zeil_typ=             ARRAY[0..max_zeil_anz-1] OF INTEGER;
  str_arr_zeil_typ=             ARRAY[0..max_zeil_anz-1] OF String;
  int_arr_spalt_typ=            ARRAY[0..max_spalt_anz-1] OF INTEGER;
  sel_rec_typ_ptr_typ=          POINTER TO sel_rec_typ;
  sel_rec_typ=                  RECORD
                                  schnur:               String_mittel;
                                  zahl:                 INTEGER;
                                  sel_rec_typ_ptr:      sel_rec_typ_ptr_typ;
                                END;            (* sel_rec_typ *)
  str_rec_typ_ptr_typ=          POINTER TO str_rec_typ;
  str_rec_typ=                  RECORD
                                  value_strr:           String_mittel;
                                  str_rec_typ_ptr:      str_rec_typ_ptr_typ;
                                END;            (* str_rec_typ *)
  input_rec_typ=                RECORD
                                  name_strr:            String_kurz;
                                  str_rec_typ_ptr:      str_rec_typ_ptr_typ;
                                  (* r fr RECORD *)
                                  ob_integ:             INTEGER;
                                  (* 1: INTEGER *)
                                  value:                INTEGER;
                                  min:                  INTEGER;
                                  max:                  INTEGER;
                                END;            (* input_rec_typ *)
  input_arr_typ=                ARRAY[0..max_param_anz-1] OF input_rec_typ;
  hid_val_rec_typ=              RECORD
                                  anz:                    INTEGER;
                                  nam:                    ARRAY[0..max_hv_anz-1] OF String;
                                  val:                    ARRAY[0..max_hv_anz-1] OF String_lang;
                                END;            (* hid_val_rec_typ *)
  sd_rec_typ=                   RECORD                  (* season data *)
                                  sea_version:          INTEGER;
                                  site_counter:         INTEGER;
                                  chat_counter:         INTEGER;
                                  sea_state:            INTEGER;
                                  zeil_anz:             INTEGER;
                                  spalt_anz:            INTEGER;
                                  spieler_anz:          INTEGER;
                                  season_start:         INTEGER;
                                  wochen_anz:           INTEGER;
                                  show_future_kw:       INTEGER;
                                  bitleiste:            INTEGER;
                                  (* bit0=0:            strenge Eintragungsprfung *)
                                  (* bit0=1:            lasche Eintragungsprfung *)
                                  (* bit1=0:            kein Debuggingoutput *)
                                  (* bit1=1:            Debuggingoutput *)
                                  (* bit2=0:            keine semilasche Eintragungsprfung *)
                                  (* bit2=1:            semilasche Eintragungsprfung *)
                                  zusatz_heading:       String;
                                  uns_courts_anz:       INTEGER;
                                  uns_court:            uns_court_typ;
                                  geschrumpfter_index:  geschrumpfter_index_typ;
                                  wochentag:            int_arr_zeil_typ;
                                  court:                str_arr_zeil_typ;
                                  uhrzeit:              int_arr_spalt_typ;
                                  spieler_name:         str_arr_spieler_typ;
                                  spieler_pers_data:    str_arr_spieler_typ;
                                  spieler_kennwort:     str_arr_spieler_typ;
                                  spieler_art:          int_arr_spieler_typ;
                                  (*
                                  sp_art_keiner (0):    kein Spieler
                                  sp_art_14t (1):       14-tgig
                                  sp_art_woe (2):       wchentlich
                                  *)
                                  spieler_aktiv:        int_arr_spieler_typ;
                                  (*
                                  sp_aktiv_nein (0):    nicht aktiv
                                  sp_aktiv_ja (1):      aktiv
                                  *)
                                  spieler_rang:         int_arr_spieler_typ;
                                  (*
                                  0: erscheint nicht in Rangliste
                                  1..sd1.spieler_anz: mglicher Rang
                                  *)
                                  max_day_delta:        int_arr_spieler_typ;
                                  (*
                                  gibt an, wieviele Tage vorher frhestens
                                  eine Eintragung mglich ist: 0: keine Beschrnkung,
                                  1: bis max. 24 h, 2: bis max. 48 h usw.
                                  *)
                                  spieler_remote_addr:  str_arr_spieler_typ;
                                  jahr_wochen_zugriff:  jahr_wochen_zugriff_typ;
                                  jahr_forderung:       jahr_forderung_typ;
                                  jahr_court_belegung:  jahr_court_belegung_typ;
                                  jahr_court_belegung_gast:  jahr_court_belegung_typ;
                                  (* 0: Spieler selbst, 1: priv. Gast, 2: offiz. Gast *)
                                  jahr_court_belegung_gast_nam:  jahr_court_belegung_str_typ;
                                END;            (* sd_rec_typ *)
  wd_typ=                       ARRAY[0..wochentage_anz] OF String_kurz;
  st_typ=                       ARRAY[0..zehnmin_anz] OF String_kurz;
  vor_typ=                      ARRAY[0..max_jahr_wochen_zugriff] OF String_kurz;
  timstr_rec_typ=               RECORD
                                  jahr_str:             String;
                                  monat_str:            String;
                                  tag_str:              String;
                                  stunde_str:           String;
                                  minute_str:           String;
                                  sekunde_str:          String;
                                END;            (* timstr_rec_typ *)
  hex_typ=                      ARRAY[0..15] OF CHAR;
  email_info_typ=               RECORD
                                  ob_emails_senden:     BOOLEAN;
                                  ob_chefs_walten:      BOOLEAN;
                                  court_index:          INTEGER;
                                  client_ukw:           INTEGER;
                                  belegung_client:      INTEGER;
                                  belegung_client_gast: INTEGER;
                                  belegung_client_gast_nam:     String_kurz;
                                  text:                 String_kurz;
                                END;            (* email_info_typ *)

CONST
  (*
  Hinweis: kann sein, da die Werte fr die chef_kennw_arr_c's und
  chefin_kennw_arr_c's alle ziemlich gleich langweilig aussehen.
  Dies ist jetzt nur solange der Fall, wie wir kein Kennwortfile
  haben und die Programmquellen aber trotzdem dem interessierten
  Leser zeigen wollen. Soll ja nicht durch einen Kraftangriff
  einfach unseren crypt aushebeln knnen, bld, oder?
  Sollten aber schne, echte Werte dastehen, haben wir das Lschen
  einfach vergessen und der Hacker darf sich freuen...
  *)
  chef_kennw_arr_c=             str_arr_tab_typ{        (* c fr CONST *)
    '00ae8bRf9p2QE', '00l8s9i0XnsYw', '00lcw/uu9CnMs', '0029XwBPRUUQo',
    '00Rey0xuoNmpE', '00xkMOrdZvnFM', '00nRCQI1MGuZU'
                                };
  
  chefin_kennw_arr_c=           str_arr_tab_typ{        (* c fr CONST *)
    '00lgGHLtVaDNU', '009Jx0xPaWM3o', '005g6flI232ag', '00lvPFur61vDg',
    '007FGcSbCuxSo', '00rudQnT.tWhM', '00yQfAlTU0x56'
                                };

  week_str=                     wd_typ{
    'Montag', 'Dienstag', 'Mittwoch', 'Donnerstag',
    'Freitag', 'Samstag', 'Sonntag', 'kein Tag'
                                };

  hour_str=                     st_typ{
    '00.00-01.00 Uhr', '00.10-01.10 Uhr', '00.20-01.20 Uhr', '00.30-01.30 Uhr', '00.40-01.40 Uhr', '00.50-01.50 Uhr',
    '01.00-02.00 Uhr', '01.10-02.10 Uhr', '01.20-02.20 Uhr', '01.30-02.30 Uhr', '01.40-02.40 Uhr', '01.50-02.50 Uhr',
    '02.00-03.00 Uhr', '02.10-03.10 Uhr', '02.20-03.20 Uhr', '02.30-03.30 Uhr', '02.40-03.40 Uhr', '02.50-03.50 Uhr',
    '03.00-04.00 Uhr', '03.10-04.10 Uhr', '03.20-04.20 Uhr', '03.30-04.30 Uhr', '03.40-04.40 Uhr', '03.50-04.50 Uhr',
    '04.00-05.00 Uhr', '04.10-05.10 Uhr', '04.20-05.20 Uhr', '04.30-05.30 Uhr', '04.40-05.40 Uhr', '04.50-05.50 Uhr',
    '05.00-06.00 Uhr', '05.10-06.10 Uhr', '05.20-06.20 Uhr', '05.30-06.30 Uhr', '05.40-06.40 Uhr', '05.50-06.50 Uhr',
    '06.00-07.00 Uhr', '06.10-07.10 Uhr', '06.20-07.20 Uhr', '06.30-07.30 Uhr', '06.40-07.40 Uhr', '06.50-07.50 Uhr',
    '07.00-08.00 Uhr', '07.10-08.10 Uhr', '07.20-08.20 Uhr', '07.30-08.30 Uhr', '07.40-08.40 Uhr', '07.50-08.50 Uhr',
    '08.00-09.00 Uhr', '08.10-09.10 Uhr', '08.20-09.20 Uhr', '08.30-09.30 Uhr', '08.40-09.40 Uhr', '08.50-09.50 Uhr',
    '09.00-10.00 Uhr', '09.10-10.10 Uhr', '09.20-10.20 Uhr', '09.30-10.30 Uhr', '09.40-10.40 Uhr', '09.50-10.50 Uhr',
    '10.00-11.00 Uhr', '10.10-11.10 Uhr', '10.20-11.20 Uhr', '10.30-11.30 Uhr', '10.40-11.40 Uhr', '10.50-11.50 Uhr',
    '11.00-12.00 Uhr', '11.10-12.10 Uhr', '11.20-12.20 Uhr', '11.30-12.30 Uhr', '11.40-12.40 Uhr', '11.50-12.50 Uhr',
    '12.00-13.00 Uhr', '12.10-13.10 Uhr', '12.20-13.20 Uhr', '12.30-13.30 Uhr', '12.40-13.40 Uhr', '12.50-13.50 Uhr',
    '13.00-14.00 Uhr', '13.10-14.10 Uhr', '13.20-14.20 Uhr', '13.30-14.30 Uhr', '13.40-14.40 Uhr', '13.50-14.50 Uhr',
    '14.00-15.00 Uhr', '14.10-15.10 Uhr', '14.20-15.20 Uhr', '14.30-15.30 Uhr', '14.40-15.40 Uhr', '14.50-15.50 Uhr',
    '15.00-16.00 Uhr', '15.10-16.10 Uhr', '15.20-16.20 Uhr', '15.30-16.30 Uhr', '15.40-16.40 Uhr', '15.50-16.50 Uhr',
    '16.00-17.00 Uhr', '16.10-17.10 Uhr', '16.20-17.20 Uhr', '16.30-17.30 Uhr', '16.40-17.40 Uhr', '16.50-17.50 Uhr',
    '17.00-18.00 Uhr', '17.10-18.10 Uhr', '17.20-18.20 Uhr', '17.30-18.30 Uhr', '17.40-18.40 Uhr', '17.50-18.50 Uhr',
    '18.00-19.00 Uhr', '18.10-19.10 Uhr', '18.20-19.20 Uhr', '18.30-19.30 Uhr', '18.40-19.40 Uhr', '18.50-19.50 Uhr',
    '19.00-20.00 Uhr', '19.10-20.10 Uhr', '19.20-20.20 Uhr', '19.30-20.30 Uhr', '19.40-20.40 Uhr', '19.50-20.50 Uhr',
    '20.00-21.00 Uhr', '20.10-21.10 Uhr', '20.20-21.20 Uhr', '20.30-21.30 Uhr', '20.40-21.40 Uhr', '20.50-21.50 Uhr',
    '21.00-22.00 Uhr', '21.10-22.10 Uhr', '21.20-22.20 Uhr', '21.30-22.30 Uhr', '21.40-22.40 Uhr', '21.50-22.50 Uhr',
    '22.00-23.00 Uhr', '22.10-23.10 Uhr', '22.20-23.20 Uhr', '22.30-23.30 Uhr', '22.40-23.40 Uhr', '22.50-23.50 Uhr',
    '23.00-24.00 Uhr', '23.10-00.10 Uhr', '23.20-00.20 Uhr', '23.30-00.30 Uhr', '23.40-00.40 Uhr', '23.50-00.50 Uhr',
    'keine Zeit'
                                };

  vor_str=                      vor_typ{
    '0', '1', '2', '3', '4', '5', '6', '7', '8'
                                };

  hex_str=                      hex_typ{
    '0', '1', '2', '3', '4', '5', '6', '7',
    '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'
                                };

VAR
  server_name_index:            INTEGER;        (* 0: 'default' (z.B. www.muc.de/colin2.muc.de)
                                                   1: dose.muc.de
                                                   2: 190.64.6.48
                                                   3: www.rudolf-schubert.dyndns.org
                                                   4: localhost *)
  server_software_index:        INTEGER;        (* 0: Apache, 1: Roxen *)
  mailto_user:                  String_mittel;
  mailto_rechner:               String_mittel;
  server_name:                  String_mittel;
  server_software:              String_mittel;
  http_host:                    String_mittel;
  script_nam_prog_appendix_arr: str_arr_tab_typ;
  chef_kennw_arr:               str_arr_tab_typ;
  chefin_kennw_arr:             str_arr_tab_typ;
  tabellen_nummer:              INTEGER;
  script_nam_prog_appendix:     String_kurz;
  script_nam:                   String_mittel;
  script_path:                  String_mittel;
  squash_base_default:          String_mittel;
  cid_in, cid_out, cid_err:     ChanId;
  cid_log:                      ChanId;
  mail_gewuenscht:              BOOLEAN;
  slog_gewuenscht:              BOOLEAN;        (* season log *)
  hlog_gewuenscht:              BOOLEAN;        (* html log *)
  hlog_ist_offen:               BOOLEAN;
  squash_base_v:                String;
  request_method:               String;
  request_ist_post:             BOOLEAN;
  query_string:                 String;
  content_length:               String;
  content_length_int:           INTEGER;
  remote_addr:                  String;
  season_name:                  String;
  lock_name:                    String;
  chat_name:                    String;
  chat_name_new:                String;
  chat_name_tmp:                String;
  bkp_pfad:                     String;
  log_pfad_s:                   String;         (* s fr 'season' *)
  log_pfad_h:                   String;         (* h fr 'html' *)
  lock_angelegt:                BOOLEAN;
  sd1:                          sd_rec_typ;     (* season data 1 *)
  chef_kennwort_default:        String_mittel;
  chefin_kennwort_default:      String_mittel;
  zeitagm:                      CARDINAL;       (* Zeit aktuell Gm *)
  zeitalc:                      CARDINAL;       (* Zeit aktuell local *)
  zeiturllc:                    CARDINAL;       (* Zeit 'update rangliste' local *)
  akt_luwn:                     CARDINAL;
  ukwa_str:                     String;
  akt_season_start_jahr:        INTEGER;
  akt_season_start_woche:       INTEGER;
  char_cnt:                     INTEGER;
  input:                        input_arr_typ;
  vor_9_montag:                 BOOLEAN;
  vor_9_donnerstag:             BOOLEAN;
  hvr:                          hid_val_rec_typ;
  (* die user_times dienen Diagnosezwecken *)
  user_time1:                   CARDINAL;
  user_time2:                   CARDINAL;
  user_time3:                   CARDINAL;
  email_info:                   email_info_typ;


PROCEDURE abbruch(text1, text2: ARRAY OF CHAR);
  BEGIN                         (* PROCEDURE abbruch *)
    (*
    Frher (als wir noch nicht mit Atexit arbeiteten) wurde hier
    sofort try_delete_lock aufgerufen. Nachdem wir aber nun mit Atexit
    arbeiten, haben wir in Ausstieg den try_delete_lock eingebaut. Der
    HALT ruft nmlich dann Ausstieg auf.

    try_delete_lock;
    *)

    schreib_page_info(sd1, text1, text2, dunkelrot);
    HALT;
  END abbruch;


PROCEDURE CompareRS(schnur1, schnur2: ARRAY OF CHAR): CompareResults;
  VAR
    ergebnis:                   CompareResults;

  BEGIN                         (* PROCEDURE CompareRS *)
    ergebnis:=Compare(schnur1, schnur2);
    IF ergebnis=equal THEN
      IF Length(schnur1)<Length(schnur2) THEN
        ergebnis:=less;
      ELSE                      (* IF Length(schnur1)<Length(schnur2) *)
        IF Length(schnur1)>Length(schnur2) THEN
          ergebnis:=greater;
        END;                    (* IF Length(schnur1)>Length(schnur2)*)
      END;                      (* ELSE Length(schnur1)<Length(schnur2) *)
    END;                        (* IF ergebnis=equal *)
    RETURN ergebnis;
  END CompareRS;


PROCEDURE TimeToLcStructTime(time: CARDINAL; VAR structTime: DateTime);
  VAR
    TmRecPtr:                   TmRecPtrTyp;
    TmRec:                      TmRecTyp;

  BEGIN                         (* PROCEDURE TimeToLcStructTime *)
    TmRecPtr:=Unix.LocalTime(time);
    (*
    So, wir haben nun einen Pointer auf die Unix-strukturierte Zeit.
    Mal sehen, ob wir daraus die fr die MODULA-Struktur bentigten
    Informationen herausziehen knnen.
    *)

    WITH structTime DO
      WITH TmRecPtr^ DO
        year:=1900+tm_year;
        month:=1+tm_mon;
        day:=tm_mday;
        hour:=tm_hour;
        minute:=tm_min;
        second:=tm_sec;
        fractions:=0;
        zone:=0;
        summerTimeFlag:=FALSE;
      END;                      (* WITH TmRecPtr^ *)
    END;                        (* WITH structTime *)
  END TimeToLcStructTime;


PROCEDURE TimeToGmStructTime(time: CARDINAL; VAR structTime: DateTime);
  VAR
    TmRecPtr:                   TmRecPtrTyp;
    TmRec:                      TmRecTyp;

  BEGIN                         (* PROCEDURE TimeToGmStructTime *)
    (*
    WriteString(cid_out, 'TimeToGmStructTime, SIZE(TmRec): ');
    WriteCard(cid_out, SIZE(TmRec), 1);
    WriteLnCrLf(cid_out);
    *)

    TmRecPtr:=Unix.GmTime(time);
    (*
    So, wir haben nun einen Pointer auf die Unix-strukturierte Zeit.
    Mal sehen, ob wir daraus die fr die MODULA-Struktur bentigten
    Informationen herausziehen knnen.
    *)

    WITH structTime DO
      WITH TmRecPtr^ DO
        year:=1900+tm_year;      
        month:=1+tm_mon;
        day:=tm_mday;
        hour:=tm_hour;
        minute:=tm_min;
        second:=tm_sec;
        fractions:=0;
        zone:=0;
        summerTimeFlag:=FALSE;
      END;                      (* WITH TmRecPtr^ *)
    END;                        (* WITH structTime *)
  END TimeToGmStructTime;


PROCEDURE LJDN(VAR structTime: DateTime): CARDINAL;
  (*
  Local Julian Day Number

  Hier haben wir ein bichen gespickt bei den Calendar FAQ unter:
  http://www.pip.dknet.dk/~c-t/calendar.html
  *)
  VAR
    a, y, m:                    CARDINAL;
    jdn:                        CARDINAL;       (* julian day number *)

  BEGIN                         (* PROCEDURE LJDN *)
    WITH structTime DO
      a := (14 - month) DIV 12;
      y := year + 4800 - a;
      m := month + 12*a - 3;
      jdn := day + ((306*m+5) DIV 10) + y*365 + (y DIV 4) -
             (y DIV 100) + (y DIV 400) - 32045;
    END;                        (* WITH structTime *)
    RETURN jdn;
  END LJDN;


PROCEDURE IntToStrRS(wert: INTEGER; VAR schnur: ARRAY OF CHAR;
                     soll_breite: INTEGER);
  VAR
    zwstr:                      String;
    i:                          INTEGER;
    str_laenge:                 INTEGER;

  BEGIN                         (* PROCEDURE IntToStrRS *)
    IntToStr(wert, zwstr);
    str_laenge:=Length(zwstr);
    Assign('', schnur);
    FOR i:=1 TO soll_breite-str_laenge DO
      Append('0', schnur);
    END;                        (* FOR i *)
    Append(zwstr, schnur);
  END IntToStrRS;


PROCEDURE StructTimeToTimstrRec(VAR timstr_rec: timstr_rec_typ;
                                VAR structTime: DateTime);
  BEGIN                         (* PROCEDURE StructTimeToTimstrRec *)
    WITH timstr_rec DO
      WITH structTime DO
        IntToStrRS(year, jahr_str, 4);
        IntToStrRS(month, monat_str, 2);
        IntToStrRS(day, tag_str, 2);
        IntToStrRS(hour, stunde_str, 2);
        IntToStrRS(minute, minute_str, 2);
        IntToStrRS(second, sekunde_str, 2);
      END;                      (* WITH structTime *)
    END;                        (* WITH timstr_rec *)
  END StructTimeToTimstrRec;


PROCEDURE StructTimeToAsciiRS1(VAR strTime: ARRAY OF CHAR; VAR structTime: DateTime);
  VAR
    timstr_rec:                 timstr_rec_typ;

  BEGIN                         (* PROCEDURE StructTimeToAsciiRS1 *)
    StructTimeToTimstrRec(timstr_rec, structTime);
    WITH timstr_rec DO
      Assign(tag_str, strTime);
      Append('.', strTime);
      Append(monat_str, strTime);
      Append('.', strTime);
      Append(jahr_str, strTime);
      Append(', Zeit: ', strTime);
      Append(stunde_str, strTime);
      Append(':', strTime);
      Append(minute_str, strTime);
      Append(':', strTime);
      Append(sekunde_str, strTime);
    END;                        (* WITH timstr_rec *)
  END StructTimeToAsciiRS1;


PROCEDURE StructTimeToDatum(VAR strTime: ARRAY OF CHAR; VAR structTime: DateTime);
  VAR
    timstr_rec:                 timstr_rec_typ;

  BEGIN                         (* PROCEDURE StructTimeToDatum *)
    StructTimeToTimstrRec(timstr_rec, structTime);
    WITH timstr_rec DO
      Assign(jahr_str, strTime);
      Append(monat_str, strTime);
      Append(tag_str, strTime);
    END;                        (* WITH timstr_rec *)
  END StructTimeToDatum;


PROCEDURE StructTimeToUhrzeit(VAR strTime: ARRAY OF CHAR; VAR structTime: DateTime);
  VAR
    timstr_rec:                 timstr_rec_typ;

  BEGIN                         (* PROCEDURE StructTimeToUhrzeit *)
    StructTimeToTimstrRec(timstr_rec, structTime);
    WITH timstr_rec DO
      Assign(stunde_str, strTime);
      Append(minute_str, strTime);
      Append(sekunde_str, strTime);
    END;                        (* WITH timstr_rec *)
  END StructTimeToUhrzeit;


PROCEDURE StructTimeToAsciiRS2(VAR strTime: ARRAY OF CHAR; VAR structTime: DateTime);
  VAR
    zwstr:                      String;

  BEGIN                         (* PROCEDURE StructTimeToAsciiRS2 *)
    StructTimeToDatum(strTime, structTime);
    Append('_', strTime);
    StructTimeToUhrzeit(zwstr, structTime);
    Append(zwstr, strTime);
  END StructTimeToAsciiRS2;


PROCEDURE construct_datename(prefix: String; VAR name: String);
  VAR
    structTime:                 DateTime;
    strTime:                    String;

  BEGIN                         (* PROCEDURE construct_datename *)
    Assign(prefix, name);
    TimeToLcStructTime(zeitagm, structTime);
    StructTimeToDatum(strTime, structTime);
    Append(strTime, name);
  END construct_datename;


PROCEDURE construct_timename(prefix: String; VAR name: String);
  VAR
    structTime:                 DateTime;
    strTime:                    String;

  BEGIN                         (* PROCEDURE construct_timename *)
    Assign(prefix, name);
    TimeToLcStructTime(zeitagm, structTime);
    StructTimeToUhrzeit(strTime, structTime);
    Append(strTime, name);
  END construct_timename;


PROCEDURE construct_datetimename(prefix: String; VAR name: String);
  VAR
    structTime:                 DateTime;
    strTime:                    String;

  BEGIN                         (* PROCEDURE construct_datetimename *)
    Assign(prefix, name);
    TimeToLcStructTime(zeitagm, structTime);
    StructTimeToAsciiRS2(strTime, structTime);
    Append(strTime, name);
  END construct_datetimename;


PROCEDURE StructTimeToTime(VAR structTime: DateTime; VAR time: CARDINAL);
  CONST
    jdn_19700101=               2440588;

  VAR
    jdn:                        CARDINAL;       (* julian day number *)
    utcdiff_int:                INTEGER;
    utcdiff_card:               CARDINAL;

  BEGIN                         (* PROCEDURE StructTimeToTime *)
    jdn:=LJDN(structTime);
    WITH structTime DO
      time:=(jdn - jdn_19700101) * s_pro_tag + s_pro_stunde * hour +
            60 * minute + second;
      utcdiff_int:=60 * zone;
      IF utcdiff_int >= 0 THEN
        utcdiff_card:=utcdiff_int;
        time:=time + utcdiff_card;
      ELSE                      (* IF utcdiff_int >= 0 *)
        utcdiff_card:=-utcdiff_int;
        time:=time - utcdiff_card;
      END;                      (* ELSE utcdiff_int >= 0 *)
      IF summerTimeFlag THEN time:=time - s_pro_stunde END;
    END;                        (* WITH structTime *)
  END StructTimeToTime;


PROCEDURE LUWN(VAR structTime: DateTime): CARDINAL;
  (*
  Wir definieren eine lokale UNIX Week Number. Immer am Montag wird
  sie um eins weitergezhlt und hlt dann bis Sonntag. Der Zeitanfang
  ist auch hier der 01.01.1970. Dies ist ein Donnerstag, d.h. die erste
  'UNIX-Woche' hat also nur 4 Tage. Wir geben dieser ersten (kurzen)
  Woche den Index 0, alle weiteren Wochen haben dann fortlaufende
  Nummern.
  *)
  CONST
    jdn_19700101=               2440588;

  VAR
    jdn:                        CARDINAL;       (* julian day number *)
    udn:                        CARDINAL;       (* unix day number *)
    uwn:                        CARDINAL;       (* unix week number *)

  BEGIN                         (* PROCEDURE LUWN *)
    jdn:=LJDN(structTime);
    udn:=jdn - jdn_19700101;
    uwn:=(udn+3) DIV 7;
    RETURN uwn;
  END LUWN;


PROCEDURE LDayOfWeek(VAR structTime: DateTime): CARDINAL;
  (*
  Wir wissen, da Tag 0 (01.01.1970) ein Donnerstag ist. Wir wollen
  beim Montag mit Index 0 beginnen, also mssen wir zur udn erst 3
  addieren.
  *)
  CONST
    jdn_19700101=               2440588;

  VAR
    jdn:                        CARDINAL;       (* julian day number *)
    udn:                        CARDINAL;       (* unix day number *)
    wd:                         CARDINAL;

  BEGIN                         (* PROCEDURE LDayOfWeek *)
    jdn:=LJDN(structTime);
    udn:=jdn - jdn_19700101;
    wd:=(udn+3) MOD 7;
    RETURN wd;
  END LDayOfWeek;


PROCEDURE LWeekOfYear(VAR structTime: DateTime): CARDINAL;
  (*
  Gem International standard IS-8601 gehrt die Woche zu dem Jahr,
  in dem sie die meisten Tage hat. Auerdem beginnt die Woche am
  Montag. Ist also der 28.12. ein Montag, dann gehrt diese Woche
  noch zum alten Jahr, ist der 29.12. ein Montag, gehrt sie bereits
  zum neuen Jahr. Wir mssen also feststellen ob das Jahr mit KW 1 oder
  sozusagen mit KW 0 beginnt.

  Auch hier haben wir ein bichen gespickt bei den Calendar FAQ unter:
  http://www.pip.dknet.dk/~c-t/calendar.html

  *)
  CONST
    jdn_19700101=               2440588;

  VAR
    structTime_0101_this:       DateTime;
    structTime_0101_next:       DateTime;
    structTime_3112_prev:       DateTime;
    wd_0101_this:               CARDINAL;
    wd_0101_next:               CARDINAL;
    start_week:                 CARDINAL;
    woy:                        CARDINAL;
    zeit1:                      CARDINAL;
    zeit2:                      CARDINAL;

  BEGIN                         (* PROCEDURE LWeekOfYear *)
    structTime_0101_this:=structTime;
    WITH structTime_0101_this DO
      month:=1;
      day:=1;
    END;                        (* WITH structTime_0101_this *)
    wd_0101_this:=LDayOfWeek(structTime_0101_this);

    IF ((0<=wd_0101_this) AND (wd_0101_this<=3)) THEN
      start_week:=1 ELSE start_week:=0 END;

    structTime_0101_next:=structTime_0101_this;
    WITH structTime_0101_next DO
      year:=year+1;
    END;                        (* WITH structTime_0101_next *)
    wd_0101_next:=LDayOfWeek(structTime_0101_next);

    (*
    Zunchst bestimmen wir den Anfang des nchsten Jahres:
    *)
    StructTimeToTime(structTime_0101_next, zeit1);
    (*
    Ist der erste Tag im nchsten Jahr Montag, Dienstag, Mittwoch
    oder Donnerstag, beginnt die KW 1 noch im alten Jahr, ansonsten
    eine Woche spter. zeit1 ist in jedem Fall der Beginn von KW 1:
    *)
    IF ((0<=wd_0101_next) AND (wd_0101_next<=3)) THEN
      zeit1:=zeit1-wd_0101_next*s_pro_tag;
    ELSE                        (* IF ((0<=wd_0101_next)... *)
      zeit1:=zeit1+(7-wd_0101_next)*s_pro_tag;
    END;                        (* ELSE ((0<=wd_0101_next)... *)

    (*
    Die woy erhalten wir einfach, wenn wir zur Startwoche die Wochen-
    differenz von aktueller Zeit zu Jahresanfang addieren. Dann kann
    es hchstens passiert sein, da das alte Jahr bereits mit KW 1 des
    neuen Jahres beginnt. Dies sehen wir einfach daran, ob zeit2 (die
    aktuelle Zeit) grer ist als zeit1 (Beginn von KW 1). Ist dies
    der Fall, ist eben woy=1 anstatt 52 oder 53 oder sowas.
    *)
    woy:=start_week+(LUWN(structTime)-LUWN(structTime_0101_this));
    StructTimeToTime(structTime, zeit2);
    IF zeit2>=zeit1 THEN woy:=1 END;

    IF woy=0 THEN
      (*
      1970 beginnt mit KW 1, wir mssen also keinen Sonderfall
      behandeln, d.h., im Jahr 1970 kommen wir gar nicht hier
      vorbei und wir knnen ganz locker year decrementieren.
      *)
      structTime_3112_prev:=structTime;
      WITH structTime_3112_prev DO
        month:=12;
        day:=31;
        year:=year-1;
      END;                      (* WITH structTime_3112_prev *)
      (*
      Haben wir doch glatt eine Rekursion drin. Geht natrlich
      nicht sehr weit, weil hier ganz bestimmt *nicht* schon
      wieder woy=0 herauskommt, weil wir uns nmlich in der
      letzten Woche des Vorjahres befinden:
      *)
      woy:=LWeekOfYear(structTime_3112_prev);
    END;                        (* IF woy=0 *)

    RETURN woy;
  END LWeekOfYear;


PROCEDURE UWNToTime(VAR uwn, time: CARDINAL);
  VAR
    udn:                        INTEGER;        (* unix day number *)

  BEGIN                         (* PROCEDURE UWNToTime *)
    udn:=7*uwn;
    udn:=udn-3;
    IF udn<0 THEN udn:=0 END;
    time:=udn*s_pro_tag;
  END UWNToTime;


PROCEDURE LUWNToZeitKwStructTime(uwn: INTEGER; VAR zeit, kw: CARDINAL;
                                 VAR structTime: DateTime);
  VAR
    hwc:                        CARDINAL;

  BEGIN                         (* PROCEDURE LUWNToZeitKwJahr *)
    (*
    uwn ist eine lokale Wochennummer, d.h. sie entspricht unserer
    lokalen Wochenzhlung. Sie ist also z.B. um 0 Uhr 30 am Montag
    bereits eine Woche weiter als die Greenwich-Woche im selben
    Augenblick:
    *)
    hwc:=uwn;

    (*
    mit UWNToTime machen wir eine (lokale) Zeit in Sekunden daraus:
    *)
    UWNToTime(hwc, zeit);

    (*
    Zur Ermittlung der kw brauchen wir die Zeit im Record DateTime.
    Diesen erzeugen wir mittels TimeToGmStructTime, da LWeekOfYear
    im wesentlichen mit year, month und day arbeitet, d.h. von lokalen
    Werten ausgeht und die zone oder die Sommerzeit nicht berck-
    sichtigt. Mit TimeToGmStructTime haben wir einfach die GMT als
    lokale Zeit erzeugt und wissen, da zone 0 ist und die Sommerzeit
    auch nicht aktiv ist.
    *)
    TimeToGmStructTime(zeit, structTime);
    kw:=LWeekOfYear(structTime);
  END LUWNToZeitKwStructTime;


PROCEDURE LUWNToJahrKw(uwn: INTEGER; VAR jahr, kw: INTEGER);
  VAR
    structTime:                 DateTime;
    zeit:                       CARDINAL;
    woy:                        CARDINAL;       (* week of year *)

  BEGIN                         (* PROCEDURE LUWNToJahrKw *)
    LUWNToZeitKwStructTime(uwn, zeit, woy, structTime);
    jahr:=structTime.year;
    kw:=woy;
    (*
    Jetzt mssen wir aufpassen. Wenn woy=1 ist, mssen wir unter-
    scheiden, ob die fragliche uwn den Jahreswechsel beinhaltet.
    Wenn nein, gibt's kein Problem, wenn ja, haben wir ein kleines.
    jahr bezieht sich nmlich auf den Wochenanfang von uwn, d.h. obwohl
    wir mglicherweise uwn irgendwoanders z.B. von KW 1 des Jahres 1998
    abgeleitet hatten, werden wir hier jahr=1997 und kw=1 bekommen (KW 1
    des Jahres 1998 beginnt nmlich bereits am 29.12.1997). Dies ist
    nicht etwa ein Fehler in LUWNToZeitKwStructTime, sondern ein
    Interpretationsfehler hier. Wir haben nmlich von der in
    LUWNToZeitKwStructTime ermittelten structTime nur das Feld
    structTime.year beachtet und dabei ggf. nicht bemerkt, da Monat
    und Tag schon sehr nahe dem Jahresende liegen. Wir werden also im
    Falle kw=1 LUWNToZeitKwStructTime ein zweites mal, diesmal aber mit
    (uwn+1) aufrufen und das sich nun ergebende Jahr verwenden.
    *)
    IF woy=1 THEN
      LUWNToZeitKwStructTime(uwn+1, zeit, woy, structTime);
      jahr:=structTime.year;
    END;                        (* IF woy=1 *)
  END LUWNToJahrKw;


PROCEDURE LUWNToLesbar(uwn: INTEGER; VAR lesbar: ARRAY OF CHAR);
  VAR
    structTime:                 DateTime;
    zeit:                       CARDINAL;
    woy:                        CARDINAL;       (* week of year *)
    zwstr:                      String;

  BEGIN                         (* PROCEDURE LUWNToLesbar *)
    Assign('KW ', lesbar);
    LUWNToZeitKwStructTime(uwn, zeit, woy, structTime);
    IntToStr(woy, zwstr);
    Append(zwstr, lesbar);
    Append(' (', lesbar);
    Append(datum_str(zeit), lesbar);
    Append(' - ', lesbar);
    Append(datum_str(zeit+6*s_pro_tag), lesbar);
    Append(')', lesbar);
  END LUWNToLesbar;


PROCEDURE JahrKwToLUWN(jahr, kw: INTEGER; VAR uwn: INTEGER);
  (*
  Umrechnung von Jahr und KW in eine lokale UNIX Week Number.
  Geht ganz einfach: zuerst ermitteln wir die LUWN und die LWeekOfYear
  des 01.01. des Jahres. Bei der LWeekOfYear des 01.01. gibt es zwei
  Flle: entweder 1 oder eine hohe Zahl (so um die 52, wenn sozusagen
  noch die letzte Woche das Vorjahres gilt). Um die aktuelle LUWN
  zu erhalten, addieren wir einfach die kw zur LUWN des 01.01.
  und subtrahieren die 1 nur, falls LWeekOfYear des 01.01. 1 war.
  *)
  VAR
    structTime:                 DateTime;
    uwn_0101:                   INTEGER;
    woy_0101:                   INTEGER;

  BEGIN                         (* PROCEDURE JahrKwToLUWN *)
    WITH structTime DO
      year:=jahr;      
      month:=1;
      day:=1;
      hour:=0;
      minute:=0;
      second:=0;
      fractions:=0;
      zone:=0;
      summerTimeFlag:=FALSE;
    END;                        (* WITH structTime *)
    uwn_0101:=LUWN(structTime);
    woy_0101:=LWeekOfYear(structTime);
    uwn:=uwn_0101+kw;
    IF woy_0101=1 THEN uwn:=uwn-1 END;
  END JahrKwToLUWN;


PROCEDURE datum_str(zeit: CARDINAL): String;
  VAR
    structTime:                 DateTime;
    tag_str:                    String;
    monat_str:                  String;
    jahr_str:                   String;
    zwstr:                      String;

  BEGIN                         (* PROCEDURE datum_str *)
    TimeToGmStructTime(zeit, structTime);
    WITH structTime DO
      IntToStr(day, tag_str);
      IntToStr(month, monat_str);
      IntToStr(year, jahr_str);
    END;                        (* WITH structTime *)
    zwstr:=tag_str;
    Append('.', zwstr);
    Append(monat_str, zwstr);
    Append('.', zwstr);
    Append(jahr_str, zwstr);
    RETURN zwstr;
  END datum_str;


PROCEDURE split_pers_data(VAR text_in, text_out1, text_out2: ARRAY OF CHAR);
  VAR
    schnur1:                    String1;
    zwstr:                      String_mittel;
    gefunden:                   BOOLEAN;
    pos:                        CARDINAL;

  BEGIN                         (* PROCEDURE split_pers_data *)
    schnur1:=';';
    FindNext(schnur1, text_in, 0, gefunden, pos);

    IF gefunden THEN
      (*
      Es wurde ein (erster) Strichpunkt gefunden, d.h. wir betrachten den Text
      vorher als E-Mail-Adresse und den Rest als weitere persnliche Daten
      *)
      Extract(text_in, 0, pos, text_out1);
      Extract(text_in, pos+1, Length(text_in)-pos-1, text_out2);
    ELSE
      (*
      Es wurde KEIN Strichpunkt gefunden, d.h. wir betrachten den gesamten
      Text als E-Mail-Adresse
      *)
      Assign(text_in, text_out1);
      Assign('', text_out2);
    END;                        (* IF (gefunden... *)
  END split_pers_data;


PROCEDURE calc_court_index_nachbar(court_index: INTEGER): INTEGER;
  BEGIN                         (* PROCEDURE calc_court_index_nachbar *)
    (*
    Falls court_index gerade ist, besitzt der Courtnachbar
    einen um 1 hheren court_index, falls court_index ungerade
    ist, einen um 1 niedrigeren court_index. Ein bichen mit
    MOD spielen sollte das schon richten:
    *)
    RETURN (court_index + 1 - 2 * (court_index MOD 2));
  END calc_court_index_nachbar;


PROCEDURE WriteLnCrLf(cid: ChanId);
  VAR
    schnur2:                    ARRAY[0..1] OF CHAR;

  BEGIN                         (* PROCEDURE WriteLnCrLf *)
    schnur2:='  ';
    schnur2[0]:=15C;            (* CR *)
    schnur2[1]:=12C;            (* LF *)
    WriteString(cid, schnur2);
  END WriteLnCrLf;


PROCEDURE init_selection(VAR sel_rec_typ_ptr: sel_rec_typ_ptr_typ;
                         texte: ARRAY OF String_kurz);
  VAR
    hwc:                        CARDINAL;
    lcl_ptr:                    sel_rec_typ_ptr_typ;

  BEGIN                         (* PROCEDURE init_selection *)
    NEW(sel_rec_typ_ptr);
    lcl_ptr:=sel_rec_typ_ptr;
    lcl_ptr^.sel_rec_typ_ptr:=NIL;
    Assign(texte[0], lcl_ptr^.schnur);
    lcl_ptr^.zahl:=0;

    FOR hwc:=1 TO HIGH(texte) DO
      NEW(lcl_ptr^.sel_rec_typ_ptr);
      lcl_ptr:=lcl_ptr^.sel_rec_typ_ptr;
      lcl_ptr^.sel_rec_typ_ptr:=NIL;
      Assign(texte[hwc], lcl_ptr^.schnur);
      lcl_ptr^.zahl:=hwc;
    END;                        (* FOR hwc *)
  END init_selection;


PROCEDURE dispose_selection(VAR sel_rec_typ_ptr: sel_rec_typ_ptr_typ);
  VAR
    lcl_ptr, hlp_ptr:           sel_rec_typ_ptr_typ;

  BEGIN                         (* PROCEDURE dispose_selection *)
    lcl_ptr:=sel_rec_typ_ptr;
    WHILE lcl_ptr<>NIL DO
      hlp_ptr:=lcl_ptr^.sel_rec_typ_ptr;
      DISPOSE(lcl_ptr);
      lcl_ptr:=hlp_ptr;
    END;                        (* WHILE lcl_ptr<>NIL *)
  END dispose_selection;


PROCEDURE show_selection(lcid_out: ChanId; VAR sel_rec_typ_ptr: sel_rec_typ_ptr_typ;
                         text1: ARRAY OF CHAR);
  VAR
    lcl_ptr:                    sel_rec_typ_ptr_typ;

  BEGIN                         (* PROCEDURE show_selection *)
    WriteString(lcid_out, '<P> ');
    WriteString(lcid_out, text1);
    WriteString(lcid_out, ' </P> ');
    lcl_ptr:=sel_rec_typ_ptr;
    WHILE lcl_ptr<>NIL DO
      WriteString(lcid_out, '<P> ');
      WriteString(lcid_out, lcl_ptr^.schnur);
      WriteString(lcid_out, ' </P> ');
      WriteLnCrLf(lcid_out);
      lcl_ptr:=lcl_ptr^.sel_rec_typ_ptr;
    END;                        (* WHILE lcl_ptr<>NIL *)
  END show_selection;


PROCEDURE get_latest_element(VAR sel_rec_typ_ptr: sel_rec_typ_ptr_typ;
                             VAR schnur: ARRAY OF CHAR);
  VAR
    lcl_ptr, lcl_ptr_sav:       sel_rec_typ_ptr_typ;

  BEGIN                         (* PROCEDURE get_latest_element *)
    lcl_ptr:=sel_rec_typ_ptr;
    lcl_ptr_sav:=NIL;
    Assign('nichts gefunden', schnur);
    WHILE lcl_ptr<>NIL DO
      lcl_ptr_sav:=lcl_ptr;
      lcl_ptr:=lcl_ptr^.sel_rec_typ_ptr;
    END;                        (* WHILE lcl_ptr<>NIL *)
    IF lcl_ptr_sav<>NIL THEN
      Assign(lcl_ptr_sav^.schnur, schnur);
    END;                        (* IF lcl_ptr_sav<>NIL *)
  END get_latest_element;


PROCEDURE show_OpenResult(lcid_out: ChanId;
                          text1, text2: ARRAY OF CHAR; res: OpenResults);
  BEGIN                         (* PROCEDURE show_OpenResult *)
    WriteString(lcid_out, '<P> ');
    WriteString(lcid_out, text1);
    WriteString(lcid_out, ' ');
    WriteString(lcid_out, text2);
    WriteString(lcid_out, ': ');
    WriteString(lcid_out, 'res_type=');
    CASE res OF
      | opened:
          WriteString(lcid_out, 'opened');

      | wrongNameFormat:
          WriteString(lcid_out, 'wrongNameFormat');

      | wrongFlags:
          WriteString(lcid_out, 'wrongFlags');

      | tooManyOpen:
          WriteString(lcid_out, 'tooManyOpen');

      | outOfChans:
          WriteString(lcid_out, 'outOfChans');

      | wrongPermissions:
          WriteString(lcid_out, 'wrongPermissions');

      | noRoomOnDevice:
          WriteString(lcid_out, 'noRoomOnDevice');

      | noSuchFile:
          WriteString(lcid_out, 'noSuchFile');

      | fileExists:
          WriteString(lcid_out, 'fileExists');

      | wrongFileType:
          WriteString(lcid_out, 'wrongFileType');

      | noTextOperations:
          WriteString(lcid_out, 'noTextOperations');

      | noRawOperations:
          WriteString(lcid_out, 'noRawOperations');

      | noMixedOperations:
          WriteString(lcid_out, 'noMixedOperations');

      | alreadyOpen:
          WriteString(lcid_out, 'alreadyOpen');

      | otherProblem:
          WriteString(lcid_out, 'otherProblem');

      | ELSE
          WriteString(lcid_out, 'unbekannter res_type');
    END;                        (* CASE res *)
    WriteString(lcid_out, ' </P> ');
    WriteLnCrLf(lcid_out);
  END show_OpenResult;


PROCEDURE show_ReadResult(lcid_out: ChanId;
                          text1, text2: ARRAY OF CHAR; cid_to_test: ChanId);
  BEGIN                         (* PROCEDURE show_ReadResult *)
    WriteString(lcid_out, '<P> ');
    WriteString(lcid_out, text1);
    WriteString(lcid_out, ' ');
    WriteString(lcid_out, text2);
    WriteString(lcid_out, ': ');
    WriteString(lcid_out, 'ReadResult=');
    CASE ReadResult(cid_to_test) OF
      | notKnown:
          WriteString(lcid_out, 'notKnown');

      | allRight:
          WriteString(lcid_out, 'allRight');

      | outOfRange:
          WriteString(lcid_out, 'outOfRange');

      | wrongFormat:
          WriteString(lcid_out, 'wrongFormat');

      | endOfLine:
          WriteString(lcid_out, 'endOfLine');

      | endOfInput:
          WriteString(lcid_out, 'endOfInput');

      | ELSE
          WriteString(lcid_out, 'unbekanntes ReadResult');
    END;                        (* CASE ReadResult(cid_to_test) *)
    WriteString(lcid_out, ' </P> ');
    WriteLnCrLf(lcid_out);
  END show_ReadResult;


PROCEDURE show_ConvResult(lcid_out: ChanId;
                          text1, text2: ARRAY OF CHAR; format: ConvResults);
  BEGIN                         (* PROCEDURE show_ConvResult *)
    WriteString(lcid_out, '<P> ');
    WriteString(lcid_out, text1);
    WriteString(lcid_out, ' ');
    WriteString(lcid_out, text2);
    WriteString(lcid_out, ': ');
    WriteString(lcid_out, 'ConvResult=');
    CASE format OF
      | strAllRight:
          WriteString(lcid_out, 'strAllRight');

      | strOutOfRange:
          WriteString(lcid_out, 'strOutOfRange');

      | strWrongFormat:
          WriteString(lcid_out, 'strWrongFormat');

      | strEmpty:
          WriteString(lcid_out, 'strEmpty');

      | ELSE
          WriteString(lcid_out, 'unbekanntes ReadResult');
    END;                        (* CASE format *)
    WriteString(lcid_out, ' </P> ');
    WriteLnCrLf(lcid_out);
  END show_ConvResult;


PROCEDURE file_existiert(name: ARRAY OF CHAR): BOOLEAN;
  VAR
    cid:                        ChanId;
    res:                        OpenResults;

  BEGIN                         (* PROCEDURE file_existiert *)
    StreamFile.Open(cid, name, read, res);
    (*
    show_OpenResult(cid_out, name, 'file_existiert', res);
    *)
    IF res=opened THEN
      StreamFile.Close(cid);
      RETURN TRUE
    ELSE                        (* IF res=opened *)
      RETURN FALSE
    END;                        (* ELSE res=opened *)
  END file_existiert;


PROCEDURE directory_existiert(pfad: String): BOOLEAN;
  VAR
    dir_ptr:                    ADDRESS;
    ok:                         BOOLEAN;

  BEGIN                         (* PROCEDURE directory_existiert *)
    dir_ptr:=Unix.Opendir(pfad);
    IF dir_ptr<>NIL THEN
      ok:=Unix.Closedir(dir_ptr);
      RETURN TRUE
    ELSE                        (* IF dir_ptr<>NIL *)
      RETURN FALSE
    END;                        (* ELSE dir_ptr<>NIL *)
  END directory_existiert;


PROCEDURE create_lock(): BOOLEAN;
  CONST
    max_wait=                   10;

  VAR
    count:                      INTEGER;
    cid:                        ChanId;
    res:                        OpenResults;
    vergangen:                  CARDINAL;

  BEGIN                         (* PROCEDURE create_lock *)
    count:=0;
    StreamFile.Open(cid, lock_name, write, res);
    (*
    show_OpenResult(cid_out, lock_name, 'create_lock', res);
    *)
    WHILE ((count<max_wait) AND (NOT (res=opened))) DO
      count:=count+1;
      vergangen:=Unix.Sleep(1);
      StreamFile.Open(cid, lock_name, write, res);
    END;                        (* WHILE ((count<max_wait... *)
    IF res=opened THEN
      StreamFile.Close(cid);
      lock_angelegt:=TRUE;
      RETURN TRUE
    ELSE                        (* IF res=opened *)
      RETURN FALSE
    END;                        (* ELSE res=opened *)
  END create_lock;


PROCEDURE create_lock2(): BOOLEAN;
  CONST
    max_wait=                   10;

  VAR
    zeit0:                      CARDINAL;
    cid:                        ChanId;
    res:                        OpenResults;
    vergangen:                  CARDINAL;

  BEGIN                         (* PROCEDURE create_lock2 *)
    zeit0:=Unix.Time();
    vergangen:=Unix.Time() - zeit0;
    StreamFile.Open(cid, lock_name, write, res);
    (*
    show_OpenResult(cid_out, lock_name, 'create_lock2', res);
    *)
    WHILE ((vergangen<max_wait) AND (NOT (res=opened))) DO
      (*
      die folgende Zeile wurde spter eingefgt, um die
      Dauerschleife zu entschrfen. Damit wird halt schon
      mal eine Sekunde gewartet, _ohne_ da CPU verbraten
      wird. Damit fr Testzwecke aber jederzeit wieder
      zur Dauerschleife umgeschaltet werden kann, wurde
      sonst nichts verndert. Dazu mu dann eben nur die
      folgende Zeile mit dem Sleep wieder weggemacht werden.
      *)
      vergangen:=Unix.Sleep(1);
      vergangen:=Unix.Time() - zeit0;
      StreamFile.Open(cid, lock_name, write, res);
    END;                        (* WHILE ((count<max_wait... *)
    IF res=opened THEN
      StreamFile.Close(cid);
      lock_angelegt:=TRUE;
      RETURN TRUE
    ELSE                        (* IF res=opened *)
      RETURN FALSE
    END;                        (* ELSE res=opened *)
  END create_lock2;


PROCEDURE try_delete_lock;
  VAR
    geloescht:                  BOOLEAN;

  BEGIN                         (* PROCEDURE try_delete_lock *)
    (*
    Ursprnglich war vorgesehen, das Lockfile bei Programmbeginn anzulegen
    und erst bei Programmende wieder zu lschen. Speziell bei langen
    Transfers zum Client, bei denen die Datenbasis nicht mehr
    angerhrt wird, knnen/mssen wir das Lockfile so frh wie
    mglich wieder wegmachen. Damit wir nicht mehrfach versuchen,
    ein (evtl. gar nicht von uns erzeugtes) Lockfile zu lschen,
    testen wir erst die Variable lock_angelegt.
    *)

    IF lock_angelegt THEN
      geloescht:=Unix.Unlink(lock_name);
      IF geloescht THEN lock_angelegt:=FALSE END;
    END;                        (* IF lock_angelegt *)
  END try_delete_lock;


PROCEDURE PutGPMString(schnur: ARRAY OF CHAR; index: INTEGER);
  PROCEDURE GibRestFrei(VAR str_rec_typ_ptr: str_rec_typ_ptr_typ);
    BEGIN                       (* PROCEDURE GibRestFrei *)
      IF str_rec_typ_ptr<>NIL THEN
        GibRestFrei(str_rec_typ_ptr^.str_rec_typ_ptr);
        DISPOSE(str_rec_typ_ptr);
      END;                      (* IF str_rec_typ_ptr<>NIL *)
    END GibRestFrei;

  PROCEDURE LegRestAb(VAR str_rec_typ_ptr: str_rec_typ_ptr_typ);
    VAR
      schnur2:                  String_mittel;

    BEGIN                       (* PROCEDURE LegRestAb *)
      IF Length(schnur)>0 THEN
        NEW(str_rec_typ_ptr);
        Extract(schnur, 0, mittellen, schnur2);
        Delete(schnur, 0, mittellen);
        Assign(schnur2, str_rec_typ_ptr^.value_strr);
        str_rec_typ_ptr^.str_rec_typ_ptr:=NIL;
        LegRestAb(str_rec_typ_ptr^.str_rec_typ_ptr);
      END;                      (* IF Length(schnur)>0 *)
    END LegRestAb;

  BEGIN                         (* PROCEDURE PutGPMString *)
    WITH input[index] DO
      (*
      Bevor neue Sachen geschrieben werden, geben wir den ganzen alten
      Rest erst mal frei. Machen wir rekursiv, echt geil oder?
      *)
      GibRestFrei(str_rec_typ_ptr);
      (*
      Solange die schnur nicht der Leerstring ist, versuchen wir
      die ersten paar Zeichen daraus zu extrahieren und zu verstauen.
      *)
      LegRestAb(str_rec_typ_ptr);
    END;                        (* WITH input[index] *)
  END PutGPMString;


PROCEDURE GetGPMString(VAR schnur: ARRAY OF CHAR; index: INTEGER);
  PROCEDURE HaengRestAn(VAR str_rec_typ_ptr: str_rec_typ_ptr_typ);
    BEGIN                       (* PROCEDURE HaengRestAn *)
      IF str_rec_typ_ptr<>NIL THEN
        Append(str_rec_typ_ptr^.value_strr, schnur);
        HaengRestAn(str_rec_typ_ptr^.str_rec_typ_ptr);
      END;                      (* IF str_rec_typ_ptr<>NIL *)
    END HaengRestAn;

  BEGIN                         (* PROCEDURE GetGPMString *)
    WITH input[index] DO
      Assign('', schnur);
      (*
      Mal sehen, ob was in der Liste steht.
      *)
      HaengRestAn(str_rec_typ_ptr);
    END;                        (* WITH input[index] *)
  END GetGPMString;


PROCEDURE show_client_info1(lcid_out: ChanId);
  VAR
    zwstr:                      String;
    char_cnt_str:               String;

  BEGIN                         (* PROCEDURE show_client_info1 *)
    WriteString(lcid_out, '<P> ');
    (*
    (*
    Unix.GetEnv(http_host_c, zwstr);
    *)
    Unix.GetEnv(http_host_c, zwstr, SIZE(zwstr));
    *)
    Assign(http_host, zwstr);

    WriteString(lcid_out, http_host_c);
    WriteString(lcid_out, ': ');
    WriteString(lcid_out, zwstr);
    WriteString(lcid_out, ' </P>');
    WriteLnCrLf(lcid_out);

    WriteString(lcid_out, '<P> ');
    (*
    (*
    Unix.GetEnv(server_name_c, zwstr);
    *)
    Unix.GetEnv(server_name_c, zwstr, SIZE(zwstr));
    *)
    Assign(server_name, zwstr);

    WriteString(lcid_out, server_name_c);
    WriteString(lcid_out, ': ');
    WriteString(lcid_out, zwstr);
    WriteString(lcid_out, ' </P>');
    WriteLnCrLf(lcid_out);

    WriteString(lcid_out, '<P> ');
    (*
    Unix.GetEnv(server_software_c, zwstr);
    *)
    Unix.GetEnv(server_software_c, zwstr, SIZE(zwstr));
    WriteString(lcid_out, server_software_c);
    WriteString(lcid_out, ': ');
    WriteString(lcid_out, zwstr);
    WriteString(lcid_out, ' </P>');
    WriteLnCrLf(lcid_out);

    WriteString(lcid_out, '<P> ');
    (*
    Unix.GetEnv(remote_addr_c, zwstr);
    *)
    Unix.GetEnv(remote_addr_c, zwstr, SIZE(zwstr));
    WriteString(lcid_out, remote_addr_c);
    WriteString(lcid_out, ': ');
    WriteString(lcid_out, zwstr);
    WriteString(lcid_out, ' </P>');
    WriteLnCrLf(lcid_out);

    WriteString(lcid_out, '<P> ');
    (*
    Unix.GetEnv(request_method_c, zwstr);
    *)
    Unix.GetEnv(request_method_c, zwstr, SIZE(zwstr));
    WriteString(lcid_out, request_method_c);
    WriteString(lcid_out, ': ');
    WriteString(lcid_out, zwstr);
    WriteString(lcid_out, ' </P>');
    WriteLnCrLf(lcid_out);

    WriteString(lcid_out, '<P> ');
    (*
    Unix.GetEnv(query_string_c, zwstr);
    *)
    Unix.GetEnv(query_string_c, zwstr, SIZE(zwstr));
    WriteString(lcid_out, query_string_c);
    WriteString(lcid_out, ': ');
    WriteString(lcid_out, zwstr);
    WriteString(lcid_out, ' </P>');
    WriteLnCrLf(lcid_out);

    WriteString(lcid_out, '<P> ');
    IntToStr(char_cnt, char_cnt_str);
    WriteString(lcid_out, 'char_cnt=');
    WriteString(lcid_out, char_cnt_str);
    WriteString(lcid_out, ' </P>');
    WriteLnCrLf(lcid_out);
  END show_client_info1;


PROCEDURE show_client_info2(lcid_out: ChanId);
  VAR
    i:                          INTEGER;
    zwstr:                      String;
    anz_arg:                    CARDINAL;
    param:                      String;
    structTime:                 DateTime;
    strTime:                    String;

  BEGIN                         (* PROCEDURE show_client_info2 *)
    WriteString(lcid_out, '<P> ');
    (*
    Unix.GetEnv('REQUEST_URI', zwstr);
    *)
    Unix.GetEnv('REQUEST_URI', zwstr, SIZE(zwstr));
    WriteString(lcid_out, 'REQUEST_URI: ');
    WriteString(lcid_out, zwstr);
    WriteString(lcid_out, ' </P>');
    WriteLnCrLf(lcid_out);

    WriteString(lcid_out, '<P> ');
    (*
    Unix.GetEnv('SCRIPT_NAME', zwstr);
    *)
    Unix.GetEnv('SCRIPT_NAME', zwstr, SIZE(zwstr));
    WriteString(lcid_out, 'SCRIPT_NAME: ');
    WriteString(lcid_out, zwstr);
    WriteString(lcid_out, ' </P>');
    WriteLnCrLf(lcid_out);

    WriteString(lcid_out, '<P> ');
    (*
    Unix.GetEnv('SCRIPT_FILENAME', zwstr);
    *)
    Unix.GetEnv('SCRIPT_FILENAME', zwstr, SIZE(zwstr));
    WriteString(lcid_out, 'SCRIPT_FILENAME: ');
    WriteString(lcid_out, zwstr);
    WriteString(lcid_out, ' </P>');
    WriteLnCrLf(lcid_out);

    WriteString(lcid_out, '<P> ');
    (*
    Unix.GetEnv(squash_base_c, zwstr);
    *)
    Unix.GetEnv(squash_base_c, zwstr, SIZE(zwstr));
    WriteString(lcid_out, squash_base_c);
    WriteString(lcid_out, ': ');
    WriteString(lcid_out, zwstr);
    WriteString(lcid_out, ' </P>');
    WriteLnCrLf(lcid_out);

    WriteString(lcid_out, '<P> ');
    (*
    Unix.GetEnv(content_length_c, zwstr);
    *)
    Unix.GetEnv(content_length_c, zwstr, SIZE(zwstr));
    WriteString(lcid_out, content_length_c);
    WriteString(lcid_out, ': ');
    WriteString(lcid_out, zwstr);
    WriteString(lcid_out, ' </P>');
    WriteLnCrLf(lcid_out);

    WriteString(lcid_out, '<P> ');
    (*
    Unix.GetEnv('PATH_INFO', zwstr);
    *)
    Unix.GetEnv('PATH_INFO', zwstr, SIZE(zwstr));
    WriteString(lcid_out, 'PATH_INFO: ');
    WriteString(lcid_out, zwstr);
    WriteString(lcid_out, ' </P>');
    WriteLnCrLf(lcid_out);

    WriteString(lcid_out, '<P> ');
    FOR i:=ii00 TO max_param_anz-1 DO
      WITH input[i] DO
        WriteString(lcid_out, name_strr);
        WriteString(lcid_out, ': ');
        GetGPMString(zwstr, i);
        WriteString(lcid_out, zwstr);
        WriteString(lcid_out, ', ');
        WriteInt(lcid_out, value, 1);
        WriteString(lcid_out, '; ');
      END;                      (* WITH input[i] *)
    END;                        (* FOR i *)
    WriteString(lcid_out, '</P>');
    WriteLnCrLf(lcid_out);

    Reset(ArgChan());
    WriteString(lcid_out, '<P> ');
    WriteString(lcid_out, 'Programmaufruf: ');
    anz_arg:=0;
    WHILE IsArgPresent() DO
      anz_arg:=anz_arg+1;
      ReadToken(ArgChan(), param);
      WriteString(lcid_out, param);
      WriteChar(lcid_out, ' ');
    NextArg();
    END;                        (* WHILE IsArgPresent() *)
    WriteString(lcid_out, '</P>');
    WriteLnCrLf(lcid_out);

    WriteString(lcid_out, '<P> ');
    WriteString(lcid_out, 'Anzahl Argumente (inclusive Programmname): ');
    WriteCard(lcid_out, anz_arg, 1);
    WriteString(lcid_out, ' </P>');
    WriteLnCrLf(lcid_out);

    TimeToLcStructTime(zeitagm, structTime);
    StructTimeToAsciiRS1(strTime, structTime);
    WriteString(lcid_out, '<P> ');
    WriteString(lcid_out, 'zeitagm: ');
    WriteString(lcid_out, strTime);
    WriteCard(lcid_out, zeitagm, 12);
    WriteString(lcid_out, ' </P>');
    WriteLnCrLf(lcid_out);

    TimeToLcStructTime(zeitalc, structTime);
    StructTimeToAsciiRS1(strTime, structTime);
    WriteString(lcid_out, '<P> ');
    WriteString(lcid_out, 'zeitalc: ');
    WriteString(lcid_out, strTime);
    WriteCard(lcid_out, zeitalc, 12);
    WriteString(lcid_out, ' </P>');
    WriteLnCrLf(lcid_out);

    TimeToLcStructTime(zeiturllc, structTime);
    StructTimeToAsciiRS1(strTime, structTime);
    WriteString(lcid_out, '<P> ');
    WriteString(lcid_out, 'zeiturllc: ');
    WriteString(lcid_out, strTime);
    WriteCard(lcid_out, zeiturllc, 12);
    WriteString(lcid_out, ' </P>');
    WriteLnCrLf(lcid_out);

    TimeToLcStructTime(user_time1, structTime);
    StructTimeToAsciiRS1(strTime, structTime);
    WriteString(lcid_out, '<P> ');
    WriteString(lcid_out, 'user_time1: ');
    WriteString(lcid_out, strTime);
    WriteCard(lcid_out, user_time1, 12);
    WriteString(lcid_out, ' </P>');
    WriteLnCrLf(lcid_out);

    TimeToLcStructTime(user_time2, structTime);
    StructTimeToAsciiRS1(strTime, structTime);
    WriteString(lcid_out, '<P> ');
    WriteString(lcid_out, 'user_time2: ');
    WriteString(lcid_out, strTime);
    WriteCard(lcid_out, user_time2, 12);
    WriteString(lcid_out, ' </P>');
    WriteLnCrLf(lcid_out);

    TimeToLcStructTime(user_time3, structTime);
    StructTimeToAsciiRS1(strTime, structTime);
    WriteString(lcid_out, '<P> ');
    WriteString(lcid_out, 'user_time3: ');
    WriteString(lcid_out, strTime);
    WriteCard(lcid_out, user_time3, 12);
    WriteString(lcid_out, ' </P>');
    WriteLnCrLf(lcid_out);
  END show_client_info2;


PROCEDURE reset_globals(VAR sd: sd_rec_typ);
  BEGIN                         (* PROCEDURE reset_globals *)
    WITH sd DO
      sea_version:=sea_version_akt;
      site_counter:=0;
      chat_counter:=0;
      sea_state:=sea_state1;
      zeil_anz:=min_zeil_anz;
      spalt_anz:=min_spalt_anz;
      spieler_anz:=min_spieler_anz;

      (*
      Im season-File wird season_start abgelegt. Dies ist unsere
      lokale UNIX Week Number. Zur etwas bequemeren Eingabe erlauben
      wir hier Jahr und die ganz normale Kalenderwoche. Diese beiden
      Gren mssen aber erst mal nach season_start umgerechnet werden.
      Wer genau hinsieht, bemerkt: akt_season_start_jahr und
      akt_season_start_woche wurden in init_msc aus der aktuellen Zeit
      gewonnen, d.h. wir knnten uns die Aufteilung eigentlich sparen
      und gleich mit der akt_luwn arbeiten. Sollte es aber doch einmal
      ntig sein, wieder menschenlesbare Zeiten hier einzugeben,
      haben wir nun die Mglichkeit dazu.
      *)
      JahrKwToLUWN(akt_season_start_jahr, akt_season_start_woche, season_start);
      wochen_anz:=min_wochen_anz;

      show_future_kw:=jahr_wochen_zugriff_default;
      bitleiste:=0;
      Assign('', zusatz_heading);
    END;                        (* WITH sd *)
  END reset_globals;


PROCEDURE reset_uns_courts(VAR sd: sd_rec_typ);
  VAR
    i:                          INTEGER;

  BEGIN                         (* PROCEDURE reset_uns_courts *)
    WITH sd DO
      (*
      Alle nur erdenklichen Courts als *nicht unser* Court markieren.
      Und zwar findet dies seinen Niederschlag sowohl in 'uns_court'
      als auch in 'geschrumpfter_index'.
      *)
      uns_courts_anz:=0;
      FOR i:=0 TO (2*max_zeil_anz*max_spalt_anz)-1 BY 2 DO
        uns_court[i]:=-1;
        uns_court[i+1]:=-1;
        geschrumpfter_index[i]:=-1;
        geschrumpfter_index[i+1]:=-1;
      END;                      (* FOR i *)
    END;                        (* WITH sd *)
  END reset_uns_courts;


PROCEDURE reset_wochentage_und_courts(VAR sd: sd_rec_typ);
  VAR
    i:                          INTEGER;

  BEGIN                         (* PROCEDURE reset_wochentage_und_courts *)
    WITH sd DO
      (*
      Alle nur erdenklichen Wochentage und Courts mit Dummy markieren:
      *)
      FOR i:=0 TO (max_zeil_anz-1) DO
        wochentag[i]:=wochentage_anz;
        court[i]:='Court xy';
      END;                      (* FOR i *)
    END;                        (* WITH sd *)
  END reset_wochentage_und_courts;


PROCEDURE reset_uhrzeiten(VAR sd: sd_rec_typ);
  VAR
    i:                          INTEGER;

  BEGIN                         (* PROCEDURE reset_uhrzeiten *)
    WITH sd DO
      (*
      Alle nur erdenklichen Uhrzeiten mit Dummy markieren:
      *)
      FOR i:=0 TO (max_spalt_anz-1) DO
        uhrzeit[i]:=zehnmin_anz;
      END;                      (* FOR i *)
    END;                        (* WITH sd *)
  END reset_uhrzeiten;


PROCEDURE reset_spieler(VAR sd: sd_rec_typ);
  TYPE
    str_arr_typ=                ARRAY[0..ssa-1] OF String;
  CONST
    keine_mail=                 '';
    kein_kennwort=              '<kein Kennwort>';
    remote_addr_init=           '<remote addr>';

    spezial_spieler=            str_arr_typ{
      '(frei)', '(abbestellt)', '(Auswahl)', '(Chef)', '(Chefin)',
      '(ein Besucher)', '(dummy6)', '(dummy7)', '(dummy8)', '(dummy9)', 
      '(dummy10)', '(dummy11)', '(dummy12)', '(dummy13)'
                                };
  VAR
    i:                          INTEGER;
    index_str:                  String;
    str_ptr:                    StrPtrTyp;

  BEGIN                         (* PROCEDURE reset_spieler *)
    WITH sd DO
      (*
      Die 'Spezialspieler' vorbelegen: bis auf '(Chef)' und '(Chefin)'
      bekommt keiner ein Kennwort. '(frei)' und '(Auswahl)' brauchen
      sowieso keines, fr den '(abbestellt)' sind der Chef oder die
      Chefin zustndig, '(ein Besucher)' soll sich auch ohne Kennwort
      am Chatten beteiligen knnen, die Dummies stehen sowieso nur
      bld rum. '(Chef)' und '(Chefin)' erhalten besondere (Start-)
      Kennwrter.
      In einem gewissen Sinne sind die Nicht-Dummy-'Spezialspieler'
      aktive Spieler, z.B. wenn es um schreib_reihe_select_spieler geht.
      *)
      FOR i:=0 TO ssa-1 DO
        spieler_name[i]:=spezial_spieler[i];
        spieler_pers_data[i]:=keine_mail;
        spieler_art[i]:=sp_art_keiner;
        spieler_aktiv[i]:=sp_aktiv_ja;
        spieler_rang[i]:=0;
        max_day_delta[i]:=0;
        spieler_kennwort[i]:=kein_kennwort;
        spieler_remote_addr[i]:=remote_addr_init;
      END;                      (* FOR i *)
      Assign(chef_kennwort_default, spieler_kennwort[i_chef]);
      Assign(chefin_kennwort_default, spieler_kennwort[i_chefin]);

      (*
      Die restlichen Namen, Kennwrter, Spielerarten
      'Spieleraktivitten' usw. dummymig
      vorbelegen.
      *)
      FOR i:=ssa TO max_spieler_anz+ssa-1 DO
        spieler_name[i]:='Spieler';
        IntToStr(i-ssa+1, index_str);
        Append(index_str, spieler_name[i]);
        spieler_pers_data[i]:=keine_mail;
        spieler_art[i]:=sp_art_woe;
        spieler_aktiv[i]:=sp_aktiv_ja;
        spieler_rang[i]:=0;
        max_day_delta[i]:=0;
        (*
        str_ptr:=Unix.Crypt(spieler_name[i], '00');
        spieler_kennwort[i]:=str_ptr^;

        str_ptr:=Unix.Crypt('geheim', '00');
        spieler_kennwort[i]:=str_ptr^;
        *)
        spieler_kennwort[i]:=kein_kennwort;
        spieler_remote_addr[i]:=remote_addr_init;
      END;                      (* FOR i *)
    END;                        (* WITH sd *)
  END reset_spieler;


PROCEDURE reset_court_belegung(VAR sd: sd_rec_typ);
  VAR
    i:                          INTEGER;
    hw_forderung:               forderung_typ;
    hw_court_belegung:          court_belegung_typ;
    hw_court_belegung_gast_nam: court_belegung_str_typ;

  BEGIN                         (* PROCEDURE reset_court_belegung *)
    WITH sd DO
      (*
      Wir whlen als Voreinstellung: alle nur erdenklichen Courts in
      allen Wochen sind frei (d.h. auch da nirgends ein Gast eingetragen
      ist, insbesondere werden die Namen der offiziellen Gste mit
      dem Leerstring vorbelegt) und Zugriff maximal jahr_wochen_zugriff_default
      Wochen vorher mglich. In keinem Court findet eine Forderung statt.
      *)
      FOR i:=0 TO (max_zeil_anz*max_spalt_anz)-1 DO
        hw_forderung[i]:=0;
      END;                      (* FOR i *)

      FOR i:=0 TO (2*max_zeil_anz*max_spalt_anz)-1 DO
        hw_court_belegung[i]:=0;
        hw_court_belegung_gast_nam[i]:='';
      END;                      (* FOR i *)

      FOR i:=0 TO max_wochen_anz-1 DO
        jahr_forderung[i]:=hw_forderung;
        jahr_wochen_zugriff[i]:=jahr_wochen_zugriff_default;
        jahr_court_belegung[i]:=hw_court_belegung;
        jahr_court_belegung_gast[i]:=hw_court_belegung;
        jahr_court_belegung_gast_nam[i]:=hw_court_belegung_gast_nam;
      END;                      (* FOR i *)
    END;                        (* WITH sd *)
  END reset_court_belegung;


PROCEDURE reset_season_data(VAR sd: sd_rec_typ);
  BEGIN                         (* PROCEDURE reset_season_data *)
    reset_globals(sd);
    reset_uns_courts(sd);
    reset_wochentage_und_courts(sd);
    reset_uhrzeiten(sd);
    reset_spieler(sd);
    reset_court_belegung(sd);
  END reset_season_data;


PROCEDURE init_std_channels;
  BEGIN                         (* PROCEDURE init_std_channels *)
    (*
    Standard-Channels ermitteln:
    *)
    cid_in:=StdInChan();
    cid_out:=StdOutChan();
    cid_err:=StdErrChan();
  END init_std_channels;


PROCEDURE CaughtSignal(sigNum: INTEGER);
  VAR
    ok:                         BOOLEAN;
    alt:                        Handler;

  BEGIN                         (* PROCEDURE CaughtSignal *)
    (*
    Wir haben also irgendein Signal erhalten. Vornehmste Aufgabe
    ist das Lschen des Lockfiles:
    *)
    try_delete_lock;

    (*
    Signalhandler *nicht* neu aufsetzen. Das Neuaufsetzten hatten wir
    von Geoffrey Elgey bernommen. In seinem Beispiel sollte das Programm
    im Gegensatz zu uns hier weiterlaufen und es sollten erneut Signale
    abgefangen werden. Wir wollen das nicht. Es reicht, wenn wir einmal
    die Chance hatten, das Lockfile zu lschen. Anschlieend soll
    durchaus das System eventuell auftretende Signale verarbeiten.
    Durch das RaiseSignal am Ende wird dem System die weitere Behandlung
    berlassen. Wir haben jedenfalls unser Lockfile gelscht.

    ok := Unix.InstallHandler(sigNum, CaughtSignal, alt);
    *)

    (*
    Wenn wirklich Testausgaben gemacht werden mssen, dann auf jeden
    Fall auf cid_err, sonst kriegen wir Riesenprobleme, weil die
    Routine hier ja hchstwahrscheinlich gerade wegen der gebrochenen
    cid_out-Pfeife aufgerufen worden ist.
    *)

    (*
    WriteLnCrLf(cid_err);
    WriteString(cid_err, 'Signal Nummer ');
    WriteInt(cid_err, sigNum, 1);
    WriteString(cid_err, ' erhalten.');
    WriteLnCrLf(cid_err);
    *)

    (*
    Also, jetzt ist das System am Zug. Soll es mit dem Signal doch
    machen, was es will ;-) Wir haben unser Schfchen jedenfalls
    im Trockenen.
    *)
    ok := Unix.RaiseSignal(sigNum);
  END CaughtSignal;


PROCEDURE init_signals;
  VAR
    ok:                         BOOLEAN;
    alt:                        Handler;

  BEGIN                         (* PROCEDURE init_signals *)
    ok:=TRUE;

    ok := ok AND Unix.InstallHandler(Unix.SIGHUP, CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGINT, CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGQUIT, CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGILL , CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGABRT, CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGFPE, CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGSEGV, CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGPIPE, CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGALRM, CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGTERM, CaughtSignal, alt);

    ok := ok AND Unix.InstallHandler(Unix.SIGUSR1, CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGUSR2, CaughtSignal, alt);
    (*
    ok := ok AND Unix.InstallHandler(Unix.SIGCHLD, CaughtSignal, alt);
    *)
    ok := ok AND Unix.InstallHandler(Unix.SIGCONT, CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGTSTP, CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGTTIN, CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGTTOU, CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGTRAP, CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGIOT, CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGBUS, CaughtSignal, alt);

    ok := ok AND Unix.InstallHandler(Unix.SIGURG, CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGIO, CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGXCPU, CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGXFSZ, CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGVTALRM, CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGPROF, CaughtSignal, alt);
    ok := ok AND Unix.InstallHandler(Unix.SIGWINCH, CaughtSignal, alt);

    (*
    WriteString(cid_out, 'Es konnten ');
    IF (NOT ok) THEN WriteString(cid_out, '*nicht* ') END;
    WriteString(cid_out, 'alle Handler installiert werden.');
    WriteLnCrLf(cid_out);
    *)
  END init_signals;


PROCEDURE Ausstieg;
  BEGIN                         (* PROCEDURE Ausstieg *)
    try_delete_lock;

    (*
    Info: mit strace erscheint der unlink zeitlich noch *vor* den
    Ausgaben auf cid_out (mittels write). Setzt man vor try_delete_lock
    aber einen Flush, dann sieht's wieder normal aus. Das merkwrdige
    Timing kommt also anscheinend von irgendeinem Buffering.
    *)

    (*
    WriteLnCrLf(cid_out);
    WriteString(cid_out, 'Hier ist Ausstieg. ');
    WriteLnCrLf(cid_out);
    *)

    (*
    Achtung: hier hatten wir mal einen HALT stehen. War natrlich
    extrem ungeil, weil dieser offenbar erneut einen Programmausstieg
    anleiert und wir wieder hier in Ausstieg landeten. Fhrte dann ganz
    zwanglos zu irgendwelchen Stackberlufen...
    *)
  END Ausstieg;


PROCEDURE init_ausstieg;
  BEGIN                         (* PROCEDURE init_ausstieg *)
    Unix.Atexit(Ausstieg);
  END init_ausstieg;


PROCEDURE init_http_connection(lcid_out: ChanId);
  BEGIN                         (* PROCEDURE init_http_connection *)
    WriteString(lcid_out, 'Content-type: text/html; charset=ISO-8859-1');
    WriteLnCrLf(lcid_out);
    WriteLnCrLf(lcid_out);
  END init_http_connection;


PROCEDURE welche_tabelle;
  VAR
    prog_nam:                   String;
    prog_nam_appendix:          String;
    i:                          INTEGER;
    appendix_gefunden:          BOOLEAN;

  BEGIN                         (* PROCEDURE welche_tabelle *)
    (*
    Wir mssen anhand des zu ermittelnden Progammnamens
    entscheiden, welche Tabelle zu bearbeiten ist. Das spiegelt
    sich dann in verschiedenen Dingen wider: Erzeugung des korrekten
    URLs, Zugriff auf die relevanten Daten im Filesystem, Festlegung
    (tabellen-)individueller Defaultkennwrter fr den Chef und die
    Chefin und hnliche Sachen. ber script_nam_prog_appendix z.B. legen
    wir global fest, wie unser Appendix heit. Das bedeutet aber auch,
    da alle unsere Programmnamen aus script_nam_prog1 ableitet werden.
    Dieser gleiche Appendix wird dann auch im Filesystem erscheinen
    zur Unterscheidung der Daten.
    *)

    (*
    Vorbelegen der Appendices und ChefIn-Kennwrter. Aus historischen
    Grnden hat die erste Tabelle gar keinen Appendix und die zweite
    heit 'gd' und nicht '02':
    *)
    FOR i:=1 TO tabellen_anz DO
      IntToStrRS(i, script_nam_prog_appendix_arr[i], 2);
      Assign(chef_kennw_arr_c[i], chef_kennw_arr[i]);
      Assign(chefin_kennw_arr_c[i], chefin_kennw_arr[i]);
    END;                        (* FOR i *)
    Assign('', script_nam_prog_appendix_arr[1]);
    Assign('gd', script_nam_prog_appendix_arr[2]);

    (*
    Machen wir also eine Initialisierung fr unsere erste Tabelle:
    *)

    (*
    Fr unsere erste Tabelle ist der Appendix brigens der Leerstring:
    *)
    Assign(script_nam_prog_appendix_arr[1], script_nam_prog_appendix);
    (*
    Die verschlsselten Defaultkennwrter fr den Administrator
    (den Chef) und die Sekri (die Chefin):
    *)
    Assign(chef_kennw_arr[1], chef_kennwort_default);
    Assign(chefin_kennw_arr[1], chefin_kennwort_default);

    (*
    Tun wir, als sei es Tabelle 1 gewesen:
    *)
    tabellen_nummer:=1;

    (*
    Anhand des Programmnamens mssen wir nun sehen, ob nicht vielleicht
    doch eine andere Tabelle vorliegt. Nachdem wir also
    den Programmnamen besorgt haben werden, testen wir einfach, ob die
    letzten paar Zeichen des Programmnamens mit dem entsprechenden Appendix
    bereinstimmen.
    *)

    Reset(ArgChan());
    (*
    Wir wissen: der Programmname ist auf jeden Fall da, also
    mssen wir nicht rumfingern mit IsArgPresent und so, sondern
    knnen einfach lesen und haben dann den Programmnamen im Kasten
    *)
    ReadToken(ArgChan(), prog_nam);

    i:=1;
    REPEAT
      i:=i+1;
      Extract(prog_nam, Length(prog_nam)-Length(script_nam_prog_appendix_arr[i]), Length(script_nam_prog_appendix_arr[i]), prog_nam_appendix);
      appendix_gefunden:=(CompareRS(prog_nam_appendix, script_nam_prog_appendix_arr[i])=equal);
      IF appendix_gefunden THEN
        (*
        Ja, der Programmname endet mit script_nam_prog_appendix_arr[i], also
        machen wir die entsprechenden Initialisierungen:
        *)
        Assign(script_nam_prog_appendix_arr[i], script_nam_prog_appendix);
        Assign(chef_kennw_arr[i], chef_kennwort_default);
        Assign(chefin_kennw_arr[i], chefin_kennwort_default);

        (*
        Auerdem merken wir uns, welche Tabelle es war:
        *)
        tabellen_nummer:=i;
      END;                      (* IF appendix_gefunden *)
    UNTIL ((i=tabellen_anz) OR (appendix_gefunden));

    (*
    Zuletzt erzeugen wir also noch den richtigen script_nam, indem wir
    den betreffenden Appendix an den 'Basisscriptnamen' der ersten
    Tabelle anhngen:
    *)
    Assign(script_nam_prog1, script_nam);
    Append(script_nam_prog_appendix, script_nam);
  END welche_tabelle;


PROCEDURE welcher_server_name;
  VAR
    zwstr:                      String_kurz;

  BEGIN                         (* PROCEDURE welcher_server_name *)
    (*
    Wir sehen uns zunchst an, wie unser SERVER_NAME heit:
    *)
    (*
    Unix.GetEnv(server_name_c, server_name);
    *)
    Unix.GetEnv(server_name_c, server_name, SIZE(server_name));

    (* +++ zum Debuggen, damit z.B. zuhause am localhost auch was geht *)

    Assign('localhost', server_name);

    (*
    07.08.2011: im Moment mssen wir wohl www.dose.muc.de hart codieren
    *)
    (*
    Assign('www.dose.muc.de', server_name);
    *)

    (*
    08.08.2007: Wie angedeutet, gibt's Probleme mit colin2.muc.de. Packen
    wir's einfach bei der Wurzel an: falls colin2.muc.de da ist, machen
    wir einfach www.dose.muc.de draus. Supergeil fr den Moment! Ob's
    irgendwelche unangenehmen Nebenwirkungen gibt, wird sich zeigen.
    *)
    IF (CompareRS(server_name, 'colin2.muc.de')=equal) THEN
      Assign('www.dose.muc.de', server_name);
    END;                        (* IF (CompareRS... *)

    (*
    Die SERVER_SOFTWARE holen wir uns auch noch:
    *)
    server_software_index:=0;   (* Voreinstellung: Apache *)
    Assign('', zwstr);

    (*
    Unix.GetEnv(server_software_c, server_software);
    *)
    Unix.GetEnv(server_software_c, server_software, SIZE(server_software));
    IF (Length(server_software) <> 0) THEN
      (* Extract nur aufrufen, falls nicht Leerstring, sonst Absturz! *)
      Extract(server_software, 0, 5, zwstr);
    END;                        (* IF (Length(server_software) <> 0) *)

    IF (CompareRS(zwstr, 'Roxen')=equal) THEN
      (* Index 1 fr Roxen *)
      server_software_index:=1;
    END;                        (* IF (CompareRS... *)

    (*
    Falls es einen HTTP_HOST gibt (dies ist dann der Fall, wenn der
    Client nicht zu alt ist; siehe auch Kommentar am Programmende),
    werden wir diesen hernehmen. Andernfalls mu halt der SERVER_NAME
    als HTTP_HOST herhalten.

    (*
    Unix.GetEnv(http_host_c, http_host);
    *)
    Unix.GetEnv(http_host_c, http_host, SIZE(http_host));
    IF Length(http_host)=0 THEN
      Assign(server_name, http_host);
    END;                        (* IF Length(http_host)>0 *)
    *)

    (*
    Seit dem Umzug auf colin2 klappt das mit dem HTTP_HOST nicht mehr so, wie
    das sein sollte. Siehe dazu auch Kommentar vom 20.03.2005. Wir nehmen daher
    den Wert von server_name fr http_host her.
    *)
    Assign(server_name, http_host);

    (*
    Machen wir ein paar Voreinstellungen:
    *)
    server_name_index:=0;
    Assign('rudolf', mailto_user);
    Assign('muc.de', mailto_rechner);
    Assign('./~rudolf/', script_path);
    Assign('/s/home/rudolf/lern/www/squash', squash_base_default);

    (*
    Welcher SERVER_NAME war's denn nun?
    *)
    IF (CompareRS(server_name, 'www.muc.de')=equal) THEN
      (* auf www.muc.de einfach noch ein '.cgi' an den script_nam anhngen: *)
      Append('.cgi', script_nam);
    END;                        (* IF (CompareRS... *)

    IF (CompareRS(server_name, 'www.dose.muc.de')=equal) THEN
      (* auf www.dose.muc.de einfach noch ein '.cgi' an den script_nam anhngen: *)
      Append('.cgi', script_nam);
      Assign('./', script_path);
    END;                        (* IF (CompareRS... *)

    IF (CompareRS(server_name, 'dose.muc.de')=equal) THEN
      server_name_index:=1;
      (*
      (* Diesen Namen fr Debugging nehmen: *)
      Assign('squash1_bash', script_nam);
      *)
      Assign('./squash/cgi-bin/', script_path);
      Assign('/home/rudolf/lern/www/squash', squash_base_default);
    END;                        (* IF (CompareRS... *)

    IF (CompareRS(server_name, '190.64.6.48')=equal) THEN
      server_name_index:=2;
      Assign('rudolf.schubert', mailto_user);
      Assign('gdm.de', mailto_rechner);
      Assign('./squash/cgi-bin/', script_path);
      Assign('/home/rudolf/lern/www/squash', squash_base_default);
    END;                        (* IF (CompareRS... *)

    IF (CompareRS(server_name, 'www.rudolf-schubert.dyndns.org')=equal) THEN
      server_name_index:=3;
      Assign('./squash/cgi-bin/', script_path);
      Assign('/home/rudolf/lern/www/squash', squash_base_default);
    END;                        (* IF (CompareRS... *)

    IF (CompareRS(server_name, 'localhost')=equal) THEN
      (* auf localhost einfach noch ein '.cgi' an den script_nam anhngen: *)
      Append('.cgi', script_nam);

      server_name_index:=4;
      (*
      Assign('./squash/cgi-bin/', script_path);
      *)
      Assign('./', script_path);
      Assign('/home/rudolf/lern/www/squash', squash_base_default);
    END;                        (* IF (CompareRS... *)

  END welcher_server_name;


PROCEDURE get_umgebung;
  VAR
    format:                     ConvResults;

  BEGIN                         (* PROCEDURE get_umgebung *)
    (*
    O.k., steng genommen haben wir weiter oben schon mal eine
    Variable (SERVER_NAME) aus der Umgebung abgeholt (sogar zwei
    Variablen, nmlich HTTP_HOST auch noch), um zu entscheiden,
    auf welcher Maschine wir sind. Dennoch hlt uns das nicht davon
    ab, die Routine hier get_umgebung zu nennen...
    *)

    (*
    Unix.GetEnv(request_method_c, request_method);
    *)
    Unix.GetEnv(request_method_c, request_method, SIZE(request_method));
    (*
    Die Requestmethode merken wir uns hier schon mal als Boolschen Wert:
    *)
    request_ist_post:=(CompareRS(request_method, 'POST')=equal);

    (*
    Unix.GetEnv(query_string_c, query_string);
    *)
    Unix.GetEnv(query_string_c, query_string, SIZE(query_string));

    (*
    Unix.GetEnv(squash_base_c, squash_base_v);
    *)
    Unix.GetEnv(squash_base_c, squash_base_v, SIZE(squash_base_v));
    (*
    Falls squash_base_v der Leerstring sein sollte, dann gilt
    folgender Default:
    *)
    IF (CompareRS(squash_base_v, '')=equal) THEN
      Assign(squash_base_default, squash_base_v);
    END;                        (* IF (CompareRS(squash_base_v, '')=equal) *)

    (*
    Unix.GetEnv(content_length_c, content_length);
    *)
    Unix.GetEnv(content_length_c, content_length, SIZE(content_length));
    (*
    Falls content_length nicht der Leerstring ist, versuchen wir eine
    Konversion nach INTEGER zu machen:
    *)
    IF (CompareRS(content_length, '')=equal) THEN content_length_int:=0
    ELSE
      StrToInt(content_length, content_length_int, format);
      IF (NOT (format=strAllRight)) THEN
        content_length_int:=0;
      END;                      (* IF (NOT format... *)
    END;                        (* ELSE (CompareRS... *)

    (*
    Unix.GetEnv(remote_addr_c, remote_addr);
    *)
    Unix.GetEnv(remote_addr_c, remote_addr, SIZE(remote_addr));
  END get_umgebung;


PROCEDURE init_msc;
  VAR
    i:                          INTEGER;
    structTime:                 DateTime;
    structTimeTmp:              DateTime;
    wd:                         CARDINAL;
    hwc:                        CARDINAL;

  BEGIN                         (* PROCEDURE init_msc *)
    (*
    So heit das Lockfile:
    *)
    (*
    Wir haben unser Lockfile in /tmp. War frher auch ganz einfach mit dem
    Debuggen, das File lag wirklich in /tmp. Neuerdings machen die Mnner ja
    immer viele neue Sachen und wir haben eine Zeitlang gebraucht, um zu
    kapieren, dass es in /tmp auf unserem Arch Linux anscheinend aktuell
    z.B. sowas gibt und tatschlich dort drin dann unser Lockfile liegt:
    systemd-private-8c5080cc24d443bdb3aad66306db904e-httpd.service-tKr0yd
    Frs echte Arbeiten nehmen wir also, wie bisher, /tmp/lock_squash' aber
    wenn wir schn einfach debuggen wollen, dann nehmen wir z.B. was Lokales:
    /home/rudolf/tmp/lock_squash. Muss man nur alles wissen, dann gehts einfach!
    Assign('/tmp/lock_squash', lock_name);
    Assign('/home/rudolf/tmp/lock_squash', lock_name);
    *)
    Assign('/tmp/lock_squash', lock_name);

    Append(script_nam_prog_appendix, lock_name);

    (*
    Dies ist der Name unserer Datenbasis:
    *)
    Assign(squash_base_v, season_name);
    Append('/data', season_name);
    Append(script_nam_prog_appendix, season_name);
    Append('/season', season_name);

    (*
    So heit das Chatfile:
    *)
    Assign(squash_base_v, chat_name);
    Append('/data', chat_name);
    Append(script_nam_prog_appendix, chat_name);
    Append('/chat', chat_name);

    (*
    So heit das (temporre) Chatfile fr die neue Mitteilung:
    *)
    Assign(squash_base_v, chat_name_new);
    Append('/data', chat_name_new);
    Append(script_nam_prog_appendix, chat_name_new);
    Append('/chat_new', chat_name_new);

    (*
    So heit das (temporre) Chatfile fr die 'gesamte' Mitteilung:
    *)
    Assign(squash_base_v, chat_name_tmp);
    Append('/data', chat_name_tmp);
    Append(script_nam_prog_appendix, chat_name_tmp);
    Append('/chat_tmp', chat_name_tmp);

    (*
    So heit der Pfad fr unsere Backups:
    *)
    Assign(squash_base_v, bkp_pfad);
    Append('/data', bkp_pfad);
    Append(script_nam_prog_appendix, bkp_pfad);
    Append('/bkps', bkp_pfad);

    (*
    So heit der Pfad fr unsere Log-season-Files:
    *)
    Assign(squash_base_v, log_pfad_s);
    Append('/data', log_pfad_s);
    Append(script_nam_prog_appendix, log_pfad_s);
    Append('/logs/season', log_pfad_s);

    (*
    So heit der Pfad fr unsere Log-html-Files:
    *)
    Assign(squash_base_v, log_pfad_h);
    Append('/data', log_pfad_h);
    Append(script_nam_prog_appendix, log_pfad_h);
    Append('/logs/html', log_pfad_h);

    (*
    Wir merken uns, da das Lockfile noch nicht angelegt ist:
    *)
    lock_angelegt:=FALSE;

    (*
    Bevor wir mit echten Zeiten manipulieren, sei das unsere aktuelle LUKW
    (= lokale Unix Kalenderwoche = LUWN):
    ukwa_str:='1503';
    *)

    (*
    Jetzt nehmen wir die echte LUWN. Nebenbei ermitteln wir dabei die
    aktuelle Zeit zeitagm. Dies ist die echte Unix.Time.
    *)
    zeitagm:=Unix.Time();
    TimeToLcStructTime(zeitagm, structTime);

    (*
    Wir mssen ggf. wissen, ob's vor 9.00 Uhr montags oder donnerstags ist:
    *)
    wd:=LDayOfWeek(structTime);
    IF ((wd=0) AND (structTime.hour<9)) THEN
      vor_9_montag:=TRUE;
    ELSE                        (* IF ((wd=0) AND (structTime.hour<9)) *)
      vor_9_montag:=FALSE;
    END;                        (* ELSE ((wd=0) AND (structTime.hour<9)) *)
    IF ((wd<3) OR ((wd=3) AND (structTime.hour<9))) THEN
      vor_9_donnerstag:=TRUE;
    ELSE                        (* IF ((wd<3)... *)
      vor_9_donnerstag:=FALSE;
    END;                        (* ELSE ((wd<3)... *)

    (*
    Damit Zeitvergleiche mit den user_times spter etwas einfacher sind,
    wird auch sowas wie eine lokale aktuelle Zeit bestimmt: zeitalc
    *)
    structTimeTmp:=structTime;
    WITH structTimeTmp DO
      zone:=0;
      summerTimeFlag:=FALSE;
    END;                        (* WITH structTimeTmp *)
    StructTimeToTime(structTimeTmp, zeitalc);

    (*
    Analog zu zeitalc brauchen wir sowas wie den aktuellen Zeitpunkt
    fr den Ranglisten-Update: +++
    ...wird auf spter verschoben...
    *)

    (*
    Nun also endlich die echte aktuelle LUWN ermitteln. 
    *)
    akt_luwn:=LUWN(structTime);
    CardToStr(akt_luwn, ukwa_str);

    (*
    Auerdem wird das aktuelle Startjahr und die aktuelle Startwoche
    der Saison ermittelt.
    *)
    akt_season_start_jahr:=structTime.year;
    hwc:=LWeekOfYear(structTime);
    akt_season_start_woche:=hwc;

    (*
    user_times vorbesetzten:
    *)
    user_time1:=0;
    user_time2:=0;
    user_time3:=0;

    (*
    Die hidden values kommen auch zu ihrem Recht. Alle werden auf '',
    bzw. '0' gesetzt und die Anzahl ist auch 0:
    *)
    WITH hvr DO
      FOR i:=0 TO max_hv_anz-1 DO
        nam[i]:='';
        val[i]:='0';
      END;                      (* FOR i *)
      anz:=0;
    END;                        (* WITH hvr *)

    (*
    Globaler Schalter, ob an Courtnachbarn berhaupt E-Mail
    geschickt werden soll oder nicht:
    *)
    mail_gewuenscht:=TRUE;

    (*
    Die folgenden Flags sind fr Logging zustndig:
    *)
    slog_gewuenscht:=TRUE;
    hlog_gewuenscht:=FALSE;
    hlog_ist_offen:=FALSE;

    (*
    Vorbelegen, da keine E-Mail zu senden ist:
    *)
    WITH email_info DO
      ob_emails_senden:=FALSE;
      ob_chefs_walten:=FALSE;
      court_index:=0;
      client_ukw:=0;
      belegung_client:=0;
      belegung_client_gast:=0;
      Assign('', belegung_client_gast_nam);
      Assign('', text);
    END;                        (* WITH email_info *)
  END init_msc;


PROCEDURE get_all_pref_nam(pfad, prefix: String;
                           VAR sel_rec_typ_ptr: sel_rec_typ_ptr_typ;
                           VAR max_index: INTEGER);
  VAR
    lcl_ptr:                    sel_rec_typ_ptr_typ;
    dir_ptr:                    ADDRESS;
    ok, gefunden:               BOOLEAN;
    pos:                        CARDINAL;
    dirent_ptr:                 DirEntRecPtrTyp;

  BEGIN                         (* PROCEDURE get_all_pref_nam *)
    NEW(sel_rec_typ_ptr);
    lcl_ptr:=sel_rec_typ_ptr;
    lcl_ptr^.sel_rec_typ_ptr:=NIL;
    Assign('(Auswahl)', lcl_ptr^.schnur);
    lcl_ptr^.zahl:=0;

    (*
    Vorbelegen, als ob kein Backupfile da wre, dann versuchen, bis
    zum Ende des Directories zu lesen. Wie der Name der PROCEDURE
    schon sagt, sollen alle Namen gefunden werden, die mit einem
    bestimmten Prefix beginnen.
    *)
    max_index:=0;

    dir_ptr:=Unix.Opendir(pfad);
    IF dir_ptr<>NIL THEN
      REPEAT
        dirent_ptr:=Unix.Readdir(dir_ptr);
        IF dirent_ptr<>NIL THEN
          (*
          Nur wenn der Filename mit dem gewnschten Prefix beginnt,
          tun wir hier was. GPM-FindNext hilft uns dabei.
          *)
          FindNext(prefix, dirent_ptr^.d_name, 0, gefunden, pos);
          IF (gefunden AND (pos=0)) THEN
            max_index:=max_index+1;
            NEW(lcl_ptr^.sel_rec_typ_ptr);
            lcl_ptr:=lcl_ptr^.sel_rec_typ_ptr;
            lcl_ptr^.sel_rec_typ_ptr:=NIL;
            Assign(dirent_ptr^.d_name, lcl_ptr^.schnur);
            lcl_ptr^.zahl:=max_index;
          END;                  (* IF (gefunden... *)
        END;                    (* IF dirent_ptr<>NIL *)
      UNTIL (dirent_ptr=NIL);
      ok:=Unix.Closedir(dir_ptr);
    END;                        (* IF dir_ptr<>NIL *)
  END get_all_pref_nam;


PROCEDURE anzahl_pref_files(pfad, prefix: String): INTEGER;
  VAR
    hwi:                        INTEGER;
    sel_rec_typ_ptr:            sel_rec_typ_ptr_typ;

  BEGIN                         (* PROCEDURE anzahl_pref_files *)
    get_all_pref_nam(pfad, prefix, sel_rec_typ_ptr, hwi);
    RETURN hwi;
  END anzahl_pref_files;


PROCEDURE try_open_file_with_new_sfx(VAR startpunkt: String;
                                     max_sfx, sfx_len: INTEGER;
                                     VAR neuer_name: String;
                                     VAR cid: ChanId; VAR res: OpenResults);
  VAR
    sfx:                        INTEGER;
    sfx_str:                    String;

  BEGIN                         (* PROCEDURE try_open_file_with_new_sfx *)
    sfx:=0;
    REPEAT
      Assign(startpunkt, neuer_name);
      Append('_', neuer_name);
      IntToStrRS(sfx, sfx_str, sfx_len);
      Append(sfx_str, neuer_name);
      (*
      schon mal sfx inkrementieren, falls eine weitere
      Runde ntig sein sollte:
      *)
      sfx:=sfx+1;

      StreamFile.Open(cid, neuer_name, write, res);
      (*
      show_OpenResult(cid_out, neuer_name, 'try_open_file_with_new_sfx', res);
      *)
    UNTIL ((res=opened) OR (sfx=max_sfx+1));
  END try_open_file_with_new_sfx;


PROCEDURE try_open_season_log_file_with_new_sfx(VAR startpunkt: String;
                                                VAR name_latest: String_mittel;
                                                sfx_len: INTEGER;
                                                VAR neuer_name: String;
                                                VAR cid: ChanId; VAR res: OpenResults);
  VAR
    sfx:                        INTEGER;
    sfx_str:                    String;
    name_latest_start:          String;
    startpunkt_ende:            String;
    gefunden:                   BOOLEAN;
    pos:                        CARDINAL;
    len_name_latest:            INTEGER;
    format:                     ConvResults;

  BEGIN                         (* PROCEDURE try_open_season_log_file_with_new_sfx *)
    (*
    Wenn name_latest tatschlich eines unserer Logfiles sein soll, dann
    sollten am 19 Zeichen 'log_datum_zeit'-String hinten am Namen ein
    Underscore und sfx_len Ziffern hngen. Wir fordern also ganz 'hart',
    dass name_latest exakt 19 + 1 + sfx_len Zeichen haben muss. Die
    letzten (1 + sfx_len) Zeichen mssen wir aber erst mal abschneiden:
    *)
    len_name_latest := Length(name_latest);
    IF len_name_latest <> (19 + 1 + sfx_len) THEN
      (*
      da gibt's bestimmt kein Matching, d.h. wir knnen getrost mit
      Index 0 arbeiten:
      *)
      sfx := 0;
    ELSE                        (* IF Length(name_latest) < (1 + sfx_len) *)
      (*
      name_latest hat korrekte Lnge, holen wir uns die ersten 19 Zeichen ab:
      *)
      Extract(name_latest, 0, 19, name_latest_start);

      (*
      jetzt holen wir uns die letzen 19 Zeichen aus startpunkt ab. Es ist
      sicher, dass startpunkt mindestens 19 Zeichen lang ist, d.h. wir
      mssen hier keine Prfung machen:
      *)
      Extract(startpunkt, Length(startpunkt) - 19, 19, startpunkt_ende);

      (*
      endlich die 'log_datum_zeit'-Strings vergleichen:
      *)
      IF (CompareRS(name_latest_start, startpunkt_ende)=equal) THEN
        (*
        Namen sind gleich, d.h. jetzt mssen wir die letzten sfx_len Zeichen
        von name_latest holen und etwa in einen INTEGER umwandeln:
        *)
        Extract(name_latest, len_name_latest - sfx_len, sfx_len, sfx_str);
        StrToInt(sfx_str, sfx, format);

        (*
        Falls es wider Erwarten Probleme bei der Konversion gegeben hat,
        dann arbeiten wir eben einfach mit Index 0. Im anderen Fall
        inkrementieren wir den gefundenen Index:
        *)
        IF (NOT (format=strAllRight)) THEN
          sfx:=0;
        ELSE                    (* IF (NOT format... *)
          (*
          Wir mssen an dieser Stelle dafr sorgen, dass sfx nicht grer wird
          als (10 hoch sfx_len) - 1, denn sonst wird unser Suffix lnger als
          sfx_len. Wir hatten mal die Idee, ein Defaultlogfile mit
          construct_default_log_season_file() anzulegen, falls das mit den
          Indizes hier nicht klappt. Das ist aber bld, denn dabei ist nicht
          viel gewonnen. Es ist nmlich egal, ob wir so ein Defaultlogfile
          (mehrfach) berschreiben oder eines der Files mit Index. Wir
          entscheiden uns hier: notfalls bleiben wir beim grtmglichen
          Index einfach stehen. brigens: nachdem wir der Meinung waren, dass
          der Compiler aus der Konstanten ohne Libraryaufruf kein
          log_file_sfx_max machen kann, haben wir halt einfach zustzlich
          zu sfx_len auch noch log_file_sfx_max direkt als Konstante angelegt
          statt (10 hoch sfx_len) - 1 zu rechnen...
          *)
          IF sfx<log_file_sfx_max THEN
            sfx:=sfx+1;
          END;                  (* IF sfx<log_file_sfx_max *)
        END;                    (* ELSE (NOT format... *)
      ELSE                      (* IF (CompareRS(name_latest_start, startpunkt_ende)=equal) *)
        (*
        Namen sind nicht gleich, d.h. wir knnen getrost mit Index 0 arbeiten:
        *)
        sfx := 0;
      END;                      (* ELSE (CompareRS(name_latest_start, startpunkt_ende)=equal) *)
    END;                        (* ELSE Length(name_latest) < (1 + sfx_len) *)

    Assign(startpunkt, neuer_name);
    Append('_', neuer_name);
    IntToStrRS(sfx, sfx_str, sfx_len);
    Append(sfx_str, neuer_name);

    StreamFile.Open(cid, neuer_name, write, res);
    (*
    show_OpenResult(cid_out, neuer_name, 'try_open_season_log_file_with_new_sfx', res);
    *)
  END try_open_season_log_file_with_new_sfx;


PROCEDURE try_open_hlog_channel;
  VAR
    html_name_log_base:         String;
    html_name_log:              String;
    basename:                   String;
    res:                        OpenResults;
    fehler:                     INTEGER;

  PROCEDURE construct_default_log_html_file;
    BEGIN                       (* PROCEDURE construct_default_log_html_file *)
      Assign(log_pfad_h, html_name_log);
      Append('/', html_name_log);
      Append(log_prefix, html_name_log);
      Append('default', html_name_log);
    END construct_default_log_html_file;

  BEGIN                         (* PROCEDURE try_open_hlog_channel *)
    (*
    Hier spicken wir ein bichen bei try_put_season_data, um einen
    Channel aufzukriegen. Der wesentliche Unterschied zwischen dort
    und hier ist, da wir dort vor dem Schreiben des Logs das soeben
    geffnete File wieder geschlossen hatten, wir also effektiv nur
    die Existenz, genauer die Nicht-Existenz des neu zu erzeugenden
    Log-season-Files sicherstellen wollten und wir hier aber nach
    erfolgreichem ffnen des Channels mit eben diesem Channel weiter
    arbeiten wollen.
    *)

    Assign(log_pfad_h, html_name_log_base);
    (*
    Neuerdings schieben wir eine weitere Directory-Zwischenebene
    ein. Wir mssen also erst einmal zusehen, da ein Directory
    des aktuellen Tages existiert, bevor wir dann ggf. endlich ein
    Logfile anlegen knnen. Da wir hier nicht notwendigerweise
    im gelockten Zustand sind, knnen wir theoretisch nicht mit
    so etwas wie 'directory_existiert' arbeiten, um zunchst zu
    prfen, ob unser gewnschtes Directory bereits da ist und
    dann ggf. eines anlegen. Tatschlich ist uns am Ende aber
    vllig egal, wer das Directory angelegt hat. Hauptsache es
    _ist_ angelegt und wir knnen unsere Logfiles darin unter-
    bringen. Daher werden wir in jedem Fall erst mal versuchen,
    eines anzulegen, egal, ob vielleicht schon lange eines da
    war oder ein anderer ein paar Nanosekunden vorher eines
    erzeugt hat. Nach unserem Versuch sehen wir dann natrlich
    nach, ob ein Directory da ist und handeln dann entsprechend:
    Ist eines da, werden wir versuchen, endlich unser Logfile zu ffnen.
    Ist wider Erwarten keines da, setzen wir eben hlog_ist_offen
    auf FALSE und ziehen beleidigt ab.
    *)
    construct_datename('/date_', basename);
    Append(basename, html_name_log_base);

    fehler:=Unix.Mkdir(html_name_log_base, 0FFFFFFFFH);

    IF directory_existiert(html_name_log_base) THEN
      IF anzahl_pref_files(html_name_log_base, log_prefix)<max_log_htm_file_anz THEN
        construct_timename(log_prefix, basename);
        Append('/', html_name_log_base);
        Append(basename, html_name_log_base);

        try_open_file_with_new_sfx(html_name_log_base,
                                   max_log_htm_file_anz-1, log_file_sfx_len,
                                   html_name_log,
                                   cid_log, res);
        IF res=opened THEN
          (* nichts weiter *)
        ELSE                    (* IF res=opened *)
          construct_default_log_html_file;
          StreamFile.Open(cid_log, html_name_log, write+old, res);
        END;                    (* ELSE res=opened *)
      ELSE                      (* IF anzahl_pref_files... *)
        construct_default_log_html_file;
        StreamFile.Open(cid_log, html_name_log, write+old, res);
      END;                      (* ELSE anzahl_pref_files... *)
      (*
      show_OpenResult(cid_out, html_name_log, 'try_open_hlog_channel', res);
      *)
      (*
      Am Ende sehen wir nach, ob irgend ein Log-Channel geffnet
      werden konnte und setzen hlog_ist_offen entsprechend:
      *)
      IF res=opened THEN
        hlog_ist_offen:=TRUE;
      ELSE                      (* IF res=opened *)
        hlog_ist_offen:=FALSE;
      END;                      (* ELSE res=opened *)
    ELSE                        (* IF directory_existiert(... *)
      hlog_ist_offen:=FALSE;
    END;                        (* ELSE directory_existiert(... *)
  END try_open_hlog_channel;


PROCEDURE some_changes(index, wert, minimum: INTEGER);
  VAR
    zwstr:                      String;

  BEGIN                         (* PROCEDURE some_changes *)
    WITH input[index] DO
      IntToStr(wert, zwstr);
      PutGPMString(zwstr, index);
      ob_integ:=1;
      value:=wert;
      min:=minimum;
    END;                        (* WITH input[index] *)
  END some_changes;


PROCEDURE init_default_inputs1;
  VAR
    i, j, i_start:              INTEGER;
    zwstr1, zwstr2:             String;

  BEGIN                         (* PROCEDURE init_default_inputs1 *)
    (*
    Erst:
    alle INPUT (String-)VALUEs-pointer mit NIL belegen,
    alle INPUT (String-)NAMEs und (String-)VALUEs mit Dummywerten belegen,
    die in INTEGERs umzuwandelnden INPUT-Parameter als solche markieren
    und die (INTEGER-)min- und -max-Werte auf 0 setzen:
    Bemerkung: die INPUT (String-)NAMEs initialisieren wir hier nur
    pedantischerweise. Sie werden eigentlich alle 'Dann:' umdefiniert.
    *)
    FOR i:=ii00 TO max_param_anz-1 DO
      WITH input[i] DO

        str_rec_typ_ptr:=NIL;
        IntToStr(i, zwstr1);
        zwstr2:='param';
        Append(zwstr1, zwstr2);
        Assign(zwstr2, name_strr);
        PutGPMString('0', i);

        (*
        Alle Strings markieren, als sollten sie nur als String interpretiert
        werden:
        *)
        ob_integ:=0;

        (*
        Trotzdem alle (INTEGER)-VALUEs mit Dummywerten belegen:
        *)
        value:=0;

        (*
        *Alle* min und max auf 0 setzen (, auch wenn spter nicht alle INPUTs
        einen zugeordneten INTEGER-Wert bekommen):
        *)
        min:=0;
        max:=0;
      END;                      (* WITH input[i] *)
    END;                        (* FOR i *)

    (*
    Dann:
    machen wir individuelle nderungen und markieren insbesondere alle
    INPUT-Parameter, die einen INTEGER-Wert bekommen als solche.
    *)
    WITH input[ii00] DO
      name_strr:='label';
    END;                        (* WITH input[ii00] *)

    WITH input[ii01] DO
      name_strr:='ukw';
      PutGPMString(ukwa_str, ii01);
      ob_integ:=1;
    END;                        (* WITH input[ii01] *)

    WITH input[ii02] DO
      name_strr:='unser_court_index';
      ob_integ:=1;
    END;                        (* WITH input[ii02] *)

    WITH input[ii03] DO
      name_strr:='spieler_index';
      ob_integ:=1;
    END;                        (* WITH input[ii03] *)

    WITH input[ii04] DO
      name_strr:='action';
      ob_integ:=1;
    END;                        (* WITH input[ii04] *)

    WITH input[ii05] DO
      name_strr:='geheim1';
      PutGPMString('', ii05);
    END;                        (* WITH input[ii05] *)

    WITH input[ii06] DO
      name_strr:='court_belegung_alt';
      ob_integ:=1;
    END;                        (* WITH input[ii06] *)

    WITH input[ii07] DO
      name_strr:='geheim2';
    END;                        (* WITH input[ii07] *)

    WITH input[ii08] DO
      name_strr:='geheim3';
    END;                        (* WITH input[ii08] *)

    WITH input[ii09] DO
      name_strr:='der_radio';
      ob_integ:=1;
    END;                        (* WITH input[ii09] *)

    WITH input[ii10] DO
      name_strr:='zeil_anz';
      some_changes(ii10, min_zeil_anz, min_zeil_anz);
    END;                        (* WITH input[ii10] *)

    WITH input[ii11] DO
      name_strr:='spalt_anz';
      some_changes(ii11, min_spalt_anz, min_spalt_anz);
    END;                        (* WITH input[ii11] *)

    WITH input[ii12] DO
      name_strr:='spieler_anz';
      some_changes(ii12, min_spieler_anz, min_spieler_anz);
    END;                        (* WITH input[ii12] *)

    WITH input[ii13] DO
      name_strr:='season_start_jahr';
      some_changes(ii13, min_season_start_jahr, min_season_start_jahr);
    END;                        (* WITH input[ii13] *)

    WITH input[ii14] DO
      name_strr:='season_start_woche';
      some_changes(ii14, min_season_start_woche, min_season_start_woche);
    END;                        (* WITH input[ii14] *)

    WITH input[ii15] DO
      name_strr:='wochen_anz';
      some_changes(ii15, min_wochen_anz, min_wochen_anz);
    END;                        (* WITH input[ii15] *)

    WITH input[ii16] DO
      name_strr:='mitteilung';
      PutGPMString('', ii16);
    END;                        (* WITH input[ii16] *)

    WITH input[ii17] DO
      name_strr:='bkp_nam';
      ob_integ:=1;
    END;                        (* WITH input[ii17] *)

    WITH input[ii18] DO
      name_strr:='gast_nam';
    END;                        (* WITH input[ii18] *)

    WITH input[ii19] DO
      name_strr:='forderung';
      ob_integ:=1;
    END;                        (* WITH input[ii19] *)

    WITH input[ii20] DO
      name_strr:='forderer';
      ob_integ:=1;
    END;                        (* WITH input[ii20] *)

    WITH input[ii21] DO
      name_strr:='geforderter';
      ob_integ:=1;
    END;                        (* WITH input[ii21] *)

    WITH input[ii22] DO
      name_strr:='pers_data';
    END;                        (* WITH input[ii22] *)

    WITH input[ii23] DO
      name_strr:='auswahl';
      ob_integ:=1;
    END;                        (* WITH input[ii23] *)

    WITH input[ii24] DO
      name_strr:='spieler_index_alt';
      ob_integ:=1;
    END;                        (* WITH input[ii24] *)

    WITH input[ii25] DO
      name_strr:='show_future_kw';
      ob_integ:=1;
    END;                        (* WITH input[ii25] *)
 
    WITH input[ii26] DO
      name_strr:='bitleiste';
      ob_integ:=1;
    END;                        (* WITH input[ii26] *)

    WITH input[ii27] DO
      name_strr:='zusatz_heading';
    END;                        (* WITH input[ii27] *)
 
    i_start:=max_basic_param_anz;
    FOR i:=0 TO max_zeil_anz-1 DO
      WITH input[i+i_start] DO
        IntToStr(i+1, zwstr1);
        name_strr:='tag_zeile';
        Append(zwstr1, name_strr);
        ob_integ:=1;
      END;                      (* WITH input[... *)
    END;                        (* FOR i *)

    i_start:=max_basic_param_anz+max_zeil_anz;
    FOR i:=0 TO max_zeil_anz-1 DO
      WITH input[i+i_start] DO
        IntToStr(i+1, zwstr1);
        name_strr:='court_zeile';
        Append(zwstr1, name_strr);
      END;                      (* WITH input[... *)
    END;                        (* FOR i *)

    i_start:=max_basic_param_anz+2*max_zeil_anz;
    FOR i:=0 TO max_spalt_anz-1 DO
      WITH input[i+i_start] DO
        IntToStr(i+1, zwstr1);
        name_strr:='spalte';
        Append(zwstr1, name_strr);
        ob_integ:=1;
      END;                      (* WITH input[... *)
    END;                        (* FOR i *)

    FOR i:=0 TO max_zeil_anz-1 DO
      IntToStr(i+1, zwstr1);
      i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
               i*max_spalt_anz;
      FOR j:=0 TO max_spalt_anz-1 DO
        IntToStr(j+1, zwstr2);
        WITH input[j+i_start] DO
          name_strr:='z';
          Append(zwstr1, name_strr);
          Append('s', name_strr);
          Append(zwstr2, name_strr);
          ob_integ:=1;
        END;                    (* WITH input[... *)
      END;                      (* FOR j *)
    END;                        (* FOR i *)

    i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
             max_zeil_anz*max_spalt_anz;
    FOR i:=0 TO max_spieler_anz-1 DO
      WITH input[i+i_start] DO
        IntToStr(i+1, zwstr1);
        name_strr:='spn';       (* Spielername *)
        Append(zwstr1, name_strr);
      END;                      (* WITH input[... *)
    END;                        (* FOR i *)

    i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
             max_zeil_anz*max_spalt_anz+max_spieler_anz;
    FOR i:=0 TO max_spieler_anz-1 DO
      WITH input[i+i_start] DO
        IntToStr(i+1, zwstr1);
        name_strr:='spar';      (* Spielerart *)
        Append(zwstr1, name_strr);
        ob_integ:=1;
      END;                      (* WITH input[... *)
    END;                        (* FOR i *)

    i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
             max_zeil_anz*max_spalt_anz+2*max_spieler_anz;
    FOR i:=0 TO max_spieler_anz-1 DO
      WITH input[i+i_start] DO
        IntToStr(i+1, zwstr1);
        name_strr:='spak';      (* Spieler aktiv? *)
        Append(zwstr1, name_strr);
        ob_integ:=1;
      END;                      (* WITH input[... *)
    END;                        (* FOR i *)

    i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
             max_zeil_anz*max_spalt_anz+3*max_spieler_anz;
    FOR i:=0 TO max_spieler_anz-1 DO
      WITH input[i+i_start] DO
        IntToStr(i+1, zwstr1);
        name_strr:='spk';       (* Spielerkennwort *)
        Append(zwstr1, name_strr);
      END;                      (* WITH input[... *)
    END;                        (* FOR i *)

    i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
             max_zeil_anz*max_spalt_anz+4*max_spieler_anz;
    FOR i:=0 TO max_spieler_anz-1 DO
      WITH input[i+i_start] DO
        IntToStr(i+1, zwstr1);
        name_strr:='spkg';      (* Spielerkennwort gltig? *)
        Append(zwstr1, name_strr);
        ob_integ:=1;
      END;                      (* WITH input[... *)
    END;                        (* FOR i *)

    i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
             max_zeil_anz*max_spalt_anz+5*max_spieler_anz;
    FOR i:=0 TO max_wochen_anz-1 DO
      WITH input[i+i_start] DO
        IntToStr(i+1, zwstr1);
        name_strr:='vor';       (* Wie lange vorher? *)
        Append(zwstr1, name_strr);
        ob_integ:=1;
      END;                      (* WITH input[... *)
    END;                        (* FOR i *)

    i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
             max_zeil_anz*max_spalt_anz+5*max_spieler_anz+
             max_wochen_anz;
    FOR i:=0 TO max_spieler_anz-1 DO
      WITH input[i+i_start] DO
        IntToStr(i+1, zwstr1);
        name_strr:='sppd';      (* Spielerpersdata *)
        Append(zwstr1, name_strr);
      END;                      (* WITH input[... *)
    END;                        (* FOR i *)

    i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
             max_zeil_anz*max_spalt_anz+5*max_spieler_anz+
             max_wochen_anz+max_spieler_anz;
    FOR i:=0 TO max_spieler_anz-1 DO
      WITH input[i+i_start] DO
        IntToStr(i+1, zwstr1);
        name_strr:='spr';       (* Spielerrang *)
        Append(zwstr1, name_strr);
        ob_integ:=1;
      END;                      (* WITH input[... *)
    END;                        (* FOR i *)

    i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
             max_zeil_anz*max_spalt_anz+5*max_spieler_anz+
             max_wochen_anz+2*max_spieler_anz;
    FOR i:=0 TO max_spieler_anz-1 DO
      WITH input[i+i_start] DO
        IntToStr(i+1, zwstr1);
        name_strr:='spdb';      (* Spieler 'days before' *)
        Append(zwstr1, name_strr);
        ob_integ:=1;
      END;                      (* WITH input[... *)
    END;                        (* FOR i *)

  END init_default_inputs1;


PROCEDURE init_default_inputs2;
  VAR
    i, i_start:                 INTEGER;

  BEGIN                         (* PROCEDURE init_default_inputs2 *)
    (*
    Erst wenn season-Daten da sind, werden max-Werte und ggf. auch neue
    min-Werte eingetragen. Einige min-/max-Werte sind fix, aber etliche
    sind auch von den season-Daten abhngig. Daher konnte die Initiali-
    sierung nicht schon bei init_default_inputs1 erfolgen. Wird natrlich
    nur mit den INPUT-Parametern gemacht, die einen INTEGER-Wert bekommen.
    *)

    WITH sd1 DO

      WITH input[ii01] DO       (* ukw *)
        (*
        Fr die ukw brauchen wir hier eigentlich keine Obergrenze, weil
        die in check_ukw bzw. advance_ukw sowieso berprft wird. Also wird
        das Maximum auf unendlich gesetzt.
        *)
        max:=unendlich;
      END;                      (* WITH input[ii01] *)

      WITH input[ii02] DO       (* unser_court_index *)
        max:=2*uns_courts_anz-1;
        IF max<0 THEN max:=0 END;
      END;                      (* WITH input[ii02] *)

      WITH input[ii03] DO       (* spieler_index *)
        max:=spieler_anz+ssa-1; (* ssa mehr wegen 'Spezialspielern' *)
      END;                      (* WITH input[ii03] *)

      WITH input[ii04] DO       (* action *)
        max:=unendlich;         (* eigentlich berflssig, weil sowieso auf *)
                                (* unerwartete Aktion geprft wird *)
      END;                      (* WITH input[ii04] *)

      WITH input[ii06] DO       (* court_belegung_alt *)
        max:=spieler_anz+ssa-1;
      END;                      (* WITH input[ii06] *)

      WITH input[ii09] DO       (* der_radio *)
        max:=max_radio;
      END;                      (* WITH input[ii09] *)

      WITH input[ii10] DO       (* zeil_anz *)
        max:=max_zeil_anz;
      END;                      (* WITH input[ii10] *)

      WITH input[ii11] DO       (* spalt_anz *)
        max:=max_spalt_anz;
      END;                      (* WITH input[ii11] *)

      WITH input[ii12] DO       (* spieler_anz *)
        max:=max_spieler_anz;
        some_changes(ii12, spieler_anz, spieler_anz);
      END;                      (* WITH input[ii12] *)

      WITH input[ii13] DO       (* (season_start_jahr) *)
        max:=max_season_start_jahr;
      END;                      (* WITH input[ii13] *)

      WITH input[ii14] DO       (* (season_start_woche) *)
        max:=max_season_start_woche;
      END;                      (* WITH input[ii14] *)

      WITH input[ii15] DO       (* wochen_anz *)
        max:=max_wochen_anz;
      END;                      (* WITH input[ii15] *)

      WITH input[ii17] DO       (* bkp_nam *)
        max:=unendlich;
      END;                      (* WITH input[ii17] *)

      WITH input[ii19] DO       (* forderung *)
        max:=max_check;
      END;                      (* WITH input[ii19] *)

      WITH input[ii20] DO       (* forderer *)
        max:=spieler_anz;
      END;                      (* WITH input[ii20] *)

      WITH input[ii21] DO       (* geforderter *)
        max:=spieler_anz;
      END;                      (* WITH input[ii21] *)

      WITH input[ii23] DO       (* auswahl *)
        max:=spieler_anz+ssa-1;
      END;                      (* WITH input[ii23] *)

      WITH input[ii24] DO       (* spieler_index_alt *)
        max:=spieler_anz+ssa-1;
      END;                      (* WITH input[ii24] *)

      WITH input[ii25] DO       (* show_future_kw *)
        max:=max_jahr_wochen_zugriff;
        some_changes(ii25, sd1.show_future_kw, min);
      END;                      (* WITH input[ii25] *)

      WITH input[ii26] DO       (* bitleiste *)
        max:=max_bitleiste;
      END;                      (* WITH input[ii26] *)

      i_start:=max_basic_param_anz;
      FOR i:=0 TO max_zeil_anz-1 DO
        WITH input[i+i_start] DO
          max:=wochentage_anz;
        END;                      (* WITH input[... *)
      END;                        (* FOR i *)

      i_start:=max_basic_param_anz+2*max_zeil_anz;
      FOR i:=0 TO max_spalt_anz-1 DO
        WITH input[i+i_start] DO
          max:=zehnmin_anz;
        END;                      (* WITH input[... *)
      END;                        (* FOR i *)

      i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz;
      FOR i:=0 TO max_zeil_anz*max_spalt_anz-1 DO
        WITH input[i+i_start] DO
          max:=max_check;
        END;                      (* WITH input[... *)
      END;                        (* FOR i *)

      i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
               max_zeil_anz*max_spalt_anz+max_spieler_anz;
      FOR i:=0 TO max_spieler_anz-1 DO
        WITH input[i+i_start] DO
          max:=max_check;       (* max fr Spielerart *)
        END;                    (* WITH input[... *)
      END;                      (* FOR i *)

      i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
               max_zeil_anz*max_spalt_anz+2*max_spieler_anz;
      FOR i:=0 TO max_spieler_anz-1 DO
        WITH input[i+i_start] DO
          max:=max_check;       (* max fr Spieler aktiv? *)
        END;                    (* WITH input[... *)
      END;                      (* FOR i *)

      i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
               max_zeil_anz*max_spalt_anz+4*max_spieler_anz;
      FOR i:=0 TO max_spieler_anz-1 DO
        WITH input[i+i_start] DO
          max:=max_check;       (* max fr Spielerkennwort gltig? *)
        END;                    (* WITH input[... *)
      END;                      (* FOR i *)

      i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
               max_zeil_anz*max_spalt_anz+5*max_spieler_anz;
      FOR i:=0 TO max_wochen_anz-1 DO
        WITH input[i+i_start] DO
          max:=max_jahr_wochen_zugriff; (* max fr jahr_wochen_zugriff *)
        END;                    (* WITH input[... *)
      END;                      (* FOR i *)

      i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
               max_zeil_anz*max_spalt_anz+5*max_spieler_anz+
               max_wochen_anz+max_spieler_anz;
      FOR i:=0 TO max_spieler_anz-1 DO
        WITH input[i+i_start] DO
          max:=spieler_anz;     (* max fr Rang *)
        END;                    (* WITH input[... *)
      END;                      (* FOR i *)

      i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
               max_zeil_anz*max_spalt_anz+5*max_spieler_anz+
               max_wochen_anz+2*max_spieler_anz;
      FOR i:=0 TO max_spieler_anz-1 DO
        WITH input[i+i_start] DO
          max:=unendlich;       (* max fr "Spieler 'days before'" *)
        END;                    (* WITH input[... *)
      END;                      (* FOR i *)

    END;                        (* WITH sd1 *)
  END init_default_inputs2;


PROCEDURE init1;
  BEGIN                         (* PROCEDURE init1 *)
    init_std_channels;
    init_signals;
    init_ausstieg;
    init_http_connection(cid_out);
    welche_tabelle;
    welcher_server_name;
    get_umgebung;
    init_msc;
    IF hlog_gewuenscht THEN try_open_hlog_channel END;
    reset_season_data(sd1);
    init_default_inputs1;
  END init1;


PROCEDURE get_globals(cid: ChanId; VAR sd: sd_rec_typ; VAR ok: BOOLEAN);
  BEGIN                         (* PROCEDURE get_globals *)
    WITH sd DO
      ReadInt(cid, sea_version);
      SkipLine(cid);
      (*
      Falls die vorliegende Version des season-Files nicht mit der
      erwarteten bereinstimmt, sieht's nicht gut aus.
      *)
      IF sea_version=sea_version_akt THEN
        ReadInt(cid, site_counter);
        SkipLine(cid);
        ReadInt(cid, chat_counter);
        SkipLine(cid);
        ReadInt(cid, sea_state);
        SkipLine(cid);
        ReadInt(cid, zeil_anz);
        SkipLine(cid);
        ReadInt(cid, spalt_anz);
        SkipLine(cid);
        ReadInt(cid, spieler_anz);
        SkipLine(cid);
        ReadInt(cid, season_start);
        SkipLine(cid);
        ReadInt(cid, wochen_anz);
        SkipLine(cid);
        ReadInt(cid, show_future_kw);
        SkipLine(cid);
        ReadInt(cid, bitleiste);
        SkipLine(cid);
        ReadString(cid, zusatz_heading);
        SkipLine(cid);
        SkipLine(cid);
      ELSE                      (* IF sea_version=sea_version_akt *)
        ok:=FALSE;
      END;                      (* ELSE sea_version=sea_version_akt *)
    END;                        (* WITH sd *)
  END get_globals;


PROCEDURE get_uns_courts(cid: ChanId; VAR sd: sd_rec_typ);
  VAR
    i:                          INTEGER;

  BEGIN                         (* PROCEDURE get_uns_courts *)
    WITH sd DO
      (*
      Die 'uns-indizes' einlesen:
      *)
      ReadInt(cid, uns_courts_anz);
      SkipLine(cid);
      FOR i:=0 TO 2*(uns_courts_anz-1) BY 2 DO
        ReadInt(cid, geschrumpfter_index[i]);
        geschrumpfter_index[i+1]:=geschrumpfter_index[i]+1;
        uns_court[geschrumpfter_index[i]]:=i;
        uns_court[geschrumpfter_index[i+1]]:=i+1;
        SkipLine(cid);
      END;                      (* FOR i *)
      SkipLine(cid);
    END;                        (* WITH sd *)
  END get_uns_courts;


PROCEDURE get_wochentage_und_courts(cid: ChanId; VAR sd: sd_rec_typ);
  VAR
    i:                          INTEGER;

  BEGIN                         (* PROCEDURE get_wochentage_und_courts *)
    WITH sd DO
      (*
      Die 'uns-wochentage' und -courts einlesen:
      *)
      FOR i:=0 TO (zeil_anz-1) DO
        ReadInt(cid, wochentag[i]);
        SkipLine(cid);
        ReadString(cid, court[i]);
        SkipLine(cid);
      END;                      (* FOR i *)
      SkipLine(cid);
    END;                        (* WITH sd *)
  END get_wochentage_und_courts;


PROCEDURE get_uhrzeiten(cid: ChanId; VAR sd: sd_rec_typ);
  VAR
    i:                          INTEGER;

  BEGIN                         (* PROCEDURE get_uhrzeiten *)
    WITH sd DO
      (*
      Die 'uns-uhrzeiten' einlesen:
      *)
      FOR i:=0 TO (spalt_anz-1) DO
        ReadInt(cid, uhrzeit[i]);
        SkipLine(cid);
      END;                      (* FOR i *)
      SkipLine(cid);
    END;                        (* WITH sd *)
  END get_uhrzeiten;


PROCEDURE get_spieler(cid: ChanId; VAR sd: sd_rec_typ);
  VAR
    i:                          INTEGER;
    index_str, zwstr:           String;

  BEGIN                         (* PROCEDURE get_spieler *)
    WITH sd DO
      (*
      Alle Namen, Persdata, Kennwrter, Spielerarten,
      'Spieleraktivitten', 'Tage voraus', Rnge und
      Remoteadressen einlesen:
      *)
      FOR i:=0 TO spieler_anz+ssa-1 DO
        ReadString(cid, spieler_name[i]);
        SkipLine(cid);
        ReadString(cid, spieler_pers_data[i]);
        SkipLine(cid);
        ReadString(cid, spieler_kennwort[i]);
        SkipLine(cid);
        ReadInt(cid, spieler_art[i]);
        ReadInt(cid, spieler_aktiv[i]);
        ReadInt(cid, spieler_rang[i]);
        ReadInt(cid, max_day_delta[i]);
        SkipLine(cid);
        ReadString(cid, spieler_remote_addr[i]);
        SkipLine(cid);
      END;                      (* FOR i *)
      SkipLine(cid);
    END;                        (* WITH sd *)
  END get_spieler;


PROCEDURE get_court_belegung(cid: ChanId; VAR sd: sd_rec_typ);
  VAR
    i, k:                       INTEGER;

  BEGIN                         (* PROCEDURE get_court_belegung *)
    WITH sd DO
      (*
      Alle Wochen (mit Zugriffszeit) lesen:
      *)
      FOR i:=0 TO wochen_anz-1 DO
        ReadInt(cid, jahr_wochen_zugriff[i]);
        SkipLine(cid);
        FOR k:=0 TO uns_courts_anz-1 DO
          ReadInt(cid, jahr_forderung[i, geschrumpfter_index[2*k] DIV 2]);
          SkipLine(cid);

          ReadInt(cid, jahr_court_belegung[i, geschrumpfter_index[2*k]]);
          ReadInt(cid, jahr_court_belegung_gast[i, geschrumpfter_index[2*k]]);
          SkipLine(cid);
          ReadString(cid, jahr_court_belegung_gast_nam[i, geschrumpfter_index[2*k]]);
          SkipLine(cid);

          ReadInt(cid, jahr_court_belegung[i, geschrumpfter_index[2*k+1]]);
          ReadInt(cid, jahr_court_belegung_gast[i, geschrumpfter_index[2*k+1]]);
          SkipLine(cid);
          ReadString(cid, jahr_court_belegung_gast_nam[i, geschrumpfter_index[2*k+1]]);
          SkipLine(cid);
        END;                    (* FOR k *)
        SkipLine(cid);
      END;                      (* FOR i *)
    END;                        (* WITH sd *)
  END get_court_belegung;


PROCEDURE get_season_data(season_name: ARRAY OF CHAR; VAR sd: sd_rec_typ; 
                          VAR ok: BOOLEAN; VAR text: ARRAY OF CHAR);
  VAR
    cid:                        ChanId;
    res:                        OpenResults;

  BEGIN                         (* PROCEDURE get_season_data *)
    StreamFile.Open(cid, season_name, read, res);
    (*
    show_OpenResult(cid_out, season_name, 'get_season_data', res);
    *)
    ok:=TRUE;
    Assign('', text);
    IF res=opened THEN
      SkipLine(cid);
      get_globals(cid, sd, ok);
      IF ok THEN
        SkipLine(cid);
        get_uns_courts(cid, sd);

        SkipLine(cid);
        get_wochentage_und_courts(cid, sd);

        SkipLine(cid);
        get_uhrzeiten(cid, sd);

        SkipLine(cid);
        get_spieler(cid, sd);

        SkipLine(cid);
        get_court_belegung(cid, sd);
      ELSE                      (* IF ok *)
        Assign(' (falsche Version)', text);
      END;                      (* ELSE ok *)
      StreamFile.Close(cid);
    ELSE                        (* IF res=opened *)
      ok:=FALSE;
      Assign(' (ffnen nicht mglich)', text);
    END;                        (* ELSE res=opened *)
  END get_season_data;


PROCEDURE check_ukw(VAR sd: sd_rec_typ);
  VAR
    hwi:                        INTEGER;
    format:                     ConvResults;
    zwstr:                      String;

  BEGIN                         (* PROCEDURE check_ukw *)
    hwi:=input[ii01].value;

    WITH sd DO
      IF (hwi>(season_start+wochen_anz-1)) THEN
        hwi:=season_start+wochen_anz-1 END;
      IF hwi<season_start THEN
        hwi:=season_start END;
    END;                        (* WITH sd *)

    IntToStr(hwi, zwstr);

    WITH input[ii01] DO
      PutGPMString(zwstr, ii01);
      value:=hwi;
    END;                        (* WITH input[ii01] *)
  END check_ukw;


PROCEDURE advance_ukw(VAR sd: sd_rec_typ);
  VAR
    hwi:                        INTEGER;
    hwi2:                       INTEGER;
    zwstr:                      String;

  PROCEDURE mindestens_ein_button_da(): BOOLEAN;
    VAR
      button:                   BOOLEAN;
      zeile, spalte:            INTEGER;
      court_index:              INTEGER;

    BEGIN                       (* PROCEDURE mindestens_ein_button_da *)
      button:=FALSE;

      (*
      Da machen wir jetzt gar nicht lang rum, sondern klappern hnlich wie
      in schreib_restliche_reihen die komplette Tabelle ab. O.k., wir knnten
      von hinten anfangen, testen, ob es ein uns_court ist und dann halt
      entsprechend abbrechen, wenn wir den ersten uns_court gefunden haben
      oder halt doch beim Tabellenanfang gelandet sind. Da mssten wir aber
      denken und dazu sind wir zu faul. Im brigen testen wir nur jeweils
      den ersten Eintrag im Court, denn die Zeit ist fr den zweiten die
      selbe, so dass wir uns die zweite Abfrage sparen knnen.
      *)
      FOR zeile:=0 TO sd.zeil_anz-1 DO
        FOR spalte:=0 TO sd.spalt_anz-1 DO
          court_index:=2*(zeile*sd.spalt_anz+spalte);
          IF sd.uns_court[court_index]>-1 THEN
            (*
            Hier beginnt das Kstchen, falls es ein uns_court ist.
            *)

            (*
            In der Vergangenheit bieten wir gar keinen Button mehr an:
            *)
            IF (user_time(sd1, input[ii01].value, court_index) > zeitalc) THEN
              button:=TRUE;
            ELSE                (* IF (user_time... *)
              (* nichts *)
            END;                (* ELSE (user_time...*)
          ELSE                  (* IF sd.uns_court[court_index]>-1 *)
            (*
            Hier beginnt das Kstchen, falls es *kein* uns_court ist.
            *)
          END;                  (* ELSE sd.uns_court[court_index]>-1 *)
          (*
          Und hier ist das Kstchen zuende, egal welches es war.
          *)
        END;                    (* FOR spalte *)
      END;                      (* FOR zeile *)
      RETURN button;
    END mindestens_ein_button_da;

  BEGIN                         (* PROCEDURE advance_ukw *)
    hwi:=input[ii01].value;

    (*
    Falls sd.show_future_kw=0 ist, soll ja eigentlich die aktuelle Woche
    angezeigt werden. Wir werden das neuerdings (27.02.2011) aber nur tun,
    falls in der aktuellen Woche noch wenigstens ein drckbarer Button da
    ist. Sollte keiner mehr da sein, probieren wir's einfach mal mit der
    nchsten Woche.
    *)
    IF sd.show_future_kw=0 THEN
      IF mindestens_ein_button_da()=FALSE THEN
        sd.show_future_kw:=1;
      END;                      (* IF mindestens_ein_button_da()=FALSE *)
    END;                        (* IF sd.show_future_kw=0 *)

    hwi:=hwi+sd.show_future_kw;
    hwi2:=akt_luwn;
    IF hwi>hwi2+sd.show_future_kw THEN hwi:=hwi2+sd.show_future_kw; END;

    WITH sd DO
      IF (hwi>(season_start+wochen_anz-1)) THEN
        hwi:=season_start+wochen_anz-1 END;
      IF hwi<season_start THEN
        hwi:=season_start END;
    END;                        (* WITH sd *)

    IntToStr(hwi, zwstr);

    WITH input[ii01] DO
      PutGPMString(zwstr, ii01);
      value:=hwi;
    END;                        (* WITH input[ii01] *)
  END advance_ukw;


PROCEDURE put_globals(cid: ChanId; VAR sd: sd_rec_typ);
  BEGIN                         (* PROCEDURE put_globals *)
    WITH sd DO
      WriteInt(cid, sea_version, miwi);
      WriteLn(cid);
      WriteInt(cid, site_counter, miwi);
      WriteLn(cid);
      WriteInt(cid, chat_counter, miwi);
      WriteLn(cid);
      WriteInt(cid, sea_state, miwi);
      WriteLn(cid);
      WriteInt(cid, zeil_anz, miwi);
      WriteLn(cid);
      WriteInt(cid, spalt_anz, miwi);
      WriteLn(cid);
      WriteInt(cid, spieler_anz, miwi);
      WriteLn(cid);
      WriteInt(cid, season_start, miwi);
      WriteLn(cid);
      WriteInt(cid, wochen_anz, miwi);
      WriteLn(cid);
      WriteInt(cid, show_future_kw, miwi);
      WriteLn(cid);
      WriteInt(cid, bitleiste, miwi);
      WriteLn(cid);
      WriteString(cid, zusatz_heading);
      WriteLn(cid);

      WriteLn(cid);
    END;                        (* WITH sd *)
  END put_globals;


PROCEDURE put_uns_courts(cid: ChanId; VAR sd: sd_rec_typ);
  VAR
    i:                          INTEGER;

  BEGIN                         (* PROCEDURE put_uns_courts *)
    WITH sd DO
      (*
      Alle unsere Courts ausgeben:
      *)
      WriteInt(cid, uns_courts_anz, miwi);
      WriteLn(cid);
      FOR i:=0 TO 2*(uns_courts_anz-1) BY 2 DO
        WriteInt(cid, geschrumpfter_index[i], miwi);
        WriteLn(cid);
      END;                      (* FOR i *)
      WriteLn(cid);
    END;                        (* WITH sd *)
  END put_uns_courts;


PROCEDURE put_wochentage_und_courts(cid: ChanId; VAR sd: sd_rec_typ);
  VAR
    i:                          INTEGER;

  BEGIN                         (* PROCEDURE put_wochentage_und_courts *)
    WITH sd DO
      (*
      Alle Wochentage und Courts ausgeben:
      *)
      FOR i:=0 TO (zeil_anz-1) DO
        WriteInt(cid, wochentag[i], miwi);
        WriteLn(cid);
        WriteString(cid, court[i]);
        WriteLn(cid);
      END;                      (* FOR i *)
      WriteLn(cid);
    END;                        (* WITH sd *)
  END put_wochentage_und_courts;


PROCEDURE put_uhrzeiten(cid: ChanId; VAR sd: sd_rec_typ);
  VAR
    i:                          INTEGER;

  BEGIN                         (* PROCEDURE put_uhrzeiten *)
    WITH sd DO
      (*
      Alle Uhrzeiten ausgeben:
      *)
      FOR i:=0 TO (spalt_anz-1) DO
        WriteInt(cid, uhrzeit[i], miwi);
        WriteLn(cid);
      END;                      (* FOR i *)
      WriteLn(cid);
    END;                        (* WITH sd *)
  END put_uhrzeiten;


PROCEDURE put_spieler(cid: ChanId; VAR sd: sd_rec_typ);
  VAR
    i:                          INTEGER;

  BEGIN                         (* PROCEDURE put_spieler *)
    WITH sd DO
      (*
      Alle Namen, Persdata, Kennwrter, Spielerarten,
      'Spieleraktivitten', 'Tage voraus', Rnge und
      Remoteadressen ausgeben:
      *)
      FOR i:=0 TO spieler_anz+ssa-1 DO
        WriteString(cid, spieler_name[i]);
        WriteLn(cid);
        WriteString(cid, spieler_pers_data[i]);
        WriteLn(cid);
        WriteString(cid, spieler_kennwort[i]);
        WriteLn(cid);
        WriteInt(cid, spieler_art[i], miwi);
        WriteInt(cid, spieler_aktiv[i], miwi);
        WriteInt(cid, spieler_rang[i], miwi);
        WriteInt(cid, max_day_delta[i], miwi);
        WriteLn(cid);
        WriteString(cid, spieler_remote_addr[i]);
        WriteLn(cid);
      END;                      (* FOR i *)
      WriteLn(cid);
    END;                        (* WITH sd *)
  END put_spieler;


PROCEDURE put_court_belegung(cid: ChanId; VAR sd: sd_rec_typ);
  VAR
    i, k:                       INTEGER;

  BEGIN                         (* PROCEDURE put_court_belegung *)
    WITH sd DO
      (*
      Alle Courts in allen Wochen (mit Zugriffszeit) ausgeben:
      *)
      FOR i:=0 TO wochen_anz-1 DO
        WriteInt(cid, jahr_wochen_zugriff[i], miwi);
        WriteLn(cid);
        FOR k:=0 TO uns_courts_anz-1 DO
          WriteInt(cid, jahr_forderung[i, geschrumpfter_index[2*k] DIV 2], miwi);
          WriteLn(cid);

          WriteInt(cid, jahr_court_belegung[i, geschrumpfter_index[2*k]], miwi);
          WriteInt(cid, jahr_court_belegung_gast[i, geschrumpfter_index[2*k]], miwi);
          WriteLn(cid);
          WriteString(cid, jahr_court_belegung_gast_nam[i, geschrumpfter_index[2*k]]);
          WriteLn(cid);

          WriteInt(cid, jahr_court_belegung[i, geschrumpfter_index[2*k+1]], miwi);
          WriteInt(cid, jahr_court_belegung_gast[i, geschrumpfter_index[2*k+1]], miwi);
          WriteLn(cid);
          WriteString(cid, jahr_court_belegung_gast_nam[i, geschrumpfter_index[2*k+1]]);
          WriteLn(cid);
        END;                    (* FOR k *)
        WriteLn(cid);
      END;                      (* FOR i *)
    END;                        (* WITH sd *)
  END put_court_belegung;


PROCEDURE put_season_data(season_name: ARRAY OF CHAR; VAR sd: sd_rec_typ;
                          VAR ok: BOOLEAN);
  VAR
    cid:                        ChanId;
    res:                        OpenResults;

  BEGIN                         (* PROCEDURE put_season_data *)
    StreamFile.Open(cid, season_name, write+old, res);
    (*
    show_OpenResult(cid_out, season_name, 'put_season_data', res);
    *)
    IF res=opened THEN
      WriteString(cid, '# globals:');
      WriteLn(cid);
      put_globals(cid, sd);

      WriteString(cid, '# uns_courts:');
      WriteLn(cid);
      put_uns_courts(cid, sd);

      WriteString(cid, '# wochentage_und_courts:');
      WriteLn(cid);
      put_wochentage_und_courts(cid, sd);

      WriteString(cid, '# uhrzeiten:');
      WriteLn(cid);
      put_uhrzeiten(cid, sd);

      WriteString(cid, '# spieler:');
      WriteLn(cid);
      put_spieler(cid, sd);

      WriteString(cid, '# court_belegung:');
      WriteLn(cid);
      put_court_belegung(cid, sd);
      StreamFile.Close(cid);
      ok:=TRUE;
    ELSE                        (* IF res=opened *)
      ok:=FALSE;
    END;                        (* ELSE res=opened *)
  END put_season_data;


PROCEDURE SaveNewChatToTmpFile(wer_str: ARRAY OF CHAR): BOOLEAN;
  VAR
    lcid_out:                   ChanId;
    res:                        OpenResults;
    structTime:                 DateTime;
    strTime:                    String;
    ok_tmp:                     BOOLEAN;
    zwstr_lang:                 String_lang;

  BEGIN                         (* PROCEDURE SaveNewChatToTmpFile *)
    (*
    Hinweis, damit wir spter auch noch durchblicken:
    das 'old' heit hier: es darf schon mal ein altes temporres File
    da sein, wir legen einfach ein neues an. Ist 'old' nicht angegeben,
    wird ein bestehendes altes temporres File nicht angerhrt und
    dann geht hier nichts. Wir arbeiten also mit 'old', weil
    wir in jedem Fall ein neues temporres File anlegen wollen, egal
    ob noch ein altes da wre oder nicht.
    *)
    StreamFile.Open(lcid_out, chat_name_new, write+old, res);
    (*
    show_OpenResult(cid_out, chat_name_new, 'file_existiert', res);
    *)
    IF res=opened THEN
      TimeToLcStructTime(zeitagm, structTime);
      StructTimeToAsciiRS1(strTime, structTime);
      WriteString(lcid_out, '--> Am ');
      WriteString(lcid_out, strTime);
      WriteString(lcid_out, ' machte ');
      WriteString(lcid_out, wer_str);
      WriteString(lcid_out, ' (IP-Nummer: ');
      WriteString(lcid_out, remote_addr);
      WriteString(lcid_out, ')');
      WriteString(lcid_out, ' folgende Mitteilung:');
      WriteLnCrLf(lcid_out);
      WriteLnCrLf(lcid_out);
      GetGPMString(zwstr_lang, ii16);
      WriteString(lcid_out, zwstr_lang);
      WriteLnCrLf(lcid_out);
      WriteLnCrLf(lcid_out);
      WriteLnCrLf(lcid_out);
      StreamFile.Close(lcid_out);
      RETURN TRUE;
    ELSE                        (* IF res=opened *)
      RETURN FALSE;
    END;                        (* ESLE res=opened *)
  END SaveNewChatToTmpFile;


PROCEDURE AppendFileContentsToStream(lcid_out: ChanId; file_name: ARRAY OF CHAR): BOOLEAN;
  CONST
    len_in=                     128;
  TYPE
    locfeldtyp128=              ARRAY[0..len_in-1] OF CHAR;
  VAR
    file_name_loc:              String;
    lcid_in:                    ChanId;
    res:                        OpenResults;
    feld:                       locfeldtyp128;
    len_read:                   CARDINAL;
    len_read_sum:               CARDINAL;

  BEGIN                         (* PROCEDURE AppendFileContentsToStream *)
    (*
    Mit der max_chat_size 'mogeln' wir so ein bisschen. Das ist nicht die
    maximale Filegre des Chatfiles, die entstehen kann, sondern es ist ja
    so: zuerst kommt die neue Mitteilung ins File. Die ist grantiert kleiner
    als die max_chat_size. Anschlieend lesen wir vom 'echten' Chatfile aber
    dann bis max_chat_size Bytes. D.h., das resultierende File knnte dann
    um die Gre der neuen Mitteilung grer sein als max_chat_size. Aber
    das ist uns Wurscht.
    *)
    Assign(file_name, file_name_loc);
    StreamFile.Open(lcid_in, file_name_loc, raw+read, res);
    (*
    show_OpenResult(cid_out, file_name_loc, 'AppendFileContentsToStream', res);
    *)
    IF res=opened THEN
      RawRead(lcid_in, ADR(feld), len_in, len_read);
      len_read_sum:=len_read;
      WHILE ((NOT ((ReadResult(lcid_in)=endOfInput) AND (len_read=0))) AND
             (len_read_sum<max_chat_size)) DO
        (* Sicherheitshalber 0 abfangen, man wei ja nie! *)
        IF len_read>0 THEN
          RawWrite(lcid_out, ADR(feld), len_read);
        END;                    (* IF len_read>0 *)
        RawRead(lcid_in, ADR(feld), len_in, len_read);
        len_read_sum:=len_read_sum+len_read;
      END;                      (* WHILE ((NOT ((ReadResult(lcid_in)=endOfInput)... *)
      (* Sicherheitshalber 0 abfangen, man wei ja nie! *)
      IF len_read>0 THEN
        RawWrite(lcid_out, ADR(feld), len_read);
      END;                      (* IF len_read>0 *)
      StreamFile.Close(lcid_in);
      RETURN TRUE; 
    ELSE                        (* IF res=opened *)
      RETURN FALSE;
    END;                        (* ESLE res=opened *)
  END AppendFileContentsToStream;


PROCEDURE put_chat_data(wer_str: ARRAY OF CHAR; VAR ok: BOOLEAN);
  VAR
    res:                        OpenResults;
    ok_tmp:                     BOOLEAN;
    lcid_out:                   ChanId;

  BEGIN                         (* PROCEDURE put_chat_data *)
    (*
    Als erstes schreiben wir den neuen Spruch ins neue temporre File:
    *)
    ok:=SaveNewChatToTmpFile(wer_str);

    (*
    Ursprnglich hatten wir mit GPM hier den Inhalt des Originalfiles
    einfach an das soeben erzeugte neue temporre File angehngt. Da
    hatten wir dann mit SeqFile.OpenAppend fr das neue temporre File
    hantiert und alles war gut. Mit GM2 haben wir aber Probleme mit dem
    SeqFile.OpenAppend. Es hat den Anschein, als wrde der gar nicht
    anhngen, sondern einfach von vorne mit dem Schreiben anfangen.
    Siehe dazu auch Kommentar vom 12.04.2023. Jetzt machen wir es eben
    noch anders: ein weiteres File aufmachen und dort der Reihe nach
    den Inhalt des neuen und des aktuellen Files schreiben (falls es
    schon einen aktuellen Chat gibt).
    *)
    StreamFile.Open(lcid_out, chat_name_tmp, write+old+raw, res);
    (*
    show_OpenResult(cid_out, chat_name_tmp, 'put_chat_data', res);
    *)

    IF res=opened THEN
      ok_tmp:=AppendFileContentsToStream(lcid_out, chat_name_new);
      IF ok_tmp THEN
        IF file_existiert(chat_name) THEN
          ok_tmp:=AppendFileContentsToStream(lcid_out, chat_name);
        END;                    (* IF file_existiert(chat_name) *)
      END;                      (* IF ok_tmp *)
      StreamFile.Close(lcid_out);
    ELSE                        (* IF res=opened *)
      ok_tmp:=FALSE;
    END;                        (* ELSE res=opened *)
    ok:=ok AND ok_tmp;

    (*
    Nun lschen wir die alten Files, soweit vorhanden,
    *)
    ok_tmp:=Unix.Unlink(chat_name_new);
    ok:=ok AND ok_tmp;
    IF file_existiert(chat_name) THEN
      ok_tmp:=Unix.Unlink(chat_name);
      ok:=ok AND ok_tmp;
    END;                        (* IF file_existiert(chat_name) *)

    (*
    machen einen Link fr das neue temporre File unter dem Originalnamen
    *)
    ok_tmp:=Unix.Link(chat_name_tmp, chat_name);
    ok:=ok AND ok_tmp;

    (*
    und lschen schlielich das neue temporre File wieder:
    *)
    ok_tmp:=Unix.Unlink(chat_name_tmp);
    ok:=ok AND ok_tmp;
  END put_chat_data;


PROCEDURE try_put_chat_data(wer_str: ARRAY OF CHAR): BOOLEAN;
  VAR
    ok:                         BOOLEAN;

  BEGIN                         (* PROCEDURE try_put_chat_data *)
    put_chat_data(wer_str, ok);
    IF ok THEN RETURN TRUE ELSE RETURN FALSE END;
  END try_put_chat_data;


PROCEDURE get_or_postings(): BOOLEAN;
  VAR
    buchst_ok:                  BOOLEAN;
    zufriedenheit:              BOOLEAN;
    buchst:                     CHAR;
    name_str:                   String;
    value_str:                  String_lang;
    index:                      INTEGER;
    lenqs:                      INTEGER;

  PROCEDURE neuer_buchstabe(VAR buchst_ok: BOOLEAN);
    BEGIN                       (* PROCEDURE neuer_buchstabe *)
      IF (request_ist_post AND (char_cnt<(content_length_int - 1))) THEN
        (*
        Bei request_ist_post nur maximal content_length_int Zeichen
        lesen. Tun wir das nicht, kann es passieren, da ein erneuter
        Leseversuch nicht eof vom Webserver bekommt, und ewig blockiert.

        Am 08.10.2000 mssen wir noch einen Schritt weiter gehen.
        Wie an anderen Stellen schon bemerkt, drfen wir mit freeBSD
        nicht das letzte Zeichen lesen, weil die Kiste sonst abschmiert,
        zumindest bei muc.de. Wir haben daher ein bugdummy ganz ans
        Ende der Postings gesetzt, welches wir jetzt nutzen, um es
        nicht ganz zu lesen. Wir lesen also nur content_length_int-1
        Zeichen und nicht content_length_int Stck.
        *)
(*
        WriteString(cid_out, 'char_cnt: ');
        WriteInt(cid_out, char_cnt, 1);
        WriteLnCrLf(cid_out);
        WriteString(cid_out, 'content_length_int: ');
        WriteInt(cid_out, content_length_int, 1);
        WriteLnCrLf(cid_out);
        Flush(cid_out);
*)
        ReadChar(cid_in, buchst);
        IF (ReadResult(cid_in)=allRight) THEN
          buchst_ok:=TRUE;
          (*
          Nachsehen, ob bitleiste (bit1) Debugging fordert.
          Falls ja, machen wir eine Ausgabe:
          *)
          IF ODD((sd1.bitleiste DIV 2)) THEN
            WriteChar(cid_out, buchst);
          ELSE                  (* IF ODD((sd1.bitleiste DIV 2)) *)
            (* nichts *)
          END;                  (* ELSE ODD((sd1.bitleiste DIV 2)) *)

          char_cnt:=char_cnt+1;
        ELSE                    (* IF (ReadResult(cid_in)=allRight) *)
          buchst_ok:=FALSE;
        END;                    (* ELSE (ReadResult(cid_in)=allRight) *)
      ELSE                      (* IF (request_ist_post... *)
        IF (char_cnt<lenqs) THEN
          buchst:=query_string[char_cnt];
          buchst_ok:=TRUE;
          (*
          Nachsehen, ob bitleiste (bit1) Debugging fordert.
          Falls ja, machen wir eine Ausgabe:
          *)
          IF ODD((sd1.bitleiste DIV 2)) THEN
            WriteChar(cid_out, buchst);
          ELSE                  (* IF ODD((sd1.bitleiste DIV 2)) *)
            (* nichts *)
          END;                  (* ELSE ODD((sd1.bitleiste DIV 2)) *)

          char_cnt:=char_cnt+1;
        ELSE
          buchst_ok:=FALSE;
        END;                    (* ELSE (char_cnt<lenqs) *)
      END;                      (* ELSE (request_ist_post... *)
    END neuer_buchstabe;

  PROCEDURE get_hex_digit(): INTEGER;
    BEGIN                       (* PROCEDURE get_hex_digit *)
      CASE buchst OF
        | '0':
            RETURN 0;
        | '1':
            RETURN 1;
        | '2':
            RETURN 2;
        | '3':
            RETURN 3;
        | '4':
            RETURN 4;
        | '5':
            RETURN 5;
        | '6':
            RETURN 6;
        | '7':
            RETURN 7;
        | '8':
            RETURN 8;
        | '9':
            RETURN 9;
        | 'A', 'a':
            RETURN 10;
        | 'B', 'b':
            RETURN 11;
        | 'C', 'c':
            RETURN 12;
        | 'D', 'd':
            RETURN 13;
        | 'E', 'e':
            RETURN 14;
        | 'F', 'f':
            RETURN 15;
        |  ELSE
            RETURN 0;
      END;                      (* CASE buchst *)
    END get_hex_digit;

  PROCEDURE lies_parameter_zuende(VAR name_str, value_str: ARRAY OF CHAR);
    VAR
      schnur1:                  String1;
      parameter_ist_zuende:     BOOLEAN;
      hwi:                      INTEGER;

    BEGIN                       (* PROCEDURE lies_parameter_zuende *)
      Assign('', name_str);
      schnur1:=' ';
      schnur1[0]:=buchst;
      Append(schnur1, name_str);
      (*
      So lange lesen, bis entweder '=' erscheint, dann ist nmlich
      der Parametername komplett eingelesen (dabei dann alle ankommenden
      Zeichen dem Parameternamen zuordnen) oder so lange lesen, bis
      (NOT buchst_ok) ist. Dann sind wir wahrscheinlich ans Ende der
      Eingabe gelangt (hchstwahrscheinlich bei GET) und mssen
      die Schleife abbrechen, weil wir sonst ewig hier hngen
      bleiben.
      *)
      REPEAT
        neuer_buchstabe(buchst_ok);
        IF ((buchst_ok) AND (buchst<>'=')) THEN
          schnur1:=' ';
          schnur1[0]:=buchst;
          Append(schnur1, name_str);
        END;                    (* IF ((buchst_ok)... *)
      UNTIL ((NOT buchst_ok) OR (buchst='='));

      Assign('', value_str);
      parameter_ist_zuende:=FALSE;
      REPEAT
        neuer_buchstabe(buchst_ok);
        IF buchst_ok THEN
          IF (buchst='&') THEN
            parameter_ist_zuende:=TRUE;
            neuer_buchstabe(buchst_ok);
          ELSE                  (* IF (buchst='&') *)
            CASE buchst OF

              | '+':
                  buchst:=' ';

              | '%':
                  neuer_buchstabe(buchst_ok);
                  IF buchst_ok THEN
                    hwi:=16*get_hex_digit();
                    neuer_buchstabe(buchst_ok);
                    IF buchst_ok THEN
                      hwi:=hwi+get_hex_digit();
                    ELSE        (* IF buchst_ok *)
                      hwi:=32;
                    END;        (* ELSE buchst_ok *)
                  ELSE          (* IF buchst_ok *)
                    hwi:=32;
                  END;          (* ELSE buchst_ok *)

                  (*
                  WriteString(cid_out, 'hwi: ');
                  WriteInt(cid_out, hwi, 1);
                  WriteString(cid_out, '; ');
                  WriteLnCrLf(cid_out);
                  buchst:='b';
                  *)

                  buchst:=CHR(hwi);

              | ELSE
                  (* nichts weiter *)

            END;                (* CASE buchst *)
            schnur1:=' ';
            schnur1[0]:=buchst;
            Append(schnur1, value_str);
          END;                  (* ELSE (buchst='&') *)
        END;                    (* IF buchst_ok *)

      UNTIL ((NOT buchst_ok) OR parameter_ist_zuende);
    END lies_parameter_zuende;

  PROCEDURE change_str_parameter(VAR name_str, value_str: ARRAY OF CHAR;
                                 VAR index: INTEGER);
    VAR
      strings_sind_gleich:      BOOLEAN;

    BEGIN                       (* PROCEDURE change_str_parameter *)
      (*
      Ganz primitiv durchprobieren, bis das erste Matching da ist,
      dann den value_strr durch den value_str ersetzen:
      *)
      index:=ii00;
      REPEAT
        strings_sind_gleich:=(CompareRS(input[index].name_strr, name_str)=equal);
        index:=index+1;
      UNTIL ((index=max_param_anz) OR strings_sind_gleich);
      index:=index-1;

      IF strings_sind_gleich THEN
        PutGPMString(value_str, index);
      END;                      (* IF strings_sind_gleich *)

    END change_str_parameter;

  PROCEDURE log_parameter(lcid_out: ChanId;
                          VAR name_str, value_str: ARRAY OF CHAR;
                          VAR index: INTEGER);
    VAR
      zwstr:                    String;
      str_ptr:                  StrPtrTyp;
      ergebnis:                 BOOLEAN;
      i:                        INTEGER;

    BEGIN                       (* PROCEDURE log_parameter *)
      WriteString(lcid_out, name_str);
      WriteString(lcid_out, ': ');
      
      Assign(value_str, zwstr);

      (*
      geheime Sachen schreiben wir nicht direkt hin, sondern lassen
      erst den crypt drber laufen, soviel Anstand haben wir dann doch.
      Geheim sind brigens die Sachen mit Index ii05, ii07 und ii08:
      *)
      IF ((index=ii05) OR (index=ii07) OR (index=ii08)) THEN
        str_ptr:=Unix.Crypt(zwstr, '00');
        Assign(str_ptr^, zwstr);

        (*
        inzwischen sind wir draufgekommen, da es noch geiler ist, nicht
        einmal die verschlsselten Sachen hinzuschreiben, sondern den
        Namen desjenigen, zu dem das Kennwort pat. Ist viel schner
        fr den Oberchef, der sich die Logfiles anschaut. Wir schreiben
        alle Matchings hin und nicht nur eines (fr den Fall, da es
        mehrere Matchings geben sollte).
        *)
        FOR i:=0 TO sd1.spieler_anz+ssa-1 DO
          IF (CompareRS(sd1.spieler_kennwort[i], zwstr)=equal) THEN
            WriteString(lcid_out, sd1.spieler_name[i]);
            WriteString(lcid_out, ' ');
          END;                  (* IF (CompareRS... *)
        END;                    (* FOR i *)
      ELSE                      (* IF ((index=ii05)... *)
        WriteString(lcid_out, zwstr);
      END;                      (* ELSE ((index=ii05)... *)

      WriteLnCrLf(lcid_out);
    END log_parameter;

  BEGIN                         (* PROCEDURE get_or_postings *)
    zufriedenheit:=TRUE;

    char_cnt:=0;

    (*
    Unabhngig von POST oder GET die Lnge des QUERY_STRING bestimmen:
    *)
    lenqs:=Length(query_string);

    (*
    Erst mal sehen, ob berhaupt was ankommt:
    *)
    neuer_buchstabe(buchst_ok);

    WHILE buchst_ok DO
      lies_parameter_zuende(name_str, value_str);
      IF Length(value_str)=langlen THEN zufriedenheit:=FALSE END;
      change_str_parameter(name_str, value_str, index);

      (*
      Notieren, was uns der User alles bergibt (aber nur, falls
      das Logfile offen ist):
      *)
      IF hlog_ist_offen THEN
        (*
        log_parameter(cid_log, name_str, value_str, index);
        *)
      END;                      (* IF hlog_ist_offen *)
      (*
      log_parameter(cid_out, name_str, value_str, index);
      *)

      (*
      WriteString(cid_out, '<P>');

      WriteString(cid_out, name_str);
      WriteString(cid_out, ': ');
      WriteString(cid_out, value_str);
      WriteString(cid_out, '; ');
      WriteLnCrLf(cid_out);

      WriteString(cid_out, '</P>');
      WriteLnCrLf(cid_out);
      *)
    END;                        (* WHILE buchst_ok *);
    RETURN zufriedenheit;
  END get_or_postings;


PROCEDURE try_get_or_postings;
  VAR
    text1, text2:               String;

  BEGIN                         (* PROCEDURE try_get_or_postings *)
    IF (NOT get_or_postings()) THEN
      Assign('Eingegebene Datenmenge war zu gro!', text1);
      Assign('Schade :-( Zum Korrigieren bitte "Back-Button" des Browsers bettigen!', text2);
      abbruch(text1, text2);
    END;                        (* IF (NOT get_or_postings) *)
  END try_get_or_postings;


PROCEDURE calc_integers;
  VAR
    i:                          INTEGER;
    zwstr:                      String;
    format:                     ConvResults;
    text1:                      String;

  BEGIN                         (* PROCEDURE calc_integers *)
    (*
    Hier wandeln wir die 'INTEGER-Strings' in INTEGERs um:
    *)
    FOR i:=ii00 TO max_param_anz-1 DO
      WITH input[i] DO
        (*
        WriteString(cid_out, '<P> ');
        WriteString(cid_out, 'i, name_strr, value_strr, ob_integ: ');
        WriteInt(cid_out, i, 1);
        WriteString(cid_out, ', ');
        WriteString(cid_out, name_strr);
        WriteString(cid_out, ', ');
        GetGPMString(zwstr, i);
        WriteString(cid_out, zwstr);
        WriteString(cid_out, ', ');
        WriteInt(cid_out, ob_integ, 1);
        WriteString(cid_out, ' </P>');
        WriteLnCrLf(cid_out);
        *)

        IF ob_integ=1 THEN
          GetGPMString(zwstr, i);
          StrToInt(zwstr, value, format);
          Assign(name_strr, text1);
          Append('=', text1);
          Append(zwstr, text1);
          IF (NOT (format=strAllRight)) THEN
            Append(': Eingabestring ist nicht "strAllRight"!', text1);
            schreib_page_accept(sd1, text1, 'Nochmal', dunkelrot, p4ac9);
            HALT;
          END;                  (* IF (NOT format... *)
          IF ((value<min) OR (value>max)) THEN
            Append(': Eingabewert auerhalb des erlaubten Bereichs!', text1);
            schreib_page_accept(sd1, text1, 'Nochmal', dunkelrot, p4ac9);
            HALT;
          END;                  (* IF ((value... *)
        END;                    (* IF ob_integ=1 *)
      END;                      (* WITH input[i] *)
    END;                        (* FOR i *)
  END calc_integers;


PROCEDURE schreib_page_header(lcid_out: ChanId; mode: INTEGER);
  (*
  mode=0: Normalmodus, Caching erlaubt
  mode=1: Caching abschalten
  *)
  BEGIN                         (* PROCEDURE schreib_page_header *)
    (* +++ zum Debuggen *)
    (*
    mode:=0;
    *)
    WriteString(lcid_out, '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">');
    WriteLnCrLf(lcid_out);
    WriteString(lcid_out, '<!--');
    WriteLnCrLf(lcid_out);
    WriteString(lcid_out, '  ');
    WriteString(lcid_out, version);
    WriteLnCrLf(lcid_out);
    WriteString(lcid_out, '-->');
    WriteLnCrLf(lcid_out);
    WriteString(lcid_out, '<HTML>');
    WriteLnCrLf(lcid_out);
    WriteString(lcid_out, '<HEAD>');
    WriteLnCrLf(lcid_out);

    (*
    WriteString(lcid_out, '<META HTTP-EQUIV="refresh" CONTENT="05,http://localhost/squash/cgi-bin/squash1">');
    WriteLnCrLf(lcid_out);
    WriteString(lcid_out, '<META HTTP-EQUIV="Cache-Control" CONTENT="no-store">');
    WriteLnCrLf(lcid_out);
    WriteString(lcid_out, '<META HTTP-EQUIV="Content-Length" CONTENT="5000">');
    WriteLnCrLf(lcid_out);
    WriteString(lcid_out, '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">');
    WriteLnCrLf(lcid_out);
    WriteString(lcid_out, '<META HTTP-EQUIV="Expires" CONTENT="NOW">');
    WriteLnCrLf(lcid_out);
    WriteString(lcid_out, '<META HTTP-EQUIV="Expires" CONTENT="Tue, 26-Oct-1965 12:00:00">');
    WriteLnCrLf(lcid_out);
    WriteString(lcid_out, '<META HTTP-EQUIV="Date" CONTENT="Sun, 07-Mar-1999 12:00:00">');
    WriteLnCrLf(lcid_out);
    WriteString(lcid_out, '<META HTTP-EQUIV="last modified" CONTENT="NOW">');
    WriteLnCrLf(lcid_out);
    WriteString(lcid_out, '<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=ISO-8859-1">');
    WriteLnCrLf(lcid_out);
    *)
    IF mode=1 THEN
      WriteString(lcid_out, '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">');
      WriteLnCrLf(lcid_out);
      WriteString(lcid_out, '<META HTTP-EQUIV="Expires" CONTENT="Tue, 26-Oct-1965 12:00:00">');
      WriteLnCrLf(lcid_out);
    ELSE                        (* IF mode=1 *)
      (* nichts *)
    END;                        (* ELSE mode=1 *) 

    WriteString(lcid_out, '<TITLE> ');
    put_amp_string(lcid_out, sd1.zusatz_heading);
    WriteString(lcid_out, ' </TITLE>');
    WriteLnCrLf(lcid_out);
    WriteString(lcid_out, '</HEAD>');
    WriteLnCrLf(lcid_out);
    WriteString(lcid_out, '<BODY BGCOLOR="');
    WriteString(lcid_out, hellblau);
    WriteString(lcid_out, '">');
    WriteLnCrLf(lcid_out);
    schreib_heading(lcid_out, sd1.zusatz_heading, 'H2');

    IF (lcid_out=cid_log) THEN
      (*
      Der erste Teil der Client Info wird auf den
      Log-Channel ausgegeben.
      *)
      show_client_info1(lcid_out);
    END;                        (* IF (lcid_out... *)

  END schreib_page_header;


PROCEDURE schreib_tdh_attributes(lcid_out: ChanId;
                                 align, color, rowspan, colspan: ARRAY OF CHAR);
  BEGIN                         (* PROCEDURE schreib_tdh_attributes *)
    (*
    WriteString(lcid_out, 'NOWRAP HEIGHT="50" ALIGN="');
    WriteString(lcid_out, 'NOWRAP ALIGN="');
    *)
    WriteString(lcid_out, 'NOWRAP ALIGN="');
    WriteString(lcid_out, align);
    WriteString(lcid_out, '" BGCOLOR="');
    WriteString(lcid_out, color);
    WriteString(lcid_out, '" ROWSPAN="');
    WriteString(lcid_out, rowspan);
    WriteString(lcid_out, '" COLSPAN="');
    WriteString(lcid_out, colspan);
    WriteString(lcid_out, '">');
    WriteLnCrLf(lcid_out);
  END schreib_tdh_attributes;


PROCEDURE schreib_td_start(lcid_out: ChanId;
                           align, color, rowspan, colspan: ARRAY OF CHAR);
  BEGIN                         (* PROCEDURE schreib_td_start *)
    WriteString(lcid_out, '<TD ');
    schreib_tdh_attributes(lcid_out, align, color, rowspan, colspan);
  END schreib_td_start;


PROCEDURE schreib_text_crlf(lcid_out: ChanId; text: ARRAY OF CHAR);
  BEGIN                         (* PROCEDURE schreib_text_crlf *)
    IF (Length(text)>0) THEN
      WriteString(lcid_out, text);
      WriteLnCrLf(lcid_out);
    END;                        (* IF (Length(text)>0) *)
  END schreib_text_crlf;


PROCEDURE schreib_td_end(lcid_out: ChanId);
  BEGIN                         (* PROCEDURE schreib_td_end *)
    WriteString(lcid_out, '</TD>');
    WriteLnCrLf(lcid_out);
  END schreib_td_end;


PROCEDURE schreib_td_text(lcid_out: ChanId;
                          align, color, rowspan, colspan, text: ARRAY OF CHAR);
  BEGIN                         (* PROCEDURE schreib_td_text *)
    schreib_td_start(lcid_out, align, color, rowspan, colspan);
    schreib_text_crlf(lcid_out, text);
    schreib_td_end(lcid_out);
  END schreib_td_text;


PROCEDURE schreib_form_start(lcid_out: ChanId);
  VAR
    zwstr:                      String;

  BEGIN                         (* PROCEDURE schreib_form_start *)
    Assign('<FORM METHOD=POST ACTION="', zwstr);
    Append(script_path, zwstr);
    Append(script_nam, zwstr);
    Append('">', zwstr);
    WriteString(lcid_out, zwstr);
    WriteLnCrLf(lcid_out);
  END schreib_form_start;


PROCEDURE schreib_select_button_start(lcid_out: ChanId;
                                      VAR select_name: ARRAY OF CHAR);
  BEGIN                         (* PROCEDURE schreib_select_button_start *)
    WriteString(lcid_out, '<SELECT NAME=');
    WriteString(lcid_out, select_name);
    WriteString(lcid_out, '>');
    WriteLnCrLf(lcid_out);
  END schreib_select_button_start;


PROCEDURE schreib_select_button_body(lcid_out: ChanId;
                                     sel_rec_typ_ptr: sel_rec_typ_ptr_typ;
                                     bis, selected: INTEGER);
  VAR
    i:                          INTEGER;
    zwstr:                      String;
    sel_rec:                    sel_rec_typ;    (* selection Record *)
    schnur_amp:                 String_mittel;

  BEGIN                         (* PROCEDURE schreib_select_button_body *)
    (*
    Der lokale sel_rec wird zuallererst teilweise belegt, genauer der
    Pointer wird gleich dem bergebenen Wert gesetzt. Dadurch kann dann
    in der FOR-Schleife als allererstes die Dereferenzierung des ersten
    echten sel_rec erfolgen. Damit knnen wir dann auf eine sonst
    ntige berprfung auf NIL am Ende der FOR-Schleife verzichten.
    Natrlich setzt das voraus, da der Aufrufer nur gltige Werte fr
    'bis' bergibt. Dies war aber auch bisher schon gegeben.
    *)
    sel_rec.sel_rec_typ_ptr:=sel_rec_typ_ptr;
    FOR i:=0 TO bis DO
      sel_rec:=sel_rec.sel_rec_typ_ptr^;
      IF sel_rec.zahl<>selected THEN WriteString(lcid_out, '<OPTION VALUE="')
      ELSE WriteString(lcid_out, '<OPTION SELECTED VALUE="') END;
      IntToStr(sel_rec.zahl, zwstr);
      WriteString(lcid_out, zwstr);
      WriteString(lcid_out, '"> ');
      convert_to_amp_string(sel_rec.schnur, schnur_amp);
      WriteString(lcid_out, schnur_amp);
      WriteLnCrLf(lcid_out);
    END;                        (* FOR i *)
  END schreib_select_button_body;


PROCEDURE schreib_select_button_end(lcid_out: ChanId);
  BEGIN                         (* PROCEDURE schreib_select_button_end *)
    WriteString(lcid_out, '</SELECT>');
    WriteLnCrLf(lcid_out);
  END schreib_select_button_end;


PROCEDURE schreib_select_button(lcid_out: ChanId;
                                VAR select_name: ARRAY OF CHAR;
                                sel_rec_typ_ptr: sel_rec_typ_ptr_typ;
                                bis, selected: INTEGER);
  BEGIN                         (* PROCEDURE schreib_select_button *)
    schreib_select_button_start(lcid_out, select_name);
    schreib_select_button_body(lcid_out, sel_rec_typ_ptr, bis, selected);
    schreib_select_button_end(lcid_out);
  END schreib_select_button;


PROCEDURE schreib_passwd(lcid_out: ChanId;
                         submit_name, submit_value: ARRAY OF CHAR);
  BEGIN                         (* PROCEDURE schreib_passwd *)
    WriteString(lcid_out, '<INPUT NAME="');
    WriteString(lcid_out, submit_name);
    WriteString(lcid_out, '" TYPE=PASSWORD VALUE="');
    WriteString(lcid_out, submit_value);
    WriteString(lcid_out, '" SIZE="8">');
    WriteLnCrLf(lcid_out);
  END schreib_passwd;


PROCEDURE schreib_checkbox1(lcid_out: ChanId;
                            name, text: ARRAY OF CHAR; checked: INTEGER);
  BEGIN                         (* PROCEDURE schreib_checkbox1 *)
    WriteString(lcid_out, text);
    WriteString(lcid_out, ' <INPUT NAME=');
    WriteString(lcid_out, name);
    WriteString(lcid_out, ' TYPE=CHECKBOX VALUE="1"');
    IF checked<>0 THEN
      WriteString(lcid_out, ' CHECKED');
    END;                        (* IF checked<>0 *)
    WriteString(lcid_out, '>');
    WriteLnCrLf(lcid_out);
  END schreib_checkbox1;


PROCEDURE schreib_hr(lcid_out: ChanId);
  BEGIN                         (* PROCEDURE schreib_hr *)
    WriteString(lcid_out, '<HR>');
    WriteLnCrLf(lcid_out);
  END schreib_hr;


PROCEDURE schreib_paragraph_start(lcid_out: ChanId);
  BEGIN                         (* PROCEDURE schreib_paragraph_start *)
    WriteString(lcid_out, '<P>');
    WriteLnCrLf(lcid_out);
  END schreib_paragraph_start;


PROCEDURE schreib_paragraph_end(lcid_out: ChanId);
  BEGIN                         (* PROCEDURE schreib_paragraph_end *)
    WriteString(lcid_out, '</P>');
    WriteLnCrLf(lcid_out);
  END schreib_paragraph_end;


PROCEDURE schreib_radio(lcid_out: ChanId; name: ARRAY OF CHAR;
                        text1, text2: ARRAY OF CHAR; checked: BOOLEAN);

  BEGIN                         (* PROCEDURE schreib_radio *)
    WriteString(lcid_out, '<INPUT NAME=');
    WriteString(lcid_out, name);
    WriteString(lcid_out, ' TYPE=RADIO VALUE="');
    WriteString(lcid_out, text1);
    WriteString(lcid_out, '"');
    IF checked THEN
      WriteString(lcid_out, ' CHECKED');
    END;                        (* IF checked *)
    WriteString(lcid_out, '>');
    WriteString(lcid_out, text2);
    WriteLnCrLf(lcid_out);
  END schreib_radio;


PROCEDURE schreib_radio3(VAR sd: sd_rec_typ; lcid_out: ChanId;
                         value_forderung: INTEGER;
                         name_radio, text1, name_forderung, text_forderung,
                         text2, text3, name2, value: ARRAY OF CHAR);
  VAR
    zwstr:                      String;

  BEGIN                         (* PROCEDURE schreib_radio3 *)
    schreib_radio(lcid_out, name_radio, '0', text1, TRUE);
    (*
    Checkbox fr Forderungsspiel nur anbieten, falls mindestens ein
    aktiver Spieler einen ordentlichen Rang zugewiesen bekommen hatte.
    Wenn es nmlich nicht mindestens zwei solche Spieler gibt,
    brauchen wir auch keine Forderungen zu spielen. O.k., wir
    geben also ggf. einfach keine checkbox aus. Der Hacker kann
    natrlich irgendwas zurckschicken, auch wenn wir _keine_
    checkbox ausgeben. Dies fangen wir aber nicht ab, weil uns das
    nicht gengend wichtig erscheint. Soll er halt Forderungen
    spielen wollen, wird ja eh keiner mitspielen. Hinweis: tatschlich
    ist rang_info_count+1 die Anzahl dieser Spieler.
    Erweiterung am 02.12.2001: Forderungsspiele sollen nur bis
    zum nchsten Ranglisten-Update mglich sein +++
    ...wird auf spter verschoben...
    *)
    IF rang_info_count(sd)>=1 THEN
      schreib_checkbox1(lcid_out, name_forderung,
                        text_forderung, value_forderung); 
    END;                        (* IF rang_info_count(sd)>=1 *)
    schreib_hr(lcid_out);
    schreib_radio(lcid_out, name_radio, '1', text2, FALSE);
    schreib_hr(lcid_out);
    schreib_radio(lcid_out, name_radio, '2', text3, FALSE);
    schreib_text(lcid_out, name2, value, '10');
  END schreib_radio3;


PROCEDURE put_amp_string(lcid_out: ChanId; schnur: ARRAY OF CHAR);
  (*
  Wir mssen an irgendeiner Stelle zusehen, da wir beim Schreiben von
  Strings keine unerwnschten Zeichen ausgeben ('<', '>' und so), die
  dann als HTML-Steuerzeichen interpretiert werden knnten. Dies wird
  u.a. in schreib_textarea und in put_hidden_values bentigt.
  *)
  VAR
    c_in:                       CARDINAL;
    buchst:                     CHAR;

  BEGIN                         (* PROCEDURE put_amp_string *)
    IF Length(schnur)>0 THEN
      FOR c_in:=0 TO Length(schnur)-1 DO
        buchst:=schnur[c_in];
        CASE buchst OF
          | '<':
              WriteString(lcid_out, '&lt;');

          | '>':
              WriteString(lcid_out, '&gt;');

          | '&':
              WriteString(lcid_out, '&amp;');

          | ELSE
              WriteChar(lcid_out, buchst);
        END;                    (* CASE buchst *)
      END;                      (* FOR c_in *)
    END;                        (* IF Length(schnur)>0 *)
  END put_amp_string;


PROCEDURE convert_to_amp_string(schnur_in: ARRAY OF CHAR;
                                VAR schnur_out: ARRAY OF CHAR);
  (*
  Analog zu put_amp_string, nur da wir hier auch fr die Ausgabe
  einen String haben.
  *)
  VAR
    c_in:                       CARDINAL;
    buchst:                     CHAR;
    schnur1:                    String1;

  BEGIN                         (* PROCEDURE convert_to_amp_string *)
    IF Length(schnur_in)>0 THEN
      Assign('', schnur_out);
      FOR c_in:=0 TO Length(schnur_in)-1 DO
        buchst:=schnur_in[c_in];
        CASE buchst OF
          | '<':
              Append('&lt;', schnur_out);

          | '>':
              Append('&gt;', schnur_out);

          | '&':
              Append('&amp;', schnur_out);

          | ELSE
              schnur1:=' ';
              schnur1[0]:=buchst;
              Append(schnur1, schnur_out);
        END;                    (* CASE buchst *)
      END;                      (* FOR c_in *)
    END;                        (* IF Length(schnur_in)>0 *)
  END convert_to_amp_string;


PROCEDURE schreib_text(lcid_out: ChanId;
                       submit_name, submit_value, size: ARRAY OF CHAR);
  BEGIN                         (* PROCEDURE schreib_text *)
    WriteString(lcid_out, '<INPUT NAME="');
    WriteString(lcid_out, submit_name);
    WriteString(lcid_out, '" TYPE=TEXT VALUE="');
    put_amp_string(lcid_out, submit_value);
    WriteString(lcid_out, '" SIZE="');
    WriteString(lcid_out, size);
    WriteString(lcid_out, '">');
    WriteLnCrLf(lcid_out);
  END schreib_text;


PROCEDURE schreib_textarea(lcid_out: ChanId;
                           submit_name, submit_value: ARRAY OF CHAR);
  BEGIN                         (* PROCEDURE schreib_textarea *)
    WriteString(lcid_out, '<TEXTAREA NAME=');
    WriteString(lcid_out, submit_name);
    WriteString(lcid_out, ' ROWS=5 COLS=60>');
    put_amp_string(lcid_out, submit_value);
    WriteString(lcid_out, '</TEXTAREA>');
    WriteLnCrLf(lcid_out);
  END schreib_textarea;


PROCEDURE schreib_submit_button(lcid_out: ChanId;
                                submit_name, submit_value: ARRAY OF CHAR);
  BEGIN                         (* PROCEDURE schreib_submit_button *)
    WriteString(lcid_out, '<INPUT NAME=');
    WriteString(lcid_out, submit_name);
    WriteString(lcid_out, ' TYPE=SUBMIT VALUE="');
    put_amp_string(lcid_out, submit_value);
    WriteString(lcid_out, '">');
    WriteLnCrLf(lcid_out);
  END schreib_submit_button;


PROCEDURE put_hidden_values(lcid_out: ChanId; VAR hvr: hid_val_rec_typ);
  VAR
    i:                          INTEGER;

  BEGIN                         (* PROCEDURE put_hidden_values *)
    WITH hvr DO
      FOR i:=0 TO anz-1 DO
        WriteString(lcid_out, '<INPUT NAME=');
        WriteString(lcid_out, nam[i]);
        WriteString(lcid_out, ' TYPE=HIDDEN VALUE="');
        put_amp_string(lcid_out, val[i]);
        WriteString(lcid_out, '">');
        WriteLnCrLf(lcid_out);
      END;                      (* FOR i *)
    END;                        (* WITH hvr *)
  END put_hidden_values;


PROCEDURE append_hidden_values_to_string(VAR schnur: ARRAY OF CHAR; VAR hvr: hid_val_rec_typ);
  VAR
    i:                          INTEGER;

  BEGIN                         (* PROCEDURE append_hidden_values_to_string *)
    WITH hvr DO
      IF anz>=1 THEN
        Append('?', schnur);
        Append(nam[0], schnur);
        Append('=', schnur);
        Append(val[0], schnur);
      END;                      (* IF anz>=1 *)
      FOR i:=1 TO anz-1 DO
        Append('&amp;', schnur);
        Append(nam[i], schnur);
        Append('=', schnur);
        Append(val[i], schnur);
      END;                      (* FOR i *)
    END;                        (* WITH hvr *)
  END append_hidden_values_to_string;


PROCEDURE gen_get_string(VAR hvr: hid_val_rec_typ;
                         VAR get_str, text: ARRAY OF CHAR);
  VAR
    zwstr:                      String;

  BEGIN                         (*  PROCEDURE gen_get_string *)
    Assign('<A HREF="', get_str);
    Append(script_path, get_str);
    Append(script_nam, get_str);
    append_hidden_values_to_string(get_str, hvr);
    Append('"> ', get_str);
    Append(text, get_str);
    Append('</A>', get_str);
  END gen_get_string;


PROCEDURE schreib_form_end(lcid_out: ChanId);
  BEGIN                         (* PROCEDURE schreib_form_end *)
    (*
    Mit GPM auf freeBSD gibt's ein Problem mit ReadChar aus TextIO.
    Dieses Problem lt sich umgehen, indem _nicht_ bis zum letzten
    Zeichen gelesen wird. Damit dies getan werden kann, mu
    wenigstens _ein_ Dummy-Zeichen gepostet werden, welches dann
    _nicht_ gelesen wird. Wir fgen also ein ganzes bugdummy mit
    Wert 00 an und sind damit zufrieden.
    *)
    WriteString(lcid_out, '<INPUT NAME=bugdummy TYPE=HIDDEN VALUE="00">');
    WriteLnCrLf(lcid_out);
    WriteString(lcid_out, '</FORM>');
    WriteLnCrLf(lcid_out);
  END schreib_form_end;


PROCEDURE schreib_td_contents(lcid_out: ChanId;
                              text, submit_name, submit_value: ARRAY OF CHAR;
                              VAR hvr: hid_val_rec_typ);
  BEGIN                         (* PROCEDURE schreib_td_contents *)
    schreib_form_start(lcid_out);
    IF Length(text)>0 THEN
      schreib_paragraph_start(lcid_out);
      WriteString(lcid_out, text);
      WriteLnCrLf(lcid_out);
      schreib_paragraph_end(lcid_out);
    END;                        (* IF length(text)>0 *)
    schreib_submit_button(lcid_out, submit_name, submit_value);
    put_hidden_values(lcid_out, hvr);
    schreib_form_end(lcid_out);
  END schreib_td_contents;


PROCEDURE schreib_td_text_form(lcid_out: ChanId;
                               align, color, rowspan, colspan, text,
                               submit_name, submit_value: ARRAY OF CHAR;
                               VAR hvr: hid_val_rec_typ);
  BEGIN                         (* PROCEDURE schreib_td_text_form *)
    schreib_td_start(lcid_out, align, color, rowspan, colspan);
    schreib_td_contents(lcid_out, text, submit_name, submit_value, hvr);
    schreib_td_end(lcid_out);
  END schreib_td_text_form;


PROCEDURE schreib_heading_align(lcid_out: ChanId;
                                text, heading, align: ARRAY OF CHAR);
  BEGIN                         (* PROCEDURE schreib_heading *)
    IF (Length(text)>0) THEN
      WriteString(lcid_out, '<');
      WriteString(lcid_out, heading);
      WriteString(lcid_out, ' ALIGN="');
      WriteString(lcid_out, align);
      WriteString(lcid_out, '"> ');
      put_amp_string(lcid_out, text);
      WriteString(lcid_out, ' </');
      WriteString(lcid_out, heading);
      WriteString(lcid_out, '>');
      WriteLnCrLf(lcid_out);
    END;                        (* IF (Length(text)>0) *)
  END schreib_heading_align;


PROCEDURE schreib_heading(lcid_out: ChanId; text, heading: ARRAY OF CHAR);
  BEGIN                         (* PROCEDURE schreib_heading *)
    schreib_heading_align(lcid_out, text, heading, 'CENTER');
  END schreib_heading;


PROCEDURE schreib_table_start_custom(lcid_out: ChanId; custom, text, heading: ARRAY OF CHAR);
  BEGIN                         (* PROCEDURE schreib_table_start *)
    schreib_heading(lcid_out, text, heading);
    WriteString(lcid_out, '<TABLE BGCOLOR="');
    WriteString(lcid_out, grau);
    WriteString(lcid_out, '" ALIGN="CENTER" BORDER="1"');
    WriteLnCrLf(lcid_out);
    WriteString(lcid_out, 'CELLSPACING="0" CELLPADDING="0"');
    WriteString(lcid_out, custom);
    WriteString(lcid_out, '>');
    WriteLnCrLf(lcid_out);
  END schreib_table_start_custom;


PROCEDURE schreib_table_start(lcid_out: ChanId; text, heading: ARRAY OF CHAR);
  BEGIN                         (* PROCEDURE schreib_table_start *)
    schreib_table_start_custom(lcid_out, ' WIDTH="80%"', text, heading);
  END schreib_table_start;


PROCEDURE schreib_table_end(lcid_out: ChanId);
  BEGIN                         (* PROCEDURE schreib_table_end *)
    WriteString(lcid_out, '</TABLE>');
    WriteLnCrLf(lcid_out);
  END schreib_table_end;


PROCEDURE start_reihe(lcid_out: ChanId);
  BEGIN                         (* PROCEDURE start_reihe *)
    WriteString(lcid_out, '<TR ALIGN="CENTER">');
    WriteLnCrLf(lcid_out);
  END start_reihe;


PROCEDURE end_reihe(lcid_out: ChanId);
  BEGIN                         (* PROCEDURE end_reihe *)
    WriteString(lcid_out, '</TR>');
    WriteLnCrLf(lcid_out);
  END end_reihe;


PROCEDURE schreib_ueberschrift(lcid_out: ChanId;
                               VAR sd: sd_rec_typ; lang: BOOLEAN;
                               seiten_info: ARRAY OF CHAR);
  VAR
    zwstr1:                     String;
    zwstr2:                     String_kurz;
    structTime:                 DateTime;
    zeit:                       CARDINAL;
    woy:                        CARDINAL;       (* week of year *)
    jahr1, jahr2:               CARDINAL;

  PROCEDURE ergaenze_schnur(VAR schnur: ARRAY OF CHAR);
    VAR
      zwstr:                    String;

    BEGIN                       (* PROCEDURE ergaenze_schnur *)
      Append(' fr Saison ', schnur);
      LUWNToZeitKwStructTime(sd.season_start, zeit, woy, structTime);
      jahr1:=structTime.year;
      IntToStr(jahr1, zwstr);
      Append(zwstr, schnur);
      (*
      Wir zeigen uns ein wenig penibel: nachdem der Anfang der Saison
      soeben ganz locker mittels LUWNToZeitKwJahr aus season_start
      ermittelt werden konnte, wollen wir nun ggf. das Ende bestimmen.
      Dazu addieren wir zum Saisonanfang einfach die wochen_anz und
      ziehen aber wieder einen Tag ab, damit wir den letzten Tag
      der letzten Woche erwischen.
      *)

      LUWNToZeitKwStructTime(sd.season_start+sd.wochen_anz, zeit, woy, structTime);
      zeit:=zeit-s_pro_tag;
      TimeToGmStructTime(zeit, structTime);
      jahr2:=structTime.year;
      IF jahr2>jahr1 THEN
        IntToStr(jahr2, zwstr);
        Append('/', schnur);
        Append(zwstr, schnur);
      END;                      (* IF jahr2>jahr1 *)
    END ergaenze_schnur;

  BEGIN                         (* PROCEDURE schreib_ueberschrift *)
    (*
    Es gibt eine lange oder eine kurze berschrift. Je nach Kontext, von
    dem aus schreib_ueberschrift aufgerufen wird, gibt's eben eine kurze
    oder eine lange berschrift. Z.B. wenn der Administrator am Machen ist,
    gibt's eine kurze berschrift, weil wir da evtl. noch nichts wissen
    ber Kalenderwochen oder Tage oder so. Im Falle des gewhnlichen Spielers
    sind wir ein bichen gesprchiger.
    *)

    zwstr1:=version;
    Append(', Server: ', zwstr1);
    Append(server_name, zwstr1);
    Append(', Tabelle: ', zwstr1);
    IntToStr(tabellen_nummer, zwstr2);
    Append(zwstr2, zwstr1);
    Append(' , page: ', zwstr1);
    Append(seiten_info, zwstr1);
    schreib_heading(lcid_out, zwstr1, 'H5');

    zwstr1:=ueberschrift;
    IF lang THEN
      ergaenze_schnur(zwstr1);
    END;                        (* IF lang *)
    schreib_heading(lcid_out, zwstr1, 'H3');
  END schreib_ueberschrift;


PROCEDURE get_nice_color(wert: INTEGER; VAR color: String);
  CONST
    digits=                     6;
  VAR
    rot, gruen, blau:           INTEGER;
    hwi:                        INTEGER;
    hwi2:                       INTEGER;

  BEGIN                         (* PROCEDURE get_nice_color *)
    (*
    Naja, mu man nicht verstehen. Alle 32 Zahlen wiederholt
    sich die ganze Chose.
    *)
    wert:=wert MOD 32;
    rot:=64*(1 + 2*(wert MOD 2));
    gruen:=256-(wert DIV 2)*16;
    IF gruen>=256 THEN gruen:=255 END;
    blau:=(wert DIV 2)*16;
    IF blau>=256 THEN blau:=255 END;
    wert:=rot*256*256 + gruen*256 + blau;

    Assign('#', color);
    FOR hwi:=0 TO digits-1 DO
      Append(' ', color);
    END;                        (* FOR hwi *)
    FOR hwi:=0 TO digits-1 DO
      hwi2:=wert MOD 16;
      color[digits-hwi]:=hex_str[hwi2];
      wert:=wert DIV 16;
    END;                        (* FOR hwi *)
  END get_nice_color;


PROCEDURE schreib_page_table0(lcid_out: ChanId;
                              VAR sd: sd_rec_typ; ich_will_action: INTEGER;
                              lang: BOOLEAN; seiten_info: ARRAY OF CHAR);
  PROCEDURE schreib_erste_reihe(lcid_out: ChanId);
    VAR
      get_str:                  String;
      text:                     String_mittel;
      submit_name:              String;
      submit_value:             String;
      color:                    String;

    BEGIN                       (* PROCEDURE schreib_erste_reihe *)
      start_reihe(lcid_out);

      WITH hvr DO
        anz:=2;
        Assign(input[ii01].name_strr, nam[0]);
        IntToStr(input[ii01].value, val[0]);
        Assign(input[ii04].name_strr, nam[1]);
        IntToStr(p0ac1, val[1]);
      END;                      (* WITH hvr *)
      CASE server_name_index OF
        | 0:                    (* 'default' (z.B. www.muc.de/colin2.muc.de) *)
            Assign('<IMG SRC="my_icons/powerlogo.gif" BORDER="0" ALT="POWERED BY FREEBSD!">', text);

        | 1,2,3,4:              (* dose.muc.de, 190.64.6.48, www.rudolf-schubert.dyndns.org, localhost *)
            (*
            Assign('<IMG SRC="/squash/my_icons/linlog.gif" BORDER="0" ALT="LINUX NOW!">', text);
            +++
            *)
            Assign('<IMG SRC="my_icons/linlog.gif" BORDER="0" ALT="LINUX NOW!">', text);


        | ELSE                  (* berhaupt *)
            Assign('<IMG SRC="my_icons/powerlogo.gif" BORDER="0" ALT="POWERED BY FREEBSD!">', text);
      END;                      (* CASE server_name_index *)
      gen_get_string(hvr, get_str, text);
      schreib_td_text(lcid_out, 'CENTER', grau, '1', '1', get_str);

      WITH hvr DO
        anz:=2;
        Assign(input[ii01].name_strr, nam[0]);
        IntToStr(input[ii01].value, val[0]);
        Assign(input[ii04].name_strr, nam[1]);
        IntToStr(p0ac2, val[1]);
      END;                      (* WITH hvr *)
      CASE server_software_index OF
        | 0:                    (* Apache *)
            CASE server_name_index OF
              | 0:              (* 'default' (z.B. www.muc.de/colin2.muc.de) *)
                  Assign('<IMG SRC="my_icons/apache_pb.gif" BORDER="0" ALT="Powered by APACHE">', text);

              | 1,2,3,4:        (* dose.muc.de, 190.64.6.48, www.rudolf-schubert.dyndns.org, localhost *)
                  (*
                  Assign('<IMG SRC="/squash/my_icons/apache_pb.gif" BORDER="0" ALT="Powered by APACHE">', text);
                  +++
                  *)
                  Assign('<IMG SRC="my_icons/apache_pb.gif" BORDER="0" ALT="Powered by APACHE">', text);

              | ELSE            (* berhaupt *)
                  Assign('<IMG SRC="my_icons/apache_pb.gif" BORDER="0" ALT="Powered by APACHE">', text);
            END;                      (* CASE server_name_index *)

        | 1:                    (* Roxen *)
            Assign('<IMG SRC="my_icons/roxen_webserver.gif" BORDER="0" ALT="Roxen WebServer ">', text);

        | ELSE                  (* Default *)
            Assign('<IMG SRC="my_icons/apache_pb.gif" BORDER="0" ALT="Powered by APACHE">', text);
      END;                      (* CASE server_software_index *)
      gen_get_string(hvr, get_str, text);
      schreib_td_text(lcid_out, 'CENTER', grau, '1', '1', get_str);

      (*
      Falls die 'Nullaktion' stattfinden soll, geben wir gleich gar keinen
      Submit-Button aus, weil er dann eh berflssig ist:
      *)
      IF ich_will_action=nullac THEN
        schreib_td_text(lcid_out, 'CENTER', grau, '1', '1', '- - - - - -');
      ELSE                      (* IF ich_will_action=nullac *)
        Assign(input[ii00].name_strr, submit_name);
        submit_value:='Ich will...';
        WITH hvr DO
          anz:=2;
          Assign(input[ii01].name_strr, nam[0]);
          IntToStr(input[ii01].value, val[0]);
          Assign(input[ii04].name_strr, nam[1]);
          IntToStr(ich_will_action, val[1]);
        END;                    (* WITH hvr *)
        schreib_td_text_form(lcid_out, 'CENTER', pink, '1', '1', '', submit_name,
                             submit_value, hvr);
      END;                      (* ELSE ich_will_action=nullac *)

      (*
      Beim Chat-Button hngen wir uns einfach an den 'Ich will...'-Button.
      Falls dieser auf nullac steht, gibt's auch keinen Chat.
      *)
      IF ich_will_action=nullac THEN
        schreib_td_text(lcid_out, 'CENTER', grau, '1', '1', '- - - - - -');
      ELSE                      (* IF ich_will_action=nullac *)
        Assign(input[ii00].name_strr, submit_name);
        submit_value:='...chatten';
        WITH hvr DO
          anz:=2;
          Assign(input[ii01].name_strr, nam[0]);
          IntToStr(input[ii01].value, val[0]);
          Assign(input[ii04].name_strr, nam[1]);
          IntToStr(p1ac3, val[1]);
        END;                    (* WITH hvr *)
        get_nice_color(sd.chat_counter, color);
        schreib_td_text_form(lcid_out, 'CENTER', color, '1', '1', '', submit_name,
                             submit_value, hvr);
      END;                      (* ELSE ich_will_action=nullac *)

      end_reihe(lcid_out);
    END schreib_erste_reihe;


  BEGIN                         (* PROCEDURE schreib_page_table0 *)
    schreib_table_start(lcid_out, '', '');
    schreib_erste_reihe(lcid_out);
    schreib_table_end(lcid_out);
    schreib_ueberschrift(lcid_out, sd, lang, seiten_info);
  END schreib_page_table0;


PROCEDURE schreib_page_table_admin_progress(lcid_out: ChanId; index: INTEGER);

  PROCEDURE schreib_erste_reihe(lcid_out: ChanId);
    VAR
      zwstr:                    String;

    BEGIN                       (* PROCEDURE schreib_erste_reihe *)
      start_reihe(lcid_out);

      IntToStr(max_sea_state-1, zwstr);

      schreib_td_start(lcid_out, 'CENTER', grau, '1', zwstr);
      schreib_paragraph_start(lcid_out);
      schreib_text_crlf(lcid_out, 'Wir befinden uns im Wartungszyklus. Mit spitzen Klammern');
      schreib_paragraph_end(lcid_out);
      schreib_text_crlf(lcid_out, 'markiertes Kstchen deutet aktuellen Wartungsschritt an:');
      schreib_td_end(lcid_out);

      end_reihe(lcid_out);
    END schreib_erste_reihe;

  PROCEDURE schreib_zweite_reihe(lcid_out: ChanId);
    VAR
      i:                        INTEGER;
      zwstr:                    String;
      zwstr2:                   String;
      color:                    String;

    BEGIN                       (* PROCEDURE schreib_zweite_reihe *)
      start_reihe(lcid_out);

      FOR i:=1 TO max_sea_state-1 DO
        IF (index = (i+1)) THEN
          zwstr:='&gt; ';
          IntToStr(i, zwstr2);
          Append(zwstr2, zwstr);
          Append(' &lt;', zwstr);
          color:=hellrot;
        ELSE                    (* IF (index = (i+1)) *)
          zwstr:='- ';
          IntToStr(i, zwstr2);
          Append(zwstr2, zwstr);
          Append(' -', zwstr);
          color:=grau;
        END;                    (* ELSE (index = (i+1)) *)
        schreib_td_text(lcid_out, 'CENTER', color, '1', '1', zwstr);
      END;                      (* FOR i *)

      end_reihe(lcid_out);
    END schreib_zweite_reihe;

  BEGIN                         (* PROCEDURE schreib_page_table_admin_progress *)
    schreib_table_start(lcid_out, '', '');
    schreib_erste_reihe(lcid_out);
    schreib_zweite_reihe(lcid_out);
    schreib_table_end(lcid_out);
  END schreib_page_table_admin_progress;


PROCEDURE erst_zweit_gast_eintrag(lcid_out: ChanId; VAR sd: sd_rec_typ);
  VAR
    ukwa:                       INTEGER;
    format:                     ConvResults;
    von, bis, index:            INTEGER;
    max_kw_delta:               INTEGER;
    client_ukw:                 INTEGER;
    lang_voraus:                BOOLEAN;
    structTime:                 DateTime;
    zeit:                       CARDINAL;
    woy:                        CARDINAL;       (* week of year *)
    schnur:                     String;
    zwstr:                      String;
    erst_str:                   String;
    zweit_str:                  String;

  PROCEDURE SchneidGgfEndeAb(VAR schnur: ARRAY OF CHAR);
    VAR
      laenge:                   INTEGER;

    BEGIN                       (* PROCEDURE SchneidGgfEndeAb *)
      laenge:=Length(schnur);
      IF laenge>0 THEN
        Delete(schnur, laenge-1, 1);
      END;                      (* IF laenge>0 *)
    END SchneidGgfEndeAb;

  BEGIN                         (* PROCEDURE erst_zweit_gast_eintrag *)
    (*
    Zuerst sehen wir nach, in welchen Wochen (zumindest theoretisch)
    eine Ersteintragung mglich ist. 'zumindest theoretisch' deshalb,
    weil wir uns nur fr ganze Wochen interessieren. Ist in der aktuellen
    Woche z.B. nur Mo und Di eine Eintragung mglich (weil sonst keine
    Courts reserviert sind), kann man sich natrlich z.B. am Mi nicht
    mehr eintragen. 'Zumindest theoretisch' wre eine Eintragung aber
    von der 'Wochenentfernung' her mglich.
    *)

    (*
    Als erstes brauchen wir mal die aktuelle Unix-Woche (ukwa):
    *)
    StrToInt(ukwa_str, ukwa, format);

    (*
    Nun mssen wir der Reihe nach alle knftigen Wochen daraufhin
    abklappern, wieviele Wochen vorher eine Eintragung erlaubt ist.
    Dies geschieht ber sd.jahr_wochen_zugriff. Wir mssen nicht
    einmal bis zum Ende der Saison durchfahren, weil es ja eine
    Obergrenze fr das maximal erlaubte 'Wochendelta' (max_kw_delta)
    gibt: max_jahr_wochen_zugriff. Bezeichnen wir etwa mit client_ukw
    die Unix-Woche, auf die der User zugreifen mchte, dann ist der
    kleinste Wert von client_ukw, fr den wir uns hier interessieren
    einfach gleich ukwa. Der grte wre dann ukwa + max_jahr_wochen_zugriff,
    falls wir damit nicht bereits ber das Saisonende hinausschieen.
    Als Index fr jahr_wochen_zugriff brauchen wir um season_start
    verkleinerte Werte. Wir mssen also nur zusehen, da unser Index
    (ukwa + max_jahr_wochen_zugriff - sd.season_start) nicht grer
    als (wochen_anz-1) wird. Oder besser: wir ermittlen 'von'
    und 'bis' zunchst ohne Rcksicht auf etwaige Indexprobleme in
    jahr_wochen_zugriff. Bei der Abarbeitung der Schleife prfen
    wir dann aber auf Einhaltung des Index. Indices auerhalb
    0..(wochen_anz-1) werden dann einfach ignoriert.
    *)

    (*
    Fr's Enhancement des spter auszugebenden Headings besetzen wir
    mal vor, als ob _nicht_ lange im Voraus eingetragen werden knnte:
    *)
    lang_voraus:=FALSE;
    WITH sd DO
      erst_str:='';
      von:=ukwa-season_start;
      bis:=ukwa + max_jahr_wochen_zugriff - season_start;
      (*
      Aus jahr_wochen_zugriff holen wir uns nun fr alle in Frage
      kommenden Wochen max_kw_delta und entscheiden dann, ob eine
      Ersteintragung mglich ist.
      *)
      FOR index:=von TO bis DO
        IF ((index>=0) AND (index<=(wochen_anz-1))) THEN
          max_kw_delta:=jahr_wochen_zugriff[index];
          IF (((index-von) < max_kw_delta) OR 
              ((index-von) = max_kw_delta) AND (NOT vor_9_montag)) THEN
            client_ukw:=index + season_start;
            (*
            Mit client_ukw haben wir jetzt eine Woche gefunden, in
            der eine Ersteintragung mglich ist. Wir mssen untersuchen,
            wie weit client_ukw von ukwa entfernt ist. Sollte unter
            wenigstens einer der client_ukws hier und ukwa ein
            grerer Abstand als z.B. jahr_wochen_zugriff_default Wochen
            vorliegen, dann werden wir die Darstellung 'enhancen'.
            *)
            IF ((client_ukw - ukwa) > jahr_wochen_zugriff_default) THEN
              lang_voraus:=TRUE;
            END;                (* IF ((client_ukw... *)
            LUWNToZeitKwStructTime(client_ukw, zeit, woy, structTime);
            IntToStr(woy, zwstr);
            Append(' ', erst_str); 
            Append(zwstr, erst_str);
            Append(',', erst_str); 
          END;                  (* IF ((index-von) <= max_kw_delta) *) 
        END;                    (* IF ((index>=0)... *)
      END;                      (* FOR index *)
      (*
      Nach der letzten KW brauchen wir das Komma natrlich nicht,
      d.h. wir mssen es ggf. wieder wegnehmen.
      *)
      SchneidGgfEndeAb(erst_str);

      (*
      Fr die Zweit-, Gasteintragung gelten folgende berlegungen:
      Sie sind, wenn berhaupt, nur in der aktuellen und in der auf
      die aktuelle Woche folgenden Woche mglich. (allerdings nur
      maximal eine Zweit- und eine Gasteintragung). Dabei sind die
      beiden Eintragungen nicht nur alternativ, sondern auch gleich-
      zeitig mglich. Eine Zweit-, Gasteintragung ist dabei nur
      mglich, falls auch eine Ersteintraugung mglich ist.
      *)

      zweit_str:='';
      index:=von;
      IF ((index>=0) AND (index<=(wochen_anz-1))) THEN
        max_kw_delta:=jahr_wochen_zugriff[index];
        IF ((0 < max_kw_delta) OR 
            (0 = max_kw_delta) AND (NOT vor_9_montag)) THEN
          client_ukw:=index + season_start;
          LUWNToZeitKwStructTime(client_ukw, zeit, woy, structTime);
          IntToStr(woy, zwstr);
          Append(' ', zweit_str); 
          Append(zwstr, zweit_str);
          Append(',', zweit_str); 
        END;                    (* IF ((index-von) <= max_kw_delta) *) 
      END;                      (* IF ((index>=0)... *)

      index:=von+1;
      IF ((index>=0) AND (index<=(wochen_anz-1))) THEN
        max_kw_delta:=jahr_wochen_zugriff[index];
        IF ((1 < max_kw_delta) OR 
            (1 = max_kw_delta) AND (NOT vor_9_montag)) THEN
          IF (NOT vor_9_donnerstag) THEN
            client_ukw:=index + season_start;
            LUWNToZeitKwStructTime(client_ukw, zeit, woy, structTime);
            IntToStr(woy, zwstr);
            Append(' ', zweit_str); 
            Append(zwstr, zweit_str);
            Append(',', zweit_str); 
          END;                  (* IF (NOT vor_9_donnerstag) *)
        END;                    (* IF ((index-von) <= max_kw_delta) *) 
      END;                      (* IF ((index>=0)... *)

      (*
      Nach der letzten KW brauchen wir das Komma natrlich nicht,
      d.h. wir mssen es ggf. wieder wegnehmen.
      *)
      SchneidGgfEndeAb(zweit_str);

    END;                        (* WITH sd *)

    (*
    Im folgenden werden alle 4 Flle bercksichtigt: Ersteintragung
    mglich / nicht mglich und Zweiteintragung mglich / nicht mglich.
    Tatschlich ist, wie an anderer Stelle bemerkt, eine Zweitein-
    tragung nicht mglich, falls eine Ersteintragung nicht mglich ist.
    Wir wollen dennoch sicherheitshalber alle 4 Flle betrachten.
    *)
    schnur:='Hinweis: ';
    IF (CompareRS(erst_str, '')=equal) THEN
      IF (CompareRS(zweit_str, '')=equal) THEN
        Append('zur Zeit keine Eintragung mglich', schnur);
      ELSE                      (* IF (CompareRS(zweit_str, '')=equal) *)
        Append('Ersteintragung nicht mglich; Zweit-, private Gasteintragung in KW ', schnur); 
        Append(zweit_str, schnur);
      END;                      (* ELSE (CompareRS(zweit_str, '')=equal) *)
    ELSE                        (* IF (CompareRS(erst_str, '')=equal) *)
      Append('Ersteintragung mglich fr KW', schnur);
      Append(erst_str, schnur);
      IF (CompareRS(zweit_str, '')=equal) THEN
        Append('; Zweit-, private Gasteintragung nicht mglich', schnur);
      ELSE                      (* IF (CompareRS(zweit_str, '')=equal) *)
        Append('; Zweit-, private Gasteintragung mglich fr KW', schnur); 
        Append(zweit_str, schnur);
      END;                      (* ELSE (CompareRS(zweit_str, '')=equal) *)
    END;                        (* ELSE (CompareRS(erst_str, '')=equal) *)
    (*
    Falls lange im Voraus Ersteintragung mglich, dann enhancen:
    *)
    IF lang_voraus THEN
      schreib_heading(lcid_out, schnur, 'H2');
    ELSE                        (* IF lang_voraus *)
      schreib_heading(lcid_out, schnur, 'H5');
    END;                        (* ELSE lang_voraus *)

  END erst_zweit_gast_eintrag;


PROCEDURE schreib_page1_table1(lcid_out: ChanId; VAR sd: sd_rec_typ);
  PROCEDURE schreib_erste_reihe(lcid_out: ChanId);
    VAR
      format:                   ConvResults;
      hwi:                      INTEGER;
      zeit:                     CARDINAL;
      woy:                      CARDINAL;       (* week of year *)
      structTime:               DateTime;
      submit_name:              String;
      submit_value:             String;
      color:                    String;

    PROCEDURE waehle_neue_ukw(submit_name, submit_value, color: ARRAY OF CHAR;
                              hwi, action: INTEGER);
      BEGIN                     (* PROCEDURE waehle_neue_ukw *)
        WITH sd DO
          IF ((hwi<season_start) OR (hwi>(season_start+wochen_anz-1))) THEN
            schreib_td_text(lcid_out, 'CENTER', hellgelb, '1', '1', '- - - -');
          ELSE                  (* IF ((hwi>... *)
            WITH hvr DO
              anz:=2;
              Assign(input[ii01].name_strr, nam[0]);
              IntToStr(hwi, val[0]);
              Assign(input[ii04].name_strr, nam[1]);
              IntToStr(action, val[1]);
            END;                (* WITH hvr *)
            schreib_td_text_form(lcid_out, 'CENTER', color, '1', '1', '',
                                 submit_name, submit_value, hvr);
          END;                  (* ELSE ((hwi>... *)
        END;                    (* WITH sd *)
      END waehle_neue_ukw;

    BEGIN                       (* PROCEDURE schreib_erste_reihe *)
      start_reihe(lcid_out);

      Assign(input[ii00].name_strr, submit_name);

      StrToInt(ukwa_str, hwi, format);

      schreib_td_text(lcid_out, 'CENTER', hellgelb, '1', '1', 'welche KW? ');

      LUWNToZeitKwStructTime(hwi, zeit, woy, structTime);
      IntToStr(woy, submit_value);
      Append(' (aktuell)', submit_value);
      IF (hwi=input[ii01].value) THEN color:=weiss ELSE color:=hellgelb END;
      waehle_neue_ukw(submit_name, submit_value, color, hwi, p1ac1);

      hwi:=hwi+1;
      LUWNToZeitKwStructTime(hwi, zeit, woy, structTime);
      IntToStr(woy, submit_value);
      IF (hwi=input[ii01].value) THEN color:=weiss ELSE color:=hellgelb END;
      waehle_neue_ukw(submit_name, submit_value, color, hwi, p1ac1);

      hwi:=hwi+1;
      LUWNToZeitKwStructTime(hwi, zeit, woy, structTime);
      IntToStr(woy, submit_value);
      IF (hwi=input[ii01].value) THEN color:=weiss ELSE color:=hellgelb END;
      waehle_neue_ukw(submit_name, submit_value, color, hwi, p1ac1);

      hwi:=sd.season_start;
      IF (hwi=input[ii01].value) THEN color:=hellgrau ELSE color:=hellgelb END;
      waehle_neue_ukw(submit_name, '<<', color, hwi, p1ac1);

      hwi:=input[ii01].value-1;
      IF (hwi<sd.season_start) THEN hwi:=sd.season_start END;
      IF (hwi=input[ii01].value) THEN color:=hellgrau ELSE color:=hellgelb END;
      waehle_neue_ukw(submit_name, '<', color, hwi, p1ac1);

      hwi:=input[ii01].value;
      waehle_neue_ukw(submit_name, '=', hellgelb, hwi, p1ac1);

      hwi:=input[ii01].value+1;
      IF (hwi>(sd.season_start+sd.wochen_anz-1)) THEN
        hwi:=(sd.season_start+sd.wochen_anz-1) END;
      IF (hwi=input[ii01].value) THEN color:=hellgrau ELSE color:=hellgelb END;
      waehle_neue_ukw(submit_name, '>', color, hwi, p1ac1);

      hwi:=sd.season_start+sd.wochen_anz-1;
      IF (hwi=input[ii01].value) THEN color:=hellgrau ELSE color:=hellgelb END;
      waehle_neue_ukw(submit_name, '>>', color, hwi, p1ac1);

      end_reihe(lcid_out);
    END schreib_erste_reihe;

  BEGIN                         (* PROCEDURE schreib_page1_table1 *)
    schreib_table_start(lcid_out, '', '');
    schreib_erste_reihe(lcid_out);
    schreib_table_end(lcid_out);
  END schreib_page1_table1;


PROCEDURE schreib_reihe_uhrzeiten(lcid_out: ChanId; VAR sd: sd_rec_typ);
  VAR
    spalte:                     INTEGER;

  BEGIN                         (* PROCEDURE schreib_reihe_uhrzeiten *)
    start_reihe(lcid_out);
    schreib_td_text(lcid_out, 'CENTER', grau, '1', '1', 'Tag, Ort\Zeit');
    FOR spalte:=0 TO (sd.spalt_anz-1) DO
      schreib_td_text(lcid_out, 'CENTER', grau, '1', '1', hour_str[sd.uhrzeit[spalte]]);
    END;                        (* FOR spalte *)
    end_reihe(lcid_out);
  END schreib_reihe_uhrzeiten;


PROCEDURE schreib_erste_spalte(lcid_out: ChanId;
                               VAR sd: sd_rec_typ; zeile: INTEGER);
  VAR
    text:                       String;
    hwc:                        CARDINAL;
    zeit:                       CARDINAL;

  BEGIN                         (* PROCEDURE schreib_erste_spalte *)
    text:='<H4> ';
    Append(week_str[sd.wochentag[zeile]], text);
    Append(' </H4>', text);

    Append(' <H4> ', text);
    hwc:=input[ii01].value;
    UWNToTime(hwc, zeit);
    hwc:=sd.wochentag[zeile];
    (*
    Hier machen wir einen kleinen Trick: falls der ungltige
    Wochentag angesagt sein sollte, geben wir nicht echt ein
    Datum aus, sondern nur einen Dummystring.
    *)
    IF hwc<wochentage_anz THEN
      zeit:=zeit+s_pro_tag*hwc;
      Append(datum_str(zeit), text);
    ELSE                        (* IF hwc<wochentage_anz *)
      Append('kein Datum', text);
    END;                        (* ELSE hwc<wochentage_anz *)
    Append(' </H4>', text);

    Append(' <H4> ', text);
    Append(sd.court[zeile], text);
    Append(' </H4>', text);

    schreib_td_text(lcid_out, 'CENTER', grau, '1', '1', text);
  END schreib_erste_spalte;


PROCEDURE generate_player_name(VAR sd: sd_rec_typ; woche, court_index: INTEGER;
                               VAR player_name: ARRAY OF CHAR);
  VAR
    spieler_index:              INTEGER;

  BEGIN                         (* PROCEDURE generate_player_name *)
    (*
    Wir unterscheiden momentan drei Gaststatus: 
    0: Spieler selbst, nur der Spielername wird ausgegeben
    1: priv. Gast, 's Gast wird an den Spielernamen gehngt
    2: offiz. Gast, OG wird dem Spielernamen vorangestellt
    Bei 0 bzw. 1 unterscheiden wir auerdem noch, ob Spieler
    bzw. 'Gastgeber' ggf. ein 'Dauergast' ist.  Wir haben
    festgelegt, da sich Dauergste durch 'Tage voraus'
    ungleich 0 auszeichnen. Testen wir das also und markieren
    den Dauergast auch als solchen.
    *)
    spieler_index:=sd.jahr_court_belegung[woche, court_index];
    CASE sd.jahr_court_belegung_gast[woche, court_index] OF
      | 0:                      (* Spieler selbst *)
          IF sd.max_day_delta[spieler_index]<>0 THEN
            Assign('DG ', player_name);
          ELSE                  (* IF sd.max_day_delta... *)
            Assign('', player_name);
          END;                  (* ELSE sd.max_day_delta... *)
          Append(sd.spieler_name[spieler_index], player_name);

      | 1:                      (* priv. Gast *)
          IF sd.max_day_delta[spieler_index]<>0 THEN
            Assign('DG ', player_name);
          ELSE                  (* IF sd.max_day_delta... *)
            Assign('', player_name);
          END;                  (* ELSE sd.max_day_delta... *)
          Append(sd.spieler_name[spieler_index], player_name);
          Append("'s Gast", player_name);

      | 2:                      (* offiz. Gast *)
          Assign('OG ', player_name);
          Append(sd.jahr_court_belegung_gast_nam[woche, court_index], player_name);

      | ELSE                    (* sollte nie vorkommen *)
          (* nichts *)
    END;                        (* CASE sd.jahr_court_belegung_gast[woche, court_index] *)
  END generate_player_name;


PROCEDURE schreib_page1_table2(lcid_out: ChanId; VAR sd: sd_rec_typ);
  PROCEDURE schreib_restliche_reihen(lcid_out: ChanId; VAR sd: sd_rec_typ;
                                     woche: INTEGER);
    VAR
      zeile, spalte:            INTEGER;
      court_index:              INTEGER;
      color:                    String_kurz;
      forderungs_text:          String_kurz;
      submit_name:              String;
      submit_value:             String;

    BEGIN                       (* PROCEDURE schreib_restliche_reihen *)
      FOR zeile:=0 TO sd.zeil_anz-1 DO
        start_reihe(lcid_out);

        (*
        In der allerersten Spalte landet der Wochentag und der Court:
        *)
        schreib_erste_spalte(lcid_out, sd, zeile);

        (*
        In die restlichen Spalten kommen endlich die Spieler,
        und zwar jeweils zwei in ein Kstchen:
        *)

        FOR spalte:=0 TO sd.spalt_anz-1 DO
          court_index:=2*(zeile*sd.spalt_anz+spalte);
          Assign(input[ii00].name_strr, submit_name);

          IF sd.uns_court[court_index]>-1 THEN
            (*
            Hier beginnt das Kstchen, falls es ein uns_court ist.
            Wir unterscheiden dabei die verschiedenen Gaststatus.
            generate_player_name wird's richten.
            *)
            generate_player_name(sd, woche, court_index, submit_value);

            (*
            Der Hintergrund soll eine schne Farbe bekommen. Wir whlen
            je nach Belegung: hellgrn, wenn kein Spieler am Platz ist,
            hellrot, wenn beide da sind und hellgelb, wenn genau einer
            da ist.
            Heute (27.10.2001) gibt's eine kleine Erweiterung: wenn ein
            Forderungsspiel ansteht, wollen wir die Farben etwas
            modifizieren.  Anstatt hellgelb gibt's dann dunkelgelb und
            anstatt hellrot nehmen wir dann dunkelrot. Man beachte dabei,
            da court_index dazu nochmal halbiert wird.
            Auerdem erzeugen wir ggf. einen 'Forderungstext'. Bei _einem_
            Spieler, also dunkelgelb kommt sogar noch ein Fragezeichen
            dazu.
            *)
            Assign('', forderungs_text);
            IF sd.jahr_forderung[woche, court_index DIV 2]>0 THEN
              IF sd.jahr_court_belegung[woche, court_index]=0 THEN
                IF sd.jahr_court_belegung[woche, court_index+1]=0 THEN color:=hellgruen
                ELSE            (* IF sd.jahr_court_belegung[woche, court_index+1]=0 *)
                  color:=dunkelgelb;
                  Assign('Forderung?', forderungs_text);
                END;            (* ELSE sd.jahr_court_belegung[woche, court_index+1]=0 *)
              ELSE              (* IF sd.jahr_court_belegung[woche, court_index]=0 *)
                IF sd.jahr_court_belegung[woche, court_index+1]=0 THEN
                  color:=dunkelgelb;
                  Assign('Forderung?', forderungs_text);
                ELSE            (* IF sd.jahr_court_belegung[woche, court_index+1]=0 *)
                  color:=dunkelrot;
                  (*
                  Je nachdem, ob der obere Spieler den unteren fordert oder
                  umgekehrt, hngen wir einen entsprechenden Pfeil an den Text:
                  *)
                  IF sd.jahr_forderung[woche, court_index DIV 2]=2 THEN
                    Assign('Forderung \/', forderungs_text);
                  ELSE          (* IF sd.jahr_forderung... *)
                    Assign('Forderung /\', forderungs_text);
                  END;          (* ELSE sd.jahr_forderung... *)
                END;            (* ELSE sd.jahr_court_belegung[woche, court_index+1]=0 *)
              END;              (* ELSE sd.jahr_court_belegung[woche, court_index]=0 *)
            ELSE                (* IF sd.jahr_forderung... *)
              IF sd.jahr_court_belegung[woche, court_index]=0 THEN
                IF sd.jahr_court_belegung[woche, court_index+1]=0 THEN color:=hellgruen
                ELSE color:=hellgelb END;
              ELSE              (* IF sd.jahr_court_belegung[woche, court_index]=0 *)
                IF sd.jahr_court_belegung[woche, court_index+1]=0 THEN color:=hellgelb
                ELSE color:=hellrot END;
              END;              (* ELSE sd.jahr_court_belegung[woche, court_index]=0 *)
            END;                (* ELSE sd.jahr_forderung... *)

            (*
            Jetzt also der erste Eintrag im Kstchen.
            *)
            schreib_td_start(lcid_out, 'CENTER', color, '1', '1');

            WITH hvr DO
              anz:=4;
              Assign(input[ii01].name_strr, nam[0]);
              IntToStr(input[ii01].value, val[0]);
              Assign(input[ii02].name_strr, nam[1]);
              IntToStr(sd.uns_court[court_index], val[1]);
              Assign(input[ii03].name_strr, nam[2]);
              IntToStr(sd.jahr_court_belegung[woche, court_index], val[2]);
              Assign(input[ii04].name_strr, nam[3]);
              IntToStr(p1ac2, val[3]);
            END;                (* WITH hvr *)
            (*
            In der Vergangenheit bieten wir gar keinen Button mehr an:
            *)
            IF (user_time(sd1, input[ii01].value, court_index) > zeitalc) THEN
              schreib_td_contents(lcid_out, '', submit_name, submit_value, hvr);
            ELSE                (* IF (user_time... *)
              schreib_paragraph_start(lcid_out);
              schreib_text_crlf(lcid_out, submit_value);
              schreib_paragraph_end(lcid_out);
            END;                (* ELSE (user_time...*)

            (*
            forderungs_text ausgeben. Auf richtigen Inhalt wurde
            weiter oben geachtet! Ausgabe allerdings nur, falls
            auch wirklich was auzugeben ist.
            *)

            IF Length(forderungs_text)>0 THEN
              schreib_paragraph_start(lcid_out);
              schreib_text_crlf(lcid_out, forderungs_text);
              schreib_paragraph_end(lcid_out);
            END;                (* IF length(forderungs_text)>0 *)

            (*
            Fr den zweiten Eintrag mssen ein paar Anpassungen
            gemacht werden. Hier mu brigens nicht mehr geprft werden,
            ob es sich um einen uns_court handelt, wenn court_index
            um 1 erhht wurde, denn court_index durchluft oben nur
            gerade Werte und die Belegung ist entweder so, da
            der Court *nicht* gemietet ist oder eben eine gerade (Halb-)
            Courtnummer und die dauraufflogende ungerade auch bentzbar
            ist, weil der Court eben angemietet ist. Auch hier
            unterscheiden wir die verschiedenen Gaststatus wieder mittels
            generate_player_name.
            *)
            court_index:=court_index+1;
            generate_player_name(sd, woche, court_index, submit_value);

            WITH hvr DO
              Assign(input[ii02].name_strr, nam[1]);
              IntToStr(sd.uns_court[court_index], val[1]);
              Assign(input[ii03].name_strr, nam[2]);
              IntToStr(sd.jahr_court_belegung[woche, court_index], val[2]);
            END;                (* WITH hvr *)
            (*
            In der Vergangenheit bieten wir gar keinen Button mehr an:
            *)
            IF (user_time(sd1, input[ii01].value, court_index) > zeitalc) THEN
              schreib_td_contents(lcid_out, '', submit_name, submit_value, hvr);
            ELSE                (* IF (user_time... *)
              schreib_text_crlf(lcid_out, submit_value);
            END;                (* ELSE (user_time...*)
          ELSE                  (* IF sd.uns_court[court_index]>-1 *)
            (*
            Hier beginnt das Kstchen, falls es *kein* uns_court ist.
            *)
            schreib_td_start(lcid_out, 'CENTER', grau, '1', '1');
            schreib_text_crlf(lcid_out, '- - - -');
          END;                  (* ELSE sd.uns_court[court_index]>-1 *)

          (*
          Und hier ist das Kstchen zuende, egal welches es war.
          *)
          schreib_td_end(lcid_out);
        END;                    (* FOR spalte *)

        end_reihe(lcid_out);
      END;                      (* FOR zeile *)
    END schreib_restliche_reihen;

  BEGIN                         (* PROCEDURE schreib_page1_table2 *)
    schreib_table_start(lcid_out, '', '');
    schreib_reihe_uhrzeiten(lcid_out, sd);
    schreib_restliche_reihen(lcid_out, sd, input[ii01].value-sd.season_start);
    schreib_table_end(lcid_out);
  END schreib_page1_table2;


PROCEDURE schreib_page_trailer(lcid_out: ChanId);
  VAR
    structTime:                 DateTime;
    strTime:                    String;

  BEGIN                         (* PROCEDURE schreib_page_trailer *)
    TimeToLcStructTime(zeitagm, structTime);
    StructTimeToAsciiRS1(strTime, structTime);

    schreib_hr(lcid_out);

    IF (lcid_out=cid_out) THEN
      (*
      Die Client Info wird, falls berhaupt, nur auf den
      StdOutChan ausgegeben.
      *)

      (*
      Nachsehen, ob bitleiste (bit1) Debugging fordert.
      Falls ja, machen wir eine Ausgabe:
      *)
      IF ODD((sd1.bitleiste DIV 2)) THEN
        show_client_info1(lcid_out);
        show_client_info2(lcid_out);
      ELSE                      (* IF ODD((sd1.bitleiste DIV 2)) *)
        (* nichts *)
      END;                      (* ELSE ODD((sd1.bitleiste DIV 2)) *)

    END;                        (* IF (lcid_out... *)

    WriteString(lcid_out, '<ADDRESS>');
    WriteLnCrLf(lcid_out);
    WriteString(lcid_out, 'Rudolf Schubert,');
    WriteLnCrLf(lcid_out);

    WriteString(lcid_out, '<A HREF="mailto:');
    WriteString(lcid_out, mailto_user);
    WriteString(lcid_out, '@');
    WriteString(lcid_out, mailto_rechner);
    WriteString(lcid_out, '"> ');
    WriteString(lcid_out, mailto_user);
    WriteString(lcid_out, '@');
    WriteString(lcid_out, mailto_rechner);
    WriteString(lcid_out, ' </A>,');
    WriteLnCrLf(lcid_out);

    WriteString(lcid_out, strTime);
    WriteString(lcid_out, '; page hits: ');
    WriteInt(lcid_out, sd1.site_counter, 1);
    WriteLnCrLf(lcid_out);

    WriteString(lcid_out, '</ADDRESS>');
    WriteLnCrLf(lcid_out);
    WriteString(lcid_out, '</BODY>');
    WriteLnCrLf(lcid_out);
    WriteString(lcid_out, '</HTML>');
    WriteLnCrLf(lcid_out);
  END schreib_page_trailer;


PROCEDURE schreib_page01(VAR sd: sd_rec_typ);
  (*
  Dies ist die Hauptseite. Die erste Tabelle dient der Auswahl
  der Kalenderwoche, die zweite Tabelle zeigt die Belegung fr die
  ausgewhlte Kalenderwoche.
  *)
  VAR
    zwstr:                      String;

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, p1ac0, TRUE, '01');

      (*
      Falls lasche Eintragungsprfung gefragt ist, wird auch
      erst_zweit_gast_eintrag nicht aufgerufen:
      *)
      IF ODD(sd.bitleiste) THEN
        (* nichts *)
      ELSE                      (* IF ODD(sd.bitleiste) *)
        erst_zweit_gast_eintrag(lcid_out, sd);
      END;                      (* ELSE ODD(sd.bitleiste) *)

      schreib_page1_table1(lcid_out, sd);
      LUWNToLesbar(input[ii01].value, zwstr);
      schreib_heading(lcid_out, zwstr, 'H3');
      schreib_page1_table2(lcid_out, sd);
      schreib_heading(lcid_out, 'Hinweis: offizielle Gste werden "OG", Dauergste "DG", private Gste einfach "Gast" genannt', 'H5');
      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page01 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page01;


PROCEDURE ermittle_wann_und_wo(VAR sd: sd_rec_typ; VAR text: String;
                               court_index: INTEGER);
  VAR
    wt_index:                   INTEGER;
    uz_index:                   INTEGER;
    hwc:                        CARDINAL;
    zeit:                       CARDINAL;

  BEGIN                         (* PROCEDURE ermittle_wann_und_wo *)
    uz_index:=(court_index MOD (2*sd.spalt_anz)) DIV 2;
    wt_index:=court_index DIV (2*sd.spalt_anz);

    Assign(week_str[sd.wochentag[wt_index]], text);

    hwc:=input[ii01].value;
    UWNToTime(hwc, zeit);
    hwc:=sd.wochentag[wt_index];

    Append(', ', text);

    (*
    Hier machen wir einen kleinen Trick: falls der ungltige
    Wochentag angesagt sein sollte, geben wir nicht echt ein
    Datum aus, sondern nur einen Dummystring.
    *)
    IF hwc<wochentage_anz THEN
      zeit:=zeit+s_pro_tag*hwc;
      Append(datum_str(zeit), text);
    ELSE                        (* IF hwc<wochentage_anz *)
      Append('kein Datum', text);
    END;                        (* ELSE hwc<wochentage_anz *)

    Append(', ', text);
    Append(hour_str[sd.uhrzeit[uz_index]], text);
    Append(', ', text);
    Append(sd.court[wt_index], text);
  END ermittle_wann_und_wo;


PROCEDURE schreib_wann_und_wo(lcid_out: ChanId; VAR sd: sd_rec_typ);
  VAR
    text:                       String;
    court_index:                INTEGER;

  BEGIN                         (* PROCEDURE schreib_wann_und_wo *)
    court_index:=sd.geschrumpfter_index[input[ii02].value];
    ermittle_wann_und_wo(sd, text, court_index);
    schreib_heading(lcid_out, text, 'H3');
  END schreib_wann_und_wo;


PROCEDURE setz_min_vorn_hin(VAR sel_rec_typ_ptr: sel_rec_typ_ptr_typ;
                            von, bis: INTEGER);
  VAR
    i:                          INTEGER;
    zwstr:                      String;
    hwi:                        INTEGER;
    lcl_ptr_von, lcl_ptr_min:   sel_rec_typ_ptr_typ;
    lcl_ptr_wrk:                sel_rec_typ_ptr_typ;

  BEGIN                         (* PROCEDURE setz_min_vorn_hin *)
    (*
    Nur falls mehr als ein Element da ist, tun wir berhaupt was:
    *)
    IF bis>von THEN
      (*
      Zuerst das Minimum suchen. Dabei mssen wir uns aber erst mal bis
      nach 'von' durcharbeiten. Momentan stehen wir nmlich noch bei 0:
      *)
      lcl_ptr_von:=sel_rec_typ_ptr;
      FOR i:=0 TO von-1 DO
        lcl_ptr_von:=lcl_ptr_von^.sel_rec_typ_ptr;
      END;                      (* FOR i *)

      (*
      Wir starten mit dem Record bei 'von' als dem Minimum:
      *)
      lcl_ptr_min:=lcl_ptr_von;

      lcl_ptr_wrk:=lcl_ptr_min;
      FOR i:=von+1 TO bis DO
        lcl_ptr_wrk:=lcl_ptr_wrk^.sel_rec_typ_ptr;
        IF (CompareRS(lcl_ptr_wrk^.schnur, lcl_ptr_min^.schnur)=less) THEN
          lcl_ptr_min:=lcl_ptr_wrk;
        END;                    (* IF (CompareRS... *)
      END;                      (* FOR i *)

      (*
      lcl_ptr_min zeigt auf das kleinste Element. Dies tauschen wir nun
      mit dem bei 'von' stehenden aus:
      *)
      Assign(lcl_ptr_von^.schnur, zwstr);
      hwi:=lcl_ptr_von^.zahl;

      Assign(lcl_ptr_min^.schnur, lcl_ptr_von^.schnur);
      lcl_ptr_von^.zahl:=lcl_ptr_min^.zahl;

      Assign(zwstr, lcl_ptr_min^.schnur);
      lcl_ptr_min^.zahl:=hwi;
    END;                        (* IF bis>von *)
  END setz_min_vorn_hin;


PROCEDURE sortiere_selection(VAR sel_rec_typ_ptr: sel_rec_typ_ptr_typ;
                             von, bis: INTEGER);
  VAR
    i:                          INTEGER;
    zwstr:                      String;
    hwi:                        INTEGER;

  BEGIN                         (* PROCEDURE sortiere_selection *)
    FOR i:=von TO bis-1 DO
      setz_min_vorn_hin(sel_rec_typ_ptr, i, bis);
    END;                        (* FOR i *)
  END sortiere_selection;


PROCEDURE find_in_selection(VAR sel_rec_typ_ptr: sel_rec_typ_ptr_typ;
                            VAR bis: INTEGER; index: INTEGER;
                            VAR found: BOOLEAN; VAR schnur: ARRAY OF CHAR);
  VAR
    i:                          INTEGER;
    lcl_ptr:                    sel_rec_typ_ptr_typ;

  BEGIN                         (* PROCEDURE find_in_selection *)
    i:=0;
    found:=FALSE;
    lcl_ptr:=sel_rec_typ_ptr;
    WHILE ((i<=bis) AND (NOT found)) DO
      IF (lcl_ptr^.zahl=index) THEN
        found:=TRUE;
        Assign(lcl_ptr^.schnur, schnur);
      END;                      (* IF (CompareRS... *)
      lcl_ptr:=lcl_ptr^.sel_rec_typ_ptr;
      i:=i+1;
    END;                        (* WHILE ((i<=hwi)... *)
  END find_in_selection;


PROCEDURE delete_selection(VAR sel_rec_typ_ptr: sel_rec_typ_ptr_typ;
                           VAR bis: INTEGER; index: INTEGER);
  (*
  Die selection wird von vorne bis 'bis' durchsucht, ob
  bzw. bis 'zahl' den Wert index annimmt. Falls es einen
  solchen Eintrag gibt, wird er aus der Liste gestrichen
  und 'bis' wird um 1 verkleinert.
  *)
  VAR
    i:                          INTEGER;
    lcl_ptr, old_ptr, hlp_ptr:  sel_rec_typ_ptr_typ;
    weiter_testen:              BOOLEAN;

  BEGIN                         (* PROCEDURE delete_selection *)
    i:=0;
    weiter_testen:=TRUE;
    lcl_ptr:=sel_rec_typ_ptr;
    (*
    Wir verbiegen in Wirklichkeit bei Bedarf nur die Zeiger. Fr
    den Fall, da bereits der erste Record der zu streichende ist,
    mssen wir also einen Sonderfall behandeln. Bei genauem Hinsehen
    bemerken wir, da der einzige Unterschied zwischen hier und der
    WHILE-Schleife unten lediglich darin besteht, da im IF-Zweig
    hier der neue Pointer nach 'sel_rec_typ_ptr' geschreiben wird
    und in der WHILE-Schleife nach old_ptr^.sel_rec_typ_ptr.
    *)
    IF (lcl_ptr^.zahl=index) THEN
      hlp_ptr:=lcl_ptr^.sel_rec_typ_ptr;
      DISPOSE(lcl_ptr);
      sel_rec_typ_ptr:=hlp_ptr;
      (*
      Sollte bereits der erste Record unsere Bedingung erfllen, sind
      wir hier schon fertig. O.k. 'bis' mssen wir noch dekrementieren
      und 'weiter_testen' auf FALSE setzen. Damit aber wird die WHILE-
      Schleife unten gar nicht mehr angerhrt.
      *)
      weiter_testen:=FALSE;
      bis:=bis-1;
    ELSE                        (* IF (... *)
      (*
      Hat der erste Record unsere Bedingung nicht erfllt, lassen wir
      'old_ptr' erst mal auf den ersten Record zeigen und stellen den
      'lcl_ptr' schon mal auf den nchsten Record. Damit sind dann
      die Startbedingungen fr die WHILE-Schleife korrekt gesetzt.
      *)
      old_ptr:=lcl_ptr;
      lcl_ptr:=lcl_ptr^.sel_rec_typ_ptr;
    END;                        (* ELSE (... *)
    (*
    'i' wird in jedem Fall inkrementiert, um die Anzahl bearbeiteter
    Records mitzuverfolgen:
    *)
    i:=i+1;

    WHILE ((i<=bis) AND (weiter_testen)) DO
      IF (lcl_ptr^.zahl=index) THEN
        hlp_ptr:=lcl_ptr^.sel_rec_typ_ptr;
        DISPOSE(lcl_ptr);
        old_ptr^.sel_rec_typ_ptr:=hlp_ptr;
        weiter_testen:=FALSE;
        bis:=bis-1;
      ELSE                      (* IF (... *)
        old_ptr:=lcl_ptr;
        lcl_ptr:=lcl_ptr^.sel_rec_typ_ptr;
      END;                      (* ELSE (... *)
      i:=i+1;
    END;                        (* WHILE ((i<=bis)... *)
  END delete_selection;


PROCEDURE copy_von_bis(VAR sd: sd_rec_typ; 
                       VAR lcl_ptr: sel_rec_typ_ptr_typ;
                       von, bis: INTEGER;
                       VAR hwi: INTEGER);
  VAR
    i:                          INTEGER;

  BEGIN                         (* PROCEDURE copy_von_bis *)
    (*
    30.10.2004: wir kopieren nicht nur einfach die Namen der Spieler, sondern
    hngen hinten auch noch ein bichen Info hin, um welchen Typ von Spieler
    es sich handelt: DG fr Dauergast oder wch./14-t. fr Spieler, die
    wchentlich bzw. 14-tgig spielen. Tun wir brigens nicht fr die
    Spezialspieler.
    *)
    FOR i:=von TO bis DO
      IF sd.spieler_aktiv[i]=sp_aktiv_ja THEN
        Assign(sd.spieler_name[i], lcl_ptr^.schnur);
        IF (i >= ssa) THEN
          IF sd.max_day_delta[i]<>0 THEN
            Append('(DG)', lcl_ptr^.schnur);
          ELSE                  (* IF sd.max_day_delta... *)
            IF (sd.spieler_art[i] = sp_art_14t) THEN
              Append('(14-tg.)', lcl_ptr^.schnur);
            ELSE                (* IF (sd.spieler_art[i]... *)
              Append('(wch.)', lcl_ptr^.schnur);
            END;                (* ELSE (sd.spieler_art[i]... *)
          END;                  (* ELSE sd.max_day_delta... *)
        END;                    (* IF (i >= ssa) *)
        lcl_ptr^.zahl:=i;
        NEW(lcl_ptr^.sel_rec_typ_ptr);
        lcl_ptr:=lcl_ptr^.sel_rec_typ_ptr;
        lcl_ptr^.sel_rec_typ_ptr:=NIL;
        hwi:=hwi+1;
      END;                      (* IF sd.spieler_aktiv[i]=sp_aktiv_ja *)
    END;                        (* FOR i *)
  END copy_von_bis;


PROCEDURE schreib_reihe_select_spieler(lcid_out: ChanId;
                                       VAR sd: sd_rec_typ; von1, bis1,
                                       von2, bis2: INTEGER);
  VAR
    selected:                   INTEGER;
    i, hwi:                     INTEGER;
    anz_matches:                INTEGER;
    sel_rec_typ_ptr, lcl_ptr:   sel_rec_typ_ptr_typ;

  BEGIN                         (* PROCEDURE schreib_reihe_select_spieler *)
    start_reihe(lcid_out);
    schreib_td_start(lcid_out, 'CENTER', hellgelb, '1', '2');

    hwi:=0;

    NEW(sel_rec_typ_ptr);
    lcl_ptr:=sel_rec_typ_ptr;
    lcl_ptr^.sel_rec_typ_ptr:=NIL;
    copy_von_bis(sd, lcl_ptr, von1, bis1, hwi);
    copy_von_bis(sd, lcl_ptr, von2, bis2, hwi);

    sortiere_selection(sel_rec_typ_ptr, 0, hwi-1);

    (*
    An dieser Stelle wird beschlossen, welcher Index 'selected'
    sein soll. Wir fahren dabei alle IP-Adressen durch. Falls kein
    oder mehr als ein Matching da ist, werden wir die '(Auswahl)'
    hernehmen.
    *)
    selected:=i_auswahl;
    i:=0;
    anz_matches:=0;
    lcl_ptr:=sel_rec_typ_ptr;
    WHILE (i<hwi) DO
      IF (CompareRS(sd.spieler_remote_addr[lcl_ptr^.zahl], remote_addr)=equal) THEN
        anz_matches:=anz_matches+1;
        selected:=lcl_ptr^.zahl;
      END;                      (* IF (CompareRS... *)
      lcl_ptr:=lcl_ptr^.sel_rec_typ_ptr;
      i:=i+1;
    END;                        (* WHILE (i<hwi) *)
    (*
    Falls anz_matches 0 oder 1 sein sollte, mssen wir hier nichts
    weiter tun. Bei anz_matches=0 wurde die Voreinstellung
    selected:=i_auswahl nicht verndert und ist damit also richtig.
    Bei anz_matches=1 wurde sie verndert und zwar auf den einzig
    richtigen Wert und ist damit also ebenfalls korrekt.
    Lediglich fr den Fall anz_matches>1 mssen wir selected wieder
    auf i_auswahl setzten, weil wir uns nun fr keinen der
    Kandidaten entscheiden knnen.
    *)
    IF (anz_matches>1) THEN
      selected:=i_auswahl;
    END;                        (* IF (anz_matches>1) *)

    (*
    An dieser Stelle haben wir also vorlufig entschieden, welcher
    Spieler selektiert sein soll. Dies ist die Meinung, wenn wir
    die Datenbasis ansehen und ggf. die IP-Adressen bercksichtigen,
    _ohne_ auf die Vorgeschichte zu achten. Dies versuchen wir nun
    mit dem input auswahl zu beheben. Falls da nicht gerade 0 drin
    steht, werden wir das mal bernehmen:
    *)
    IF input[ii23].value<>0 THEN
      selected:=input[ii23].value;
    END;                        (* IF input[ii23].value<>0 *)

    (*
    Falls nicht die '(Auswahl)' selektiert sein sollte, bieten wir
    sie auch gar nicht mehr an, macht sich irgendwie besser.
    Die alphabetische Reihenfolge wird dadurch nicht gestrt,
    d.h. es reicht, wenn wir den Eintrag einfach rausnehmen und
    alle folgenden nachrcken lassen. Das alles macht 'delete_selection'
    fr uns.
    *)
    hwi:=hwi-1;
    IF NOT(selected=i_auswahl) THEN
      delete_selection(sel_rec_typ_ptr, hwi, i_auswahl);
    END;                        (* IF NOT(selected=i_auswahl) *)

    schreib_select_button(lcid_out, input[ii03].name_strr, sel_rec_typ_ptr,
                          hwi, selected);
    schreib_td_end(lcid_out);
    end_reihe(lcid_out);
    dispose_selection(sel_rec_typ_ptr);
  END schreib_reihe_select_spieler;


PROCEDURE schreib_reihe_select_bkp_nam(lcid_out: ChanId);
  VAR
    hwi:                        INTEGER;
    sel_rec_typ_ptr:            sel_rec_typ_ptr_typ;

  BEGIN                         (* PROCEDURE schreib_reihe_select_bkp_nam *)
    start_reihe(lcid_out);
    schreib_td_start(lcid_out, 'CENTER', hellgelb, '1', '2');

    get_all_pref_nam(bkp_pfad, bkp_prefix, sel_rec_typ_ptr, hwi);

    (*
    '(Auswahl)' vorne stehen lassen, daher erst bei 1 mit dem
    Sortieren beginnen. brigens: '(Auswahl)' hat hier den Index 0
    (und nicht i_auswahl) und hat nichts mit der '(Auswahl)' fr die
    Spieler zu tun!
    *)

    sortiere_selection(sel_rec_typ_ptr, 1, hwi);

    schreib_select_button(lcid_out, input[ii17].name_strr, sel_rec_typ_ptr,
                          hwi, 0);
    schreib_td_end(lcid_out);
    end_reihe(lcid_out);
  END schreib_reihe_select_bkp_nam;


PROCEDURE schreib_reihe_ro_text(lcid_out: ChanId; text: ARRAY OF CHAR);
  BEGIN                         (* PROCEDURE schreib_reihe_ro_text *)
    start_reihe(lcid_out);
    schreib_td_text(lcid_out, 'CENTER', hellgelb, '1', '2', text);
    end_reihe(lcid_out);
  END schreib_reihe_ro_text;


PROCEDURE schreib_reihe_ok(lcid_out: ChanId;
                           VAR sd: sd_rec_typ; text: ARRAY OF CHAR; action: INTEGER);
  VAR
    court_index:                INTEGER;
    belegung_file:              INTEGER;
    unser_court_index:          INTEGER;
    submit_name:                String;
    submit_value:               String;
    woche:                      INTEGER;
    spieler_index_alt:          INTEGER;

  BEGIN                         (* PROCEDURE schreib_reihe_ok *)
    start_reihe(lcid_out);
    schreib_td_start(lcid_out, 'CENTER', hellgruen, '1', '2');

    woche:=input[ii01].value-sd.season_start;
    court_index:=sd.geschrumpfter_index[input[ii02].value];
    IF ((court_index>-1) AND (0<=woche) AND (woche<=(max_wochen_anz-1))) THEN
      belegung_file:=sd.jahr_court_belegung[woche, court_index];
    ELSE                        (* IF court_index>-1 *)
      belegung_file:=0;
    END;                        (* ELSE court_index>-1 *)

    unser_court_index:=input[ii02].value;
    spieler_index_alt:=input[ii03].value;

    Assign(input[ii00].name_strr, submit_name);
    Assign(text, submit_value);
    WITH hvr DO
      anz:=7;
      Assign(input[ii01].name_strr, nam[0]);
      IntToStr(input[ii01].value, val[0]);
      Assign(input[ii04].name_strr, nam[1]);
      IntToStr(action, val[1]);
      Assign(input[ii02].name_strr, nam[2]);
      IntToStr(unser_court_index, val[2]);
      Assign(input[ii06].name_strr, nam[3]);
      IntToStr(belegung_file, val[3]);
      Assign(input[ii20].name_strr, nam[4]);
      IntToStr(input[ii20].value, val[4]);
      Assign(input[ii21].name_strr, nam[5]);
      IntToStr(input[ii21].value, val[5]);
      Assign(input[ii24].name_strr, nam[6]);
      IntToStr(spieler_index_alt, val[6]);
    END;                        (* WITH hvr *)

    schreib_submit_button(lcid_out, submit_name, submit_value);
    put_hidden_values(lcid_out, hvr);

    schreib_td_end(lcid_out);
    end_reihe(lcid_out);
  END schreib_reihe_ok;


PROCEDURE schreib_reihe_not_ok(lcid_out: ChanId;
                               VAR sd: sd_rec_typ; text: ARRAY OF CHAR;
                               action: INTEGER);
  VAR
    submit_name:                String;
    submit_value:               String;
    zwstr:                      String;

  BEGIN                         (* PROCEDURE schreib_reihe_not_ok *)
    start_reihe(lcid_out);
    schreib_td_start(lcid_out, 'CENTER', hellrot, '1', '2');

    Assign(input[ii00].name_strr, submit_name);
    Assign(text, submit_value);
    WITH hvr DO
      anz:=3;
      Assign(input[ii01].name_strr, nam[0]);
      IntToStr(input[ii01].value, val[0]);
      Assign(input[ii04].name_strr, nam[1]);
      IntToStr(action, val[1]);
      Assign(input[ii05].name_strr, nam[2]);
      GetGPMString(zwstr, ii05);
      Assign(zwstr, val[2]);
    END;                        (* WITH hvr *)

    schreib_submit_button(lcid_out, submit_name, submit_value);
    put_hidden_values(lcid_out, hvr);

    schreib_td_end(lcid_out);
    end_reihe(lcid_out);
  END schreib_reihe_not_ok;


PROCEDURE schreib_reihe_passwd(lcid_out: ChanId;
                               halign, was, name, value: ARRAY OF CHAR);
  BEGIN                         (* PROCEDURE schreib_reihe_passwd *)
    start_reihe(lcid_out);
    schreib_td_text(lcid_out, halign, hellgelb, '1', '1', was);
    schreib_td_start(lcid_out, 'CENTER', hellgelb, '1', '1');
    schreib_passwd(lcid_out, name, value);
    schreib_td_end(lcid_out);
    end_reihe(lcid_out);
  END schreib_reihe_passwd;


PROCEDURE schreib_reihe_radio(VAR sd: sd_rec_typ; lcid_out: ChanId;
                              value_forderung: INTEGER;
                              halign, was, name_radio,
                              text1, name_forderung, text_forderung, text2, text3, 
                              name2, value: ARRAY OF CHAR);
  BEGIN                         (* PROCEDURE schreib_reihe_radio *)
    start_reihe(lcid_out);
    schreib_td_text(lcid_out, halign, hellgelb, '1', '1', was);
    schreib_td_start(lcid_out, 'LEFT', hellgelb, '1', '1');
    schreib_radio3(sd, lcid_out, value_forderung, name_radio, text1,
                   name_forderung, text_forderung, text2, text3, name2, value);
    schreib_td_end(lcid_out);
    end_reihe(lcid_out);
  END schreib_reihe_radio;


PROCEDURE schreib_reihe_text(lcid_out: ChanId;
                             halign, was, name, value, size: ARRAY OF CHAR);
  BEGIN                         (* PROCEDURE schreib_reihe_text *)
    start_reihe(lcid_out);
    schreib_td_text(lcid_out, halign, hellgelb, '1', '1', was);
    schreib_td_start(lcid_out, 'CENTER', hellgelb, '1', '1');
    schreib_text(lcid_out, name, value, size);
    schreib_td_end(lcid_out);
    end_reihe(lcid_out);
  END schreib_reihe_text;


PROCEDURE schreib_reihe_textarea(lcid_out: ChanId;
                                 name, value: ARRAY OF CHAR);
  BEGIN                         (* PROCEDURE schreib_reihe_textarea *)
    start_reihe(lcid_out);
    schreib_td_start(lcid_out, 'CENTER', hellgelb, '1', '2');
    schreib_textarea(lcid_out, name, value);
    schreib_td_end(lcid_out);
    end_reihe(lcid_out);
  END schreib_reihe_textarea;


PROCEDURE schreib_page02(VAR sd: sd_rec_typ);
  (*
  Dies ist die 'Eintragsseite'. Ein Court ist frei und soll
  nun durch einen neuen Spieler besetzt werden.
  *)

  VAR
    woche, court_index:         INTEGER;

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      woche:=input[ii01].value-sd.season_start;
      court_index:=sd.geschrumpfter_index[input[ii02].value];
      (*
      Fr die Forderung brauchen wir wirklich nur den eigentlichen
      Courtindex. Diesen erhalten wir einfach, indem wir nochmal
      durch 2 teilen. Siehe unten.
      *)

      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, TRUE, '02');

      schreib_wann_und_wo(lcid_out, sd);
      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, 'Folgende Eintragung soll erfolgen:', 'H3');
      schreib_reihe_select_spieler(lcid_out, sd, i_abbestellt, i_chefin, ssa, sd.spieler_anz+ssa-1);
      schreib_reihe_radio(sd, lcid_out, sd.jahr_forderung[woche, court_index DIV 2], 'CENTER',
                          'Wer spielt wirklich?', input[ii09].name_strr,
                          ' der Spieler selbst', input[ii19].name_strr, '. Dies ist ein Forderungsspiel',
                          ' ein privater Gast des Spielers', ' ein offizieller Gast, nmlich',
                          input[ii18].name_strr, 'wer?');
      schreib_reihe_passwd(lcid_out, 'CENTER', '(Spieler oder ChefIn-)Kennwort:', input[ii05].name_strr, '');
      schreib_reihe_ok(lcid_out, sd, 'OK', p2ac1);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, '', '');
      schreib_reihe_not_ok(lcid_out, sd, 'nicht OK', p2ac2);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page02 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page02;


PROCEDURE schreib_page03(VAR sd: sd_rec_typ);
  (*
  Dies ist die 'Austragsseite'. Ein Court ist besetzt und soll
  nun wieder frei gemacht werden.
  *)

  VAR
    woche, court_index:         INTEGER;
    player_name:                String_kurz;
    schnur_amp:                 String_mittel;
    kennwort_text:              String_mittel;

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      woche:=input[ii01].value-sd.season_start;
      court_index:=sd.geschrumpfter_index[input[ii02].value];

      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, TRUE, '03');

      schreib_wann_und_wo(lcid_out, sd);
      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, 'Folgender Eintrag soll gelscht werden:', 'H3');
      generate_player_name(sd, woche, court_index, player_name);
      convert_to_amp_string(player_name, schnur_amp);
      schreib_reihe_ro_text(lcid_out, schnur_amp);
      (*
      Ist zwar nur eine ganz kleine kosmetische Sache, aber wenn
      schon, denn schon: bei normalen Spielern oder deren privaten
      Gsten kann mit Kennwrtern der Spieler oder der Chefs
      gearbeitet werden. Bei offiziellen Gsten, oder falls der
      (abbestellt) wieder ausgetragen werden soll, gehen aber nur
      die Chef-Kennwrter. Daher wollen wir auch nur nach den
      entsprechend 'wirksamen' Kennwrtern fragen:
      *)
      IF ((sd.jahr_court_belegung_gast[woche, court_index]=2) OR
          (sd.jahr_court_belegung[woche, court_index]=i_abbestellt)) THEN
        Assign('(ChefIn-)Kennwort:', kennwort_text);
      ELSE                      (* IF sd.jahr_court_belegung_gast... *)
        Assign('(Spieler oder ChefIn-)Kennwort:', kennwort_text);
      END;                      (* ELSE sd.jahr_court_belegung_gast... *)
      schreib_reihe_passwd(lcid_out, 'CENTER', kennwort_text, input[ii05].name_strr, '');
      schreib_reihe_ok(lcid_out, sd, 'OK', p3ac1);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, '', '');
      schreib_reihe_not_ok(lcid_out, sd, 'nicht OK', p3ac2);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page03 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page03;


PROCEDURE schreib_page4_table1(lcid_out: ChanId; VAR sd: sd_rec_typ;
                               text1, text2, color: ARRAY OF CHAR;
                               action: INTEGER);
  PROCEDURE schreib_erste_reihe(lcid_out: ChanId);
    VAR
      submit_name:              String;
      submit_value:             String;
      zwstr_lang:               String_lang;

    BEGIN                       (* PROCEDURE schreib_erste_reihe *)
      start_reihe(lcid_out);

      Assign(input[ii00].name_strr, submit_name);
      Assign(text2, submit_value);
      WITH hvr DO
        anz:=8;
        Assign(input[ii01].name_strr, nam[0]);
        IntToStr(input[ii01].value, val[0]);
        Assign(input[ii02].name_strr, nam[1]);
        IntToStr(input[ii02].value, val[1]);
        Assign(input[ii06].name_strr, nam[2]);
        IntToStr(input[ii06].value, val[2]);
        Assign(input[ii04].name_strr, nam[3]);
        IntToStr(action, val[3]);
        Assign(input[ii05].name_strr, nam[4]);
        GetGPMString(zwstr_lang, ii05);
        Assign(zwstr_lang, val[4]);
        Assign(input[ii16].name_strr, nam[5]);
        GetGPMString(zwstr_lang, ii16);
        Assign(zwstr_lang, val[5]);
        Assign(input[ii23].name_strr, nam[6]);
        IntToStr(input[ii03].value, val[6]);
        Assign(input[ii24].name_strr, nam[7]);
        IntToStr(input[ii24].value, val[7]);
      END;                      (* WITH hvr *)
      schreib_td_text_form(lcid_out, 'CENTER', color, '1', '1', '', submit_name,
                           submit_value, hvr);

      end_reihe(lcid_out);
    END schreib_erste_reihe;

  BEGIN                         (* PROCEDURE schreib_page4_table1 *)
    schreib_table_start(lcid_out, text1, 'H3');
    schreib_erste_reihe(lcid_out);
    schreib_table_end(lcid_out);
  END schreib_page4_table1;


PROCEDURE schreib_page_accept(VAR sd: sd_rec_typ;
                              text1, text2, color: ARRAY OF CHAR;
                              action: INTEGER);
  (*
  Dies ist die 'Acceptseite'. Es wird ein Text ausgegeben und ein
  Accept-Button, den man drcken kann, um zur nchsten Seite zu gelangen.
  *)
  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 1);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, 'accept');
      schreib_page4_table1(lcid_out, sd, text1, text2, color, action);
      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page_accept *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page_accept;


PROCEDURE schreib_page_info(VAR sd: sd_rec_typ;
                            text1, text2, color: ARRAY OF CHAR);
  (*
  Dies ist die 'Infoseite'. Es wird ein groer und ein kleiner
  Text ausgegeben.
  *)

  PROCEDURE schreib_erste_reihe(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_erste_reihe *)
      start_reihe(lcid_out);

      schreib_td_text(lcid_out, 'CENTER', color, '1', '1', text2);

      end_reihe(lcid_out);
    END schreib_erste_reihe;

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, 'info');
      schreib_table_start(lcid_out, text1, 'H3');
      schreib_erste_reihe(lcid_out);
      schreib_table_end(lcid_out);
      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page_info *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page_info;


PROCEDURE schreib_page06(VAR sd: sd_rec_typ);
  (*
  Dies ist eine der ersten 'Adminseiten'. Es ist kein season-File da und es
  wird danach gefragt, ob ein neues angelegt werden soll.
  *)
  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '06');

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, 'Keine Datenbasis vorhanden, soll eine neue angelegt werden?', 'H3');
      schreib_reihe_passwd(lcid_out, 'CENTER', 'Default-Chef-Kennwort:', input[ii05].name_strr ,'');
      schreib_reihe_ok(lcid_out, sd, 'OK', p6ac1);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, '', '');
      schreib_reihe_not_ok(lcid_out, sd, 'nicht OK', p6ac2);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page06 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page06;


PROCEDURE schreib_page07(VAR sd: sd_rec_typ);
  (*
  Dies ist die zweite 'Adminseite'. Die Datenbasis ist bereit fr
  nderung bzw. Besttigung von Basisdaten.
  *)

  VAR
    season_start_jahr:          INTEGER;
    season_start_woche:         INTEGER;
    zwstr:                      String;

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    PROCEDURE srtl(wert, input_index: INTEGER;
                   text, text2: String); (* schreib reihe text local *)
      VAR
        zwstr1, zwstr2:         String;

      BEGIN                     (* PROCEDURE srtl *)
        IntToStr(wert, zwstr2);
        Append(' (', text);
        IntToStr(input[input_index].min, zwstr1);
        Append(zwstr1, text);
        Append('..', text);
        IntToStr(input[input_index].max, zwstr1);
        Append(zwstr1, text);
        Append('): ', text);
        Append(text2, text);
        schreib_reihe_text(lcid_out, 'LEFT', text, input[input_index].name_strr,
                           zwstr2, '8');
    END srtl;

    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 1);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '07');
      schreib_page_table_admin_progress(lcid_out, sd.sea_state);

      schreib_form_start(lcid_out);

      schreib_heading(lcid_out, 'Achtung!', 'H3');
      schreib_heading(lcid_out, 'Bei nderung des Saisonstart werden in jedem Fall alle Spieler ausgetragen', 'H3');
      schreib_heading(lcid_out, '(falls bereits welche eingetragen sind). Bei nderung der Zeilen- bzw.', 'H3');
      schreib_heading(lcid_out, 'Spaltenanzahl werden zustzlich alle Pltze als *nicht unsere Pltze* markiert!', 'H3');

      schreib_table_start(lcid_out, 'Aktuelle Basisdaten. Bitte ggf. ndern!', 'H3');

      WITH sd DO
        srtl(zeil_anz, ii10, 'Tabellenlnge (Anzahl Zeilen)', '');
        srtl(spalt_anz, ii11, 'Tabellenbreite (Anzahl Spalten)', '');
        srtl(spieler_anz, ii12, 'Anzahl Spieler (incl. nicht aktive)', '');
        LUWNToJahrKw(sd.season_start, season_start_jahr, season_start_woche);
        srtl(season_start_jahr, ii13, 'Saisonstart, Jahr', '');
        srtl(season_start_woche, ii14, 'Saisonstart, KW', '');
        srtl(wochen_anz, ii15, 'Gesamtdauer der Saison in Wochen', '');
        srtl(show_future_kw, ii25, 'KW Displaystart aktuell + ?:', '');

        Assign('', zwstr);
        Append('<P> (nur bit0, bit1 und bit2 belegt) </P>', zwstr);
        Append(' <P> bit0 (1) = 0/1: Eintragung streng/lasch </P>', zwstr);
        Append(' <P> bit1 (2) = 0/1: Debugging off/on </P>', zwstr);
        Append(' <P> bit2 (4) = 0/1: Eintragung nicht semilasch/semilasch </P>', zwstr);
        srtl(bitleiste, ii26, 'bitleiste', zwstr);

        schreib_reihe_text(lcid_out, 'LEFT', 'berschrift:', input[ii27].name_strr,
                           zusatz_heading, '40');
      END;                      (* WITH sd *)
      schreib_table_end(lcid_out);

      schreib_table_start(lcid_out, '', '');
      GetGPMString(zwstr, ii05);
      schreib_reihe_passwd(lcid_out, 'CENTER', 'Chef-Kennwort:',
                           input[ii05].name_strr, zwstr);
      schreib_reihe_ok(lcid_out, sd, 'OK', p7ac1);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, '', '');
      schreib_reihe_not_ok(lcid_out, sd, 'nicht OK', p7ac2);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page07 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page07;


PROCEDURE schreib_page08(VAR sd: sd_rec_typ);
  (*
  Dies ist die 'Ich will...'-Seite.
  *)

  PROCEDURE schreib_eine_reihe(lcid_out: ChanId;
                               text, color: ARRAY OF CHAR; action: INTEGER);
    VAR
      submit_name:              String;
      submit_value:             String;

    BEGIN                       (* PROCEDURE schreib_eine_reihe *)
      start_reihe(lcid_out);

      Assign(input[ii00].name_strr, submit_name);
      Assign(text, submit_value);
      WITH hvr DO
        anz:=2;
        Assign(input[ii01].name_strr, nam[0]);
        IntToStr(input[ii01].value, val[0]);
        Assign(input[ii04].name_strr, nam[1]);
        IntToStr(action, val[1]);
      END;                      (* WITH hvr *)
      schreib_td_text_form(lcid_out, 'CENTER', color, '1', '1', '', submit_name,
                           submit_value, hvr);

      end_reihe(lcid_out);
    END schreib_eine_reihe;

  PROCEDURE schreib_alle_reihen(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_alle_reihen *)
      (*
      Ausgabe der Rangliste nur anbieten, falls mindestens ein aktiver
      Spieler einen ordentlichen Rang zugewiesen bekommen hatte. Also
      bestimmen wir erst mal die Anzahl dieser Spieler und entscheiden
      dann weiter. Tatschlich ist rang_info_count+1 die Anzahl dieser Spieler,
      d.h., nur wenn rang_info_count>=0 gilt, pinseln wir was hin:
      *)
      IF rang_info_count(sd)>=0 THEN
        schreib_eine_reihe(lcid_out, '--> Zur Rangliste <--', hellgruen, p8ac5);
      END;                      (* IF rang_info_count(sd)>=0 *)
      schreib_eine_reihe(lcid_out, '--> Kennwort ndern <--', hellgruen, p8ac1);

      (*
      Editieren der Persdata nur auf www.muc.de/colin2.muc.de, dose.muc.de
      und www.rudolf-schubert.dyndns.org anbieten. Lassen wir erst mal so
      drin, obwohl das ursprnglich fr die E-Mail-Adressen gedacht war und
      dort auch Sinn gemacht hat. Eigentlich knnten wir die Unterscheidung
      vielleicht auch einfach wieder herausnehmen aber im Moment sind wir
      zu faul dafr.
      *)
      CASE server_name_index OF
        | 0,1,3,4:              (* 'default' (z.B. www.muc.de/colin2.muc.de),
                                   dose.muc.de, www.rudolf-schubert.dyndns.org, localhost *)
            schreib_eine_reihe(lcid_out, '--> Persnliche Daten editieren <--', hellgruen, p8ac10);

        | ELSE                  (* 190.64.6.48 und berhaupt *)
            (* nichts *)
      END;                      (* CASE server_name_index *)

      schreib_eine_reihe(lcid_out, '--> Einen Wartungszyklus durchfhren <--', hellgruen, p8ac6);
      schreib_eine_reihe(lcid_out, '--> Statistikseite anzeigen <--', hellgruen, p8ac11);
      schreib_eine_reihe(lcid_out, '--> Datenbasis lschen+Backup anlegen <--', hellgruen, p8ac8);
      IF anzahl_pref_files(bkp_pfad, bkp_prefix)>0 THEN
        (*
        Einlesen von alten Backups nur anbieten, falls wirklich mindestens
        eines da ist. Wir treffen keine weiteren Vorkehrungen gegen
        Hacker, d.h., falls jemand trotzdem die Page irgendwie zum
        Abschicken kriegt, dann ist das Directory halt leer. Wie
        wir gelernt haben, ist es durchaus schick eine grayed out
        Anzeige zu machen, falls nichts geht. Tun wir das.
        *)
        schreib_eine_reihe(lcid_out, '--> Alte Datenbasis von Backup einlesen <--', hellgruen, p8ac9);
      ELSE                      (* IF anzahl_pref_files... *)
        schreib_eine_reihe(lcid_out, '--> Alte Datenbasis von Backup einlesen <--', hellgrau, p1ac0);
      END;                      (* ELSE anzahl_pref_files... *)

      CASE server_name_index OF
        | 1:                    (* dose.muc.de *)
            schreib_eine_reihe(lcid_out, '--> Das Webserver Logfile anschauen <--', hellgruen, p8ac7);

        | ELSE                  (* 190.64.6.48, www.muc.de/colin2.muc.de und berhaupt *)
            (* nichts *)
      END;                      (* CASE server_name_index *)

      schreib_eine_reihe(lcid_out, '--> Die Programmquellen einsehen <--', hellgruen, p8ac3);
      schreib_eine_reihe(lcid_out, '--> Schnell weg von hier <--', hellgruen, p8ac4);
      schreib_eine_reihe(lcid_out, '--> Zurck zum Spielbelegungsplan <--', hellgruen, p8ac2);
    END schreib_alle_reihen;

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '08');
      schreib_table_start(lcid_out, 'Ich will...', 'H3');
      schreib_alle_reihen(lcid_out);
      schreib_table_end(lcid_out);
      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page08 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page08;


PROCEDURE schreib_page09(VAR sd: sd_rec_typ);
  (*
  Dies ist die Seite zum Kennwortndern.
  *)
  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '09');

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, 'Kennwort ndern fr:', 'H3');
      schreib_reihe_select_spieler(lcid_out, sd, i_auswahl, i_chefin, ssa, sd.spieler_anz+ssa-1);
      schreib_reihe_passwd(lcid_out, 'RIGHT', 'bisheriges (oder Chef-)Kennwort:', input[ii05].name_strr, '');
      schreib_reihe_passwd(lcid_out, 'RIGHT', 'neues Kennwort:', input[ii07].name_strr, '');
      schreib_reihe_passwd(lcid_out, 'RIGHT', 'nochmal neues Kennwort:', input[ii08].name_strr, '');

      (*
      Frher gab's hier mal echt eine eigene PROCEDURE schreib_reihe5 und
      nicht den Aufruf von schreib_reihe_ok. Jetzt ist es einheitlicher,
      dafr werden in schreib_reihe_ok aber 2 nicht bentzte INPUT-Parameter
      verwendet: input[ii02] (unser_court_index) und input[ii06]
      (spieler_index_alt).
      Na ja, halt ein kleiner Overhead, den wir fr die Vereinheitlichung
      wohl aufbringen mssen.
      *)

      schreib_reihe_ok(lcid_out, sd, 'OK', p9ac1);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, '', '');
      schreib_reihe_not_ok(lcid_out, sd, 'nicht OK', p9ac2);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page09 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page09;


PROCEDURE try_my_cat(lcid_out: ChanId;
                     file_name: ARRAY OF CHAR; mode: CARDINAL);
  CONST
    linefeed=                   10;
    max_cpl=                    100;    (* max. char per line *)
    len_in=                     128;
    len_out=                    4*len_in+8;
  TYPE
    feld_in_typ=                ARRAY[0..len_in-1] OF CHAR;
    feld_out_typ=               ARRAY[0..len_out-1] OF CHAR;
  VAR
    cid:                        ChanId;
    res:                        OpenResults;
    wert:                       CHAR;
    feld:                       feld_in_typ;
    len_read:                   CARDINAL;
    len_read_int:               INTEGER;
    text_out:                   feld_out_typ;
    c_in, c_out:                INTEGER;
    cpl:                        CARDINAL;
    cr_lf_muss_raus:            BOOLEAN;

  BEGIN                         (* PROCEDURE try_my_cat *)
    StreamFile.Open(cid, file_name, read+raw, res);
    (*
    show_OpenResult(cid_out, file_name, 'try_my_cat', res);
    *)
    IF res=opened THEN
      RawRead(cid, ADR(feld), len_in, len_read);
      cpl:=0;
      cr_lf_muss_raus:=FALSE;
      WHILE (NOT ((ReadResult(cid)=endOfInput) AND (len_read=0))) DO
        (*
        Falls hier len_read=0 sein sollte aber ReadResult nicht endOfInput,
        dann laufen wir hier durch und im weiteren Verlauf wird dann also
        die gelesene Anzahl Bytes, nmlich 0 an der Zahl, verarbeitet.
        Die Verarbeitung hlt sich aber vom Umfang her in Grenzen, denn
        die betreffenden Schleifen, die jeweils mit c_in durchlaufen
        werden, sind in diesem Fall beendet, bevor sie begonnen haben, weil
        sie da von 0 bis 0-1 laufen wrden und daher also nichts zu
        laufen haben;-) Wir sind mit c_in daher von CARDINAL auf INTEGER
        umgeschwenkt, damit da garantiert nichts anbrennt! Weil man das
        aber nie so recht blickt, wann genau es zu 'Kollisionen' beim
        Thema CARDINAL/INTEGER kommt, fhren wir noch ein len_read_int ein.
        Diesem INTEGER-Wert drfen wir einen CARDINAL-Wert zuweisen, solange
        zur Laufzeit kein berlauf entsteht (soweit haben wir das noch
        umrissen) und damit knnen wir dann spter locker die Differenz
        len_read_int-1 bilden, vor allem auch fr den Fall len_read_int=0
        und sollten dann keine Probleme bekommen, denn c_in haben wir jetzt
        ja auch als INTEGER festgelegt und alles sollte prima laufen!
        *)
        len_read_int:=len_read;
        CASE mode OF
          | 0:                  (* nichts ersetzen *)
              FOR c_in:=0 TO len_read_int-1 DO
                wert:=feld[c_in];
                text_out[c_in]:=CHR(wert);
              END;              (* FOR c_in *)
              c_out:=len_read_int;
              text_out[c_out]:=0C;
              WriteString(lcid_out, text_out);

          | 1:                  (* LF durch CRLF ersetzen *)
              c_out:=0;
              FOR c_in:=0 TO len_read_int-1 DO
                wert:=feld[c_in];
                CASE wert OF
                  | CHR(linefeed):
                      text_out[c_out]:=CHR(13);
                      c_out:=c_out+1;
                      text_out[c_out]:=CHR(10);
                      c_out:=c_out+1;

                  | ELSE
                      text_out[c_out]:=CHR(wert);
                      c_out:=c_out+1;
                END;            (* CASE wert *)
              END;              (* FOR c_in *)
              text_out[c_out]:=0C;
              WriteString(lcid_out, text_out);

          | 2:                  (* '<', '>', '&' ersetzen, auerdem cpl *)
                                (* auf max_cpl prfen und ggf. CRLF geben *)
                                (* und versuchen, Wrter ganz zu lassen *)
              c_out:=0;
              FOR c_in:=0 TO len_read_int-1 DO
                wert:=feld[c_in];
                (*
                Sollte cpl bereits das Maximum erreicht haben, notieren
                wir erst mal die Notwendigkeit, da CRLF raus mu:
                *)
                IF cpl>=max_cpl THEN
                  cr_lf_muss_raus:=TRUE;
                END;            (* IF cpl>=max_cpl *)
                cpl:=cpl+1;

                CASE wert OF
                  | ' ':
                      (*
                      Damit ganze Wrter nicht zerrissen werden, versuchen
                      wir einen anstehenden CRLF erst beim nchsten Space
                      zu geben. Den Space brauchen wir dann gar nicht mehr.
                      *)
                      IF cr_lf_muss_raus THEN
                        text_out[c_out]:=CHR(13);
                        c_out:=c_out+1;
                        text_out[c_out]:=CHR(10);
                        c_out:=c_out+1;
                        cpl:=0;
                        cr_lf_muss_raus:=FALSE;
                      ELSE      (* IF cr_lf_muss_raus *)
                        text_out[c_out]:=CHR(wert);
                        c_out:=c_out+1;
                      END;      (* ELSE cr_lf_muss_raus *)

                  | CHR(linefeed):
                      (*
                      Nach linefeed cpl wieder auf 0 setzen, da wir nun
                      sowieso einen CRLF ausgegeben haben. Gilt natrlich
                      nur fr unseren chat-Text, wo wir (zumindest glauben
                      zu) wissen, da hier als linefeed immer CRLF vorliegt.
                      *)
                      text_out[c_out]:=CHR(wert);
                      c_out:=c_out+1;
                      cpl:=0;
                      cr_lf_muss_raus:=FALSE;

                  | '<':
                      text_out[c_out]:='&';
                      c_out:=c_out+1;
                      text_out[c_out]:='l';
                      c_out:=c_out+1;
                      text_out[c_out]:='t';
                      c_out:=c_out+1;
                      text_out[c_out]:=';';
                      c_out:=c_out+1;

                  | '>':
                      text_out[c_out]:='&';
                      c_out:=c_out+1;
                      text_out[c_out]:='g';
                      c_out:=c_out+1;
                      text_out[c_out]:='t';
                      c_out:=c_out+1;
                      text_out[c_out]:=';';
                      c_out:=c_out+1;

                  | '&':
                      text_out[c_out]:='&';
                      c_out:=c_out+1;
                      text_out[c_out]:='a';
                      c_out:=c_out+1;
                      text_out[c_out]:='m';
                      c_out:=c_out+1;
                      text_out[c_out]:='p';
                      c_out:=c_out+1;
                      text_out[c_out]:=';';
                      c_out:=c_out+1;

                  | ELSE
                      text_out[c_out]:=CHR(wert);
                      c_out:=c_out+1;
                END;            (* CASE wert *)
              END;              (* FOR c_in *)
              text_out[c_out]:=0C;
              WriteString(lcid_out, text_out);

          | 3:                  (* CR, '<', '>', '&' ersetzen *)
              c_out:=0;
              FOR c_in:=0 TO len_read_int-1 DO
                wert:=feld[c_in];
                CASE wert OF
                  | CHR(linefeed):
                      text_out[c_out]:=CHR(13);
                      c_out:=c_out+1;
                      text_out[c_out]:=CHR(10);
                      c_out:=c_out+1;

                  | '<':
                      text_out[c_out]:='&';
                      c_out:=c_out+1;
                      text_out[c_out]:='l';
                      c_out:=c_out+1;
                      text_out[c_out]:='t';
                      c_out:=c_out+1;
                      text_out[c_out]:=';';
                      c_out:=c_out+1;

                  | '>':
                      text_out[c_out]:='&';
                      c_out:=c_out+1;
                      text_out[c_out]:='g';
                      c_out:=c_out+1;
                      text_out[c_out]:='t';
                      c_out:=c_out+1;
                      text_out[c_out]:=';';
                      c_out:=c_out+1;

                  | '&':
                      text_out[c_out]:='&';
                      c_out:=c_out+1;
                      text_out[c_out]:='a';
                      c_out:=c_out+1;
                      text_out[c_out]:='m';
                      c_out:=c_out+1;
                      text_out[c_out]:='p';
                      c_out:=c_out+1;
                      text_out[c_out]:=';';
                      c_out:=c_out+1;

                  | ELSE
                      text_out[c_out]:=CHR(wert);
                      c_out:=c_out+1;
                END;            (* CASE wert *)
              END;              (* FOR c_in *)
              text_out[c_out]:=0C;
              WriteString(lcid_out, text_out);
    
          | ELSE
              abbruch('Fehler in "try_my_cat"!',
                      'In jedem Fall dem Programmierer drohen!');
        END;                    (* CASE mode *)

        RawRead(cid, ADR(feld), len_in, len_read);
      END;                      (* WHILE (NOT ((ReadResult(cid)=endOfInput)... *)

      WriteLnCrLf(lcid_out);
      StreamFile.Close(cid);
    END;                        (* ELSE res=opened *)
  END try_my_cat;


PROCEDURE try_my_cat_stdout(lcid_out: ChanId;
                            file_name: ARRAY OF CHAR; mode: CARDINAL);
  BEGIN                         (* PROCEDURE try_my_cat_stdout *)
    (*
    try_my_cat nur mit StdOutChan aufrufen, der Rest
    wird ziemlich billig abgespeist.
    *)
    IF (lcid_out=cid_out) THEN
      try_my_cat(lcid_out, file_name, mode);
    ELSE                        (* IF (lcid_out... *)
      put_amp_string(lcid_out, '<Echte Info wird nur auf StdOutChan ausgegeben>');
      WriteLnCrLf(lcid_out);
    END;                        (* ELSE (lcid_out... *)

  END try_my_cat_stdout;


PROCEDURE schreib_page_sys_info(VAR sd: sd_rec_typ; action: INTEGER);
  VAR
    system_name:                String;
  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, 'sys_info');

      schreib_heading(lcid_out, 'Sytem Info...', 'H3');

      (*
      So heit das File mit der System-Info:
      *)
      Assign(squash_base_v, system_name);
      Append('/data', system_name);
      Append(script_nam_prog_appendix, system_name);
      Append('/beschr_system.html', system_name);

      try_my_cat_stdout(lcid_out, system_name, 1);

      schreib_page4_table1(lcid_out, sd, '', 'Zurck zum Spielbelegungsplan', dunkelgruen, action);
    
      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page_sys_info *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page_sys_info;


PROCEDURE schreib_page_wsv_info(VAR sd: sd_rec_typ; action: INTEGER);
  VAR
    wsv_name:                   String;

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, 'wsv_info');

      schreib_heading(lcid_out, 'Web-Server Info...', 'H3');

      (*
      So heit das File mit der Web-Server-Info:
      *)
      Assign(squash_base_v, wsv_name);
      Append('/data', wsv_name);
      Append(script_nam_prog_appendix, wsv_name);
      Append('/beschr_wsv.html', wsv_name);

      try_my_cat_stdout(lcid_out, wsv_name, 1);
    
      schreib_page4_table1(lcid_out, sd, '', 'Zurck zum Spielbelegungsplan', dunkelgruen, action);
    
      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page_wsv_info *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page_wsv_info;


PROCEDURE schreib_page10(VAR sd: sd_rec_typ);
  VAR
    source_name:                String;

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);

    PROCEDURE list_text_file(file_name: ARRAY OF CHAR);
      BEGIN                       (* PROCEDURE list_text_file *)
        Assign(squash_base_v, source_name);
        Append('/src/', source_name);
        Append(file_name, source_name);

        schreib_heading(lcid_out, file_name, 'H3');

        WriteString(lcid_out, '<PRE>');
        WriteLnCrLf(lcid_out);

        try_my_cat_stdout(lcid_out, source_name, 3);

        WriteString(lcid_out, '</PRE>');
        WriteLnCrLf(lcid_out);
      END list_text_file;

    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '10');

      list_text_file('squash1.mod');
      list_text_file('ctv2.def');
      list_text_file('ctv2.mod');
      list_text_file('unix.c');
      list_text_file('unix.def');

      schreib_page4_table1(lcid_out, sd, '', 'Zurck zum Spielbelegungsplan', dunkelgruen, p4ac1);
    
      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page10 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page10;


PROCEDURE schreib_page11(VAR sd: sd_rec_typ);
  VAR
    links_name:                 String;

  PROCEDURE show_one_link(lcid_out: ChanId; index: INTEGER;
                          text: String_mittel);
    VAR
      zwstr:                    String;
      zwstr2:                   String_kurz;
    BEGIN                       (* PROCEDURE show_one_link *)
      Assign('<H3> <A HREF="', zwstr);
      Append(script_path, zwstr);
      Append(script_nam_prog1, zwstr);
      Append(script_nam_prog_appendix_arr[index], zwstr);
      (*
      Welcher SERVER_NAME war's denn?
      *)
      IF (server_name_index=0) THEN
        (* auf www.muc.de/colin2.muc.de einfach noch ein '.cgi' an den script_nam anhngen: *)
        Append('.cgi', zwstr);
      END;                      (* (server_name_index... *)

      IF (server_name_index=4) THEN
      (* auf localhost einfach noch ein '.cgi' an den script_nam anhngen: *)
      Append('.cgi', zwstr);
      END;                      (* (server_name_index... *)

      Append('">', zwstr);
      WriteString(lcid_out, zwstr);
      WriteLnCrLf(lcid_out);
      
      Assign('--&gt; Tabelle ', zwstr);
      IntToStr(index, zwstr2);
      Append(zwstr2,  zwstr);
      Append(' </A> ', zwstr);
      Append(text, zwstr);
      Append(' </H3>', zwstr);
      WriteString(lcid_out, zwstr);
      WriteLnCrLf(lcid_out);
    END show_one_link;

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    VAR
      i:                        INTEGER;
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '11');

      schreib_heading(lcid_out, 'Schnell weg von hier...', 'H3');
      schreib_heading(lcid_out, '...zuerst zu den anderen Spielbelegungsplnen:', 'H3');

      (*
      Bevor wir die Links aus dem Schnell-weg-links-file anzeigen,
      prsentieren wir die anderen Tabellen:
      *)
      FOR i:=1 TO tabellen_anz DO
        IF i=tabellen_nummer THEN
          show_one_link(lcid_out, i, '(hier sind wir gerade)');
        ELSE                    (* IF i... *)
          show_one_link(lcid_out, i, '');
        END;                    (* ELSE i... *)
      END;                      (* FOR i *)

      (*
      So heit das File mit den Schnell-weg-links:
      *)
      Assign(squash_base_v, links_name);
      Append('/data', links_name);
      Append(script_nam_prog_appendix, links_name);
      Append('/schnell_weg.html', links_name);

      schreib_heading(lcid_out, '...dann zu ein paar weiteren Zielen:', 'H3');
      try_my_cat_stdout(lcid_out, links_name, 1);

      schreib_page4_table1(lcid_out, sd, '', 'Zurck zum Spielbelegungsplan', dunkelgruen, p4ac1);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page11 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page11;


PROCEDURE get_rang_info(VAR sd: sd_rec_typ;
                        VAR rang_feld: rang_feld_typ;
                        VAR count: INTEGER;
                        VAR max_name_length: CARDINAL);
  VAR
    hwc:                        CARDINAL;
    rang:                       INTEGER;

  BEGIN                         (* PROCEDURE get_rang_info *)
    (*
    Also: rang_feld erst mit -1 vorbelegen:
    *)
    FOR hwc:=0 TO max_spieler_anz-1 DO
      rang_feld[hwc]:=-1;
    END;                        (* FOR hwc *)

    (*
    rang_feld gem tatschlicher Rangordnung auffllen.
    brigens werden hier nur aktive Spieler bercksichtig.
    Nebenbei bestimmen wir dabei, wie lang der lngste
    Spielername ist. Dies brauchen wir fr's Padden.
    *)
    max_name_length:=0;
    FOR hwc:=ssa TO max_spieler_anz+ssa-1 DO
      rang:=sd.spieler_rang[hwc];
      IF ((rang>0) AND (rang<=sd.spieler_anz) AND
          (sd.spieler_aktiv[hwc]=sp_aktiv_ja)) THEN
        rang_feld[rang-1]:=hwc;
        IF Length(sd.spieler_name[hwc])>max_name_length THEN
          max_name_length:=Length(sd.spieler_name[hwc]);
        END;                    (* IF Length... *)
      END;                      (* IF ((sd.spieler_rang... *)
    END;                        (* FOR hwc *)

    (*
    hchsten Index in rang_feld suchen, der nicht -1 enthlt:
    *)
    count:=max_spieler_anz;
    REPEAT
      count:=count-1;
    UNTIL ((count<0) OR (rang_feld[count]<>-1));
  END get_rang_info;


PROCEDURE rang_info_count(VAR sd: sd_rec_typ): INTEGER;
  VAR
    rang_feld:                  rang_feld_typ;
    count:                      INTEGER;
    max_name_length:            CARDINAL;

  BEGIN                         (* PROCEDURE rang_info_count *)
    get_rang_info(sd, rang_feld, count, max_name_length);
    RETURN count;
  END rang_info_count;


PROCEDURE hoehe_pascalsches_dreieck(n: INTEGER): INTEGER;
  CONST
    epsilon=                    0.0001;
  VAR
    dreiecks_hoehe_real:        REAL;
    hwi:                        INTEGER;

  BEGIN                         (* PROCEDURE hoehe_pascalsches_dreieck *)
    dreiecks_hoehe_real:=(sqrt(FLOAT(1+8*n))-FLOAT(1))*0.5;
    hwi:=TRUNC(dreiecks_hoehe_real);
    (*
    Falls eine schne Zahl ist (z.B. 3, 6, 10 usw.), so da unsere
    Rechnung ganzzahlig ist, sollten dreiecks_hoehe_real und hwi nur
    um ganz wenig voneineander abweichen (je nach Rechengenauigkeit
    der Maschine halt). Wir sagen, falls diese Differenz kleiner
    epsilon war, nehmen wir hwi als echte Dreieckshhe, im anderen
    Fall geben wir eine Zeile zu.
    *)
    IF ((dreiecks_hoehe_real-FLOAT(hwi))>epsilon) THEN
      hwi:=hwi+1;
    END;                        (* IF ((dreiecks_hoehe_real... *)
    RETURN hwi;
  END hoehe_pascalsches_dreieck;


PROCEDURE schreib_page12_oder_24(VAR sd: sd_rec_typ; ob_page12: BOOLEAN);
  (*
  Das ist ein bichen popelig hier, aber wir wollten einfach nicht
  unntig viel Code erzeugen. Fr das jungfruliche Anzeigen der Pyramide
  ist page12 zustndig. Wird ein Spieler gedrckt, wollen wir die
  Pyramide nochmal anzeigen, aber mit dem Unterschied, da nun alle
  Links den in der jungfruliche Pyramide gedrckten Spieler, also
  den Forderer mit sich schleppen. Damit knnen wir dann nach dem
  zweiten mal Drcken eines Spielers (in der nunmehr erneut angezeigten
  Pyramide), aufgrund der beiden Spieler (Forderer von erster Pyramide
  und Geforderter von zweiter Paramide) den Update in einem weiteren
  Dialog von den Chefs absegenen lassen (oder auch nicht).
  *)

  PROCEDURE append_chars_to_string(VAR zwstr: ARRAY OF CHAR; buchst: CHAR;
                                   anz: CARDINAL);
    VAR
      count:                    CARDINAL;
      schnur1:                  String1;

    BEGIN                       (* PROCEDURE append_chars_to_string *)
      FOR count:=1 TO anz DO
        Assign(' ', schnur1);
        schnur1[0]:=buchst;
        Append(schnur1, zwstr);
      END;                      (* FOR count *)
    END append_chars_to_string;

  PROCEDURE append_chars_to_nullstring(VAR zwstr: ARRAY OF CHAR; buchst: CHAR;
                                       anz: CARDINAL);
    BEGIN                       (* PROCEDURE append_chars_to_nullstring *)
      Assign('', zwstr);
      append_chars_to_string(zwstr, buchst, anz);
    END append_chars_to_nullstring;

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    VAR
      count:                    INTEGER;
      rang_feld:                rang_feld_typ;
      max_name_length:          CARDINAL;
      str_length:               CARDINAL;
      fuell_str:                String_kurz;
      spieler_index:            INTEGER;
      pyramiden_hoehe:          INTEGER;
      zeilen_count:             INTEGER;
      breiten_count:            INTEGER;
      index:                    INTEGER;
      zwstr, zwstr2:            String_mittel;
      spieler_name:             String_kurz;
      spieler_name_amp:         String_mittel;
      get_str:                  String;
      color:                    String_kurz;

    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);

      (*
      Es geht also darum, eine gengend groe Pyramide aufzustellen
      und alle Spieler dort hineinzustellen, denen ein gltiger Rang
      im Bereich 1..sd1.spieler_anz zugewiesen wurde. Die Anzahl der
      Spieler, die in der Pyramide stehen, mu nicht gleich
      sd1.spieler_anz sein, denn falls _keine_ Pyramide gewnscht ist,
      ist ersterer Wert nmlich 0. O.k. es sollte eigentlich keine
      Zwischenwerte geben (zwischen 0 und sd1.spieler_anz), aber
      wer wei, was sich die Chefs denken oder was die eintippen, oder
      vielleicht gibt es ja wirklich ein paar Memmen, die zwar so
      mitspielen, aber nicht in die Pyrmamide wollen. Also werden
      wir einfach so vorgehen:
      Wir legen ein temporres INTEGER-Feld (rang_feld) an, welches
      max_spieler_anz Elemente hat. Wir belegen es etwa vor mit -1.
      Dann gehen wir durch dir letzten max_spieler_anz Elemente von
      sd1.spieler_rang durch (d.h. das sind alle Spieler auer den
      Spezialspielern). Jedesmal, wenn ein solcher Wert einen
      gltigen Rang angibt, verwenden wir diesen Wert als Index in
      obiges temporres INTEGER-Feld und tragen dort den Index des
      Spielers ein, bei dem wir in sd1.spieler_rang gerade sind.
      Dann suchen wir den hchsten Index im temporren INTEGER-Feld,
      welcher nicht -1 ist. ber diesen Index ermitteln wir dann,
      wie gro wir die Pyramide machen mssen.
      Am Ende fllen wir die Pyramide einfach nur noch auf. Aller-
      dings nehmen wir nur aktive Spieler.
      *)

      get_rang_info(sd, rang_feld, count, max_name_length);

      Assign('Die aktuelle Rangliste: ', zwstr2);
      IF ob_page12 THEN
        Assign('12', zwstr);
        Append('welcher Spieler soll "umgesiedelt" werden?', zwstr2);
      ELSE                      (* IF ob_page12 *)
        Assign('24', zwstr);
        Append('wessen Platz soll ', zwstr2);
        Append(sd.spieler_name[rang_feld[input[ii20].value-1]], zwstr2);
        Append(' einnehmen?', zwstr2);
      END;                      (* ELSE ob_page12 *)

      schreib_page_table0(lcid_out, sd, nullac, FALSE, zwstr);
      schreib_heading(lcid_out, zwstr2, 'H3');

      (*
      Nachdem wir also die max_name_length wissen, konstruieren
      wir erst mal einen Fller:
      *)
      IF max_name_length>4 THEN
        append_chars_to_nullstring(fuell_str, '-', 4);
      ELSE                      (* IF max_name_length>4 *)
        append_chars_to_nullstring(fuell_str, '-', max_name_length);
      END;                      (* ELSE max_name_length>4 *)

      (*
      Nun sehen wir uns count an.
      Falls count<0 war, ist pyramiden_hoehe gleich 0, im
      anderen Fall rechnen wir uns die Mindesthhe aus,
      die wir brauchen. War, denke ich Pascalsches
      Dreieck oder so. Anzahl n der Elemente im Dreieck
      gleich (x*(x+1))/2, mit x=Anzahl der Zeilen,
      bzw. pyramiden_hoehe, wie wir es hier bezeichent
      haben. Bei uns ist n gleich count+1. Mit Schulmathematik
      1. Jahr Grundschule ermitteln wir dann aus count die
      zu bentzende Pyramidenhhe.
      *)
      IF count<0 THEN
        pyramiden_hoehe:=0;
      ELSE                      (* IF count<0 *)
        pyramiden_hoehe:=hoehe_pascalsches_dreieck(count+1);
      END;                      (* ELSE count<0 *)

      (*
      Nachdem nun also auch die Pyramidenhhe bekannt ist, wollen
      wir die Pyramide endlich auffllen:
      *)
      index:=1;

      FOR zeilen_count:=1 TO pyramiden_hoehe DO
        schreib_table_start_custom(lcid_out, '', '', '');
        start_reihe(lcid_out);
        FOR breiten_count:=1 TO zeilen_count DO
          IntToStrRS(index, zwstr2, 2);
          Assign(zwstr2, zwstr);

          str_length:=Length(zwstr);
          (*
          Falls max_name_length>str_length ist padden wir ggf.
          ein wenig:
          *)
          IF max_name_length>str_length THEN
            append_chars_to_nullstring(zwstr2, '_',
                                       (max_name_length-str_length) DIV 2);
            Append(zwstr, zwstr2);
            str_length:=Length(zwstr2);
            append_chars_to_string(zwstr2, '_', max_name_length-str_length);
          END;                  (* IF max_name_length... *)

          IF index>max_spieler_anz THEN
            Assign(fuell_str, get_str);
          ELSE                  (* IF index>max_spieler_anz *)
            spieler_index:=rang_feld[index-1];
            IF spieler_index=-1 THEN
              Assign(fuell_str, get_str);
            ELSE                (* IF spieler_index=-1 *)
              Assign(sd.spieler_name[spieler_index], spieler_name);
              WITH hvr DO
                IF ob_page12 THEN
                  (*
                  Soll page12 angezeigt werden, brauchen wir nur
                  3 'hidden values': die ukw, die action und den 
                  forderer.
                  *)
                  anz:=3;
                  Assign(input[ii01].name_strr, nam[0]);
                  IntToStr(input[ii01].value, val[0]);
                  Assign(input[ii04].name_strr, nam[1]);
                  IntToStr(p12ac1, val[1]);
                  Assign(input[ii20].name_strr, nam[2]);
                  IntToStr(index, val[2]);
                ELSE            (* ob_page12 *)
                  (*
                  Im anderen Fall sind es 4 'hidden values',
                  weil sich jetzt noch der geforderte hinzu-
                  gesellt. Auerdem brauchen wir natrlich
                  eine neue action.
                  *)
                  anz:=4;
                  Assign(input[ii01].name_strr, nam[0]);
                  IntToStr(input[ii01].value, val[0]);
                  Assign(input[ii04].name_strr, nam[1]);
                  IntToStr(p24ac1, val[1]);
                  Assign(input[ii20].name_strr, nam[2]);
                  IntToStr(input[ii20].value, val[2]);
                  Assign(input[ii21].name_strr, nam[3]);
                  IntToStr(index, val[3]);
                END;            (* ELSE ob_page12 *)
              END;              (* WITH hvr *)
              convert_to_amp_string(spieler_name, spieler_name_amp);
              gen_get_string(hvr, get_str, spieler_name_amp);
            END;                (* ELSE spieler_index=-1 *)
          END;                  (* IF index>max_spieler_anz *)

          (*
          Beim zweiten Pyramidenbild, also auf page24 wollen wir
          den forderer wenigstens ein bichen hervorheben:
          *)
          IF ob_page12 THEN
            Assign(hellgelb, color);
          ELSE                  (* IF ob_page12 *)
            IF index=input[ii20].value THEN
              Assign(hellrot, color);
            ELSE                (* IF index=input[ii20].value *)
              Assign(hellgelb, color);
            END;                (* ELSE index=input[ii20].value *)
          END;                  (* ELSE ob_page12 *)

          schreib_td_start(lcid_out, 'CENTER', color, '1', '1');
          schreib_paragraph_start(lcid_out);
          schreib_text_crlf(lcid_out, zwstr2);
          schreib_paragraph_end(lcid_out);
          schreib_text_crlf(lcid_out, get_str);
          schreib_td_end(lcid_out);
          index:=index+1;
        END;                    (* FOR breiten_count *)
        end_reihe(lcid_out);
        schreib_table_end(lcid_out);
      END;                      (* FOR zeilen_count *)

      schreib_hr(lcid_out);
      schreib_page4_table1(lcid_out, sd, '', 'Zurck zum Spielbelegungsplan', dunkelgruen, p4ac1);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page12_oder_24 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page12_oder_24;


PROCEDURE schreib_page13(VAR sd: sd_rec_typ);
  (*
  Dies ist die Seite zum Umstellen auf den Wartungsmodus.
  *)

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '13');

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, 'Einen Wartungszyklus durchfhren?', 'H3');
      schreib_reihe_passwd(lcid_out, 'CENTER', 'Chef-Kennwort:', input[ii05].name_strr, '');
      schreib_reihe_ok(lcid_out, sd, 'OK', p13ac1);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, '', '');
      schreib_reihe_not_ok(lcid_out, sd, 'nicht OK', p13ac2);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page13 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page13;


PROCEDURE schreib_page14(VAR sd: sd_rec_typ);
  (*
  Dies ist die dritte 'Adminseite'. Die Datenbasis ist bereit fr
  nderung bzw. Besttigung der 'Zeilenberschriften', der
  Spaltenberschriften bzw. welches unsere Courts sind.
  *)

  VAR
    zwstr:                      String;

  PROCEDURE schreib_reihe_uhrzeiten2(lcid_out: ChanId; VAR sd: sd_rec_typ);
    VAR
      spalte, i_start:          INTEGER;
      sel_rec_typ_ptr:          sel_rec_typ_ptr_typ;

    BEGIN                       (* PROCEDURE schreib_reihe_uhrzeiten2 *)
      init_selection(sel_rec_typ_ptr, hour_str);
      start_reihe(lcid_out);
      schreib_td_text(lcid_out, 'CENTER', grau, '1', '1', 'Tag, Ort\Zeit');
      i_start:=max_basic_param_anz+2*max_zeil_anz;
      FOR spalte:=0 TO (sd.spalt_anz-1) DO
        schreib_td_start(lcid_out, 'CENTER', hellgelb, '1', '1');
        schreib_select_button(lcid_out, input[spalte+i_start].name_strr,
                              sel_rec_typ_ptr, zehnmin_anz,
                              sd.uhrzeit[spalte]);
        schreib_td_end(lcid_out);
      END;                      (* FOR spalte *)
      end_reihe(lcid_out);
      dispose_selection(sel_rec_typ_ptr);
    END schreib_reihe_uhrzeiten2;

  PROCEDURE schreib_erste_spalte2(lcid_out: ChanId;
                                  VAR sd: sd_rec_typ; zeile: INTEGER);
    VAR
      i_start:                  INTEGER;
      sel_rec_typ_ptr:          sel_rec_typ_ptr_typ;

    BEGIN                       (* PROCEDURE schreib_erste_spalte2 *)
      init_selection(sel_rec_typ_ptr, week_str);
      i_start:=max_basic_param_anz;
      schreib_td_start(lcid_out, 'CENTER', hellgelb, '1', '1');
      schreib_select_button(lcid_out, input[zeile+i_start].name_strr,
                            sel_rec_typ_ptr, wochentage_anz,
                            sd.wochentag[zeile]);


      i_start:=max_basic_param_anz+max_zeil_anz;
      schreib_paragraph_start(lcid_out);
      schreib_text(lcid_out, input[zeile+i_start].name_strr, sd.court[zeile], '10');
      schreib_paragraph_end(lcid_out);
      schreib_td_end(lcid_out);
      dispose_selection(sel_rec_typ_ptr);

    END schreib_erste_spalte2;

  PROCEDURE sez(lcid_out: ChanId; zeile: INTEGER);      (* schreib eine zeile *)
    VAR
      spalte, i_start:          INTEGER;
      court_index:              INTEGER;
      checked:                  INTEGER;

    BEGIN                       (* PROCEDURE sez *)
      start_reihe(lcid_out);

      schreib_erste_spalte2(lcid_out, sd, zeile);
      i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
               zeile*max_spalt_anz;
      FOR spalte:=0 TO sd.spalt_anz-1 DO
        court_index:=2*(zeile*sd.spalt_anz+spalte);
        IF sd.uns_court[court_index]>-1 THEN checked:=1 ELSE checked:=0 END;
        schreib_td_start(lcid_out, 'CENTER', hellgelb, '1', '1');
        WITH input[spalte+i_start] DO
          (*
          Zuerst hatten wir hier mit schreib_radio2 gearbeitet. Eine
          Checkbox ist einfach geiler. Allerdings mu man sich genau
          klar machen, wie die funktioniert. Ist die Box angekreuzt,
          schickt der Browser ein entsprechendes name/value-Paar
          ab, ansonsten nicht. Wir haben in schreib_checkbox1 als
          value "1" drinstehen, d.h. wir knnen die entsprechenden
          INPUT-Parameter als INTEGERs betrachten. D.h. bei angekreuzter
          Box kommt 1, ansonsten kommt gar nichts, nicht etwa ein
          name/value-Paar mit Leerstring als value. Dies wrde nmlich
          sofort eine Fehlermeldung in calc_integers nach sich ziehen.
          D.h. aber, da dann der Defaultwert von input[j+i_start].value
          in analyse_layout_and_react zum Tragen kommt. Dieser ist in
          init_default_inputs1 auf 0 gesetzt worden.
          Wollten wir anstatt mit schreib_checkbox1 mit schreib_radio2
          arbeiten, htte das so auzusehen:

          schreib_radio2(lcid_out, name_strr, 'ja', 1, 'nein', 0, checked);

          wobei checked genau anders belegt werden mte:

          IF sd.uns_court[court_index]>-1 THEN checked:=0 ELSE checked:=1 END;
          *)
          schreib_checkbox1(lcid_out, name_strr,
                            '<P> Dieser Platz ist </P> unser Platz', checked); 
        END;                    (* WITH input[... *)
        schreib_td_end(lcid_out);
      END;                      (* FOR spalte *)
      end_reihe(lcid_out);
    END sez;

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    VAR
      zeile:                    INTEGER;

    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 1);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '14');
      schreib_page_table_admin_progress(lcid_out, sd.sea_state);

      schreib_form_start(lcid_out);

      schreib_heading(lcid_out, 'Achtung!', 'H3');
      schreib_heading(lcid_out, 'Nach Hinzu- oder Wegnahme auch nur eines einzigen Platzes werden', 'H3');
      schreib_heading(lcid_out, 'in jedem Fall alle Spieler ausgetragen (falls bereits welche eingetragen', 'H3');
      schreib_heading(lcid_out, 'sind). Bei nderung eines Wochentages bzw. einer Uhrzeit ebenso!', 'H3');
      schreib_heading(lcid_out, 'nderungen am Platznamen bleiben diesbezglich ohne Folgen.', 'H3');

      schreib_table_start(lcid_out, 'Aktuelles Tabellenlayout. Bitte ggf. ndern!', 'H3');

      schreib_reihe_uhrzeiten2(lcid_out, sd);

      FOR zeile:=0 TO sd.zeil_anz-1 DO
        sez(lcid_out, zeile);
      END;                      (* FOR zeile *)

      schreib_table_end(lcid_out);

      schreib_table_start(lcid_out, '', '');
      GetGPMString(zwstr, ii05);
      schreib_reihe_passwd(lcid_out, 'CENTER', 'Chef-Kennwort:',
                           input[ii05].name_strr, zwstr);
      schreib_reihe_ok(lcid_out, sd, 'OK', p14ac1);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, '', '');
      schreib_reihe_not_ok(lcid_out, sd, 'nicht OK', p14ac2);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page14 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page14;


PROCEDURE schreib_page15(VAR sd: sd_rec_typ);
  (*
  Dies ist die vierte 'Adminseite'. Die Datenbasis ist bereit fr
  nderung bzw. Besttigung von Spielername, persnlichen Daten, wchentlich / 14-tgig,
  Kennwort usw..
  *)

  VAR
    zwstr:                      String;

  PROCEDURE skz(lcid_out: ChanId);      (* schreib Kopfzeile *)
    BEGIN                       (* PROCEDURE skz *)
      start_reihe(lcid_out);
      schreib_td_text(lcid_out, 'CENTER', hellgelb, '1', '1', '#');
      schreib_td_text(lcid_out, 'CENTER', hellgelb, '1', '1', 'Name');
      schreib_td_text(lcid_out, 'CENTER', hellgelb, '1', '1', 'Persdata');
      schreib_td_text(lcid_out, 'CENTER', hellgelb, '1', '1', '14-tgig?');
      schreib_td_text(lcid_out, 'CENTER', hellgelb, '1', '1', 'aktiv?');
      schreib_td_text(lcid_out, 'CENTER', hellgelb, '1', '1', 'Rang');
      schreib_td_text(lcid_out, 'CENTER', hellgelb, '1', '1', 'Tage voraus');
      schreib_td_text(lcid_out, 'CENTER', hellgelb, '1', '2', 'Kennwort eintragen?');
      end_reihe(lcid_out);
    END skz;

  PROCEDURE sez(lcid_out: ChanId; sp_index: INTEGER);   (* schreib eine zeile *)
    VAR
      i_start:                  INTEGER;
      index_str:                String;
      zwstr, zwstr2:            String;
      kennwstr:                 String;
      checked:                  INTEGER;

    BEGIN                       (* PROCEDURE sez *)
      start_reihe(lcid_out);

      IntToStr(sp_index+1, index_str);
      schreib_td_text(lcid_out, 'CENTER', hellgelb, '1', '1', index_str);

      i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
               max_zeil_anz*max_spalt_anz;
      Assign(input[sp_index+i_start].name_strr, zwstr);
      schreib_td_start(lcid_out, 'CENTER', hellgelb, '1', '1');
      schreib_text(lcid_out, zwstr, sd.spieler_name[sp_index+ssa], '14');
      schreib_td_end(lcid_out);

      i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
               max_zeil_anz*max_spalt_anz+5*max_spieler_anz+
               max_wochen_anz;
      Assign(input[sp_index+i_start].name_strr, zwstr);
      schreib_td_start(lcid_out, 'CENTER', hellgelb, '1', '1');
      schreib_text(lcid_out, zwstr, sd.spieler_pers_data[sp_index+ssa], '20');
      schreib_td_end(lcid_out);

      i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
               max_zeil_anz*max_spalt_anz+max_spieler_anz;
      IF sd.spieler_art[sp_index+ssa]=sp_art_14t THEN checked:=1 ELSE
        checked:=0 END;
      Assign(input[sp_index+i_start].name_strr, zwstr);
      schreib_td_start(lcid_out, 'CENTER', hellgelb, '1', '1');
      schreib_checkbox1(lcid_out, zwstr, 'ja', checked); 
      schreib_td_end(lcid_out);

      i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
               max_zeil_anz*max_spalt_anz+2*max_spieler_anz;
      IF sd.spieler_aktiv[sp_index+ssa]=sp_aktiv_ja THEN checked:=1 ELSE
        checked:=0 END;
      Assign(input[sp_index+i_start].name_strr, zwstr);
      schreib_td_start(lcid_out, 'CENTER', hellgelb, '1', '1');
      schreib_checkbox1(lcid_out, zwstr, 'ja', checked); 
      schreib_td_end(lcid_out);

      i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
               max_zeil_anz*max_spalt_anz+5*max_spieler_anz+
               max_wochen_anz+max_spieler_anz;
      Assign(input[sp_index+i_start].name_strr, zwstr);
      IntToStr(sd.spieler_rang[sp_index+ssa], zwstr2);
      schreib_td_start(lcid_out, 'CENTER', hellgelb, '1', '1');
      schreib_text(lcid_out, zwstr, zwstr2, '4');
      schreib_td_end(lcid_out);

      i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
               max_zeil_anz*max_spalt_anz+5*max_spieler_anz+
               max_wochen_anz+2*max_spieler_anz;
      Assign(input[sp_index+i_start].name_strr, zwstr);
      IntToStr(sd.max_day_delta[sp_index+ssa], zwstr2);
      schreib_td_start(lcid_out, 'CENTER', hellgelb, '1', '1');
      schreib_text(lcid_out, zwstr, zwstr2, '4');
      schreib_td_end(lcid_out);

      i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
               max_zeil_anz*max_spalt_anz+3*max_spieler_anz;
      Assign(input[sp_index+i_start].name_strr, zwstr);
      schreib_td_start(lcid_out, 'CENTER', hellgelb, '1', '1');
      Assign('Kennw', kennwstr);
      Append(index_str, kennwstr);
      schreib_text(lcid_out, zwstr, kennwstr, '8');
      schreib_td_end(lcid_out);

      i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
               max_zeil_anz*max_spalt_anz+4*max_spieler_anz;
      checked:=0;
      Assign(input[sp_index+i_start].name_strr, zwstr);
      schreib_td_start(lcid_out, 'CENTER', hellgelb, '1', '1');
      schreib_checkbox1(lcid_out, zwstr, 'ja', checked); 
      schreib_td_end(lcid_out);

      end_reihe(lcid_out);
    END sez;

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    VAR
      zwstr1:                   String;
      zwstr2:                   String_kurz;
      sp_index:                 INTEGER;

    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 1);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '15');
      schreib_page_table_admin_progress(lcid_out, sd.sea_state);

      schreib_form_start(lcid_out);
      schreib_heading(lcid_out, 'Name, Persdata, Typ, Aktivitt, Rang, Tage voraus und Kennwort. Bitte ggf. ndern!', 'H3');

      schreib_heading(lcid_out, 'Hinweis1: unter "Persdata" ist eine normale Internet-E-Mail-Adresse bzw. zustzliche persnliche Daten einzugeben.', 'H5');
      schreib_heading(lcid_out, "E-Mail-Adresse und persnliche Daten werden durch Strichpunkt getrennt. Der Strichpunkt darf fehlen, dann gibt's", 'H5');
      schreib_heading(lcid_out, 'nur eine E-Mail-Adresse. Keine der beiden Informationen mu vorhanden sein.', 'H5');
      schreib_heading(lcid_out, 'Die Internet-E-Mail-Adresse sollte die Form irgendwer@domain.de haben.', 'H5');
      schreib_heading(lcid_out, 'An diese Adresse werden automatisch Benachrichtigungen ber Aktivitten auf dem (eigenen) Platz verschickt.', 'H5');
      schreib_heading(lcid_out, 'Werden fr den Spieler keine Benachrichtigungen gewnscht, bitte einfach leeres E-Mail-Feld eingeben!', 'H5');

      schreib_heading(lcid_out, 'Hinweis2: Spieler, die nur alle 14 Tage spielen, sollten entsprechend gekennzeichnet werden. Damit wird dann', 'H5');
      schreib_heading(lcid_out, 'u.a. verhindert, da sich in einer Woche mehr als die Hlfte aller 14-tgigen Spieler eintrgt.', 'H5');
      schreib_heading(lcid_out, 'Natrlich knnen die Chefs jederzeit trotzdem 14-tgige Spieler eintragen.', 'H5');

      schreib_heading(lcid_out, 'Hinweis3: das Kstchen "aktiv" ist dazu gedacht, Spieler, die einmal mit dabei waren und aus irgend einem', 'H5');
      schreib_heading(lcid_out, 'Grund nun nicht mehr mitmachen, sozusagen "deaktivieren" zu knnen. Dies ist viel praktischer, als den', 'H5');
      schreib_heading(lcid_out, 'Spieler komplett aus der Liste zu streichen. Dadurch bleiben interne Indizes unverndert und man kann', 'H5');
      schreib_heading(lcid_out, 'den betreffenden Spieler jederzeit (doch) wieder "aktivieren", fall dies gewnscht sein sollte.', 'H5');

      schreib_heading(lcid_out, 'Hinweis4: soll ein Spieler in der Rangliste erscheinen, mu ihm ein Rang zwischen (einschlielich)', 'H5');
      Assign('1 und ', zwstr);
      IntToStr(sd.spieler_anz, zwstr2);
      Append(zwstr2, zwstr);
      Append(' zugewiesen werden. 0 bedeutet dabei: der Spieler erscheint nicht in der Rangliste!', zwstr);
      schreib_heading(lcid_out, zwstr, 'H5');

      schreib_heading(lcid_out, 'Hinweis5: bei "Tage voraus" wird angegeben, wieviele Tage im Voraus sich ein Spieler frhestens', 'H5');
      schreib_heading(lcid_out, 'eintragen kann, wenn nicht andere Grnde dagegen sprechen. 0 heit: keine Beschrnkung. Jeder Wert', 'H5');
      schreib_heading(lcid_out, 'ungleich 0 stempelt den Spieler zum (Dauer-)Gast ab und lt ihn als solchen in der Statistik erscheinen!', 'H5');

      schreib_heading(lcid_out, 'Hinweis6: die angezeigten Kennwrter sind nicht die momentan gltigen, weil diese verschlsselt', 'H5');
      schreib_heading(lcid_out, 'sind und nicht gelesen werden knnen. Bestehende Kennwrter knnen lediglich "blind" durch', 'H5');
      schreib_heading(lcid_out, 'ein neues ersetzt werden. Dazu neues Kennwort eintippen und Kstchen "ja" ankreuzen.', 'H5');
      schreib_table_start(lcid_out, '', 'H5');

      skz(lcid_out);
      FOR sp_index:=0 TO sd.spieler_anz-1 DO
        sez(lcid_out, sp_index);
      END;                      (* FOR sp_index *)

      schreib_table_end(lcid_out);

      schreib_table_start(lcid_out, '', '');
      GetGPMString(zwstr, ii05);
      schreib_reihe_passwd(lcid_out, 'CENTER', 'Chef-Kennwort:',
                           input[ii05].name_strr, zwstr);
      schreib_reihe_ok(lcid_out, sd, 'OK', p15ac1);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, '', '');
      schreib_reihe_not_ok(lcid_out, sd, 'nicht OK', p15ac2);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page15 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page15;


PROCEDURE schreib_page16(VAR sd: sd_rec_typ);
  (*
  Dies ist die fnfte 'Adminseite'. Die Datenbasis ist bereit fr
  nderung bzw. Besttigung des jahr_wochen_zugriff.
  *)

  VAR
    zwstr:                      String;

  PROCEDURE sez(lcid_out: ChanId; wo_index: INTEGER);   (* schreib eine zeile *)
    VAR
      i_start:                  INTEGER;
      zwstr1, zwstr2:           String;
      sel_rec_typ_ptr:          sel_rec_typ_ptr_typ;

    BEGIN                       (* PROCEDURE sez *)
      start_reihe(lcid_out);

      i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
               max_zeil_anz*max_spalt_anz+5*max_spieler_anz;

      zwstr2:='fr ';
      LUWNToLesbar(wo_index+sd.season_start, zwstr1);
      Append(zwstr1, zwstr2);
      schreib_td_text(lcid_out, 'LEFT', hellgelb, '1', '1', zwstr2);

      init_selection(sel_rec_typ_ptr, vor_str);

      schreib_td_start(lcid_out, 'CENTER', hellgelb, '1', '1');
      schreib_text_crlf(lcid_out, 'um ');
      schreib_select_button(lcid_out, input[wo_index+i_start].name_strr,
                            sel_rec_typ_ptr, max_jahr_wochen_zugriff,
                            sd.jahr_wochen_zugriff[wo_index]);
      schreib_text_crlf(lcid_out, ' Wochen');
      schreib_td_end(lcid_out);
      dispose_selection(sel_rec_typ_ptr);

      end_reihe(lcid_out);
    END sez;

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    VAR
      wo_index:                 INTEGER;

    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 1);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '16');
      schreib_page_table_admin_progress(lcid_out, sd.sea_state);

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, 'Wieviele Wochen vorher soll Eintragung mglich sein? Bitte ggf. ndern!', 'H3');

      FOR wo_index:=0 TO sd.wochen_anz-1 DO
        sez(lcid_out, wo_index);
      END;                      (* FOR wo_index *)

      schreib_table_end(lcid_out);

      schreib_table_start(lcid_out, '', '');
      GetGPMString(zwstr, ii05);
      schreib_reihe_passwd(lcid_out, 'CENTER', 'Chef-Kennwort:',
                           input[ii05].name_strr, zwstr);
      schreib_reihe_ok(lcid_out, sd, 'OK', p16ac1);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, '', '');
      schreib_reihe_not_ok(lcid_out, sd, 'nicht OK', p16ac2);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page16 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page16;


PROCEDURE schreib_page17(VAR sd: sd_rec_typ);
  (*
  Dies ist die sechste 'Adminseite'. Die Datenbasis ist komplett
  umgekrempelt und es wird danach gefragt, ob der Wartungsmodus
  endgltig verlassen werden soll.
  *)

  VAR
    zwstr:                      String;

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 1);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '17');
      schreib_page_table_admin_progress(lcid_out, sd.sea_state);

      schreib_form_start(lcid_out);

      schreib_heading(lcid_out, 'Letzter Wartungsschritt erreicht. Soll nun Rckkehr in den Normalmodus erfolgen?', 'H3');
      schreib_table_start(lcid_out, 'Hinweis: bei Auswahl von "nicht OK" wird nochmal ein Wartungszyklus gestartet!', 'H5');
      GetGPMString(zwstr, ii05);
      schreib_reihe_passwd(lcid_out, 'CENTER', 'Chef-Kennwort:',
                           input[ii05].name_strr, zwstr);
      schreib_reihe_ok(lcid_out, sd, 'OK', p17ac1);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, '', '');
      schreib_reihe_not_ok(lcid_out, sd, 'nicht OK', p17ac2);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page17 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page17;


PROCEDURE schreib_page18(VAR sd: sd_rec_typ);
  VAR
    wslog_name:                 String;

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '18');

      (*
      So heit das File mit dem Webserver Logfile:
      *)
      Assign(squash_base_v, wslog_name);
      Append('/data', wslog_name);
      Append(script_nam_prog_appendix, wslog_name);
      Append('/access_log', wslog_name);

      schreib_heading(lcid_out, 'Das Webserver Logfile...', 'H3');

      WriteString(lcid_out, '<PRE>');
      WriteLnCrLf(lcid_out);

      try_my_cat_stdout(lcid_out, wslog_name, 3);

      WriteString(lcid_out, '</PRE>');
      WriteLnCrLf(lcid_out);

      schreib_page4_table1(lcid_out, sd, '', 'Zurck zum Spielbelegungsplan', dunkelgruen, p4ac1);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page18 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page18;


PROCEDURE schreib_page19(VAR sd: sd_rec_typ);
  (*
  Dies ist die Seite zum Abgeben einer ffentlichen Meinung.
  *)

  VAR
    text, zwstr:                String;
    zwstr_lang:                 String_lang;

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '19');

      schreib_form_start(lcid_out);
      schreib_heading(lcid_out, 'Wer will eine ffentliche Mitteilung machen?', 'H3');

      schreib_heading(lcid_out, 'Datenschutzhinweis: Datum, Uhrzeit, Name des Verfassers (oder Text', 'H5');
      schreib_heading(lcid_out, '"(ein Besucher)" bei anonymer Mitteilung) und IP-Nummer werden in der', 'H5');
      schreib_heading(lcid_out, 'Mitteilung erscheinen. Wer das nicht will, sollte keine Mitteilung absenden!', 'H5');
      text:='Hinweis2: Mitteilung kann nicht lnger als ';
      IntToStr(langlen-1, zwstr);
      Append(zwstr, text);
      Append(' Zeichen sein!', text);
      schreib_heading(lcid_out, text, 'H5');

      schreib_table_start(lcid_out, 'Hinweis3: fr bisher gemachte Mitteilungen siehe unten', 'H5');
      schreib_reihe_select_spieler(lcid_out, sd, i_auswahl, i_ein_besucher, ssa, sd.spieler_anz+ssa-1);
      GetGPMString(zwstr_lang, ii16);
      schreib_reihe_textarea(lcid_out, input[ii16].name_strr,
                             zwstr_lang);
      schreib_reihe_passwd(lcid_out, 'CENTER', 'Kennwort (Besucher braucht keines):', input[ii05].name_strr, '');

      schreib_reihe_ok(lcid_out, sd, 'OK', p19ac1);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, '', '');
      schreib_reihe_not_ok(lcid_out, sd, 'weg hier', p19ac2);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      IF file_existiert(chat_name) THEN
        schreib_heading(lcid_out, 'Bisher gemachte Mitteilungen...', 'H3');

        WriteString(lcid_out, '<PRE>');
        WriteLnCrLf(lcid_out);

        try_my_cat_stdout(lcid_out, chat_name, 2);

        WriteString(lcid_out, '</PRE>');
        WriteLnCrLf(lcid_out);

      ELSE                      (* IF file_existiert(chat_name) *)
        schreib_heading(lcid_out, "Bisher gemachte Mitteilungen... gibt's noch keine.", 'H3');
      END;                      (* ELSE file_existiert(chat_name) *)

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page19 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page19;


PROCEDURE schreib_page20(VAR sd: sd_rec_typ);
  (*
  Dies ist die Seite zum Umbenennen der Datenbasis.
  *)

  VAR
    text:                       String;

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '20');

      schreib_form_start(lcid_out);
      Assign('Datenbasis lschen+Backup anlegen (unter ', text);
      Append(bkp_prefix, text);
      Append('<Datum/Zeit>)?', text);
      schreib_table_start(lcid_out, text, 'H3');
      schreib_reihe_passwd(lcid_out, 'CENTER', 'Chef-Kennwort:', input[ii05].name_strr, '');
      schreib_reihe_ok(lcid_out, sd, 'OK', p20ac1);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, '', '');
      schreib_reihe_not_ok(lcid_out, sd, 'nicht OK', p20ac2);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page20 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page20;


PROCEDURE schreib_page21(VAR sd: sd_rec_typ);
  (*
  Dies ist die Seite zum Wiedereinlesen einer alten Datenbasis.
  *)

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '21');

      schreib_form_start(lcid_out);
      schreib_heading(lcid_out, 'Alte Datenbasis von welchem Backup einlesen?', 'H3');
      schreib_heading(lcid_out, 'Hinweis1: vorhandene aktuelle Datenbasis wird dabei berschrieben!', 'H3');
      schreib_table_start(lcid_out, 'Hinweis2: Nach dem Einlesen gilt wieder das Default-Chef-Kennwort!', 'H3');
      schreib_reihe_select_bkp_nam(lcid_out);
      schreib_reihe_passwd(lcid_out, 'CENTER', 'Chef-Kennwort:', input[ii05].name_strr, '');
      schreib_reihe_ok(lcid_out, sd, 'OK', p21ac1);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, '', '');
      schreib_reihe_not_ok(lcid_out, sd, 'nicht OK', p21ac2);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page21 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page21;


PROCEDURE schreib_page22(VAR sd: sd_rec_typ);
  (*
  Dies ist eine der ersten 'Adminseiten'. Es ist kein season-File da, aber
  es gibt (mindestens) ein altes Backup. Es wird danach gefragt, ob ein
  solches eingelesen werden soll.
  *)
  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '22');

      schreib_form_start(lcid_out);
      schreib_heading(lcid_out, 'Keine Datenbasis vorhanden, soll eine alte eingelesen werden?', 'H3');
      schreib_table_start(lcid_out, 'Hinweis: Nach dem Einlesen gilt weiterhin das Default-Chef-Kennwort!', 'H3');
      schreib_reihe_select_bkp_nam(lcid_out);
      schreib_reihe_passwd(lcid_out, 'CENTER', 'Default-Chef-Kennwort:', input[ii05].name_strr ,'');
      schreib_reihe_ok(lcid_out, sd, 'OK', p22ac1);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, '', '');
      schreib_reihe_not_ok(lcid_out, sd, 'nicht OK', p22ac2);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page22 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page22;


PROCEDURE schreib_page06_oder_22;
  (*
  Es ist kein season-File da und wir mssen sehen, ob wenigstens irgend-
  ein Backupfile da ist. Falls ja, machen wir bei page22 weiter und fragen,
  ob davon eines genommen werden soll. Falls nein, gehen wir zu page06 und
  fragen nach, ob eine neue Datenbasis angelegt werden soll.
  *)

  BEGIN                         (* PROCEDURE schreib_page06_oder_22 *)
    IF anzahl_pref_files(bkp_pfad, bkp_prefix)=0 THEN
      schreib_page06(sd1);
    ELSE                        (* IF anzahl_pref_files... *)
      schreib_page22(sd1);
    END;                        (* ELSE anzahl_pref_files... *)
  END schreib_page06_oder_22;


PROCEDURE schreib_page23(VAR sd: sd_rec_typ);
  (*
  Dies ist die Seite zum Lschen eines alten Lockfiles.
  *)

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '23');

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, 'Achtung, altes Lockfile entdeckt! Jetzt lschen?', 'H3');
      schreib_reihe_passwd(lcid_out, 'CENTER', 'ChefIn-Kennwort:', input[ii05].name_strr, '');
      schreib_reihe_ok(lcid_out, sd, 'OK', p23ac1);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, '', '');
      schreib_reihe_not_ok(lcid_out, sd, 'nicht OK', p23ac2);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page23 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page23;


PROCEDURE schreib_page25(VAR sd: sd_rec_typ);
  (*
  Dies ist die Seite zum Umstellen der Rangliste.
  *)

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    VAR
      count:                    INTEGER;
      rang_feld:                rang_feld_typ;
      max_name_length:          CARDINAL;
      zwstr:                    String_mittel;

    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '25');

      schreib_form_start(lcid_out);

      get_rang_info(sd, rang_feld, count, max_name_length);
      Assign('Rangliste ndern: soll ', zwstr);
      Append(sd.spieler_name[rang_feld[input[ii20].value-1]], zwstr);
      Append(' den Platz von ', zwstr);
      Append(sd.spieler_name[rang_feld[input[ii21].value-1]], zwstr);
      Append(' einnehmen?', zwstr);

      schreib_table_start(lcid_out, zwstr, 'H3');
      schreib_reihe_passwd(lcid_out, 'CENTER', 'ChefIn-Kennwort:', input[ii05].name_strr, '');
      schreib_reihe_ok(lcid_out, sd, 'OK', p25ac1);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, '', '');
      schreib_reihe_not_ok(lcid_out, sd, 'nicht OK', p25ac2);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page25 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page25;


PROCEDURE schreib_page26(VAR sd: sd_rec_typ);
  (*
  Dies ist die Eingangsseite zum Editieren der Persdata.
  *)

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '26');

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, 'Persnliche Daten editieren?', 'H3');
      schreib_reihe_select_spieler(lcid_out, sd, i_auswahl, i_auswahl, ssa, sd.spieler_anz+ssa-1);
      schreib_reihe_passwd(lcid_out, 'CENTER', '(Spieler oder ChefIn-)Kennwort:',
                           input[ii05].name_strr, '');
      schreib_reihe_ok(lcid_out, sd, 'OK', p26ac1);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, '', '');
      schreib_reihe_not_ok(lcid_out, sd, 'nicht OK', p26ac2);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page26 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page26;


PROCEDURE schreib_page27(VAR sd: sd_rec_typ);
  (*
  Dies ist die Endseite zum Editieren der persnlichen Daten.
  *)
  VAR
    zwstr:                      String_mittel;

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 1);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '27');

      schreib_form_start(lcid_out);
      schreib_heading(lcid_out, 'Persnliche Daten editieren:', 'H3');
      schreib_heading(lcid_out, 'Hinweis: Die persnlichen Daten bestehen aus einem oder (optional) zwei Teilen.', 'H5');
      schreib_heading(lcid_out, 'Der erste (oder einzige) Teil der eingegebenen Daten wird als E-Mail-Adresse interpretiert.', 'H5');
      schreib_heading(lcid_out, 'Die E-Mail-Adresse sollte dabei die Form irgendwer@domain.de haben. An diese Adresse werden', 'H5');
      schreib_heading(lcid_out, 'automatisch Benachrichtigungen ber Aktivitten auf dem (eigenen) Platz verschickt.', 'H5');
      schreib_heading(lcid_out, 'Werden fr den Spieler keine Benachrichtigungen gewnscht, bitte einfach leeres E-Mail-Feld eingeben!', 'H5');

      schreib_heading(lcid_out, 'Ein optionaler, zweiter Teil der persnlichen Daten wird erkannt, sobald ein Strichpunkt vorliegt.', 'H5');
      schreib_heading(lcid_out, 'Der gesamte Text NACH diesem (ersten) Strichpunkt wird dann gegen Ende der Statistikseite', 'H5');
      schreib_heading(lcid_out, 'beim jeweiligen Spieler in den Spielerinformationen mit ausgegeben.', 'H5');
      schreib_heading(lcid_out, 'Der Text VOR dem (ersten) Strichpunkt wird also NICHT mit auf der Statistikseite ausgegeben!', 'H5');

      schreib_heading(lcid_out, 'Werden fr den Spieler keine Benachrichtigungen gewnscht und sollen aber trotzdem', 'H5');
      schreib_heading(lcid_out, 'persnliche Daten eingegeben werden, dann bitte gleich als erstes Zeichen', 'H5');

      schreib_table_start(lcid_out, 'einen Strichpunkt in die Zeile eingeben', 'H5');
      convert_to_amp_string(sd.spieler_name[input[ii03].value], zwstr);
      schreib_reihe_ro_text(lcid_out, zwstr);
      schreib_reihe_text(lcid_out, 'CENTER', 'Persnliche Daten:', input[ii22].name_strr,
                         sd.spieler_pers_data[input[ii03].value], '50');
      GetGPMString(zwstr, ii05);
      schreib_reihe_passwd(lcid_out, 'CENTER', '(Spieler oder ChefIn-)Kennwort:',
                           input[ii05].name_strr, zwstr);
      schreib_reihe_ok(lcid_out, sd, 'neue Daten bernehmen', p27ac1);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, '', '');
      schreib_reihe_not_ok(lcid_out, sd, 'Daten NICHT ndern', p27ac2);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page27 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page27;


PROCEDURE schreib_page28(VAR sd: sd_rec_typ);
  (*
  Dies ist die Eingangsseite zum Anzeigen der Statistikseite.
  *)

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '28');

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, 'Statistikseite anzeigen?', 'H3');
      schreib_reihe_select_spieler(lcid_out, sd, i_auswahl, i_chefin, ssa, sd.spieler_anz+ssa-1);
      schreib_reihe_passwd(lcid_out, 'CENTER', 'Kennwort:',
                           input[ii05].name_strr, '');
      schreib_reihe_ok(lcid_out, sd, 'OK', p28ac1);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_form_start(lcid_out);
      schreib_table_start(lcid_out, '', '');
      schreib_reihe_not_ok(lcid_out, sd, 'nicht OK', p28ac2);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page28 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page28;


PROCEDURE schreib_page29(VAR sd: sd_rec_typ);
  (*
  Dies ist die Statistikseite
  *)
  VAR
    gesamt_platz_zahl:          INTEGER;
    spieler_wie_oft:            int_arr_spieler_typ;
    spieler_wie_oft_saison:     int_arr_spieler_typ;
    spieler_wie_oft_gast:       int_arr_spieler_typ;
    spieler_wie_oft_gast_saison:        int_arr_spieler_typ;
    spieler_wie_oft_gesamt:     INTEGER;
    abbestellt_anz:             INTEGER;
    abbestellt_anz_pro_woche:   INTEGER;
    abbestellt_wochen_anz:      INTEGER;
    verschenkt_anz:             INTEGER;
    dauergast_anz:              INTEGER;
    gast_von_dauergast_anz:     INTEGER;
    priv_gast_anz:              INTEGER;
    offiz_gast_anz:             INTEGER;
    gesamt_gast_anz:            INTEGER;
    format:                     ConvResults;
    ukwa:                       INTEGER;
    soll_wochen_anzi:           INTEGER;
    soll_wochen_anz:            REAL;
    zwstr1, zwstr2, zwstr3:     String_mittel;

  PROCEDURE ermittle_gast_usw_anz;
    VAR
      i, k:                     INTEGER;
      belegung_file:            INTEGER;
      belegung_file_zw:         INTEGER;
      belegung_file_gast:       INTEGER;

    PROCEDURE update_ggf_gast_usw_count;
      BEGIN                     (* PROCEDURE update_ggf_gast_usw_count *)
        (*
        Wie oft ist denn der einzelne Spieler dabei? Wir unterscheiden
        zwischen Spieler und seinem Gast. Gezhlt wird hier noch alles,
        also auch (abbestellt), die Chefs und so. Ausgeben tun wir spter
        evtl. nur den (abbestellt) und die regulren Spieler. Aber macht
        ja nix.
        *)
        IF belegung_file_gast=0 THEN
          (* Der Spieler spielt selber *)
          spieler_wie_oft[belegung_file]:=spieler_wie_oft[belegung_file]+1;
          spieler_wie_oft_saison[belegung_file]:=spieler_wie_oft_saison[belegung_file]+1;
        ELSE                    (* IF belegung_file_gast=0 THEN *)
          (* Ein Gast des Spielers spielt *)
          spieler_wie_oft_gast[belegung_file]:=spieler_wie_oft_gast[belegung_file]+1;
          spieler_wie_oft_gast_saison[belegung_file]:=spieler_wie_oft_gast_saison[belegung_file]+1;
        END;

        IF belegung_file=i_abbestellt THEN
          abbestellt_anz_pro_woche:=abbestellt_anz_pro_woche+1;
        ELSE                    (* IF belegung_file... *)
          IF belegung_file=i_frei THEN
            (* nichts *)
          ELSE                  (* IF belegung_file=i_frei *)
            (*
            (abbestellt) und (frei) sollen nicht mit zhlen
            *)
            spieler_wie_oft_gesamt:=spieler_wie_oft_gesamt+1;
          END;                  (* ELSE belegung_file=i_frei *)
        END;                    (* ELSE belegung_file... *)

        (*
        Wir nehmen belegung_file_gast als Hauptschalter fr
        die Gaststatistik her:
        *)
        CASE belegung_file_gast OF
          | 0:                  (* Spieler selbst *)
              (*
              Nachdem der Spieler selbst eingetragen ist, besteht nur
              noch die Mglichkeit, da wir einen Dauergast vorliegen
              haben. Anderswo haben wir festgelegt, da sich Dauergste
              durch 'Tage voraus' ungleich 0 auszeichnen. Testen wir das
              also:
              *)
              IF sd.max_day_delta[belegung_file]<>0 THEN
                dauergast_anz:=dauergast_anz+1;
              END;              (* IF sd.max_day_delta... *)

          | 1:                  (* priv. Gast *)
              (*
              Es ist ein privater Gast eingetragen. Ist es der private
              Gast einer normalen Spielers oder der eines Dauergastes?
              Anderswo haben wir festgelegt, da sich Dauergste durch
              'Tage voraus' ungleich 0 auszeichnen. Testen wir das also:
              *)
              IF sd.max_day_delta[belegung_file]<>0 THEN
                gast_von_dauergast_anz:=gast_von_dauergast_anz+1;
              ELSE              (* IF sd.max_day_delta... *)
                priv_gast_anz:=priv_gast_anz+1;
              END;              (* ELSE sd.max_day_delta... *)

          | 2:                  (* offiz. Gast *)
              (*
              Es ist ein offizieller Gast eingetragen. Keine
              weitere Betrachtung ntig:
              *)
              offiz_gast_anz:=offiz_gast_anz+1;

          | ELSE                (* sollte nie vorkommen *)
              (* nichts *)
        END;                    (* CASE belegung_file_gast *)
      END update_ggf_gast_usw_count;

    PROCEDURE update_ggf_gast_usw_count_saison;
      BEGIN                     (* PROCEDURE update_ggf_gast_usw_count_saison *)
        (*
        Wie oft ist denn der einzelne Spieler dabei? Wir unterscheiden
        zwischen Spieler und seinem Gast. Gezhlt wird hier noch alles,
        also auch (abbestellt), die Chefs und so. Ausgeben tun wir spter
        evtl. nur den (abbestellt) und die regulren Spieler. Aber macht
        ja nix.
        *)
        IF belegung_file_gast=0 THEN
          (* Der Spieler spielt selber *)
          spieler_wie_oft_saison[belegung_file]:=spieler_wie_oft_saison[belegung_file]+1;
        ELSE                    (* IF belegung_file_gast=0 THEN *)
          (* Ein Gast des Spielers spielt *)
          spieler_wie_oft_gast_saison[belegung_file]:=spieler_wie_oft_gast_saison[belegung_file]+1;
        END;
      END update_ggf_gast_usw_count_saison;

    BEGIN                       (* PROCEDURE ermittle_gast_usw_anz *)
      (*
      erst mal alle Anzahlen auf 0 setzen:
      *)
      gesamt_platz_zahl:=0;
      FOR i:=0 TO sd.spieler_anz+ssa-1 DO
        spieler_wie_oft[i]:=0;
        spieler_wie_oft_saison[i]:=0;
        spieler_wie_oft_gast[i]:=0;
        spieler_wie_oft_gast_saison[i]:=0;
      END;                      (* FOR i *)
      spieler_wie_oft_gesamt:=0;
      abbestellt_anz:=0;
      abbestellt_wochen_anz:=0;
      verschenkt_anz:=0;
      dauergast_anz:=0;
      gast_von_dauergast_anz:=0;
      priv_gast_anz:=0;
      offiz_gast_anz:=0;

      WITH sd DO
        (*
        Alle Courts in allen Wochen abklappern:
        *)
        FOR i:=0 TO wochen_anz-1 DO
          (*
          In jeder Woche alle unsere Courts durchstbern. Zuvorderst
          interessieren wir uns fr die echten Spieler, die in den Courts
          sitzen. Auerdem aber auch fr die abbestellten Pltze und die
          (versehentlich oder absichtlich) nicht abbestellten. Es kommt vor,
          da in einer Woche _alle_ Courts (abbestellt) sind. Dies kann
          insbesondere dann passieren, wenn es nur einen Spieltag gibt und
          an diesem Tag etwa ein Feiertag ist. Dieser Tag wurde dann von
          vorneherein nicht bezahlt und wir zhlen dann nicht die Einzel-
          courts, sondern inkrementieren nur die Zahl der komplett abbestellten
          Wochen. Gibt es pro Woche mehr als einen Spieltag, tut das unserer
          Statistik auch nicht weh. Es ist nur so, da der Nutzen der
          Statistik fr diesen Fall dann nicht besonders gro ist, wenn es
          also z.B. etwa einen voll abbestellten Feiertag und einen normalen
          nicht voll abbestellten weiteren Spieltag gibt. Die Zahl der
          komplett abbestellten Wochen wird dann nicht inkrementiert und
          wir knnen dann nicht ableiten, da etwa ein kompletter Tag
          nicht bestellt war. Egal, dieser Teil der Statistik ist eben
          nur sinnvoll, falls es genau _einen_ Spieltag gibt. Punkt. Zu
          mehr Arbeit haben wir keine Lust.
          *)
          abbestellt_anz_pro_woche:=0;

          FOR k:=0 TO uns_courts_anz-1 DO
            (*
            berhaupt interessieren wir uns im wesentlichen fr die Vergangenheit,
            d.h. fr das tatschlich bis zum aktuellen Zeitpunkt abgelaufene
            Geschehen. Wir knnten das evtl. sehr elegant machen und die
            Schleife ber die Wochen (index i) schon mal nur ber die
            vergangenen Wochen laufen lassen und in der aktuellen Woche
            dann eine gesonderte Betrachtung anstellen. Dazu haben wir
            aber keine Lust. Es ist viel einfacher, wirklich alle Courts
            in allen Wochen anzufassen und jedesmal die Zeit zu berprfen.
            Ist zwar nicht sehr elegant aber unheimlich einfach. Und
            mit Rechenpower gibt's doch sowieso niemals Probleme, oder?

            Nun werden wir doch zustzlich die gesamte Saison abgrasen, d.h.
            wir werden zustzlich sowas wie spieler_wie_oft_saison bzw.
            spieler_wie_oft_gast_saison mitzhlen.
            *)
            IF (user_time(sd, season_start+i, geschrumpfter_index[2*k]) <= zeitalc) THEN
              (*
              Zuallererst zhlen wir mal mit, wieviele Pltze berhaupt da sind:
              *)
              gesamt_platz_zahl:=gesamt_platz_zahl+1;

              belegung_file:=jahr_court_belegung[i, geschrumpfter_index[2*k]];
              belegung_file_zw:=belegung_file;
              belegung_file_gast:=jahr_court_belegung_gast[i, geschrumpfter_index[2*k]];
              update_ggf_gast_usw_count;

              belegung_file:=jahr_court_belegung[i, geschrumpfter_index[2*k+1]];
              belegung_file_gast:=jahr_court_belegung_gast[i, geschrumpfter_index[2*k+1]];
              update_ggf_gast_usw_count;

              (*
              Falls beide Eintrge frei sind, werden wir das notieren.
              *)
              IF ((belegung_file_zw=i_frei) AND (belegung_file=i_frei)) THEN
                verschenkt_anz:=verschenkt_anz+1;
              END;              (* IF ((belegung_file_zw... *)
            ELSE                (* IF (user_time... *)
              (*
              Fr den Rest der Zeit zhlen wir nur noch spieler_wie_oft_saison
              bzw. spieler_wie_oft_gast_saison weiter.
              *)
              belegung_file:=jahr_court_belegung[i, geschrumpfter_index[2*k]];
              belegung_file_gast:=jahr_court_belegung_gast[i, geschrumpfter_index[2*k]];
              update_ggf_gast_usw_count_saison;

              belegung_file:=jahr_court_belegung[i, geschrumpfter_index[2*k+1]];
              belegung_file_gast:=jahr_court_belegung_gast[i, geschrumpfter_index[2*k+1]];
              update_ggf_gast_usw_count_saison;
            END;                (* ELSE (user_time... *)
          END;                  (* FOR k *)

          (*
          Falls nicht zufllig alle Courts in der Woche abbestellt
          waren, werden wir abbestellt_anz entsprechend aktualisieren
          und abbestellt_wochen_anz nicht anrhren. Im anderen Fall,
          wenn also (zufllig) alle Courts in der Woche abbestellt
          waren, werden wir abbestellt_wochen_anz inkrementieren
          und abbestellt_anz nicht anrhren.
          *)
          IF abbestellt_anz_pro_woche<(uns_courts_anz * 2) THEN
            abbestellt_anz:=abbestellt_anz+abbestellt_anz_pro_woche;
          ELSE                  (* IF abbestellt_anz_pro_woche... *)
            abbestellt_wochen_anz:=abbestellt_wochen_anz+1;
          END;                  (* ELSE abbestellt_anz_pro_woche... *)
        END;                    (* FOR i *)
      END;                      (* WITH sd *)
    END ermittle_gast_usw_anz;

  PROCEDURE show_count(lcid_out: ChanId; VAR text: ARRAY OF CHAR; anz: CARDINAL);
    VAR
      zwstr:                    String_mittel;

    BEGIN                       (* PROCEDURE show_count *)
      CardToStr(anz, zwstr);
      Append(zwstr, text);
      schreib_heading_align(lcid_out, text, 'H3', 'LEFT');
    END show_count;

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    VAR
      i, hwi:                   INTEGER;
      sel_rec_typ_ptr:          sel_rec_typ_ptr_typ;
      lcl_ptr:                  sel_rec_typ_ptr_typ;
      gesamt_abbestellt_anz:    INTEGER;
      gesamt_nicht_abbestellt_anz:      INTEGER;
      gesamt_benuetzt_anz:      INTEGER;

    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '29');
      schreib_heading(lcid_out, 'Statistik fr die gesamte Saison:', 'H3');
      (*
      Anla fr diese Statistikseite war der Wunsch einer Chefin.
      Sie wollte wissen, wieviele Gste im Lauf der Saison
      eingetragen waren/sind, um am Ende die Kassenlage damit
      abgleichen zu knnen. Momentan werden wir uns also
      um die Gste kmmern. Ob dann spter auch andere Daten
      auf der Statistikseite auftauchen werden, wissen wir
      jetzt noch nicht.
      Was die Gste betrifft, ist die Chefin eigentlich nur an
      einer einzigen Zahl interessiert: wie viele Gasteintragungen
      haben whrend der gesamten Saison stattgefunden? Dabei ist
      es vllig Wurscht, um welchen Typ von Gast es sich dabei
      handelt: 1. einen Dauergast (das ist einer mit einem von 0
      verschiedenen 'Tage voraus'-Wert), 2. einen privaten Gast
      eines Dauergastes (ja, auch die gibt es theoretisch),
      3. einen privaten Gast eines normalen Spielers oder 4. einen
      offiziellen Gast.
      Wir werden in einem ersten Anlauf also die gesamte Saison
      durchkmmen und fr jeden der 4 Gasttypen die Eintragungen
      zhlen.
      Weil's so schn einfach war, zhlen wir gleich ein bichen
      weiter: auch die Anzahl der abbestellten Courts interessiert
      uns.
      Und eine globale Statistik ber die einzelnen Spieler machen
      wir auch gleich mit. Da interessieren wir uns im brigen nur fr
      die echten Spieler. Den (abbestellt) haben wir sowieso
      schon behandelt und die offiziellen Gste der Chefs
      sind auch schon abgehakt.
      *)
      schreib_hr(lcid_out);

      Assign('Gesamtdauer der Saison in Wochen: ', zwstr1);
      show_count(lcid_out, zwstr1, sd.wochen_anz);

      (*
      Wie gro ist die Sollspielzeit? Werden wir einfach aus ukwa_str
      und dem season_start ermitteln. Der maximale Wert ist offenbar
      die wochen_anz. Minimal kann die Sollspielzeit natrlich eigentlich
      0 sein. Dies ist fr alle Wochen _vor_ der ersten Saisonwoche der 
      Fall. Zufllig ist es natrlich so, da es vor Saisonbeginn noch
      niemanden gibt, der eingetragen sein kann, d.h. Zeiten vor
      Saisonbeginn sind fr uns uninteressant, weil da noch nichts
      passiert. Frhestens in der ersten Saisonwoche sind dann
      Eintragungen mglich. Wir legen mal fest: wenn die aktuelle Woche
      die erste Woche der Saison ist, dann ist die Sollspielzeit gleich
      1 Woche. brigens: diese Aussagen gelten fr wchentliche Spieler.
      Fr 14-tgige ist es genau die Hlfte!
      *)

      (*
      Als erstes brauchen wir mal die aktuelle Unix-Woche (ukwa):
      *)
      StrToInt(ukwa_str, ukwa, format);
      soll_wochen_anzi:=ukwa-sd.season_start+1;

      (*
      Werte kleiner 0 mgen wir also nicht:
      *)
      IF soll_wochen_anzi<0 THEN soll_wochen_anzi:=0; END;

      (*
      Und Werte grer wochen_anz auch nicht:
      *)
      IF soll_wochen_anzi>sd.wochen_anz THEN soll_wochen_anzi:=sd.wochen_anz; END;

      schreib_hr(lcid_out);
      Assign('Bisherige Dauer der Saison (auf ganze Wochen aufgerundet): ', zwstr1);
      show_count(lcid_out, zwstr1, soll_wochen_anzi);

      Assign('Hinweis: fast alle folgenden Angaben beziehen sich auf diesen Zeitraum, also auf', zwstr1);
      schreib_heading_align(lcid_out, zwstr1, 'H3', 'LEFT');

      Assign('die Zeit von Saisonbeginn bis jetzt und nicht auf die Gesamtdauer der Saison!', zwstr1);
      schreib_heading_align(lcid_out, zwstr1, 'H3', 'LEFT');

      ermittle_gast_usw_anz;
      gesamt_gast_anz:=dauergast_anz+gast_von_dauergast_anz+priv_gast_anz+offiz_gast_anz;

      schreib_hr(lcid_out);
      Assign('Gesamtzahl verfgbarer Pltze: ', zwstr1);
      show_count(lcid_out, zwstr1, gesamt_platz_zahl);

      gesamt_abbestellt_anz:=(abbestellt_anz + abbestellt_wochen_anz * sd.uns_courts_anz * 2) DIV 2;
      schreib_hr(lcid_out);
      Assign('Gesamtzahl abbestellter Pltze: ', zwstr1);
      show_count(lcid_out, zwstr1, gesamt_abbestellt_anz);

      IF gesamt_abbestellt_anz>=sd.uns_courts_anz THEN
        Assign('Davon komplett abbestellte Wochen (zu je ', zwstr1);
        IntToStr(sd.uns_courts_anz, zwstr2);
        Append(zwstr2, zwstr1);
        IF sd.uns_courts_anz=1 THEN
          Append(' Platz pro Woche): ', zwstr1);
        ELSE                    (* IF sd.uns_courts_anz... *)
          Append(' Pltzen pro Woche): ', zwstr1);
        END;                    (* ELSE sd.uns_courts_anz... *)
        show_count(lcid_out, zwstr1, abbestellt_wochen_anz);
      END;                      (* IF gesamt_abbestellt_anz>0 *)

      gesamt_nicht_abbestellt_anz:=gesamt_platz_zahl - gesamt_abbestellt_anz;
      schreib_hr(lcid_out);
      Assign('Damit Gesamtzahl NICHT abbestellter Pltze: ', zwstr1);
      show_count(lcid_out, zwstr1, gesamt_nicht_abbestellt_anz);

      Assign('Davon komplett freie Pltze: ', zwstr1);
      show_count(lcid_out, zwstr1, verschenkt_anz);

      gesamt_benuetzt_anz:=gesamt_nicht_abbestellt_anz - verschenkt_anz;
      Assign('Verbleiben teil- bzw. vollbesetzte Pltze: ', zwstr1);
      show_count(lcid_out, zwstr1, gesamt_benuetzt_anz);

      Assign('Damit betrgt die reine Platzauslastung: ', zwstr1);
      IF gesamt_platz_zahl>0 THEN
        CardToStr(TRUNC((FLOAT(100 * gesamt_benuetzt_anz)) / FLOAT(gesamt_platz_zahl)), zwstr2);
      ELSE                      (* gesamt_platz_zahl>0 *)
        Assign('??', zwstr2);
      END;
      Append(zwstr2, zwstr1);
      Append('% (= ', zwstr1);
      CardToStr(gesamt_benuetzt_anz, zwstr2);
      Append(zwstr2, zwstr1);
      Append(' von ', zwstr1);
      CardToStr(gesamt_platz_zahl, zwstr2);
      Append(zwstr2, zwstr1);
      Append(' Pltzen)', zwstr1);
      schreib_heading_align(lcid_out, zwstr1, 'H3', 'LEFT');

      schreib_hr(lcid_out);
      Assign('Gesamtzahl der Eintragungen: ', zwstr1);
      show_count(lcid_out, zwstr1, spieler_wie_oft_gesamt);

      Assign('Davon Gasteintragungen: ', zwstr1);
      show_count(lcid_out, zwstr1, gesamt_gast_anz);

      Assign('Damit betrgt die reine Spielauslastung: ', zwstr1);
      IF gesamt_platz_zahl>0 THEN
        CardToStr(TRUNC((FLOAT(100 * spieler_wie_oft_gesamt)) / FLOAT(gesamt_platz_zahl * 2)), zwstr2);
      ELSE                      (* gesamt_platz_zahl>0 *)
        Assign('??', zwstr2);
      END;
      Append(zwstr2, zwstr1);
      Append('% (= ', zwstr1);
      CardToStr(spieler_wie_oft_gesamt, zwstr2);
      Append(zwstr2, zwstr1);
      Append(' von ', zwstr1);
      CardToStr(gesamt_platz_zahl * 2, zwstr2);
      Append(zwstr2, zwstr1);
      Append(' mglichen Spielen)', zwstr1);
      schreib_heading_align(lcid_out, zwstr1, 'H3', 'LEFT');

      schreib_hr(lcid_out);
      Assign('Spielhufigkeit der einzelnen Spieler: Ggf. nach Charakterisierung des Spielers', zwstr1);
      schreib_heading_align(lcid_out, zwstr1, 'H3', 'LEFT');

      Assign('("Dauergast" / wchentlich / 14-ttig) und persnlichen Daten (in "" eingeschlossen)', zwstr1);
      schreib_heading_align(lcid_out, zwstr1, 'H3', 'LEFT');

      Assign('erscheinen fnf Zahlenangaben: die ersten beiden durch Komma getrennten Zahlen', zwstr1);
      schreib_heading_align(lcid_out, zwstr1, 'H3', 'LEFT');

      Assign('geben an, wie oft der Spieler bisher bzw. in der gesamten Saison eingetragen ist.', zwstr1);
      schreib_heading_align(lcid_out, zwstr1, 'H3', 'LEFT');

      Assign('Nach dem Schrgstrich stehen zwei durch Komma getrennte Zahlen fr die Zahl seiner', zwstr1);
      schreib_heading_align(lcid_out, zwstr1, 'H3', 'LEFT');

      Assign('"Gastspiele" bisher bzw. in der gesamten Saison.', zwstr1);
      schreib_heading_align(lcid_out, zwstr1, 'H3', 'LEFT');

      Assign('Die Prozentangabe in Klammer gibt die "Planerfllung"', zwstr1);
      schreib_heading_align(lcid_out, zwstr1, 'H3', 'LEFT');

      Assign('der eigenen Spiele an: Anzahl Eintragungen (bisher) bezogen auf die "Sollspielzeit".', zwstr1);
      schreib_heading_align(lcid_out, zwstr1, 'H3', 'LEFT');

      Assign('Fr wchentliche Spieler gilt: "Sollspielzeit" = bisherige Dauer der Saison in Wochen,', zwstr1);
      schreib_heading_align(lcid_out, zwstr1, 'H3', 'LEFT');

      Assign('Fr 14-tgige Spieler gilt: "Sollspielzeit" = (bisherige Dauer der Saison in Wochen) / 2.', zwstr1);
      schreib_heading_align(lcid_out, zwstr1, 'H3', 'LEFT');

      Assign('Dauergste haben keine "Sollspielzeit", d.h. sie bekommen auch keine Prozentangabe.', zwstr1);
      schreib_heading_align(lcid_out, zwstr1, 'H3', 'LEFT');

      Assign('Hinweis: fr die Chefs werden ggf. nur die "Gastspiele" angegeben, also:', zwstr1);
      schreib_heading_align(lcid_out, zwstr1, 'H3', 'LEFT');

      schreib_hr(lcid_out);
      (*
      Wir wollen die Spieler in alphabeticher Reihenfolge ausgeben.
      Dazu machen wir wieder so Tricks wie in schreib_reihe_select_spieler.
      *)

      hwi:=0;

      NEW(sel_rec_typ_ptr);
      lcl_ptr:=sel_rec_typ_ptr;
      lcl_ptr^.sel_rec_typ_ptr:=NIL;
      copy_von_bis(sd, lcl_ptr, ssa, sd.spieler_anz+ssa-1, hwi);
      copy_von_bis(sd, lcl_ptr, i_chef, i_chefin, hwi);

      sortiere_selection(sel_rec_typ_ptr, 0, hwi-1);

      lcl_ptr:=sel_rec_typ_ptr;
      WHILE lcl_ptr^.sel_rec_typ_ptr<>NIL DO
        i:=lcl_ptr^.zahl;

        IF (sd.spieler_art[i] = sp_art_14t) THEN
          soll_wochen_anz:=(FLOAT(soll_wochen_anzi)) / 2.0;
        ELSE                    (* IF (sd.spieler_art[i]... *)
          soll_wochen_anz:=FLOAT(soll_wochen_anzi);
        END;                    (* ELSE (sd.spieler_art[i]... *)

        Assign(lcl_ptr^.schnur, zwstr1);
        Append(', ', zwstr1);

        (*
        Wir zerlegen die persnlichen Daten in E-Mail-Adresse und Rest
        und schreiben hier aber nur den Rest her. Die E-Mail-Adresse
        betrachten wir vorerst mal als heilig und verbergen sie vor der Welt
        *)
        split_pers_data(sd.spieler_pers_data[i], zwstr2, zwstr3);
        Append('"', zwstr1);
        Append(zwstr3, zwstr1);
        Append('"', zwstr1);

        IF ((i=i_chef) OR (i=i_chefin)) THEN
          Append(': --, -- (--%) ', zwstr1);
        ELSE                    (* IF ((i=i_chef)... *)
          Append(': ', zwstr1);
          CardToStr(spieler_wie_oft[i], zwstr2);
          Append(zwstr2, zwstr1);
          Append(', ', zwstr1);
          CardToStr(spieler_wie_oft_saison[i], zwstr2);
          Append(zwstr2, zwstr1);

          Append(' (', zwstr1);
          (*
          Wir zeigen hier leicht paranoides Verhalten. soll_wochen_anz
          darf natrlich nicht 0 sein, wenn es im Nenner auftaucht. Nach
          menschlichem Ermessen sollten wir diese Stelle hier auch gar
          nicht erreichen, falls soll_wochen_anz=0 ist. Weil nmlich:
          wenn es noch keine Vergangenheit gibt (das ist eben dann der
          Fall, wenn soll_wochen_anz=0 ist), dann kann auch noch kein
          Spieler eingetragen sein. Weiter oben wird irgendwo eine
          Abfrage gemacht, ob spieler_wie_oft_gesamt<>0 ist und das ist
          natrlich genau dann auch der Fall, wenn eben soll_wochen_anz=0
          ist. Dennoch fangen wir den Fall hier nochmal ab und geben dann
          halt anstatt der Prozentzahl ein paar dmliche Fragezeichen aus
          oder was. BTW wir fragen nicht soll_wochen_anz, sondern
          soll_wochen_anzi ab. INTEGERs sind geiler fr's Vergleichen.
          30.10.2004: Auch der Dauergast bekommt die Fragezeichen
          *)
          IF ((soll_wochen_anzi=0) OR (sd.max_day_delta[i]<>0)) THEN
            Assign('??', zwstr2);
          ELSE                  (* IF soll_wochen_anz=0 *)
            CardToStr(TRUNC((FLOAT(100*spieler_wie_oft[i])) / soll_wochen_anz), zwstr2);
          END;                  (* ELSE soll_wochen_anz... *)
          Append(zwstr2, zwstr1);
          Append('%)', zwstr1);
        END;                    (* ELSE ((i=i_chef)... *)

        Append(' / ', zwstr1);
        CardToStr(spieler_wie_oft_gast[i], zwstr2);
        Append(zwstr2, zwstr1);
        Append(', ', zwstr1);
        CardToStr(spieler_wie_oft_gast_saison[i], zwstr2);
        Append(zwstr2, zwstr1);

        schreib_heading_align(lcid_out, zwstr1, 'H3', 'LEFT');

        lcl_ptr:=lcl_ptr^.sel_rec_typ_ptr;
      END;                      (* WHILE lcl_ptr<>NIL *)

      dispose_selection(sel_rec_typ_ptr);

      IF gesamt_gast_anz<>0 THEN
        schreib_hr(lcid_out);
        Assign('Die Gasteintragungen  verteilen sich im Einzelnen auf: ', zwstr1);
        schreib_heading_align(lcid_out, zwstr1, 'H3', 'LEFT');

        Assign('"Dauergste": ', zwstr1);
        show_count(lcid_out, zwstr1, dauergast_anz);

        Assign('private Gste von "Dauergsten": ', zwstr1);
        show_count(lcid_out, zwstr1, gast_von_dauergast_anz);

        Assign('private Gste von normalen Spielern: ', zwstr1);
        show_count(lcid_out, zwstr1, priv_gast_anz);

        Assign('offizielle Gste der Chefs: ', zwstr1);
        show_count(lcid_out, zwstr1, offiz_gast_anz);

      END;                      (* IF gesamt_gast_anz<>0 *)

      schreib_hr(lcid_out);
      schreib_page4_table1(lcid_out, sd, '', 'Zurck zum Spielbelegungsplan', dunkelgruen, p4ac1);
      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page29 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page29;


PROCEDURE schreib_page30(VAR sd: sd_rec_typ);
  (*
  Dies ist die Seite zum (Wieder-)Einstieg in den Wartungsmodus.
  Kriegt man dann, wenn grad der Wartungsmodus luft, d.h. sea_state
  ungleich sea_state0 ist aber kein Chef-Kennwort erkannt wurde.
  *)

  PROCEDURE schreib_auf_kanal(lcid_out: ChanId);
    BEGIN                       (* PROCEDURE schreib_auf_kanal *)
      schreib_page_header(lcid_out, 0);
      schreib_page_table0(lcid_out, sd, nullac, FALSE, '30');

      schreib_form_start(lcid_out);
      schreib_heading(lcid_out, 'Ein Wartungszyklus ist im Gange! Entweder spter nochmal probieren', 'H3');
      schreib_table_start(lcid_out, 'oder das Chef-Kennwort eingeben, um die Wartung fortzufhren', 'H3');
      schreib_reihe_passwd(lcid_out, 'CENTER', 'Chef-Kennwort:', input[ii05].name_strr, '');
      schreib_reihe_ok(lcid_out, sd, 'OK', p30ac1);
      schreib_table_end(lcid_out);
      schreib_form_end(lcid_out);

      schreib_page_trailer(lcid_out);
    END schreib_auf_kanal;

  BEGIN                         (* PROCEDURE schreib_page30 *)
    IF hlog_ist_offen THEN schreib_auf_kanal(cid_log) END;
    schreib_auf_kanal(cid_out);
  END schreib_page30;


PROCEDURE try_get_season_data(season_name: ARRAY OF CHAR;
                              VAR sd: sd_rec_typ;
                              VAR text: ARRAY OF CHAR): BOOLEAN;
  VAR
    ok:                         BOOLEAN;

  BEGIN                         (* PROCEDURE try_get_season_data *)
    get_season_data(season_name, sd, ok, text);
    IF ok THEN RETURN TRUE ELSE RETURN FALSE END;
  END try_get_season_data;


PROCEDURE try_put_log_data(season_name: ARRAY OF CHAR;
                           VAR sd: sd_rec_typ; VAR ok: BOOLEAN);
  VAR
    hwi:                        INTEGER;
    sel_rec_typ_ptr:            sel_rec_typ_ptr_typ;
    lcl_ptr:                    sel_rec_typ_ptr_typ;
    i:                          INTEGER;
    geloescht:                  BOOLEAN;
    season_name_log_base:       String;
    season_name_log:            String;
    season_name_log_new:        String;
    basename:                   String;
    cid:                        ChanId;
    res:                        OpenResults;
    name_latest:                String_mittel;

  BEGIN                         (* PROCEDURE try_put_log_data *)
    (*
    Nachdem wir ein bichen Logging machen wollen, versuchen wir
    erst mal, ein Log-season-File anzulegen.  Wir mssen uns
    also einen schnen Namen fr das neue Log-season-File ausdenken.
    Natrlich werden wir da ein wenig spicken, wie das beim Anlegen
    von Backupfiles gemacht wurde. Im brigen erlauben wir nur eine
    bestimmte Maximalzahl von Log-season-Files, damit wir keinen
    Engpa auf dem Massenspeicher bekommen. Sollte die maximal erlaubte
    Zahl von Log-season-Files bereits erreicht sein, wird einfach
    ein Default-Log-season-File angelget (oder drber geschrieben).
    Der User kriegt davon nichts mit aber der Administrator sollte
    sptestens dann kapieren, da zu viele Log-season-Files
    existieren.
    nderung am 24.03.2002: bei Erreichen der Maximalzahl von
    Log-season-Files werden wir nicht mehr einfach mit einem
    Default-Log-season-File hantieren, sondern eine Art FIFO fr
    die alten Log-season-Files einrichten: die uralten Files werden
    einfach alle gelscht, bis nur noch die gewnschte Zahl brig-
    bleibt. Dann knnen wir einfach wie gehabt mit der Erzeugung
    eines neuen Files fortfahren.
    Hinweis: dennoch werden wir noch auf das Default-Log-season-File
    zurckgreifen, falls try_open_file_with_new_sfx Probleme hatte.
    *)

    (*
    Im Gegensatz zu frher arbeiten wir hier nun nicht mehr mit
    anzahl_pref_files, weil wir ggf. ja die Namen noch brauchen. Wir
    werden also direkt get_all_pref_nam bemhen.
    *)
    get_all_pref_nam(log_pfad_s, log_prefix, sel_rec_typ_ptr, hwi);
    (*
    show_selection(cid_out, sel_rec_typ_ptr, 'unsorted:');
    *)

    (*
    Als nchste Aktion werden wir die Filenamen erst mal sortieren. Man
    beachte, dass bei Index 0 die '(Auswahl)' steht. Die interessiert
    uns nicht.
    *)
    sortiere_selection(sel_rec_typ_ptr, 1, hwi);
    (*
    show_selection(cid_out, sel_rec_typ_ptr, 'sorted:');
    *)

    (*
    Nun sind alle Files bekannt, deren Name mit log_prefix beginnt. Falls
    das zu viele sind, werden die ltesten unter ihnen gelscht.
    *)
    IF (hwi > (max_log_sea_file_anz - 1)) THEN
      (*
      Die ersten paar Files (genauer hwi-(max_log_sea_file_anz-1) Stck)
      wollen wir also lschen. Nachdem get_all_pref_nam den allerersten
      Eintrag mit '(Auswahl)' vorbelegt hat, mssen wir natrlich beim
      zweiten beginnen. brigens, damit keine Verwirrung auftritt: hwi
      ist echt die Zahl der gefundenen Filenamen, die '(Auswahl)' stnde
      an Platz 0 und zhlt sozusagen nicht. Denn eigentlich ist hwi nmlich
      eher der maximale Index. Aber das kapiert jetzt doch eh keiner...
      Halt optimale Programmierung.
      *)

      lcl_ptr:=sel_rec_typ_ptr;
      FOR i:=1 TO (hwi-(max_log_sea_file_anz-1)) DO
        lcl_ptr:=lcl_ptr^.sel_rec_typ_ptr;
        Assign(log_pfad_s, season_name_log);
        Append('/', season_name_log);
        Append(lcl_ptr^.schnur, season_name_log);
        geloescht:=Unix.Unlink(season_name_log);
      END;                      (* FOR i *)
    END;                        (* IF hwi... *)

    (*
    Dann holen wir uns den jngsten Eintrag. Fr das neu anzulegende Logfile
    gibt es zwei Mglichkeiten. Entweder der 'Basename' ist identisch zum
    'Basename' des letzten Eintrags. In diesem Fall liegen wir offenbar noch
    in der gleichen Sekunde wie beim Anlegen des letzten Logfiles. Oder es ist
    schon mehr Zeit vergangen seit dem Anlegen des letzten Logfiles. Dann ist
    der neue 'Basename' schon 'upgedatet'. In letzterem Fall ist es ganz
    einfach: da hngen wir den Index 0 an den neuen 'Basename' an und wir
    sind fertig. Im ersten Fall ermitteln wir erst den Index des jngsten
    Eintrags und nehmen als neuen Index fr das neue Logfile einfach den um
    1 erhhten Index.
    Hinweis: den unnatrlichen Fall, dass der neue Eintrag zeitlich vor dem
    letzten Eintag liegt betrachten wir hier nicht. Der kann nmlich nur
    auftreten, wenn jemand an der Uhr dreht. Das kann bei Tests mit fest
    vorgegebener Zeit der Fall sein (wenn wir also etwa an zeitagm drehen).
    *)
    get_latest_element(sel_rec_typ_ptr, name_latest);
    (*
    WriteString(cid_out, '<P> ');
    WriteString(cid_out, 'get_latest_element:');
    WriteString(cid_out, ' </P> ');
    WriteString(cid_out, '<P> ');
    WriteString(cid_out, name_latest);
    WriteString(cid_out, ' </P> ');
    *)

    (*
    In jedem Fall ist jetzt wieder Platz da und wir knnen bequem
    beginnen, ein neues Logfile anzulegen:
    *)
    Assign(log_pfad_s, season_name_log_base);
    Append('/', season_name_log_base);
    construct_datetimename(log_prefix, basename);
    Append(basename, season_name_log_base);
    (*
    Damit ist der 'Basename' fr das (neue) Log-season-File bekannt. Als
    nchstes mssen wir einen neuen Suffix fr diesen Namen finden. Wie
    oben dargelegt, mssen wir uns nun zum Finden des neuen Suffix also den
    jngsten Eintrag ansehen. Das erledigt
    try_open_season_log_file_with_new_sfx(). Sollte es aus unerfindlichen
    Gnden dennoch passiert sein, da kein neuer Suffix zu finden war, nehmen
    wir einfach ein Default-Log-season-File her.
    *)

    try_open_season_log_file_with_new_sfx(season_name_log_base,
                                          name_latest,
                                          log_file_sfx_len,
                                          season_name_log_new,
                                          cid, res);

    IF res=opened THEN
      StreamFile.Close(cid);
    END;                        (* IF res=opened *)

    (*
    Wir knnen hier deshalb so schn nacheinander erst testen, ob
    season_name_log_new schon existiert und dann, falls es nicht
    existiert, ein neues Log-season-File erzeugen, weil der
    globale Lock gesetzt ist. Nur deshalb knnen wir sicher
    sein, da zwischen dem Test auf Existenz eines Log-season-Files
    und dem Neuanlegen nicht irgend ein anderer User schon mal
    ein neues Log-season-File angelegt hat.
    Im brigen ist das hier eigentlich nicht so ganz toll. Da wird
    im Rahmen des Tests, ob ein File erzeugt werden kann, erst ein File
    geffnet, (falls es angelegt werden kann, d.h. der Name eben noch
    nicht existiert hat bisher) dann wird es erst mal wieder geschlossen,
    um dann in put_season_data() wieder geffnet zu werden, naja...
    *)

    put_season_data(season_name_log_new, sd, ok);
  END try_put_log_data;


PROCEDURE try_put_season_data(season_name: ARRAY OF CHAR;
                              VAR sd: sd_rec_typ; log_mode: INTEGER): BOOLEAN;
  (*
  log_mode=0: kein Logging
  log_mode=1: evtl. Logging
  *)
  VAR
    ok:                         BOOLEAN;

  BEGIN                         (* PROCEDURE try_put_season_data *)
    (*
    Falls Logging gewnscht ist, wollen wir dies probieren:
    *)
    IF (slog_gewuenscht AND (log_mode=1)) THEN
      try_put_log_data(season_name, sd, ok);
    END;                        (* (slog_gewuenscht... *)

    (*
    Ob das Schreiben eines Log-season-Files o.k. war, ist uns
    hier Wurscht, nur wenn das eigentliche season-File nicht
    geschrieben werden konnte, verlassen wir try_put_season_data
    mit nicht o.k..
    *)

    put_season_data(season_name, sd, ok);
    IF ok THEN RETURN TRUE ELSE RETURN FALSE END;
  END try_put_season_data;


PROCEDURE eintragungslimit_erreicht(belegung_client: INTEGER;
                                    VAR text: ARRAY OF CHAR): BOOLEAN;
  (*
  Hier wird festgelegt bzw. geprft, ob sich der User eintragen darf.
  Wir legen mal fest: in der aktuellen Woche darf sich der normale
  User maximal 2 mal eintragen, was darber hinaus geht, mu die Chefin
  bzw. der Chef machen. In den freigegebenen zuknftigen Wochen ist *eine*
  Eintragung erlaubt. Ob eine Woche zur Eintragung freigegeben ist, wird
  mit jahr_wochen_zugriff festgelegt. Der Courtbelegung jeder einzelnen
  Woche ist ein weiterer Wert zugeordnet. Dieser besagt, wieviele
  Wochen vorher eine Eintragung erfolgen darf. 0 heit etwa, da erst
  in der aktuellen Woche eingetragen werden kann, 2 z.B. da schon 2
  Wochen vorher eine Eintragung erfolgen darf. Um Weihnachten herum
  knnten etwa 3 oder 4 Wochen erlaubt sein. In allen Wochen, die das
  Eintragungslimit nicht erfllen, ist keine Eintragung mglich.
  Als kleine Zusatzbedingung fr die am weitesten in der Zukunft
  gelegene Woche gilt: Eintragung ist erst am Montag ab 9.00 Uhr
  lokaler Zeit erlaubt, vorher geht noch nichts.
  Ergnzung am 10.10.1998: der User soll nicht nur in der aktuellen,
  sondern auch in der knftigen KW ein bichen mehr drfen, falls
  es schon nach Donnerstag 9.00 Uhr ist. Siehe dazu weiter unten.
  *)
  VAR
    i:                          INTEGER;
    (*
    count_oft_selbst zhlt, wie oft der ggf. einzutragende Spieler
    selbst schon in der gewnschten Woche eingetragen ist,
    count_oft_gast zhlt, wie oft der ggf. einzutragende Gast des
    Spielers schon in der gewnschten Woche eingetragen ist,
    *)
    count_oft_selbst:           INTEGER;
    count_oft_gast:             INTEGER;
    (*
    count_14t zhlt, wieviele 14-tgige Spieler in der gewnschten
    Woche schon eingetragen sind:
    *)
    count_14t:                  INTEGER;
    nix_geht:                   BOOLEAN;
    ukwa:                       INTEGER;
    client_ukw:                 INTEGER;
    kw_delta:                   INTEGER;
    max_kw_delta:               INTEGER;
    format:                     ConvResults;
    court_index:                INTEGER;
    court_index_nachbar:        INTEGER;
    belegung_file:              INTEGER;
    belegung_file_gast:         INTEGER;
    zeit:                       CARDINAL;
    structTime:                 DateTime;
    woy:                        CARDINAL;       (* week of year *)
    woy_str:                    String;

  PROCEDURE geht_endlich_was;
    VAR
      i:                        INTEGER;
      count_14t_max:            INTEGER;

    BEGIN                       (* geht_endlich_was *)
      (*
      Falls der User schon mindestens einmal eingetragen ist, und er
      sich selbst nochmal eintragen will, geht momentan sowieso nichts
      mehr. Falls ein privater Gast eingetragen werden soll, geht schon gleich
      berhaupt nichts, da ist nmlich momentan gar nichts drin. Ein privater
      Gast darf hchstens in der aktuellen oder, falls es nach Donnerstag
      9.00 Uhr ist in der kommenden Woche eingetragen werden. Falls aber
      eine Eintragung erfolgen soll, sehen wir nach, ob es sich um einen
      14-tgigen oder einen wchentlichen Spieler handelt. Ein wchentlicher
      Spieler darf nun endlich eine Eintragung machen, beim 14-tgigen
      prfen wir, ob bereits die erlaubte Anzahl 14-tgiger eingetragen ist.
      Falls ja, geht momentan nichts mehr.
      Urspnglich wollten wir es so machen: die ersten count_14t_max
      14-tgigen Spieler, die sich in der ersten Woche eingetragen
      haben, drfen sich in der zweiten nicht mehr eintragen. Ent-
      sprechend drfen sich die 14-tgigen Spieler der zweiten Woche
      nicht in der dritten eintragen usf.. Weil wir aber z.B. in der
      aktuellen Woche auch fr die 14-tgigen Spieler 2 Eintragungen
      erlauben und die Chefin bzw. der Chef sowieso machen knnen, was
      sie wollen, geht das so nicht. Nun prfen wir einfach nur auf
      count_14t_max ab, auch wenn sich dabei einer schon wieder eintrgt,
      obwohl er schon unmittelbar in der Woche vorher dran war. Das mu
      dann eben die Chefin bzw. der Chef wieder richten oder man mu mit
      dem Betreffenden ein ernstes Wrtchen reden...
      *)
      IF (((input[ii09].value=0) AND (count_oft_selbst>=1)) OR
          ((input[ii09].value=1) AND (count_oft_gast>=0))) THEN
        nix_geht:=TRUE;
        (*
        Die folgenden paar Zeilen dienen einzig und allein dazu, eine
        schne Fehlermeldung zu generieren, sonst nichts.
        *)
        IF (input[ii09].value=0) THEN
          Assign('Momentan nur 1 Spielereintrag in KW ', text);
        ELSE                    (* IF (input[ii09].value=0) *)
          Assign('Momentan noch kein privater Gasteintrag in KW ', text);
        END;                    (* ELSE  (input[ii09].value=0) *)
        Append(woy_str, text);
        Append(' mglich, ggf. die Chefs fragen!', text);
      ELSE                      (* IF (((input[ii09].value=0)... *)
        IF (sd1.spieler_art[belegung_client] = sp_art_14t) THEN
          (*
          Erst mal sehen, wieviele 14-tgige Spieler wir berhaupt haben.
          Pro Woche darf sich dann genau die Hlfte eintragen.
          brigens zhlen hier nur aktive Spieler!
          nderung am 26.10.2005: einen zustzlichen 14-tgigen Spieler
          draufaddieren, damit's bei ungerader Gesamtzahl auch noch
          ohne die Chefs geht.
          *)
          count_14t_max:=0;
          WITH sd1 DO
            FOR i:=ssa TO spieler_anz+ssa-1 DO
              IF ((spieler_art[i]=sp_art_14t) AND
                  (spieler_aktiv[i]=sp_aktiv_ja)) THEN
                count_14t_max:=count_14t_max+1;
              END;                  (* IF (spieler_art[i] = sp_art_14t) *)
            END;                    (* FOR i *)
          END;                      (* WITH sd1 *)
          count_14t_max:=(count_14t_max+1) DIV 2;

          IF count_14t>=count_14t_max THEN
            nix_geht:=TRUE;
            Assign('Kein 14-tgiger Spieler in KW ', text);
            Append(woy_str, text);
            Append(' mehr mglich, ggf. die Chefs fragen!', text);
          ELSE
            (* nichts *);
          END;
        ELSE                    (* IF (sd1.spieler_art[belegung_client]... *)
          (* nichts *);
        END;                    (* ELSE (sd1.spieler_art[belegung_client]... *)
      END;                      (* ELSE (((input[ii09].value=0)... *)
    END geht_endlich_was;

  BEGIN                         (* PROCEDURE eintragungslimit_erreicht *)
    (*
    Schon mal die woy als String darstellen; wird weiter unten
    mindestens 2 mal gebraucht:
    *)
    LUWNToZeitKwStructTime(input[ii01].value, zeit, woy, structTime);
    IntToStr(woy, woy_str);

    (*
    Dieser Default-Text sollte nie zu sehen sein:
    *)
    Assign('Nicht erwarteter Fehler, ggf. dem Programmierer drohen!', text);

    (*
    Voreinstellung ist, _da eine_ Eintragung stattfinden darf:
    *)
    nix_geht:=FALSE;

    (*
    ukwa ist die akutelle Unix-Woche:
    *)
    StrToInt(ukwa_str, ukwa, format);

    (*
    client_ukw ist die Unix-Woche, auf die der User zugreifen mchte:
    *)
    client_ukw:=input[ii01].value;

    (*
    kw_delta ist die Wochendifferenz zwischen der gewnschten Woche, also
    der KW, auf die der User zugreifen will und der aktuellen Woche.
    *)
    kw_delta:=client_ukw-ukwa;

    (*
    max_kw_delta ist der maximal erlaubte Wert fr kw_delta. Ist kw_delta
    grer als max_kw_delta, darf der User (noch) keine Eintragung
    machen:
    *)
    WITH sd1 DO
      max_kw_delta:=jahr_wochen_zugriff[client_ukw-season_start];
    END;                        (* WITH sd1 *)

    IF ((kw_delta<0) OR
        ((kw_delta=max_kw_delta) AND (vor_9_montag)) OR
        (kw_delta>max_kw_delta)) THEN
      (*
      Also: der User will sich an der Vergangenheit vergreifen oder zu
      weit in die Zukunft greifen. Da geht gar nichts. Der Fall,
      da der User in die Vergangenheit greifen will, sollte hier nicht
      mehr vorkommen, weil er bereits weiter oben abgefangen wurde. Wir
      nehmen den Fall negativer Diffenrenzen hier dennoch mit auf.
      *)
      nix_geht:=TRUE;

      IF (kw_delta<0) THEN
        Assign('Wir wollen doch keine Geschichtsflschung betreiben!', text);
      ELSE                      (* IF (kw_delta<0) *)
        IF (kw_delta=max_kw_delta) THEN
          (*
          Ein Zugriff auf die am weitest entfernte Woche ist erst
          ab Montag, nach 9.00 Uhr Ortszeit mglich. Fr max_kw_delta=0
          z.B. heit das, da auch in der aktuellen Woche erst nach
          9.00 Uhr montags was geht.
          *)
          Assign('Heute vor 9.00 Uhr keine Eintragung in KW ', text);
        ELSE                    (* IF (kw_delta=max_kw_delta) *)
          Assign('Noch keine Eintragung in KW ', text);
        END;                    (* ELSE (kw_delta=max_kw_delta) *)
        Append(woy_str, text);
        Append(' mglich, ggf. die Chefs fragen!', text);
      END;                      (* ELSE (kw_delta<0) *)

    ELSE                        (* IF ((kw_delta>max_kw_delta)... *)
      (*
      Endlich: es soll Zugriff auf die aktuelle oder eine der in naher
      Zunkunft gelegenen Wochen erfolgen. Als erste Aktion stellen wir
      mal fest, wie oft der User und ggf. sein privater Gast schon ein-
      getragen sind und wieviele 14-tgige Spieler schon eingetragen sind.
      Hinweis: natrlich knnten wir uns im Falle eines nicht-14-tgigen
      Spielers die Ermittlung von count_14t sparen. Dann mten wir aber
      eine Abfrage und eine weitere Schleife einbauen. Dazu haben wir
      keine Lust:
      Heute (26.05.2009) ndert sich: es gibt einen neuen Laschheitsmodus.
      Falls semilasch angesagt ist, darf jetzt eine Eintragung erfolgen.
      Im anderen Fall, gibt es die angedrohten Prfungen.
      *)

      (*
      Nachsehen, ob bitleiste (bit2) semilasche Eintragung erlaubt.
      Falls ja, wird hier nicht weiter geprft:
      *)
      IF ODD((sd1.bitleiste DIV 4)) THEN
        (* nichts *)
      ELSE                      (* IF ODD((sd1.bitleiste DIV 4)) *)
        count_oft_selbst:=0;
        count_oft_gast:=0;
        count_14t:=0;
        WITH sd1 DO
          FOR i:=0 TO 2*uns_courts_anz-1 DO
            belegung_file:=jahr_court_belegung[client_ukw-season_start,
                                               geschrumpfter_index[i]];
            belegung_file_gast:=jahr_court_belegung_gast[client_ukw-season_start,
                                               geschrumpfter_index[i]];

            IF (belegung_file = belegung_client) THEN
              (*
              Ein privater Gast ist eingetragen, falls belegung_file_gast=1
              gilt, sonst ist es der Spieler selbst.
              *)
              IF (belegung_file_gast=1) THEN
                count_oft_gast:=count_oft_gast+1;
              ELSE              (* IF (belegung_file_gast=1) *)
                count_oft_selbst:=count_oft_selbst+1;
              END;              (* ELSE (belegung_file_gast=1) *)
            END;                (* IF (belegung_file = belegung_client) *)

            IF (spieler_art[belegung_file] = sp_art_14t) THEN
              count_14t:=count_14t+1;
            END;                (* IF (spieler_art[belegung_file]... *)
          END;                  (* FOR i *)
        END;                    (* WITH sd1 *)

        (*
        Nun unterscheiden wir, ob auf die aktuelle oder eine andere Woche
        zugegriffen wird. In der aktuellen darf der User ein bichen mehr
        als sonst. In der aktuellen Woche sind wir auch mit den 14-tgigen
        Spielern sehr grozgig. Normalerweise darf nur die Hlfte
        aller 14-tgigen Spieler spielen aber in der aktuellen Woche
        wollen wir diese Einschrnkung aufheben. Falls also der
        aktuelle Spieler nicht schon 2 mal eingetragen ist, erlauben
        wir in jedem Fall (noch) einen weiteren Eintrag, egal ob es
        sich um einen 14-tgigen oder einen wchentlichen Spieler
        handelt. Unserem Squash-Oberchef hat es nicht gefallen, da
        sich ein und derselbe Spieler im gleichen Court 2 mal eintragen
        kann. Natrlich macht es keinen Sinn, da sich einer 2 mal in
        einen Court eintrgt. Aber spter wollen wir auch das mit den
        Gsten irgendwie handhaben. Ein privater Gast wird dabei eindeutig
        einem bestimmten Spieler zugeordnet sein. Dann wird der betreffende
        Spieler 2 mal im Court stehen aber einmal mit einem Flag fr den
        privaten Gast versehen sein. Vielleicht aber wird auch nur die Sekri
        private Gste eintragen drfen. Na ja, jedenfalls werden wir im
        Moment eine direkte Doppeleintragung in *einem* Court unterbinden.
        Wie wir dann weiterverfahren, mu sich noch zeigen.
        Ergnzung am 10.10.1998: der User soll nicht nur in der aktuellen,
        sondern auch in der knftigen KW ein bichen mehr drfen, falls
        es schon nach Donnerstag 9.00 Uhr ist. Dazu werden wir u.a. einfach
        die alte Abfrage 'IF (kw_delta=0)' ein bichen aufbohren.
        *)
        IF ((kw_delta=0) OR ((kw_delta=1) AND (NOT vor_9_donnerstag))) THEN
          IF (((input[ii09].value=0) AND (count_oft_selbst>=2)) OR
              ((input[ii09].value=1) AND (count_oft_gast>=1))) THEN
            nix_geht:=TRUE;
            (*
            Die folgenden paar Zeilen dienen einzig und allein dazu, eine
            schne Fehlermeldung zu generieren, sonst nichts.
            *)
            IF (kw_delta=0) THEN
              IF (input[ii09].value=0) THEN
                Assign('In aktueller KW nur 2 Spielereintrge mglich, ggf. die Chefs fragen!', text);
              ELSE              (* IF (input[ii09].value=0) *)
                Assign('In aktueller KW nur 1 privater Gasteintrag mglich, ggf. die Chefs fragen!', text);
              END;              (* ELSE  (input[ii09].value=0) *)
            END;                (* IF (kw_delta=0) *)
            IF (kw_delta=1) THEN
              IF (input[ii09].value=0) THEN
                Assign('In kommender KW nur 2 Spielereintrge mglich, ggf. die Chefs fragen!', text);
              ELSE              (* IF (input[ii09].value=0) *)
                Assign('In kommender KW nur 1 privater Gasteintrag mglich, ggf. die Chefs fragen!', text);
              END;              (* ELSE  (input[ii09].value=0) *)
            END;                (* IF (kw_delta=0) *)
          ELSE                  (* IF (((input[ii09].value=0)... *)
            (*
            Der betreffende Spieler ist also noch nicht 2 mal in der
            aktuellen Woche bzw. falls wir bereits Donnerstag nach 9.00 Uhr
            haben, in der kommenden Woche eingetragen. Ebenso ist auch ein
            potentieller privater Gast noch nicht 1 mal eingetragen. Wir werden
            nun prfen, ob er direkt im aktuell gewnschten Court schon einmal
            drinsitzt. Wenn ja, werden wir ihm, zumindest beim momentanen
            Stand der Diskussion, keine weitere Eintragung in diesem Court
            gewhren. Dazu sehen wir uns erst mal den aktuellen Court-
            index an.
            Hinweis: Fr den privaten Gast ist der folgende Test eigentlich
            berflssig, da er sowieso kein zweites mal eingetragen
            werden kann. Sollte uns aber spter einfallen, da dies
            doch mglich sein soll, dann wird dieser Fall hier bereits
            mit behandelt.
            *)
            court_index:=sd1.geschrumpfter_index[input[ii02].value];
            court_index_nachbar:=calc_court_index_nachbar(court_index);

            (*
            Somit ist also dies der Courtnachbar:
            *)
            WITH sd1 DO
              belegung_file:=jahr_court_belegung[client_ukw-season_start,
                                                 court_index_nachbar];
              belegung_file_gast:=jahr_court_belegung_gast[client_ukw-season_start,
                                                           court_index_nachbar];
            END;                (* WITH sd1 *)

            (*
            Eine Eintragung ist nicht mglich, falls die Eintragung im
            Nachbarcourt identisch mit der gewnschten Eintragung ist,
            d.h. wir knnen uns zu unserem privaten Gast oder der private
            Gast kann sich zu uns eintragen, es ist aber nicht mglich,
            da wir selbst 2 mal drinstehen oder ein privater Gast, der
            zum gleichen Spieler gehrt, 2 mal drinsteht. Letzeres wird
            aber sowieso nicht passieren knnen, weil wir weiter oben
            wahrscheinlich sowieso nur maximal einen privaten Gast pro
            Spieler zulassen werden.
            *)
            IF ((belegung_file = belegung_client) AND
                (belegung_file_gast = input[ii09].value)) THEN
              nix_geht:=TRUE;
              Assign('Allein den ganzen Court blockieren, das geht nicht!', text);
            ELSE                (* IF ((belegung_file... *)
              (* nichts *);
            END;                (* ELSE ((belegung_file... *)
          END;                  (* ELSE (((input[ii09].value=0)... *)
        ELSE                    (* IF ((kw_delta=0)... *)
          geht_endlich_was;
        END;                    (* ELSE ((kw_delta=0)... *)
      END;                      (* ELSE ODD((sd1.bitleiste DIV 4)) *)
    END;                        (* ELSE ((kw_delta>max_kw_delta)... *)

    RETURN nix_geht;
  END eintragungslimit_erreicht;


PROCEDURE forderung_moeglich(VAR text: ARRAY OF CHAR): BOOLEAN;
  VAR
    geht_in_ordnung:            BOOLEAN;
    court_index:                INTEGER;
    court_index_nachbar:        INTEGER;
    court_index_oben:           INTEGER;
    woche:                      INTEGER;
    belegung_client:            INTEGER;
    belegung_file:              INTEGER;
    belegung_file_nachbar:      INTEGER;
    belegung_oben:              INTEGER;
    rang_nachbar:               INTEGER;
    rang_client:                INTEGER;
    rang_oben:                  INTEGER;
    min_rang, max_rang:         INTEGER;
    min_rang_erlaubt:           INTEGER;
    pyramiden_hoehe:            INTEGER;

  BEGIN                         (* PROCEDURE forderung_moeglich *)
    (*
    Hier geht es darum, zu prfen, falls im Nachbarcourt schon
    jemand drin sitzt und die aktuelle Eintragung ein Forderungsspiel
    verlangt, ob diese Forderung vertrglich mit der aktuellen
    Rangliste ist.
    *)
    court_index:=sd1.geschrumpfter_index[input[ii02].value];
    woche:=input[ii01].value-sd1.season_start;
    belegung_client:=input[ii03].value;
    belegung_file:=sd1.jahr_court_belegung[woche, court_index];
    court_index_nachbar:=calc_court_index_nachbar(court_index);
    belegung_file_nachbar:=sd1.jahr_court_belegung[woche, court_index_nachbar];

    Assign('', text);
    geht_in_ordnung:=TRUE;
    (*
    Nur falls also ein Nachbar da sein sollte und ein Forderungs-
    spiel gewnscht ist, machen wir eine genauere Prfung:
    *)
    IF belegung_file_nachbar<>i_frei THEN
      IF input[ii19].value<>0 THEN
        (* Rang von Nachbar und Client ermitteln: *)
        rang_nachbar:=sd1.spieler_rang[belegung_file_nachbar];
        rang_client:=sd1.spieler_rang[belegung_client];

        (*
        Nur wenn beide einen von 0 verschiedenen Rang haben,
        also in der Rangliste gefhrt werden, kann gefordert werden:
        *)
        IF (rang_nachbar=0) OR (rang_client=0) THEN
          Assign('Forderung nur zwischen Spielern in der Rangliste mglich!', text);
          geht_in_ordnung:=FALSE;
        ELSE                    (* IF (rang_nachbar=0)... *)
          (* Rnge nach Gre sortieren: *)
          IF rang_nachbar<=rang_client THEN
            min_rang:=rang_nachbar;
            max_rang:=rang_client;
          ELSE                  (* IF rang_nachbar<=rang_client *)
            min_rang:=rang_client;
            max_rang:=rang_nachbar;
          END;                  (* ELSE rang_nachbar<=rang_client *)

          (* in welchem Stockwerk sitzt der Forderer? *)
          pyramiden_hoehe:=hoehe_pascalsches_dreieck(max_rang);

          (*
          Jetzt bestimmen wir den kleinsten erlaubten Rang min_rang_erlaubt,
          den der Spieler, der max_rang hat, noch fordern darf. Dazu mssen
          wir den Spezialfall max_rang=3 beachten. Normalerweise darf bis
          zu max_rang-(pyramiden_hoehe-1) gefordert werden, nur von Platz 3
          aus (wo also pyramiden_hoehe-1 = 1 ist und also hchstens Platz 2
          gefordert werden drfte) darf auch der Platz 1 gefordert werden.
          *)
          IF max_rang=3 THEN
            min_rang_erlaubt:=1;
          ELSE                  (* IF max_rang=3 *)
            min_rang_erlaubt:=max_rang-(pyramiden_hoehe-1);
          END;                  (* ELSE max_rang=3 *)

          (*
          Endlich knnen wir testen: falls min_rang gleich max_rang
          sein sollte (der Depp will sich also selber fordern!), oder
          min_rang kleiner min_rang_erlaubt ist, geht nichts.
          *)
          IF min_rang=max_rang THEN
            Assign('Sich selber fordern macht wohl keinen groen Sinn!', text);
            geht_in_ordnung:=FALSE;
          ELSE                  (* IF min_rang=max_rang *)
            IF min_rang<min_rang_erlaubt THEN
              Assign('Forderung gem aktueller Rangliste nicht mglich!', text);
              geht_in_ordnung:=FALSE;
            ELSE                (* IF (min_rang<min_rang_erlaubt *)
              court_index_oben:=2 * (court_index DIV 2);
              belegung_oben:=sd1.jahr_court_belegung[woche, court_index_oben];
              rang_oben:=sd1.spieler_rang[belegung_oben];

              IF rang_oben=max_rang THEN
                (* der obere Spieler hat hheren Rang, fordert also *)
                sd1.jahr_forderung[woche, court_index DIV 2]:=2;
              ELSE              (* IF rang_oben=max_rang *)
                (* der untere Spieler hat hheren Rang, fordert also *)
                sd1.jahr_forderung[woche, court_index DIV 2]:=3;
              END;              (* ELSE rang_oben=max_rang *)
            END;                (* ELSE (min_rang<min_rang_erlaubt *)
          END;                  (* ELSE min_rang=max_rang *)
        END;                    (* ELSE (rang_nachbar=0)... *)
      END;                      (* IF input[ii19].value<>0 *)
    ELSE                        (* IF belegung_file_nachbar<>i_frei *)
      IF input[ii19].value<>0 THEN
        sd1.jahr_forderung[woche, court_index DIV 2]:=1;
      END;                      (* IF input[ii19].value<>0 *)
    END;                        (* ELSE belegung_file_nachbar<>i_frei *)

    RETURN geht_in_ordnung;
  END forderung_moeglich;


PROCEDURE ist_kennwort_ok(index: INTEGER): BOOLEAN;
  VAR
    zwstr1, zwstr2:             String;
    str_ptr:                    StrPtrTyp;
    ergebnis:                   BOOLEAN;

  BEGIN                         (* PROCEDURE ist_kennwort_ok *)
    (*
    zwstr1 ist das aus dem season-File gelesene Kennwort. Dies ist
    also bereits verschlsselt.
    *)
    zwstr1:=sd1.spieler_kennwort[index]; 
    (*
    zwstr2 ist das, was uns der Client als Kennwort anbietet. Dies
    mssen wir noch verschlsseln.
    *)
    GetGPMString(zwstr2, ii05);
    str_ptr:=Unix.Crypt(zwstr2, '00');
    zwstr2:=str_ptr^;
    ergebnis:=(CompareRS(zwstr1, zwstr2)=equal);
    (*
    Falls das Kennwort o.k. ist, wollen wir uns die IP-Adresse
    des Clients sofort aufschreiben.
    *)
    IF ergebnis THEN
      Assign(remote_addr, sd1.spieler_remote_addr[index]);
    END;                        (* IF ergebnis *)

    RETURN ergebnis;
  END ist_kennwort_ok;


PROCEDURE user_time(VAR sd: sd_rec_typ; ukw, court_index: INTEGER): CARDINAL;
  VAR
    wt_index:                   INTEGER;
    uz_index:                   INTEGER;
    hwc:                        CARDINAL;
    zeit:                       CARDINAL;

  BEGIN                         (* PROCEDURE user_time *)
    uz_index:=(court_index MOD (2*sd.spalt_anz)) DIV 2;
    wt_index:=court_index DIV (2*sd.spalt_anz);

    hwc:=ukw;
    UWNToTime(hwc, zeit);
    hwc:=sd.wochentag[wt_index];
    zeit:=zeit+s_pro_tag*hwc;
    (*
    user_time soll das Ende des Spiels bedeuten, daher mssen wir eine
    Stunde (oder 6 mal zehnmin) addieren, denn sd.uhrzeit[uz_index]
    bedeutet den Beginn des Spiels. Neuerdings (ab 05.09.2001) haben wir
    die Granularit verfeinert: sd.uhrzeit gibt nicht mehr den Anfang
    einer vollen Stunde an, sondern den Anfang von 10 Minuten.
    *)
    hwc:=sd.uhrzeit[uz_index]+6;
    zeit:=zeit+s_pro_zehnmin*hwc;

    RETURN zeit;
  END user_time;


PROCEDURE backup_einspielen(action: INTEGER);
  VAR
    hwi:                        INTEGER;
    sel_rec_typ_ptr:            sel_rec_typ_ptr_typ;
    bkp_index:                  INTEGER;
    found:                      BOOLEAN;
    season_name_bkp_loc:        String;
    season_name_bkp:            String;
    ok:                         BOOLEAN;
    text1, text2:               String;

  BEGIN                         (* PROCEDURE backup_einspielen *)
    (*
    Der OK-Button auf page21/22 wurde gedrckt. Es soll also ein altes
    Backup eingespielt werden. Falls das Kennwort nicht
    OK ist, gibt's eine ordentliche Fehlermeldung. Im anderen Fall 
    wird eingelesen.
    Man beachte, da im Erfolgsfalle schreib_page_accept mit p4ac1
    aufgerufen wird, da wir uns von nun an in jedem Fall wieder im
    Usermodus befinden (weil (garantiert) ein season-File da ist).
    *)
    IF ist_kennwort_ok(i_chef) THEN
      (*
      Bevor wir nun versuchen, das Backupfile einzulesen, machen wir
      fr die input's einen Reset. Ist vielleicht ein bichen ber
      das Ziel hinausgeschossen, aber wir htten sonst evtl. Probleme
      mit hidden values der accept page, die dann spter irgendwie
      out of range sein knnten. Vorher aber schnell noch den Index
      fr das Backupfile bernehmen.
      *)
      bkp_index:=input[ii17].value;
      IF bkp_index=0 THEN
        schreib_page_accept(sd1,
                            'Es wurde keine gltige Auswahl getroffen!',
                            'Nochmal', dunkelrot, action);
      ELSE                      (* IF bkp_index=0 *)
        init_default_inputs1;
        (*
        Vom User bekommen/bernehmen wir nur eine Zahl und nicht
        einen Filenamen. Wir mssen also nochmal get_all_pref_nam
        aufrufen, um an den Filenamen heranzukommen. Setzt natrlich
        voraus, da sich der Chef nicht selbst in die Quere kommt,
        sich also zwischen dem Vorgang hier und dem (bereits erfolgten)
        erstmaligen Lesen fr den Select-Button nichts am Backupdirectory
        gendert hat. Machen wir brigens aus Sicherheitsgrnden.
        Dem Hacker sollte es somit unmglich sein, durch geschickte
        Pfadangaben, irgendeinen Schaden irgendwo im System anzurichten.
        *)
        get_all_pref_nam(bkp_pfad, bkp_prefix, sel_rec_typ_ptr, hwi);

        find_in_selection(sel_rec_typ_ptr, hwi, bkp_index,
                          found, season_name_bkp_loc);
        IF found THEN
          Assign(bkp_pfad, season_name_bkp);
          Append('/', season_name_bkp);
          Append(season_name_bkp_loc, season_name_bkp);

          Assign('Backup "', text2);
          Append(season_name_bkp_loc, text2);

          IF try_get_season_data(season_name_bkp, sd1, text1) THEN
            (*
            Lesen war o.k., also probieren wir das Schreiben.
            Bevor wir aber schreiben, rufen wir auch noch den
            init_default_inputs2 auf und setzen das Chef-Kennwort
            auf den Defaultwert zurck:
            *)
            init_default_inputs2;
            Assign(chef_kennwort_default, sd1.spieler_kennwort[i_chef]);
            IF try_put_season_data(season_name, sd1, 1) THEN
              Append('" wurde erfolgreich eingelesen!', text2);
              Append(text1, text2);
              schreib_page_accept(sd1,
                                  text2, "Weiter geht's", dunkelgruen, p4ac1);
            ELSE                (* IF try_put_season_data... *)
              Append('" konnte nicht zur aktuellen Datenbasis gemacht werden!', text2);
              Append(text1, text2);
              schreib_page_accept(sd1,
                                  text2, 'Groer Mist', dunkelrot, action);
            END;                (* ELSE try_put_season_data... *)
          ELSE                  (* IF try_get_season_data... *)
            Append('" konnte nicht gelesen werden!', text2);
            Append(text1, text2);
            schreib_page_accept(sd1,
                                text2, 'Groer Mist', dunkelrot, action);
          END;                  (* ELSE try_get_season_data... *)
        ELSE                    (* IF found *)
          schreib_page_info(sd1, 'Gib Hackern keine Chance!',
                            'Zu bld :-(', dunkelrot);
        END;                  (* ELSE found *)
      END;                      (* ELSE bkp_index=0 *)
    ELSE                        (* IF ist_kennwort_ok(i_chef) *)
      schreib_page_accept(sd1,
                          'Wir haben doch nicht etwa ein Problem mit dem Chef-Kennwort?',
                          'Groer Mist', dunkelrot, action);
    END;                        (* ELSE ist_kennwort_ok(i_chef) *)
  END backup_einspielen;


PROCEDURE schreib_ggf_email(email_infol: email_info_typ);
  VAR
    fehler:                     INTEGER;
    court_index_nachbar:        INTEGER;
    belegung_file_nachbar:      INTEGER;
    belegung_file_nachbar_gast: INTEGER;
    belegung_file_nachbar_gast_nam:     String_kurz;
    wann_und_wo:                String;
    bei_dir_oder_gast:          String;
    client_name:                String;
    nachbar_name:               String;
    client_mail:                String;
    nachbar_mail:               String;
    bodystr:                    String_lang;
    subjectstr:                 String;
    system_string:              String_lang;
    forderungs_text:            String_kurz;
    zwstr1:                     String_mittel;

  BEGIN                         (* PROCEDURE schreib_ggf_email *)
    (*
    Falls ein Courtnachbar da sein sollte, wollen wir diesen
    ggf. informieren, da sich in seiner Nachbarschaft etwas
    getan hat. Dies kann sowohl eine Ein- als auch eine
    Austragung sein. schreib_ggf_email gibt dabei einfach
    nur den 'text' weiter, der als Parameter bergeben wurde.

    Auerdem wird evtl. der Spieler selbst auch informiert, falls
    die Ein- oder Austragung von Chefseite stattgefunden hat.
    *)
    court_index_nachbar:=calc_court_index_nachbar(email_infol.court_index);

    (*
    Somit ist also dies der Courtnachbar:
    *)
    WITH sd1 DO
      belegung_file_nachbar:=jahr_court_belegung[email_infol.client_ukw-season_start,
                                                 court_index_nachbar];
      belegung_file_nachbar_gast:=jahr_court_belegung_gast[email_infol.client_ukw-season_start,
                                                           court_index_nachbar];
      Assign(jahr_court_belegung_gast_nam[email_infol.client_ukw-season_start, court_index_nachbar],
             belegung_file_nachbar_gast_nam);
    END;                        (* WITH sd1 *)

    (*
    E-Mail-Adresse aus den persnlichen Daten herausfischen. Der Rest interessiert nicht
    *)
    split_pers_data(sd1.spieler_pers_data[email_infol.belegung_client], client_mail, zwstr1);
    split_pers_data(sd1.spieler_pers_data[belegung_file_nachbar], nachbar_mail, zwstr1);

    ermittle_wann_und_wo(sd1, wann_und_wo, email_infol.court_index);

    (*
    Falls das Forderungsflag nicht 0 sein sollte, schreiben wir
    in groen Lettern hin, da es sich um ein Forderungsspiel handelt
    *)
    WITH sd1 DO
      IF jahr_forderung[email_infol.client_ukw-season_start,
                        email_infol.court_index DIV 2]>0 THEN
        Assign(', FORDERUNGSSPIEL!', forderungs_text);
      ELSE                      (* IF jahr_forderung... *)
        Assign('', forderungs_text);
      END;                      (* ELSE jahr_forderung... *)
    END;                        (* WITH sd1 *)

    (*
    Falls ein Courtnachbar da sein sollte, wenn also
    belegung_file_nachbar <> i_frei sein sollte, verschicken wir
    an den Nachbarn eine Mail. Genauer gesagt schicken wir
    nicht unbedingt dem Nachbarn die Mail, sondern nur dessen
    'Gastgeber', d.h., falls der Nachbar lediglich privater Gast von
    irgend jemand ist, schicken wir die Mail nicht dem privaten Gast,
    von dem wir ja sowieso keine E-Mail-Adresse haben, sondern dem
    irgend jemand selber. Auerdem schicken wir die Mail auch
    nur dann, falls Nachbar und Ein-/Austrager nicht ein 'Gastgeber'-
    privater Gast-Verhltnis haben. Falls der nachbarschaftliche
    Gastgeber allerdings einer der Chefs ist (dies ist dann der Fall,
    wenn es sich beim eingetragenen Nachbarn um einen offiziellen
    Gast handelt), schicken wir ebenfalls keine E-Mail.
    Knnten wir uns vielleicht noch mal anders berlegen,
    aber im Moment sind wir zu faul dazu, denn die Chefs knnen
    momentan keine E-Mail haben, weil sie keine Spieler sind
    und also auch nicht im Wartungszyklus auftauchen, wo ggf.
    E-Mail-Adressen eingetragen werden knnten (ansonsten
    wrde das schon prima klappen: den Chefs manuell eine
    E-Mail-Adresse ins season-File schreiben und schon geht's!).
    Im brigen schicken wir auch nur dann eine Mail, falls
    berhaupt eine Adresse angegeben ist. Speziell:
    falls der String fr die Mailadresse 0 lang sein sollte,
    probieren wir's gar nicht erst. Ach ja und das alles nur
    dann, falls berhaupt eine Mail gewnscht ist.
    *)
    IF ((belegung_file_nachbar <> i_frei) AND
        (belegung_file_nachbar <> email_infol.belegung_client) AND
        (Length(nachbar_mail)>0) AND
        (mail_gewuenscht)) THEN
      (*
      Beim Ein- bzw. Austrager unterscheiden wir also die drei
      Gaststatus und erzeugen entsprechende Meldungen:
      *)
      CASE email_infol.belegung_client_gast OF
        | 0:                    (* Spieler selbst *)
            Assign(sd1.spieler_name[email_infol.belegung_client], client_name);

        | 1:                    (* priv. Gast *)
            Assign('privater Gast von ', client_name);
            Append(sd1.spieler_name[email_infol.belegung_client], client_name);

        | 2:                    (* offiz. Gast *)
            Assign('offizieller Gast ', client_name);
            Append(email_infol.belegung_client_gast_nam, client_name);

        | ELSE                  (* sollte nie vorkommen *)
            (* nichts *)
      END;                      (* CASE email_infol.belegung_client_gast *)

      (*
      Auch beim Nachbarn unterscheiden wir die drei
      Gaststatus und erzeugen entsprechende Meldungen,
      wohlwissend, da der Fall 'offizieller Gast' momentan
      nicht bearbeitet wird, weil die Chefs keine E-Mail haben.
      *)
      CASE belegung_file_nachbar_gast OF
        | 0:                    (* Spieler selbst *)
            Assign('dir ', bei_dir_oder_gast);

        | 1:                    (* priv. Gast *)
            Assign('deinem privaten Gast ', bei_dir_oder_gast);

        | 2:                    (* offiz. Gast *)
            Assign('deinem offiziellen Gast ', bei_dir_oder_gast);
            Append(belegung_file_nachbar_gast_nam, bei_dir_oder_gast);
            Append(' ', bei_dir_oder_gast);

        | ELSE                  (* sollte nie vorkommen *)
            (* nichts *)
      END;                      (* CASE belegung_file_nachbar_gast *)

      (*
      heute (05.12.2023) drcken wir das sd1.zusatz_heading auch noch mit rein!
      *)

      Assign('"', bodystr);
      Append(sd1.zusatz_heading, bodystr);
      Append(', ', bodystr);
      Append(wann_und_wo, bodystr);
      Append(': ', bodystr);
      Append(client_name, bodystr);
      Append(' wurde bei ', bodystr);
      Append(bei_dir_oder_gast, bodystr);
      Append(email_infol.text, bodystr);
      Append('getragen', bodystr);
      Append(forderungs_text, bodystr);
      Append('"', bodystr);

      Assign('"Sportinfo" ', subjectstr);

      Assign('echo ', system_string);
      Append(bodystr, system_string);
      Append(' | mail -s ', system_string);
      Append(subjectstr, system_string);
      Append(nachbar_mail, system_string);

      (*
      fehler:=Unix.System(system_string);
      *)
      WriteString(cid_out, system_string);
    END;                        (* IF ((belegung_file_nachbar... *)
  

    (*
    Falls die Chefs walten, der Spieler sich also nicht selber
    ein- oder ausgetragen hat, verschicken wir ggf. an den Spieler
    selbst auch noch eine Nachricht. Er soll ja zumindest einen
    Hinweis bekommen, da die Chefs ber seinen Verbleib entschieden
    haben...
    *)
    IF (email_infol.ob_chefs_walten AND (Length(client_mail)>0) AND
       (mail_gewuenscht)) THEN
      (*
      Beim Ein- bzw. Ausgetragenen unterscheiden wir also wieder
      die drei Gaststatus und erzeugen entsprechende Meldungen,
      wohlwissend, da der Fall 'offizieller Gast' momentan
      nicht bearbeitet wird, weil die Chefs keine E-Mail haben.
      *)
      CASE email_infol.belegung_client_gast OF
        | 0:                    (* Spieler selbst *)
            Assign('dich ', bei_dir_oder_gast);

        | 1:                    (* priv. Gast *)
            Assign('deinen privaten Gast ', bei_dir_oder_gast);

        | 2:                    (* offiz. Gast *)
            (* nichts *)

        | ELSE                  (* sollte nie vorkommen *)
            (* nichts *)
      END;                      (* CASE email_infol.belegung_client_gast *)

      (*
      Auch beim Nachbarn unterscheiden wir die drei
      Gaststatus und erzeugen entsprechende Meldungen.
      *)
      CASE belegung_file_nachbar_gast OF
        | 0:                    (* Spieler selbst *)
            Assign(sd1.spieler_name[belegung_file_nachbar], nachbar_name);

        | 1:                    (* priv. Gast *)
            Assign('privatem Gast von ', nachbar_name);
            Append(sd1.spieler_name[belegung_file_nachbar], nachbar_name);

        | 2:                    (* offiz. Gast *)
            Assign('offiziellem Gast ', nachbar_name);
            Append(belegung_file_nachbar_gast_nam, nachbar_name);

        | ELSE                  (* sollte nie vorkommen *)
            (* nichts *)
      END;                      (* CASE belegung_file_nachbar_gast *)

      Assign('"siehe subject/Betreff"', bodystr);

      Assign('"Sportinfo: ', subjectstr);
      Append(wann_und_wo, subjectstr);
      Append(': ', subjectstr);
      Append(' die Chefs haben ', subjectstr);
      Append(bei_dir_oder_gast, subjectstr);
      IF belegung_file_nachbar<>i_frei THEN
        Append('bei ', subjectstr);
        Append(nachbar_name, subjectstr);
        Append(' ', subjectstr);
      END;                      (* IF belegung_file_nachbar... *)
      Append(email_infol.text, subjectstr);
      Append('getragen', subjectstr);
      Append('" ', subjectstr);

      Assign('echo ', system_string);
      Append(bodystr, system_string);
      Append(' | mail -s ', system_string);
      Append(subjectstr, system_string);
      Append(client_mail, system_string);

      fehler:=Unix.System(system_string);
      (*
      WriteString(cid_out, system_string);
      *)
    END;                        (* IF (email_infol.ob_chefs_walten... *)
  END schreib_ggf_email;

PROCEDURE process_user_post_action;
  VAR
    zwstr0, zwstr1, zwstr2:     String;
    strings_sind_gleich:        BOOLEAN;
    belegung_file:              INTEGER;
    belegung_client:            INTEGER;

  PROCEDURE act_p1ac0;
    BEGIN                       (* PROCEDURE act_p1ac0 *)
      (*
      Es wurde der 'Ich will...'-Button auf page01 gedrckt
      oder wir haben an anderer Stelle das Bedrfnis, page08
      anzuzeigen.
      *)
      schreib_page08(sd1);
    END act_p1ac0;

  PROCEDURE act_p1ac1;
    BEGIN                       (* PROCEDURE act_p1ac1 *)
      (*
      Es wurde einer der KW-Auswahl-Buttons gedrckt. Die
      neue KW haben wir bereits erhalten und auch schon in das
      input[ii01]-Feld eingetragen. Wir mssen also einfach nur noch
      die page01 darstellen.
      *)
      schreib_page01(sd1);
    END act_p1ac1;

  PROCEDURE act_p1ac2;
    VAR
      court_index:              INTEGER;

    BEGIN                       (* PROCEDURE act_p1ac2 *)
      (*
      Einer der Spieler-Buttons in den Courts wurde gedrckt. Jetzt
      werden wir versuchen, den Court umzubelegen. Dies tun wir natrlich
      mit neuen pages. Wir unterscheiden, ob der Court momentan frei ist
      oder bereits ein Spieler drin sitzt. Falls der Court frei ist, fragen
      wir sofort nach dem neuen Spieler. Falls aber schon ein Spieler drin
      sitzt, mu *vor* einer Neubelegung erst der momentane mit Angabe
      eines Kennworts ausgetragen werden.
      Als allerestes berprfen wir, ob ein Zugriff auf die Vergangenheit
      stattfinden soll. Sollte dies der Fall sein, geben wir nur eine
      Fehlermeldung aus. Im anderen Fall wird ggf. eine Umtragung gemacht.
      Dazu berprfen wir, ob der im season-File eingetragene Spieler mit
      dem bereinstimmt, der im Browser des Clients zu sehen ist. Falls der
      nmlich ewig lang herumgetrdelt hat, kann sich die Datenbasis
      inzwischen verndert haben. In diesem Fall geben wir auch nur eine
      Fehlermeldung aus.
      *)
      court_index:=sd1.geschrumpfter_index[input[ii02].value];
      user_time1:=user_time(sd1, input[ii01].value, court_index);
      IF (user_time(sd1, input[ii01].value, court_index) > zeitalc) THEN
        belegung_client:=input[ii03].value;
        belegung_file:=sd1.jahr_court_belegung[input[ii01].value-sd1.season_start,
                                               court_index];

        IF belegung_file=belegung_client THEN
          IF belegung_file=i_frei THEN
            (*
            Court ist frei, also neuen Spieler eintragen:
            *)
            schreib_page02(sd1);
          ELSE                  (* IF belegung_file=i_frei *)
            (*
            Court ist *nicht* frei, also erst frei machen:
            *)
            schreib_page03(sd1);
          END;                  (* ELSE belegung_file=i_frei *)
        ELSE                    (* IF belegung_file=belegung_client *)
          schreib_page_accept(sd1,
                              'Daten waren nicht mehr aktuell, bitte von vorne beginnen!',
                              'Groer Mist', dunkelrot, p4ac1);
        END;                    (* ELSE belegung_file=belegung_client *)
      ELSE                      (* IF (user_time... *)
        schreib_page_accept(sd1,
                            'Wir wollen doch keine Geschichtsflschung betreiben!',
                            'Sehe ich ein', dunkelrot, p4ac1);
      END;                      (* ELSE (user_time... *)
    END act_p1ac2;

  PROCEDURE act_p1ac3;
    BEGIN                       (* PROCEDURE act_p1ac3 *)
      (*
      Jemand will zur Chat-/Newsecke.
      Hier rufen wir die Seite zum Abgeben einer ffentlichen
      Meinung auf.
      *)
      schreib_page19(sd1);
    END act_p1ac3;

  PROCEDURE act_p2ac1;
    VAR
      court_index_nachbar:      INTEGER;
      court_nachbar:            INTEGER;
      court_nachbar_gast:       INTEGER;
      court_index:              INTEGER;
      client_ukw:               INTEGER;
      max_day_delta_loc:        CARDINAL;
      zwstr:                    String_kurz;
      text:                     String;
      ob_eintragen:             BOOLEAN;

    PROCEDURE trag_ein;
      PROCEDURE try_put_season_data_and_prepare_e_mail;
        BEGIN                   (* PROCEDURE try_put_season_data_and_prepare_e_mail *)
          IF try_put_season_data(season_name, sd1, 1) THEN
            schreib_page01(sd1);
            (*
            Notieren, da am Ende ggf. E-Mails zu senden sind:
            *)
            email_info.ob_emails_senden:=TRUE;
            email_info.court_index:=court_index;
            email_info.client_ukw:=client_ukw;
            email_info.belegung_client:=belegung_client;
            email_info.belegung_client_gast:=input[ii09].value;
            GetGPMString(email_info.belegung_client_gast_nam, ii18);
            Assign('EIN-', email_info.text);
          ELSE                  (* IF try_put_season_data... *)
            schreib_page_info(sd1,
                              'Daten konnten nicht aktualisiert werden!',
                              'Spter nochmal probieren, ggf. dem Programmierer drohen!',
                              dunkelrot);
          END;                    (* ELSE try_put_season_data... *)
        END try_put_season_data_and_prepare_e_mail;


      BEGIN                     (* PROCEDURE trag_ein *)
        (*
        In 'alten Zeiten', als es noch keine offiziellen Gste gab, war
        die Sache ganz einfach. Da mute lediglich entschieden werden,
        ob eine Eintragung stattfinden darf oder nicht. Entweder war
        sowieso der Chef oder die Chefin am Sagen oder der normale Spieler
        hatte sich qualifiziert. In jedem Fall wurde dann hier in trag_ein
        einfach die Eintragung durchgefhrt: der Client wurde eingetragen
        und der 'Gaststatus' ebenso.
        Jetzt wird die Sache etwas komplizierter. Natrlich soll auch
        wieder eine Eintragung gemacht werden, aber wir mssen nun
        unterscheiden, ob die Chefs oder die normalen Spieler eintragen
        wollen und in Verbindung damit mssen wir prfen, ob der Spieler
        selber oder einer der mglichen Gste eingetragen werden soll.
        Wie an anderer Stelle schon erwhnt, sind dabei nur gewisse
        Kombinationen erlaubt. Wir werden uns zuerst den Gaststatus ansehen.
        Fr 0 (Spieler selbst) oder 1 (priv. Gast) unterscheiden wir
        dann weiter, _wer_ eingetragen werden soll. Theoretisch kann
        es sich dabei um den (abbestellt), einen der Chefs oder einen
        normalen Spieler handeln.
        Im Gegensatz zu frher werden wir beim (abbestellt) zum einen
        versuchen, gleich den Nachbarn auch mit abzubestellen aber zum
        anderen _keine_ Abbestellung machen und nur eine Warnung ausgeben,
        falls der Nachbar nicht auch (frei) war.
        Sollte versucht werden, einen der Chefs mit Gaststatus 0 oder 1
        einzutragen, gibt's einfach nur eine Fehlermeldung, weil die
        Chefs eben nur einen offiziellen Gast aber nicht sich selber
        oder einen privaten Gast eintragen knnen sollen.
        Normale Spieler werden wie bisher auch ganz normal eingetragen.

        Ist der Gaststatus 2 (offiz. Gast), mu zwingend einer der
        Chefs die Eintragung vornehmen. Jeder normale Spieler wird
        abgewiesen.

        Tatschlich werden wir das Abbestellen unabhngig vom Gaststatus
        aber immer erlauben. Natrlich knnen das nur die Chefs, aber
        zumindest soll der Gaststatus keine Rolle spielen.
        *)

        (*
        Erst mal sehen, wer der Courtnachbar ist.
        *)
        court_index_nachbar:=calc_court_index_nachbar(court_index);
        court_nachbar:=sd1.jahr_court_belegung[client_ukw-sd1.season_start,
                                               court_index_nachbar];

        (*
        Als Voreinstellung lschen wir den 'Forderungsstatus' erst mal.
        Spter wird dann ggf. ein neuer 'Forderungsstatus' bernommen.
        Siehe dazu aber weiter unten. Man beachte dabei, da court_index
        nochmal halbiert wird!
        *)
        sd1.jahr_forderung[client_ukw-sd1.season_start,
                           court_index DIV 2]:=0;

        IF belegung_client=i_abbestellt THEN
          (*
          Abbestellen geht nur, falls auch der Nachbar noch (frei) ist.
          *)
          IF court_nachbar=i_frei THEN
            (*
            Nachbar ist ebenfalls frei, also wird der Court komplett
            abbestellt. Man beachte, da der Gaststatus unbedingt
            auf 0 gesetzt wird, egal was (ChefIn) beantragt hat.
            *)
            sd1.jahr_court_belegung[client_ukw-sd1.season_start,
                                    court_index]:=belegung_client;
            sd1.jahr_court_belegung_gast[client_ukw-sd1.season_start,
                                    court_index]:=0;
            sd1.jahr_court_belegung[client_ukw-sd1.season_start,
                                    court_index_nachbar]:=belegung_client;
            sd1.jahr_court_belegung_gast[client_ukw-sd1.season_start,
                                    court_index_nachbar]:=0;
            try_put_season_data_and_prepare_e_mail;
          ELSE                  (* IF court_nachbar=i_frei *)
            schreib_page_accept(sd1,
                                'Nur ein komplett freier Court kann abbestellt werden!',
                                'Habe verstanden', dunkelrot, p4ac1);
          END;                  (* ELSE court_nachbar=i_frei *)
        ELSE                    (* IF belegung_client=i_abbestellt *)
          (*
          Es soll also nicht abbestellt werden:
          *)
          CASE input[ii09].value OF     (* input[ii09].value ist der radio *)
            | 0, 1:
              (*
              Mal sehen, ob evtl. einer der dmmlichen Chefs versucht,
              sich selber oder einen privaten Gast einzutragen:
              *)
              IF ((belegung_client=i_chef) OR (belegung_client=i_chefin)) THEN
                (*
                Ja tatschlich. Das erlauben wir aber nicht!
                *)
                schreib_page_accept(sd1,
                                    'Die Chefs knnen nur offizielle Gste eintragen, sonst niemanden!',
                                    'Habe verstanden', dunkelrot, p4ac4);
              ELSE              (* IF ((belegung_client=i_chef... *)
                (*
                Schlielich soll also eine ganz normale Eintragung gemacht werden:
                entweder der Spieler selbst oder sein privater Gast.
                *)
                sd1.jahr_court_belegung[client_ukw-sd1.season_start,
                                        court_index]:=belegung_client;
                sd1.jahr_court_belegung_gast[client_ukw-sd1.season_start,
                                        court_index]:=input[ii09].value;

                (*
                'Forderungsstatus' nur genau dann bernehmen, wenn hier
                der Spieler selbst eingetragen werden soll _und_ es sich
                beim Courtnachbarn ebenfalls um den Spieler selbst und
                nicht seinen privaten Gast handelt. Obacht! Damit der unten
                durchgefhrte Vergleich mit court_nachbar_gast=0 auch
                fr den (frei) als Nachbarn funktioniert, ist vorausgesetzt,
                da der freie Platz immer 'selber' (frei) ist und nicht
                der 'Gast des (frei)' im Court sitzt. Dies ist aber bei
                uns der Fall. Weiters machen wir mit forderung_moeglich
                einen Test, ob aufgrund der aktuellen Rangliste berhaupt
                eine Forderung mglich ist.
                *)
                court_nachbar_gast:=sd1.jahr_court_belegung_gast[client_ukw-sd1.season_start,
                                                                 court_index_nachbar];
                IF ((input[ii09].value=0) AND (court_nachbar_gast=0)) THEN
                  IF forderung_moeglich(text) THEN
                    try_put_season_data_and_prepare_e_mail;
                  ELSE          (* IF forderung_moeglich... *)
                    schreib_page_accept(sd1,
                                        text, 'Ah, so ist das', dunkelrot, p4ac4);
                  END;          (* ELSE forderung_moeglich... *)
                ELSE            (* IF ((input[ii09].value=0)... *)
                  try_put_season_data_and_prepare_e_mail;
                END;            (* ELSE ((input[ii09].value=0)... *)
              END;              (* ELSE ((belegung_client=i_chef... *)

            | 2:
                IF ((belegung_client=i_chef) OR (belegung_client=i_chefin)) THEN
                  (*
                  Der Chef oder die Chefin wollen also einen offiziellen Gast
                  eintragen. Nichts leichter als das. Zur
                  sd1.jahr_court_belegung und sd1.jahr_court_belegung_gast
                  kommt halt jetzt noch der jahr_court_belegung_gast_nam
                  hinzu. Damit's auch ganz korrekt mit den Kennwrtern
                  abluft und nicht der Chef sich als Chefin ausgeben kann
                  und umgekehrt, machen wir eine weitere Abfrage:
                  *)
                  IF (((belegung_client=i_chef) AND ist_kennwort_ok(i_chef)) OR
                      ((belegung_client=i_chefin) AND ist_kennwort_ok(i_chefin))) THEN
                    sd1.jahr_court_belegung[client_ukw-sd1.season_start,
                                            court_index]:=belegung_client;
                    sd1.jahr_court_belegung_gast[client_ukw-sd1.season_start,
                                            court_index]:=input[ii09].value;
                    GetGPMString(sd1.jahr_court_belegung_gast_nam[client_ukw-sd1.season_start,court_index], ii18);
                    try_put_season_data_and_prepare_e_mail;
                  ELSE
                    schreib_page_accept(sd1,
                                        'Wir haben doch nicht etwa ein Problem mit dem ChefIn-Kennwort?',
                                        'Groer Mist', dunkelrot, p4ac4);
                  END;
                ELSE            (* IF ((belegung_client=i_chef... *)
                  schreib_page_accept(sd1,
                                      'Nur die Chefs knnen offizielle Gste eintragen!',
                                      'Habe verstanden', dunkelrot, p4ac4);
                END;            (* ELSE ((belegung_client=i_chef... *)

            | ELSE
                schreib_page_info(sd1, 'Gib Hackern keine Chance!',
                                  'Zu bld :-(', dunkelrot);
          END;                  (* CASE input[ii09].value *)
        END;                    (* ELSE belegung_client=i_abbestellt *)
      END trag_ein;

    BEGIN                       (* PROCEDURE act_p2ac1 *)
      (*
      Der OK-Button auf page02 wurde gedrckt. Falls das Kennwort nicht OK
      ist, gibt's eine ordentliche Fehlermeldung. Im anderen Fall 
      aktualisieren wir die Courtbelegung (falls der Spieler nicht schon
      zu oft in dieser KW eingetragen ist) und das season-File
      und zeigen dann page01 an, verhindern aber, da ein bser Hacker
      Geschichtsflschung betreibt. Die Chefin und der Chef drfen
      brigens beliebig weit in der Zukunft beliebig viele Eintragungen
      machen. Als erstes fhren wir aber einen Rangecheck fr die
      court_belegung durch. Alle nicht erlaubten 'Spezialspieler' landen
      nach einem Hinweis wieder hier. Im brigen knnen nur aktive Spieler
      eingetragen werden. Diese Prfung machen wir gleich beim Rangecheck
      fr die court_belegung mit.
      Bevor wir dann aber ggf. eine Eintragung machen, berprfen wir,
      ob im season-File nicht inzwischen jemand (anders) eingetragen ist.
      In diesem Fall geben wir lediglich eine Meldung aus, fhren aber
      _keine_ Eintragung durch.
      *)
      court_index:=sd1.geschrumpfter_index[input[ii02].value];
      (*
      client_ukw ist die Unix-Woche, auf die der User zugreifen mchte:
      *)
      client_ukw:=input[ii01].value;
      user_time2:=user_time(sd1, input[ii01].value, court_index);
      IF (user_time(sd1, input[ii01].value, court_index) > zeitalc) THEN
        belegung_client:=input[ii03].value;
        (*
        Bis etwa 10.2001 war fr belegung_client lediglich i_abbestellt
        erlaubt oder ein Wert grer oder gleich ssa. Nun soll es fr
        die Chefs mglich sein, offizielle Gste einzutragen. Daher
        mssen wir auch i_chef und i_chefin erlauben.
        *)
        IF (NOT((belegung_client=i_abbestellt) OR (belegung_client=i_chef) OR
                (belegung_client=i_chefin) OR (belegung_client>=ssa)) OR
            (sd1.spieler_aktiv[belegung_client]<>sp_aktiv_ja)) THEN
          schreib_page_accept(sd1,
                              'Es wurde keine gltige Auswahl getroffen!',
                              'Nochmal', dunkelrot, p4ac4);
        ELSE                    (* IF (NOT((belegung_client... *)
          (*
          O.k., es wurde also zumindest eine gltige Auswahl durch den Client
          getroffen. Als nchstes sehen wir nach, ob die Belegung im File
          wirklich (frei) ist. Nur falls belegung_file=i_frei gilt, geht
          berhaupt was weiter.
          *)
          belegung_file:=sd1.jahr_court_belegung[client_ukw-sd1.season_start,
                                                 court_index];
          IF belegung_file=i_frei THEN
            IF (ist_kennwort_ok(i_chefin) OR ist_kennwort_ok(i_chef)) THEN
              email_info.ob_chefs_walten:=TRUE;
              trag_ein;
            ELSE                (* IF (ist_kennwort_ok(i_chefin)... *)
              IF ist_kennwort_ok(belegung_client) THEN
                (*
                Frher war's mal so:
                Ein Spieler kann nur sich selbst eintragen. Um einen privaten
                Gast einzutragen, brauchten wir die Chefin oder den Chef.
                Der Spieler wollte sich selbst eintragen, falls
                input[ii09].value=0. Inzwischen (22.10.1998) wurde diese
                Restriktion wieder fallen gelassen.
                Falls lasche Eintragungsprfung gefragt ist, wird
                eintragungslimit_erreicht gar nicht bemht:
                *)
                IF ODD(sd1.bitleiste) THEN
                  ob_eintragen:=TRUE;
                ELSE            (* IF ODD(sd1.bitleiste) *)
                  ob_eintragen:=NOT eintragungslimit_erreicht(belegung_client, text);
                END;            (* ELSE ODD(sd1.bitleiste) *)

                IF ob_eintragen THEN
                  (*
                  Das 'Eintragungslimit' ist noch nicht erreicht, d.h. es
                  sind noch nicht zu viele Eintragungen fr den Spieler
                  erfolgt. Er knnte also eingetragen werden. Heute
                  (18.11.2001) stellen wir aber eine zustzliche Bedingung
                  auf: Bestimmte Spieler (insbesondere solche, die
                  keinen Saisonbeitrag geleistet haben) drfen erst kurz
                  vor dem Spiel eine Eintragung machen, z.B. 1 oder 2
                  Tage vorher. Dies werden wir hier berprfen.
                  Oben wurde schon ermittelt, da user_time(sd1,
                  input[ii01].value, court_index) grer als zeitalc
                  ist. Jetzt schauen wir uns also den Abstand
                  user_time(sd1, input[ii01].value court_index) - zeitalc
                  nochmal an und fordern, da er nicht zu gro sein
                  darf. Wir tricksen ein bichen mit Spielanfang und
                  -ende. Weil user_time das Spielende ermittelt,
                  mssen wir irgendwo 3600 s, d.h. eine Stunde addieren,
                  weil unser Spiel eben eine Stunde vor dem Ende beginnt.
                  Man knnte auch sagen, das Spiel dauert eine Stunde!
                  brigens wird nur bei max_day_delta_loc<>0 getestet.
                  Den Fall max_day_delta_loc=0 interpretieren wir als:
                  keine Prfung ntig, Spieler ist kein (Dauer-)Gast,
                  den man gngeln mu.
                  *)
                  max_day_delta_loc:=sd1.max_day_delta[belegung_client];
                  IF max_day_delta_loc<>0 THEN
                    IF (user_time(sd1, input[ii01].value, court_index) - zeitalc) > (max_day_delta_loc*24+1)*3600 THEN
                      Assign('Eintragung frhestens ', text);
                      CardToStr(max_day_delta_loc*24, zwstr);
                      Append(zwstr, text);
                      Append(' Stunden vor Spielbeginn mglich, ggf. die Chefs fragen!', text);
                      schreib_page_accept(sd1,
                                          text, 'Groer Mist', dunkelrot, p4ac4);
                    ELSE        (* IF (user_time... *)
                      trag_ein;
                    END;        (* ELSE (user_time... *)
                  ELSE          (* IF max_day_delta_loc<>0 *)
                    trag_ein;
                  END;          (* ELSE max_day_delta_loc<>0 *)
                ELSE            (* IF ob_eintragen *)
                  schreib_page_accept(sd1,
                                      text, 'Groer Mist', dunkelrot, p4ac4);
                END;            (* ELSE ob_eintragen *)
              ELSE              (* IF ist_kennwort_ok(belegung_client) *)
                schreib_page_accept(sd1,
                                    'Wir haben doch nicht etwa ein Problem mit dem Kennwort?',
                                    'Groer Mist', dunkelrot, p4ac4);
              END;              (* ELSE ist_kennwort_ok(belegung_client) *)
            END;                (* ELSE (ist_kennwort_ok(i_chefin)... *)
          ELSE                  (* IF belegung_file=i_frei *)
            schreib_page_accept(sd1,
                                'Eintragung war nicht mglich, bitte von vorne beginnen!',
                                'Groer Mist', dunkelrot, p4ac1);
          END;                  (* ELSE belegung_file=i_frei *)
        END;                    (* ELSE (NOT((belegung_client... *)
      ELSE                      (* IF (user_time... *)
        schreib_page_accept(sd1,
                            'Wir wollen doch keine Geschichtsflschung betreiben!',
                            'Sehe ich ein', dunkelrot, p4ac1);
      END;                      (* ELSE (user_time... *)
   END act_p2ac1;

  PROCEDURE act_p2ac2;
    BEGIN                       (* PROCEDURE act_p2ac2 *)
      (*
      Der nicht-OK-Button auf page02 wurde gedrckt. Einfach wieder page01
      anzeigen:
      *)
      schreib_page01(sd1);
    END act_p2ac2;

  PROCEDURE act_p3ac1;
    VAR
      court_index:              INTEGER;
      client_ukw:               INTEGER;

    PROCEDURE trag_aus;
      VAR
        belegung_client_gast:           INTEGER;
        belegung_client_gast_nam:       String_kurz;
        court_index_nachbar:            INTEGER;

      PROCEDURE eintrag_loeschen(court_index: INTEGER);
        BEGIN                   (* PROCEDURE eintrag_loeschen *)
          (* wieder (frei): *)
          sd1.jahr_court_belegung[client_ukw-sd1.season_start,
                                  court_index]:=i_frei;
          (* Gaststatus: Spieler selbst *)
          sd1.jahr_court_belegung_gast[client_ukw-sd1.season_start,
                                  court_index]:=0;
          (* Name eines potenziellen offiziellen Gastes: nullinger *)
          Assign('', sd1.jahr_court_belegung_gast_nam[client_ukw-sd1.season_start, court_index]);

          (*
          eventuell vorhandenen 'Forderungsstatus' lschen. Man beachte
          dabei, da court_index dazu nochmal halbiert wird! Achtung: wir
          lschen den 'Forderungsstatus' nur, wenn der Nachbar der (frei)
          ist. Im anderen Fall ndern wir nichts!
          *)
          court_index_nachbar:=calc_court_index_nachbar(court_index);
          IF sd1.jahr_court_belegung[client_ukw-sd1.season_start, court_index_nachbar]=i_frei THEN
            sd1.jahr_forderung[client_ukw-sd1.season_start, court_index DIV 2]:=0;
          END;                  (* IF sd1.jahr_court_belegung... *)
        END eintrag_loeschen;

      BEGIN                     (* PROCEDURE trag_aus *)
        (*
        Schnell noch bevor's zu spt ist merken, ob das ein privater
        Gast war, der jetzt ausgetragen wird oder was. Den Client
        selbst haben wir noch in belegung_client vorliegen.
        *)
        belegung_client_gast:=sd1.jahr_court_belegung_gast[client_ukw-sd1.season_start,
                                                           court_index];
        Assign(sd1.jahr_court_belegung_gast_nam[client_ukw-sd1.season_start, court_index],
               belegung_client_gast_nam);
        eintrag_loeschen(court_index);

        (*
        Nachdem wir beim Eintragen von (abbestellt) auch gleich
        den Nachbarn mit abbestellen, wollen wir dies beim evtl.
        durchzufhrenden Austragen analog machen. Jetzt sind
        keinerlei Vorsichtsmanahmen ntig, weil garantiert ist,
        da der Nachbar ebenfalls (abbestellt) ist, falls der
        zu bearbeitende Platz (abbestellt) ist.
        *)
        IF belegung_client=i_abbestellt THEN
          (*
          Wir haben also ein (abbestellt) ausgetragen. Schaun wir
          doch mal, wer unser Nachbar ist.
          *)
          court_index_nachbar:=calc_court_index_nachbar(court_index);
          eintrag_loeschen(court_index_nachbar);
        END;                    (* IF belegung_client=i_abbestellt *)

        IF try_put_season_data(season_name, sd1, 1) THEN
          schreib_page01(sd1);
          (*
          Notieren, da am Ende ggf. E-Mails zu senden sind:
          *)
          email_info.ob_emails_senden:=TRUE;
          email_info.court_index:=court_index;
          email_info.client_ukw:=client_ukw;
          email_info.belegung_client:=belegung_client;
          email_info.belegung_client_gast:=belegung_client_gast;
          Assign(belegung_client_gast_nam, email_info.belegung_client_gast_nam);
          Assign('AUS-', email_info.text);
        ELSE                    (* IF try_put_season_data... *)
          schreib_page_info(sd1,
                            'Daten konnten nicht aktualisiert werden!',
                            'Spter nochmal probieren, ggf. dem Programmierer drohen!',
                            dunkelrot);
        END;                    (* ELSE try_put_season_data... *)
      END trag_aus;

    BEGIN                       (* PROCEDURE act_p3ac1 *)
      (*
      Der OK-Button auf page03 wurde gedrckt. Falls das Kennwort nicht OK
      ist, gibt's eine ordentliche Fehlermeldung. Im anderen Fall 
      machen wir den Court frei, aktualisieren das season-File und 
      zeigen dann page01 an, verhindern aber, da ein bser Hacker
      Geschichtsflschung betreibt.
      Bevor wir aber berhaupt eine Austragung machen, berprfen wir,
      ob im season-File nicht inzwischen jemand (anders) eingetragen ist.
      In diesem Fall geben wir eine Meldung aus.
      Sollte irgendjemand (z.B. die Chefin bzw. der Chef) den Spieler soeben
      ausgetragen haben (dann gilt zwar auch: belegung_file<>belegung_client),
      dann drfen wir aber nicht sagen: 'Austragung war nicht mglich...',
      sondern gehen sofort zur page01 weiter, weil die Austragung
      offenbar schon stattgefunden hatte. brigens darf die Chefin bzw. der
      Chef jede beliebige Austragung vornehmen.
      Update am 25.02.2007: der normale Spieler darf sich nur bis maximal
      25 Stunden vor Spielende wieder austragen.
      *)
      court_index:=sd1.geschrumpfter_index[input[ii02].value];
      (*
      client_ukw ist die Unix-Woche, auf die der User zugreifen mchte:
      *)
      client_ukw:=input[ii01].value;
      user_time3:=user_time(sd1, input[ii01].value, court_index);
      IF (user_time(sd1, input[ii01].value, court_index) > zeitalc) THEN
        belegung_client:=input[ii06].value;
        belegung_file:=sd1.jahr_court_belegung[client_ukw-sd1.season_start,
                                               court_index];
        IF belegung_file=belegung_client THEN
          IF (ist_kennwort_ok(i_chefin) OR ist_kennwort_ok(i_chef)) THEN
            email_info.ob_chefs_walten:=TRUE;
            trag_aus;
          ELSE                  (* IF (ist_kennwort_ok(i_chefin)... *)
            IF (user_time(sd1, input[ii01].value, court_index) < (zeitalc + 25 * s_pro_stunde)) THEN
              schreib_page_accept(sd1,
                                'Austragung nicht mehr mglich, ggf. die Chefs fragen!',
                                'Groer Mist', dunkelrot, p4ac1);
            ELSE                (* IF (user_time... *)
              IF ist_kennwort_ok(belegung_client) THEN
                trag_aus;
              ELSE              (* IF (ist_kennwort_ok(belegung_client)... *)
                schreib_page_accept(sd1,
                                'Wir haben doch nicht etwa ein Problem mit dem Kennwort?',
                                'Groer Mist', dunkelrot, p4ac5);
              END;              (* ELSE (ist_kennwort_ok(belegung_client)... *)
            END;                (* ELSE (user_time... *)
          END;                  (* ELSE (ist_kennwort_ok(i_chefin)... *)
        ELSE                    (* IF belegung_file=belegung_client *)
          IF belegung_file=i_frei THEN
            schreib_page01(sd1);
          ELSE                  (* IF belegung_file=i_frei *)
            schreib_page_accept(sd1,
                                'Austragung war nicht mglich, bitte von vorne beginnen!',
                                'Groer Mist', dunkelrot, p4ac1);
          END;                  (* ELSE belegung_file=i_frei *)
        END;                    (* ELSE belegung_file=belegung_client *)
      ELSE                      (* IF (user_time... *)
        schreib_page_accept(sd1,
                            'Wir wollen doch keine Geschichtsflschung betreiben!',
                            'Sehe ich ein', dunkelrot, p4ac1);
      END;                      (* ELSE (user_time... *)
    END act_p3ac1;

  PROCEDURE act_p3ac2;
    BEGIN                       (* PROCEDURE act_p3ac2 *)
      (*
      Der nicht-OK-Button auf page03 wurde gedrckt. Einfach wieder page01
      anzeigen:
      *)
      schreib_page01(sd1);
    END act_p3ac2;

  PROCEDURE act_p4ac1;
    BEGIN                       (* PROCEDURE act_p4ac1 *)
      (*
      Der normale User hat den Accept-Button auf page04 oder auch einer
      anderen Seite gedrckt. Einfach wieder page01 anzeigen.
      *)
      schreib_page01(sd1);
    END act_p4ac1;

  PROCEDURE act_p4ac4;
    BEGIN                       (* PROCEDURE act_p4ac4 *)
      (*
      Der normale User hatte auf page 2 entweder eine ungltige Auswahl
      getroffen, ein falsches Kennwort gedrckt oder ist in dieser Woche
      schon gengend oft eingetragen. Akzeptieren des 'Nochmal'- oder
      'Groer Mist'-Buttons fhrt wieder auf page02 zurck, falls der Court
      (immer) noch frei ist, andernfalls wird eine Fehlermeldung ausgegeben.
      *)
      belegung_file:=sd1.jahr_court_belegung[input[ii01].value-sd1.season_start,
                                             sd1.geschrumpfter_index[input[ii02].value]];
      IF belegung_file=i_frei THEN
        schreib_page02(sd1);
      ELSE                      (* IF belegung_file=i_frei *)
        schreib_page_accept(sd1,
                            'Eintragung nicht mehr mglich, bitte von vorne beginnen!',
                            'Groer Mist', dunkelrot, p4ac1);
      END;                      (* ELSE belegung_file=i_frei *)
    END act_p4ac4;

  PROCEDURE act_p4ac5;
    BEGIN                       (* PROCEDURE act_p4ac5 *)
      (*
      Der normale User hatte ein falsches Kennwort auf page03 gedrckt.
      Akzeptieren des 'Groer Mist'-Buttons fhrte ihn hierher und wird
      ihn wieder auf page01 zurckfhren, falls der Court immer noch mit
      dem alten Spieler belegt ist, andernfalls wird eine Fehlermeldung
      ausgegeben.
      Sollte irgendjemand (z.B. die Chefin bzw. der Chef) den Spieler soeben
      ausgetragen haben (dann gilt zwar auch: belegung_file<>belegung_client),
      dann drfen wir aber nicht sagen: 'Austragung war nicht mglich...',
      sondern gehen sofort wieder zur page01 zurck, weil die Austragung
      offenbar schon stattgefunden hatte.
      *)
      belegung_client:=input[ii06].value;
      belegung_file:=sd1.jahr_court_belegung[input[ii01].value-sd1.season_start,
                                             sd1.geschrumpfter_index[input[ii02].value]];
      IF belegung_file=belegung_client THEN
        schreib_page03(sd1);
      ELSE                      (* IF belegung_file=belegung_client *)
        IF belegung_file=i_frei THEN
          schreib_page01(sd1);
        ELSE                    (* IF belegung_file=i_frei *)
          schreib_page_accept(sd1,
                              'Austragung war nicht mglich, bitte von vorne beginnen!',
                              'Groer Mist', dunkelrot, p4ac1);
        END;                    (* ELSE belegung_file=i_frei *)
      END;                      (* ELSE belegung_file=belegung_client *)
    END act_p4ac5;

  PROCEDURE act_p4ac6;
    BEGIN                       (* PROCEDURE act_p4ac6 *)
      (*
      Der User hat den Accept-Button auf page04 gedrckt, nachdem
      es ein Problem beim ndern des Kennworts gab. Drcken des
      Accept-Buttons fhrt ihn wieder auf page09 zurck.
      *)
      schreib_page09(sd1);
    END act_p4ac6;

  PROCEDURE act_p4ac7;
    BEGIN                       (* PROCEDURE act_p4ac7 *)
      (*
      Der User hat den Accept-Button auf page04 gedrckt, nachdem
      das ndern des Kennworts erfolgreich verlief (oder ein Chat-
      Beitrag genehmigt wurde oder eine ggf. genderte Persdata
      eingetragen wurden). Drcken des Accept-Buttons fhrt
      ihn wieder auf page01 zurck.
      *)
      schreib_page01(sd1);
    END act_p4ac7;

  PROCEDURE act_p4ac8;
    BEGIN                       (* PROCEDURE act_p4ac8 *)
      (*
      Der User hat den Accept-Button auf page04 gedrckt, nachdem
      es ein Problem beim Chatten gab. Drcken des
      Accept-Buttons fhrt ihn wieder auf page19 zurck.
      *)
      schreib_page19(sd1);
    END act_p4ac8;

  PROCEDURE act_p4ac9;
    BEGIN                       (* PROCEDURE act_p4ac9 *)
      (*
      Es wurde soeben ein altes Lockfile gelscht oder es gab ein
      Problem in calc_integers und wir sind daraufhin im Normalmodus
      gelandet, d.h. wir machen wieder ganz normal weiter.
      *)
      schreib_page01(sd1);
    END act_p4ac9;

  PROCEDURE act_p4ac10;
    BEGIN                       (* PROCEDURE act_p4ac10 *)
      (*
      Der User hat den Accept-Button auf page04 gedrckt, nachdem
      es ein Problem beim Editieren der Persdata gab. Drcken des
      Accept-Buttons fhrt ihn wieder auf page26 zurck.
      *)
      schreib_page26(sd1);
    END act_p4ac10;

  PROCEDURE act_p4ac11;
    BEGIN                       (* PROCEDURE act_p4ac11 *)
      (*
      Der User hat den Accept-Button auf page04 gedrckt, nachdem
      es ein Problem beim Anzeigen der Statistikseite gab. Drcken des
      Accept-Buttons fhrt ihn wieder auf page28 zurck.
      *)
      schreib_page28(sd1);
    END act_p4ac11;

  PROCEDURE act_p8ac1;
    BEGIN                       (* PROCEDURE act_p8ac1 *)
      (*
      Man will: Kennwort ndern.
      Hier rufen wir die Seite zum ndern des Kennworts auf.
      *)
      schreib_page09(sd1);
    END act_p8ac1;

  PROCEDURE act_p8ac2;
    BEGIN                       (* PROCEDURE act_p8ac2 *)
      (*
      Man will: Zurck an den Anfang.
      Hier zeigen wir wieder page01 an.
      *)
      schreib_page01(sd1);
    END act_p8ac2;

  PROCEDURE act_p8ac3;
    BEGIN                       (* PROCEDURE act_p8ac3 *)
      (*
      Man will: Die Programmquelle einsehen. Das macht page10.
      Hinweis: weil die Ausgabe ggf. recht lange dauert, wir aber das
      season-File sowieso nicht mehr anrhren, lschen wir das Lockfile
      schon an dieser Stelle.
      *)

      try_delete_lock;

      schreib_page10(sd1);
    END act_p8ac3;

  PROCEDURE act_p8ac4;
    BEGIN                       (* PROCEDURE act_p8ac4 *)
      (*
      Man will: Schnell weg von hier. Das macht page11.
      *)
      schreib_page11(sd1);
    END act_p8ac4;

  PROCEDURE act_p8ac5;
    BEGIN                       (* PROCEDURE act_p8ac5 *)
      (*
      Man will: Zur Rangliste
      Das macht page12. Das TRUE heit brigens: wirklich page12
      und nicht page24.
      *)
      schreib_page12_oder_24(sd1, TRUE);
    END act_p8ac5;

  PROCEDURE act_p8ac6;
    BEGIN                       (* PROCEDURE act_p8ac6 *)
      (*
      Man will: Einen Wartungszyklus durchfhren
      (Kann er nur, wenn er das Chef-Kennwort kennt :-)):
      Das macht page13.
      *)
      schreib_page13(sd1);
    END act_p8ac6;

  PROCEDURE act_p8ac7;
    BEGIN                       (* PROCEDURE act_p8ac7 *)
      (*
      Man will: Das Webserver Logfile anschauen. Das macht page18.
      Hinweis: weil die Ausgabe ggf. recht lange dauert, wir aber das
      season-File sowieso nicht mehr anrhren, lschen wir das Lockfile
      schon an dieser Stelle.
      *)

      try_delete_lock;

      schreib_page18(sd1);
    END act_p8ac7;

  PROCEDURE act_p8ac8;
    BEGIN                       (* PROCEDURE act_p8ac8 *)
      (*
      Die aktuelle Datenbasis soll gelscht und ein Backup erstellt
      werden. Dies entspricht einfach einem umbenennen.
      *)
      schreib_page20(sd1);
    END act_p8ac8;

  PROCEDURE act_p8ac9;
    BEGIN                       (* PROCEDURE act_p8ac9 *)
      (*
      Die aktuelle Datenbasis soll durch ein (vorhandenes) Backup
      ersetzt werden.
      *)
      schreib_page21(sd1);
    END act_p8ac9;

  PROCEDURE act_p8ac10;
    BEGIN                       (* PROCEDURE act_p8ac10 *)
      (*
      Die Persdata sollen editiert werden
      *)
      schreib_page26(sd1);
    END act_p8ac10;

  PROCEDURE act_p8ac11;
    BEGIN                       (* PROCEDURE act_p8ac11 *)
      (*
      Die Statistikseite soll ausgegeben werden
      *)
      schreib_page28(sd1);
    END act_p8ac11;

  PROCEDURE act_p9ac1;
    VAR
      str_ptr:                  StrPtrTyp;
      text:                     String;

    BEGIN                       (* PROCEDURE act_p9ac1 *)
      (*
      Der OK-Button auf page09 wurde gedrckt. Es soll also ein Kennwort
      gendert werden. Zuerst sehen wir nach, welchen Wert die court_belegung
      hat. court_belegung ist hier nicht eine tatschliche Belegung
      des Courts, sondern nur der Index desjenigen, dessen Kennwort
      gendert werden soll. Als erstes fhren wir aber einen Rangecheck fr
      die court_belegung durch. Fr '(frei)' und '(Auswahl)' wird keine
      Kennwortnderung durchgefhrt. Fr '(frei)' sowieso nicht, weil er
      gleich gar nicht im Auswahlmen erschienen ist und fr die '(Auswahl)'
      erlauben wir es einfach nicht. Diese landet nach einem Hinweis wieder
      hier. Im brigen knnen nur aktive Spieler eingetragen werden. Diese
      Prfung machen wir gleich beim Rangecheck fr die court_belegung mit.
      Wenn dann das vom Client bermittelte Kennwort mit dem entsprechend
      zugeordneten Kennwort aus dem season-File bereinstimmt oder wenn es
      sich beim vom Client bermittelten Kennwort um das Chef-Kennwort
      handelt, wird geprft, ob die beiden neuen Kennwrter identisch sind.
      Erst wenn dies der Fall ist, wird das neue (verschlsselte) Kennwort
      in das season-File
      mit bernommen. In allen anderen Fllen gibt es entsprechende
      Fehlermeldungen.
      Nebenbemerkung: der Leerstring wird nicht als neues Kennwort
      erlaubt.
      *)

      belegung_client:=input[ii03].value;
      IF (NOT((belegung_client=i_chef) OR (belegung_client=i_chefin) OR 
              (belegung_client>=ssa)) OR
          (sd1.spieler_aktiv[belegung_client]<>sp_aktiv_ja)) THEN
        schreib_page_accept(sd1,
                            'Es wurde keine gltige Auswahl getroffen!',
                            'Nochmal', dunkelrot, p4ac6);
      ELSE                      (* IF NOT((belegung_client... *)
        IF (ist_kennwort_ok(belegung_client) OR ist_kennwort_ok(i_chef)) THEN
          (*
          Das Kennwort ist o.k.. Jetzt mssen wir prfen, ob die beiden
          neuen Kennwrter identisch sind. Dazu knnen wir uns natrlich
          das vorherige Verschlsseln sparen:
          *)
          (*
          zwstr1 ist das erste neue Kennwort:
          *)
          GetGPMString(zwstr1, ii07);

          (*
          zwstr2 ist das zweite neue Kennwort:
          *)
          GetGPMString(zwstr2, ii08);

          strings_sind_gleich:=(CompareRS(zwstr1, zwstr2)=equal);

          IF strings_sind_gleich THEN
            (*
            Jetzt ist (fast) alles prima, denn wir wollen noch den
            Fall des Leerstrings als neues Kennwort abfangen. Danach
            mssen wir das neue Kennwort noch verschlsseln und knnen es
            dann mit in das season-File bernehmen.
            Sollte im brigen alles o.k. sein und lediglich das neue
            Kennwort gleich dem alten sein, dann geben wir zum Spa eine
            kleine Scherzboldmeldung aus.
            *)
            IF (NOT(CompareRS(zwstr1, '')=equal)) THEN
              (*
              zwstr0 ist das alte, unverschlsselte Kennwort:
              *)
              GetGPMString(zwstr0, ii05);

              (*
              Also: es liegt _nicht_ der Leerstring vor, verschlsseln
              wir das zweite, neu eingegebene Kennwort und tragen
              es schon mal in das season-File ein:
              *)
              str_ptr:=Unix.Crypt(zwstr2, '00');
              zwstr2:=str_ptr^;
              sd1.spieler_kennwort[belegung_client]:=zwstr2; 
              IF try_put_season_data(season_name, sd1, 1) THEN
                IF (CompareRS(zwstr0, zwstr1)=equal) THEN
                  text:='Kleiner Scherzbold: Kennwort fr ';
                  Append(sd1.spieler_name[belegung_client], text);
                  Append(' sollte wohl gar nicht gendert werden?', text);
                ELSE            (* IF (CompareRS(zwstr0, zwstr1)=equal) *)
                  text:='Gewnschtes Kennwort fr ';
                  Append(sd1.spieler_name[belegung_client], text);
                  Append(' ist nun gltig!', text);
                END;            (* ELSE (CompareRS(zwstr0, zwstr1)=equal) *)

                schreib_page_accept(sd1, text,
                                    "Weiter geht's", dunkelgruen, p4ac7);
              ELSE              (* IF try_put_season_data... *)
                schreib_page_info(sd1,
                                  'Daten konnten nicht aktualisiert werden!',
                                  'Spter nochmal probieren, ggf. dem Programmierer drohen!',
                                  dunkelrot);
              END;              (* ELSE try_put_season_data... *)
            ELSE                (* IF (CompareRS(zwstr1, '')=equal) *)
              schreib_page_accept(sd1,
                                  'Es wurde kein neues Kennwort eingegeben!',
                                  'Nochmal', dunkelrot, p4ac6);
            END;                (* ELSE (CompareRS(zwstr1, '')=equal) *)
          ELSE                  (* IF strings_sind_gleich *)
            schreib_page_accept(sd1,
                                'Die beiden neuen Kennwrter sind nicht gleich!',
                                'Groer Mist', dunkelrot, p4ac6);
          END;                  (* ELSE strings_sind_gleich *)
        ELSE                    (* IF (ist_kennwort_ok(belegung_client)... *)
          schreib_page_accept(sd1,
                              'Wir haben doch nicht etwa ein Problem mit dem Kennwort?',
                              'Groer Mist', dunkelrot, p4ac6);
        END;                    (* ELSE (ist_kennwort_ok(belegung_client)... *)
      END;                      (* ELSE NOT((belegung_client... *)
   END act_p9ac1;

  PROCEDURE act_p9ac2;
    BEGIN                       (* PROCEDURE act_p9ac2 *)
      (*
      Der nicht-OK-Button auf page09 wurde gedrckt.
      Wahrscheinlich will der User gleich zur Startseite zurck,
      daher zeigen wir wieder page01 an.
      *)
      schreib_page01(sd1);
    END act_p9ac2;

  PROCEDURE act_p13ac1;
    BEGIN                       (* PROCEDURE act_p13ac1 *)
      (*
      Der OK-Button auf page13 wurde gedrckt. Es soll also vom Usermodus
      auf den Wartungsmodus umgestellt werden. Falls das Kennwort nicht
      OK ist, gibt's eine ordentliche Fehlermeldung. Im anderen Fall 
      wird auf den Wartungsmodus umgestellt, d.h. sea_state
      wird auf einen geeigneten Wert ungleich sea_state0 gesetzt.
      Man beachte, da im Erfolgsfalle schreib_page_accept mit p4ac2
      aufgerufen wird, da wir uns von nun an nicht mehr im Usermodus
      befinden.
      *)
      IF ist_kennwort_ok(i_chef) THEN
        (*
        Es soll auf den Wartungsmodus umgestellt werden. Dies
        erlauben wir nur, wenn sea_state momentan den Wert sea_state0
        hat:
        *)
        IF sd1.sea_state=sea_state0 THEN
          (*
          Nun also: Den Wartungszyklus beginnen.
          *)
          sd1.sea_state:=sea_state2;
          IF try_put_season_data(season_name, sd1, 1) THEN
            schreib_page_accept(sd1,
                              'Der Wartungszyklus wurde begonnen!',
                              "Weiter geht's", dunkelgruen, p4ac2);
          ELSE                  (* IF try_put_season_data... *)
            schreib_page_info(sd1,
                              'Daten konnten nicht aktualisiert werden!',
                              'Spter nochmal probieren, ggf. dem Programmierer drohen!',
                              dunkelrot);
          END;                  (* ELSE try_put_season_data... *)
        ELSE                    (* IF sd1.sea_state=sea_state2 *)
          schreib_page_accept(sd1,
                              'bermittelte Daten und Datenbasis waren nicht konsistent!',
                              "Weiter geht's", dunkelrot, p4ac2);
        END;                    (* ELSE sd1.sea_state=sea_state2 *)
      ELSE                      (* IF ist_kennwort_ok(i_chef) *)
        schreib_page_accept(sd1,
                            'Wir haben doch nicht etwa ein Problem mit dem Chef-Kennwort?',
                            'Groer Mist', dunkelrot, p8ac6);
      END;                      (* ELSE ist_kennwort_ok(i_chef) *)
    END act_p13ac1;

  PROCEDURE act_p13ac2;
    BEGIN                       (* PROCEDURE act_p13ac2 *)
      (*
      Der nicht-OK-Button auf page13 wurde gedrckt. Wird eben kein
      Wartungszyklus begonnen.
      Wahrscheinlich will der Mensch gleich zur Startseite zurck,
      daher zeigen wir wieder page01 an.
      *)
      schreib_page01(sd1);
    END act_p13ac2;

  PROCEDURE act_p19ac1;
    VAR
      text:                     String;
      wer_str:                  String;
      zwstr_lang:               String_lang;
      booldummy:                BOOLEAN;

    BEGIN                       (* PROCEDURE act_p19ac1 *)
      (*
      Der OK-Button auf page19 wurde gedrckt. Es soll also ein Beitrag fr
      die Chat-/Newsecke gemacht werden. Hier werden der Chef und die Chefin
      wie ganz normale User behandelt, d.h. sie haben, was das Abgeben einer
      ffentlichen Meinung angeht, keine besonderen Rechte.
      Zuerst sehen wir nach, welchen Wert die court_belegung hat.
      court_belegung ist hier nicht eine tatschliche Belegung des Courts,
      sondern nur der Index desjenigen, der chatten will. Als erstes fhren
      wir aber einen Rangecheck fr die court_belegung durch. Der Chef,
      die Chefin und alle Spieler knnen ihre Meinung nur mit Kennwort
      abgeben. Ein Besucher kann allerdings anonym posten. Im brigen
      knnen nur aktive Spieler posten. Diese Prfung machen wir gleich
      beim Rangecheck fr die court_belegung mit.
      *)

      belegung_client:=input[ii03].value;
      IF (NOT((belegung_client=i_chef) OR (belegung_client=i_chefin) OR 
              (belegung_client=i_ein_besucher) OR (belegung_client>=ssa)) OR
          (sd1.spieler_aktiv[belegung_client]<>sp_aktiv_ja)) THEN
        schreib_page_accept(sd1,
                            'Es wurde keine gltige Auswahl getroffen!',
                            'Nochmal', dunkelrot, p4ac8);
      ELSE                      (* IF (NOT((belegung_client=i_chef)... *)
        IF ((belegung_client=i_ein_besucher) OR
            ist_kennwort_ok(belegung_client)) THEN
          (*
          Ein Besucher ist da (der geht ohne Kennwort durch) oder das
          Kennwort ist o.k., d.h. wir werden die abgegebene Meinung
          bernehmen. Leere Meinungen wollen wir aber schon aus
          Diskretionsgrnden dem zerstreuten Poster gegenber lieber
          nicht annehemen. Schaut doch irgendwie bld aus, wenn
          jemand aus lauter Bldheit die Nullmeinung abgibt.
          *)
          GetGPMString(zwstr_lang, ii16);
          IF Length(zwstr_lang)<>0 THEN
            wer_str:=sd1.spieler_name[belegung_client];
            IF try_put_chat_data(wer_str) THEN
              (*
              Wir wollen nun in jedem Fall unseren schnen chat_counter
              aktualisieren. Damit sollte eine unerwartete Einfrbung
              des '...chatten'-Buttons problemlos mglich sein. Auch
              diesen Update mssen wir nicht unbedingt im Logfile haben.
              *)
              sd1.chat_counter:=sd1.chat_counter+1;
              booldummy:=try_put_season_data(season_name, sd1, 0);

              text:='Mitteilung von ';
              Append(wer_str, text);
              Append(' wurde registriert!', text);
              schreib_page_accept(sd1, text,
                                  "Weiter geht's", dunkelgruen, p4ac7);
            ELSE                (* IF try_put_chat_data... *)
              schreib_page_info(sd1,
                                'Meinung konnte nicht ffentlich abgegeben werden!',
                                'Spter nochmal probieren, ggf. dem Programmierer drohen!',
                                dunkelrot);
            END;                (* ELSE try_put_chat_data... *)
          ELSE                  (* IF Length(zwstr_lang)<>0 *)
            schreib_page_accept(sd1,
                                'Wir wollten doch nicht eine leere Meinung abgeben?',
                                'Ist wahr', dunkelrot, p4ac8);
          END;                  (* ELSE Length(zwstr_lang)<>0 *)
        ELSE                    (* IF ist_kennwort_ok(belegung_client) *)
          schreib_page_accept(sd1,
                              'Wir haben doch nicht etwa ein Problem mit dem Kennwort?',
                              'Groer Mist', dunkelrot, p4ac8);
        END;                    (* ELSE ist_kennwort_ok(belegung_client) *)
      END;                      (* ELSE (belegung_client<i_chef) *)
   END act_p19ac1;

  PROCEDURE act_p19ac2;
    BEGIN                       (* PROCEDURE act_p19ac2 *)
      (*
      Der nicht-OK-Button auf page19 wurde gedrckt.
      Momentan wird page01 angzeigt.
      *)
      schreib_page01(sd1);
    END act_p19ac2;

  PROCEDURE act_p20ac1;
    VAR
      season_name_bkp:          String;
      basename:                 String;
      ok:                       BOOLEAN;
      text:                     String;

    BEGIN                       (* PROCEDURE act_p20ac1 *)
      (*
      Der OK-Button auf page20 wurde gedrckt. Es soll also das
      season-File umbenannt werden. Falls das Kennwort nicht
      OK ist, gibt's eine ordentliche Fehlermeldung. Im anderen Fall 
      wird umbenannt.
      Man beachte, da im Erfolgsfalle schreib_page_accept mit p4ac2
      aufgerufen wird, da wir uns von nun an nicht mehr im Usermodus
      befinden (weil kein season-File mehr da ist).
      *)
      IF ist_kennwort_ok(i_chef) THEN
        (*
        Zuerst versuchen wir, einen 'Backup'-Link fr das aktuelle
        season-File anzulegen:
        *)
        Assign(bkp_pfad, season_name_bkp);
        Append('/', season_name_bkp);
        construct_datetimename(bkp_prefix, basename);
        Append(basename, season_name_bkp);

        ok:=Unix.Link(season_name, season_name_bkp);
        IF ok THEN
          (*
          Falls der Link angelegt werden konnte, versuchen wir,
          das aktuelle season-File zu lschen:
          *)
          ok:=Unix.Unlink(season_name);
          IF ok THEN
            (*
            Nachdem nun kein season-File mehr da ist, tun wir gut daran,
            fr die input's einen Reset zu machen. Sonst htten wir evtl.
            Probleme mit hidden values der accept page, die dann spter
            irgendwie out of range sein knnten.
            *)
            init_default_inputs1;
            reset_season_data(sd1);
            init_default_inputs2;

            Assign('Backup "', text);
            Append(basename, text);
            Append('" wurde angelegt, Datenbasis selbst gelscht!', text);
            schreib_page_accept(sd1, text,
                                "Weiter geht's", dunkelgruen, p4ac2);
          ELSE                  (* IF ok *)
            schreib_page_info(sd1,
                              'Die Datenbasis konnte nicht gelscht werden!',
                              'Spter nochmal probieren, ggf. dem Programmierer drohen!',
                              dunkelrot);
          END;                  (* ELSE ok *)
        ELSE                    (* IF ok *)
          schreib_page_info(sd1,
                            'Es konnte kein Backup der Datenbasis angelegt werden!',
                            'Spter nochmal probieren, ggf. dem Programmierer drohen!',
                            dunkelrot);
        END;                    (* ELSE ok *)
      ELSE                      (* IF ist_kennwort_ok(i_chef) *)
        schreib_page_accept(sd1,
                            'Wir haben doch nicht etwa ein Problem mit dem Chef-Kennwort?',
                            'Groer Mist', dunkelrot, p8ac8);
      END;                      (* ELSE ist_kennwort_ok(i_chef) *)
    END act_p20ac1;

  PROCEDURE act_p20ac2;
    BEGIN                       (* PROCEDURE act_p20ac2 *)
      (*
      Der nicht-OK-Button auf page20 wurde gedrckt. Wird das
      season-File eben nicht umbenannt.
      Wir schicken den Menschen gleich zur Startseite zurck,
      daher zeigen wir wieder page01 an.
      *)
      schreib_page01(sd1);
    END act_p20ac2;

  PROCEDURE act_p21ac1;
    BEGIN                       (* PROCEDURE act_p21ac1 *)
      backup_einspielen(p8ac9);
    END act_p21ac1;

  PROCEDURE act_p21ac2;
    BEGIN                       (* PROCEDURE act_p21ac2 *)
      (*
      Der nicht-OK-Button auf page21 wurde gedrckt. Wird eben
      kein Backup eingespielt.
      Wir schicken den Menschen gleich zur Startseite zurck,
      daher zeigen wir wieder page01 an.
      *)
      schreib_page01(sd1);
    END act_p21ac2;

  PROCEDURE act_p25ac1;
    VAR
      count:                    INTEGER;
      rang_feld:                rang_feld_typ;
      max_name_length:          CARDINAL;
      rang_forderer:            INTEGER;
      rang_geforderter:         INTEGER;
      forderer:                 INTEGER;
      index:                    INTEGER;

    BEGIN                       (* PROCEDURE act_p25ac1 *)
      (*
      Der OK-Button auf page25 wurde gedrckt. Es soll also die
      Pyramide gem der Daten in forderer und geforderter umgestellt
      werden. Das kann nur einer der beiden Chefs genehmigen.
      *)
      IF (ist_kennwort_ok(i_chef) OR ist_kennwort_ok(i_chefin)) THEN
        (*
        Die Pyramide darf also umgestellt werden. Nach Umstellung der
        Pyramide und erfolgreichem Schreiben der Datenbasis zeigen wir
        die Pyramide gleich wieder frisch an, damit gleich weiter
        editiert werden kann.
        *)

        (* Als erstes besorgen wir uns wieder mal die Ranginfo: *)
        get_rang_info(sd1, rang_feld, count, max_name_length);

        (* Dann sehen wir, wer forderer und geforderter ist: *)
        rang_forderer:=input[ii20].value-1;
        rang_geforderter:=input[ii21].value-1;

        (*
        In Wirklichkeit hat der forderer natrlich hchstens einen
        kleineren Rang als der geforderte. Wir erlauben aber alles,
        weil wir ggf. eine Korrekur in der Rangliste vornehmen mssen
        und daher mssen wir erst einmal sehen, ob unser 'forderer'
        auf-, ab- oder gar nicht steigt. Letzteres ist zwar nur
        der Dummheit oder dem Spieltrieb der Chefs zuzuschreiben
        aber lassen wir sie halt...
        *)
        IF rang_forderer=rang_geforderter THEN
          (* gar nichts *)
        ELSE                    (* IF rang_forderer=rang_geforderter *)
          (* Zunchst verlt der forderer seinen Platz und wartet: *)
          forderer:=rang_feld[rang_forderer];
          IF rang_forderer>rang_geforderter THEN
            (*
            So soll es sein: der forderer will aufsteigen, sich also
            zu kleineren Rangnummern hocharbeiten. Dazu schieben
            wir zuerst einfach im rang_feld alle Eintrge, angefangen von
            rang_forderer-1 bis zu rang_geforderter um eine Position
            zu greren Indizes hin.
            *)
            FOR index:=rang_forderer-1 TO rang_geforderter BY -1 DO
              rang_feld[index+1]:=rang_feld[index];
            END;

            (*
            Am Ende darf der forderer seinen angestrebten Platz
            einnehmen:
            *)
            rang_feld[rang_geforderter]:=forderer;
          ELSE                  (* IF rang_forderer<rang_geforderter *)
            (*
            O.k., scheint eine administrative Korrektur der Rangliste
            anzustehen. Tun wir's.
            *)
            FOR index:=rang_forderer+1 TO rang_geforderter BY 1 DO
              rang_feld[index-1]:=rang_feld[index];
            END;
            rang_feld[rang_geforderter]:=forderer;
          END;                  (* ELSE rang_forderer<rang_geforderter *)
        END;                    (* ELSE rang_forderer=rang_geforderter *)

        (*
        Das rang_feld wre umgestellt. Jetzt mssen wir diese Information
        in die 'Wirklichkeit' zurckschreiben, d.h. der spieler_rang
        mu entsprechend angepat werden. Beim Erstellen des rang_feld
        wurden genau alle aktiven Spieler, die einen vernnftigen Rang
        hatten bercksichtigt. Durch die Schiebereien oben wurde weder
        die Anzahl dieser Spieler noch deren Zusammensetzung verndert,
        d.h. genau jeder einzelne Spieler, der vorher im rang_feld war,
        ist jetzt auch wieder drin. Es wird also ausreichen, einfach
        das rang_feld abzuklappern und immer, wenn ein Eintrag ungleich
        der Vorbesetzung (-1) ist, werden wir diesen Wert zum Indizieren
        in spieler_rang verwenden und den Index im rang_feld einfach
        als (neuen) Rang eintragen.
        *)
        FOR index:=0 TO max_spieler_anz-1 DO
          IF rang_feld[index]<>-1 THEN
            sd1.spieler_rang[rang_feld[index]]:=index+1;
          END;
        END;                    (* FOR index *)

        IF try_put_season_data(season_name, sd1, 1) THEN
          schreib_page12_oder_24(sd1, TRUE);
        ELSE                    (* IF try_put_season_data... *)
          schreib_page_info(sd1,
                            'Daten konnten nicht aktualisiert werden!',
                            'Spter nochmal probieren, ggf. dem Programmierer drohen!',
                            dunkelrot);
        END;                    (* ELSE try_put_season_data... *)
      ELSE                      (* IF ist_kennwort_ok(i_chef) *)
        schreib_page_accept(sd1,
                            'Wir haben doch nicht etwa ein Problem mit dem Chef-Kennwort?',
                            'Groer Mist', dunkelrot, p8ac5);
      END;                      (* ELSE ist_kennwort_ok(i_chef) *)
    END act_p25ac1;

  PROCEDURE act_p25ac2;
    BEGIN                       (* PROCEDURE act_p25ac2 *)
      (*
      Der nicht-OK-Button auf page25 wurde gedrckt. Wird die Pyramide
      eben nicht editiert.
      Wahrscheinlich will der Mensch aber trotzdem wieder zur Pyramide
      zurck, bittesehr:
      *)
      schreib_page12_oder_24(sd1, TRUE);
    END act_p25ac2;

  PROCEDURE act_p26ac1;
    BEGIN                       (* PROCEDURE act_p26ac1 *)
      (*
      Der OK-Button auf page26 wurde gedrckt. Es sollen also die Persdata
      gendert werden. Zuerst sehen wir nach, welchen Wert die
      court_belegung hat. court_belegung ist hier nicht eine tatschliche
      Belegung eines Courts, sondern nur der Index desjenigen, dessen Persdata
      gendert werden sollen. Wir fhren im wesentlichen einen
      Rangecheck fr die court_belegung durch und rufen dann ggf. die nchste
      Seite zum Editieren derselben auf. Allerdings mu dazu ein korrektes
      Kennwort eingegeben worden sein.
      *)

      belegung_client:=input[ii03].value;
      IF (NOT(belegung_client>=ssa) OR
          (sd1.spieler_aktiv[belegung_client]<>sp_aktiv_ja)) THEN
        schreib_page_accept(sd1,
                            'Es wurde keine gltige Auswahl getroffen!',
                            'Nochmal', dunkelrot, p4ac10);
      ELSE                      (* IF NOT((belegung_client... *)
        IF (ist_kennwort_ok(belegung_client) OR ist_kennwort_ok(i_chefin) OR
            ist_kennwort_ok(i_chef)) THEN
          schreib_page27(sd1);
        ELSE                      (* IF (ist_kennwort_ok(belegung_client)... *)
          schreib_page_accept(sd1,
                              'Wir haben doch nicht etwa ein Problem mit dem Kennwort?',
                              'Groer Mist', dunkelrot, p4ac10);
        END;                      (* ELSE (ist_kennwort_ok(belegung_client)... *)
      END;                      (* ELSE NOT((belegung_client... *)
   END act_p26ac1;

  PROCEDURE act_p26ac2;
    BEGIN                       (* PROCEDURE act_p26ac2 *)
      (*
      Der nicht-OK-Button auf page26 wurde gedrckt.
      Wahrscheinlich will der User gleich zur Startseite zurck,
      daher zeigen wir wieder page01 an.
      *)
      schreib_page01(sd1);
    END act_p26ac2;

  PROCEDURE act_p27ac1;
    VAR
      spieler_index:            INTEGER;
      zwstr:                    String;

    BEGIN                       (* PROCEDURE act_p27ac1 *)
      (*
      Der OK-Button auf page27 wurde gedrckt. Es sollen also bereits
      editierte Persdata abgespeichert werden.
      *)
      spieler_index:=input[ii24].value;

      IF (ist_kennwort_ok(spieler_index) OR ist_kennwort_ok(i_chefin) OR
          ist_kennwort_ok(i_chef)) THEN
        (*
        Kennwort ist o.k., also knnen wir die neuen Persdata bernehmen:
        *)
        GetGPMString(zwstr, ii22);
        Assign(zwstr, sd1.spieler_pers_data[spieler_index]);
        IF try_put_season_data(season_name, sd1, 1) THEN
          Assign('Persnliche Daten fr ', zwstr);
          Append(sd1.spieler_name[spieler_index], zwstr);
          IF Length(sd1.spieler_pers_data[spieler_index])>0 THEN
            Append(' lauten: "', zwstr);
            Append(sd1.spieler_pers_data[spieler_index], zwstr);
            Append('"', zwstr);
          ELSE                  (* IF Length(sd1.spieler_pers_data... *)
            Append(' wurden gelscht, es werden auch keine E-Mails verschickt!', zwstr);
          END;                  (* ELSE Length(sd1.spieler_pers_data... *)
          schreib_page_accept(sd1, zwstr,
                              "Weiter geht's", dunkelgruen, p4ac7);
        ELSE                    (* IF try_put_season_data... *)
          schreib_page_info(sd1,
                            'Daten konnten nicht aktualisiert werden!',
                            'Spter nochmal probieren, ggf. dem Programmierer drohen!',
                            dunkelrot);
        END;                    (* ELSE try_put_season_data... *)
      ELSE                      (* IF (ist_kennwort_ok(spieler_index)... *)
        schreib_page_accept(sd1,
                            'Wir haben doch nicht etwa ein Problem mit dem Kennwort?',
                            'Groer Mist', dunkelrot, p4ac10);
      END;                      (* ELSE (ist_kennwort_ok(spieler_index)... *)
   END act_p27ac1;

  PROCEDURE act_p27ac2;
    BEGIN                       (* PROCEDURE act_p27ac2 *)
      (*
      Der nicht-OK-Button auf page27 wurde gedrckt.
      Wahrscheinlich will der User gleich zur Startseite zurck,
      daher zeigen wir wieder page01 an.
      *)
      schreib_page01(sd1);
    END act_p27ac2;

  PROCEDURE act_p28ac1;
    BEGIN                       (* PROCEDURE act_p28ac1 *)
      (*
      Der OK-Button auf page28 wurde gedrckt. Es soll also die Statistikseite
      angezeigt werden. Hier werden der Chef und die Chefin wie ganz normale
      User behandelt, d.h. sie haben, was das Azeigen der Statistikseite
      angeht, keine besonderen Rechte. Zuerst sehen wir nach, welchen Wert
      die court_belegung hat. court_belegung ist hier nicht eine tatschliche
      Belegung des Courts, sondern nur der Index desjenigen, der anzeigen will.
      Als erstes fhren wir aber einen Rangecheck fr die court_belegung durch.
      Der Chef, die Chefin und alle Spieler knnen ihre Meinung nur mit Kennwort
      abgeben. Im brigen knnen nur aktive Spieler anzeigenen. Diese Prfung machen
      wir gleich beim Rangecheck fr die court_belegung mit.
      *)

      belegung_client:=input[ii03].value;
      IF (NOT((belegung_client=i_chef) OR (belegung_client=i_chefin) OR 
              (belegung_client>=ssa)) OR
          (sd1.spieler_aktiv[belegung_client]<>sp_aktiv_ja)) THEN
        schreib_page_accept(sd1,
                            'Es wurde keine gltige Auswahl getroffen!',
                            'Nochmal', dunkelrot, p4ac11);
      ELSE                      (* IF (NOT((belegung_client=i_chef)... *)
        IF (ist_kennwort_ok(belegung_client)) THEN
          (*
          Das Kennwort ist o.k., d.h. wir werden die Statistikseite anzeigen
          *)
          schreib_page29(sd1);
        ELSE                    (* IF ist_kennwort_ok(belegung_client) *)
          schreib_page_accept(sd1,
                              'Wir haben doch nicht etwa ein Problem mit dem Kennwort?',
                              'Groer Mist', dunkelrot, p4ac11);
        END;                    (* ELSE ist_kennwort_ok(belegung_client) *)
      END;                      (* ELSE (belegung_client<i_chef) *)
   END act_p28ac1;

  PROCEDURE act_p28ac2;
    BEGIN                       (* PROCEDURE act_p28ac2 *)
      (*
      Der nicht-OK-Button auf page28 wurde gedrckt.
      Wahrscheinlich will der User gleich zur Startseite zurck,
      daher zeigen wir wieder page01 an.
      *)
      schreib_page01(sd1);
    END act_p28ac2;

  BEGIN                         (* PROCEDURE process_user_post_action *)
    CASE input[ii04].value OF   (* input[ii04].value ist die action *)
      | p1ac0:
          act_p1ac0;

      | p1ac1:
          act_p1ac1;

      | p1ac2:
          act_p1ac2;

      | p1ac3:
          act_p1ac3;

      | p2ac1:
          act_p2ac1;

      | p2ac2:
          act_p2ac2;
 
      | p3ac1:
          act_p3ac1;

      | p3ac2:
          act_p3ac2;

      | p4ac1:
          act_p4ac1;

      | p4ac4:
          act_p4ac4;

      | p4ac5:
          act_p4ac5;

      | p4ac6:
          act_p4ac6;

      | p4ac7:
          act_p4ac7;

      | p4ac8:
          act_p4ac8;

      | p4ac9:
          act_p4ac9;

      | p4ac10:
          act_p4ac10;

      | p4ac11:
          act_p4ac11;

      | p8ac1:
          act_p8ac1;

      | p8ac2:
          act_p8ac2;

      | p8ac3:
          act_p8ac3;

      | p8ac4:
          act_p8ac4;

      | p8ac5:
          act_p8ac5;

      | p8ac6:
          act_p8ac6;

      | p8ac7:
          act_p8ac7;

      | p8ac8:
          act_p8ac8;

      | p8ac9:
          act_p8ac9;

      | p8ac10:
          act_p8ac10;

      | p8ac11:
          act_p8ac11;

      | p9ac1:
          act_p9ac1;

      | p9ac2:
          act_p9ac2;

      | p13ac1:
          act_p13ac1;

      | p13ac2:
          act_p13ac2;

      | p19ac1:
          act_p19ac1;

      | p19ac2:
          act_p19ac2;

      | p20ac1:
          act_p20ac1;

      | p20ac2:
          act_p20ac2;

      | p21ac1:
          act_p21ac1;

      | p21ac2:
          act_p21ac2;

      | p25ac1:
          act_p25ac1;

      | p25ac2:
          act_p25ac2;

      | p26ac1:
          act_p26ac1;

      | p26ac2:
          act_p26ac2;

      | p27ac1:
          act_p27ac1;

      | p27ac2:
          act_p27ac2;

      | p28ac1:
          act_p28ac1;

      | p28ac2:
          act_p28ac2;

      | ELSE
          schreib_page_accept(sd1,
                              'process_user_post_action: Unerwartete Aktion!',
                              "Weiter geht's", dunkelrot, p4ac1);
    END;                        (* CASE input[ii04].value *)
  END process_user_post_action;


PROCEDURE process_user_get_action;
  PROCEDURE act_p0ac1;
    BEGIN                       (* PROCEDURE act_p0ac1 *)
      (*
      Es wurde die Betriebssystem-Werbung gedrckt:
      *)
      schreib_page_sys_info(sd1, p4ac1);
    END act_p0ac1;

  PROCEDURE act_p0ac2;
    BEGIN                       (* PROCEDURE act_p0ac2 *)
      (*
      Es wurde die Webserver-Werbung gedrckt:
      *)
      schreib_page_wsv_info(sd1, p4ac1);
    END act_p0ac2;

  PROCEDURE act_p12ac1;
    BEGIN                       (* PROCEDURE act_p12ac1 *)
      (*
      Es wurde ein Spielerlink in der frischen Rangliste gedrckt.
      Fhrt anschlieend zum zweiten Teil der Ranglistenbearbeitung.
      *)
      schreib_page12_oder_24(sd1, FALSE);
    END act_p12ac1;

  PROCEDURE act_p24ac1;
    BEGIN                       (* PROCEDURE act_p12ac1 *)
      (*
      Es wurde ein Spielerlink in der zweiten Rangliste gedrckt.
      Jetzt sollten forderer und geforderter bekannt sein, so da
      nun die Chefs auf page25 die Vernderung genehmigen oder
      ablehnen knnen.
      *)
      schreib_page25(sd1);
    END act_p24ac1;

  BEGIN                         (* PROCEDURE process_user_get_action *)
    CASE input[ii04].value OF   (* input[ii04].value ist die action *)
      | p0ac1:
          act_p0ac1;

      | p0ac2:
          act_p0ac2;

      | p12ac1:
          act_p12ac1;

      | p24ac1:
          act_p24ac1;

      | ELSE
          schreib_page_accept(sd1,
                              'process_user_get_action: Unerwartete Aktion!',
                              "Weiter geht's", dunkelrot, p4ac1);
    END;                        (* CASE input[ii04].value *)
  END process_user_get_action;


PROCEDURE decide_on_seastate;
  (*
  Wir wollen einige Adminseiten vor neugierigen Blicken schtzen.
  Einen Anfang machen die pages 07, 14, 15, 16 und 17.
  *)
  BEGIN                         (* PROCEDURE decide_on_seastate *)
    CASE sd1.sea_state OF
      | sea_state1:
          schreib_page06_oder_22;

      | sea_state2:
          IF ist_kennwort_ok(i_chef) THEN
            schreib_page07(sd1);
          ELSE                  (* IF ist_kennwort_ok(i_chef) *)
            schreib_page30(sd1);
          END;                  (* ELSE ist_kennwort_ok(i_chef) *)

      | sea_state3:
          IF ist_kennwort_ok(i_chef) THEN
            schreib_page14(sd1);
          ELSE                  (* IF ist_kennwort_ok(i_chef) *)
            schreib_page30(sd1);
          END;                  (* ELSE ist_kennwort_ok(i_chef) *)

      | sea_state4:
          IF ist_kennwort_ok(i_chef) THEN
            schreib_page15(sd1);
          ELSE                  (* IF ist_kennwort_ok(i_chef) *)
            schreib_page30(sd1);
          END;                  (* ELSE ist_kennwort_ok(i_chef) *)

      | sea_state5:
          IF ist_kennwort_ok(i_chef) THEN
            schreib_page16(sd1);
          ELSE                  (* IF ist_kennwort_ok(i_chef) *)
            schreib_page30(sd1);
          END;                  (* ELSE ist_kennwort_ok(i_chef) *)

      | sea_state6:
          IF ist_kennwort_ok(i_chef) THEN
            schreib_page17(sd1);
          ELSE                  (* IF ist_kennwort_ok(i_chef) *)
            schreib_page30(sd1);
          END;                  (* ELSE ist_kennwort_ok(i_chef) *)

      | ELSE
          schreib_page_info(sd1,
                            'Unerwarteter Wert fr sd1.sea_state!',
                            'Ggf. dem Programmierer drohen!', dunkelrot);
    END;                        (* CASE sd1.sea_state *)
  END decide_on_seastate;


PROCEDURE process_admin_post_action;
  PROCEDURE act_p4ac2;
    BEGIN                       (* PROCEDURE act_p4ac2 *)
      decide_on_seastate;
    END act_p4ac2;

  PROCEDURE act_p4ac9;
    BEGIN                       (* PROCEDURE act_p4ac9 *)
      (*
      Es wurde soeben ein altes Lockfile gelscht oder es gab ein
      Problem in calc_integers und wir sind daraufhin im Adminmodus/
      Wartungszyklus gelandet, d.h. wir lassen wieder den 'seastate'
      entscheiden.
      *)
      decide_on_seastate;
    END act_p4ac9;

  PROCEDURE act_p6ac1;
    BEGIN                       (* PROCEDURE act_p6ac1 *)
      (*
      Der OK-Button auf page06 wurde gedrckt. Falls das Kennwort nicht OK
      ist, gibt's eine ordentliche Fehlermeldung. Im anderen Fall 
      speichern wir das Default-season-File ab, und machen dann weiter.
      *)
      IF ist_kennwort_ok(i_chef) THEN
        (*
        Ein Default-season-File soll abgespeichert werden. Dies
        erlauben wir nur, wenn sea_state momentan den Wert sea_state1
        hat, weil nmlich genau dann noch kein season-File existiert:
        *)
        IF sd1.sea_state=sea_state1 THEN
          (*
          Nun also: das Default-season-File abspeichern, aber vorher
          noch sd1.sea_state auf neuen Wert bringen: 
          *)
          sd1.sea_state:=sea_state2;
          IF try_put_season_data(season_name, sd1, 1) THEN
            decide_on_seastate;
          ELSE                  (* IF try_put_season_data... *)
            schreib_page_info(sd1,
                              'Default-Datenbasis konnte nicht angelegt werden!',
                              'Spter nochmal probieren, ggf. dem Programmierer drohen!',
                              dunkelrot);
          END;                  (* ELSE try_put_season_data... *)
        ELSE                    (* IF sd1.sea_state=sea_state1 *)
          schreib_page_accept(sd1,
                              'bermittelte Daten und Datenbasis waren nicht konsistent!',
                              "Weiter geht's", dunkelrot, p4ac2);
        END;                    (* ELSE sd1.sea_state=sea_state1 *)
      ELSE                      (* IF ist_kennwort_ok(i_chef) *)
        schreib_page_accept(sd1,
                            'Wir haben doch nicht etwa ein Problem mit dem Chef-Kennwort?',
                            'Groer Mist', dunkelrot, p4ac2);
      END;                      (* ELSE ist_kennwort_ok(i_chef) *)
    END act_p6ac1;

  PROCEDURE act_p6ac2;
    BEGIN                       (* PROCEDURE act_p6ac2 *)
      (*
      Der nicht-OK-Button auf page06 wurde gedrckt. Nachdem also kein
      season-File da ist, der Administrator aber auch keines anlegen
      will/kann, lassen wir es mit einer schnden Bemerkung gut sein:
      *)
      schreib_page_accept(sd1,
                          'Ohne Datanbasis geht leider gar nichts!',
                          'Ok, dann halt nochmal', dunkelrot, p4ac2);
    END act_p6ac2;

  PROCEDURE analyse_globals_and_react(VAR sd: sd_rec_typ; VAR ok: BOOLEAN;
                                      VAR text: ARRAY OF CHAR);
    VAR
      season_start_woche_neu:   INTEGER;
      season_start_neu:         INTEGER;
      structTime_max:           DateTime;
      woy_max:                  INTEGER;

    BEGIN                       (* PROCEDURE analyse_globals_and_react *)
      WITH sd DO
        (*
        Hier werden wir prfen, ob tatschlich neue Werte angekommen
        sind oder nicht und dann entsprechend reagieren. ok und text
        dienen dazu, nach Ablauf von analyse_globals_and_react bei
        Bedarf eine schne Fehlermeldung ausgeben zu knnen.
        *)
        ok:=TRUE;
        Assign('ok!', text);

        IF zeil_anz<>input[ii10].value THEN
          zeil_anz:=input[ii10].value;
          (*
          Falls sich die zeil_anz gendert haben sollte, werden
          wir die gesamte Courtbelegung rcksetzen und alle Courts
          werden als nicht unser Court markiert.
          *)
          reset_court_belegung(sd);
          reset_uns_courts(sd);
        END;                    (* IF zeil_anz<>input[ii10].value *)

        IF spalt_anz<>input[ii11].value THEN
          spalt_anz:=input[ii11].value;
          (*
          Falls sich die spalt_anz gendert haben sollte, werden
          wir die gesamte Courtbelegung rcksetzen und alle Courts
          werden als nicht unser Court markiert.
          *)
          reset_court_belegung(sd);
          reset_uns_courts(sd);
        END;                    (* IF spalt_anz<>input[ii11].value *)

        spieler_anz:=input[ii12].value;

        (*
        Bevor wir JahrKwToLUWN aufrufen, prfen wir zum Spa, ob das
        Startjahr auch wirkich mindestens so viele Wochen hat, wie
        der User meint. Je nach Jahr sind das dann maximal 52 oder 53,
        wenn wir das richtig sehen. Das Maximum fr die Startwoche ist
        also flexibel und wir werden hier auf korrekte Eingabe prfen.
        Bemerkung: Eingabewerte fr season_start_woche grer
        max_season_start_woche werden schon in calc_integers abgefangen.
        Bei max_season_start_woche=53 gibt's also nur im Falle woy_max=52
        eine extraschne Fehlermerlung, falls input[ii14].value zu gro ist.
        brigens: woy_max finden wir nicht einfach am 31.12., wie wir
        zunchst dmmlicherweise codiert hatten, sondern ggf. schon eine
        Woche vorher, weil ja die letzte Woche des Jahres u.U. bereits als
        Woche 1 des folgenden Jahres gelten kann!
        *)
        WITH structTime_max DO
          year:=input[ii13].value;      
          month:=12;
          day:=31;
          hour:=0;
          minute:=0;
          second:=0;
          fractions:=0;
          zone:=0;
          summerTimeFlag:=FALSE;
        END;                    (* WITH structTime_max *)
        woy_max:=LWeekOfYear(structTime_max);
        IF woy_max=1 THEN
          structTime_max.day:=24;
          woy_max:=LWeekOfYear(structTime_max);
        END;                    (* IF woy_max=1 *)

        IF woy_max>=input[ii14].value THEN
          JahrKwToLUWN(input[ii13].value, input[ii14].value, season_start_neu);
          IF season_start<>season_start_neu THEN
            season_start:=season_start_neu;
            (*
            Falls sich der season_start gendert haben sollte, werden
            wir die gesamte Courtbelegung rcksetzen.
            *)
            reset_court_belegung(sd);
          END;                  (* IF season_start<>season_start_neu *)
        ELSE                    (* IF woy_max>=input[ii14].value *)
          ok:=FALSE;
          Assign('Gewnschter Wert fr "Saisonstart, KW" war zu gro!', text);
        END;                    (* ELSE woy_max>=input[ii14].value *)

        wochen_anz:=input[ii15].value;

        show_future_kw:=input[ii25].value;
        bitleiste:=input[ii26].value;

        GetGPMString(zusatz_heading, ii27);

        sea_state:=sea_state3;
      END;                      (* WITH sd *)
    END analyse_globals_and_react;

  PROCEDURE act_p7ac1;
    VAR
      ok:                       BOOLEAN;
      text:                     String;

    BEGIN                       (* PROCEDURE act_p7ac1 *)
      (*
      Der OK-Button auf page07 wurde gedrckt. Falls das Kennwort nicht OK
      ist, gibt's eine ordentliche Fehlermeldung. Im anderen Fall 
      tun wir hier einen weiteren Schritt in der Wartung des season-Files.
      *)
      IF ist_kennwort_ok(i_chef) THEN
        (*
        Ein (modifziertes) season-File soll abgespeichert werden. Dies
        erlauben wir nur, wenn sea_state momentan den Wert sea_state2
        hat:
        *)
        IF sd1.sea_state=sea_state2 THEN
          (*
          Nun also: vom Client empfangene Daten analysieren und
          verarbeiten:
          *)
          analyse_globals_and_react(sd1, ok, text);
          (*
          Falls keine Probleme bei der Analyse und der anschlieenden
          Reaktion auf evtl. genderte Daten auftraten, wird versucht,
          das neue season-File zu schreiben. Im anderen Fall gibt's
          (wie immer) eine entsprechende Fehlermeldung.
          *)
          IF ok THEN
            IF try_put_season_data(season_name, sd1, 1) THEN
              decide_on_seastate;
            ELSE                (* IF try_put_season_data... *)
              schreib_page_info(sd1,
                                'Daten konnten nicht aktualisiert werden!',
                                'Spter nochmal probieren, ggf. dem Programmierer drohen!',
                                dunkelrot);
            END;                (* ELSE try_put_season_data... *)
          ELSE                  (* IF ok *)
            schreib_page_accept(sd1,
                                text, 'Groer Mist', dunkelrot, p4ac2);
          END;                  (* ELSE ok *)
        ELSE                    (* IF sd1.sea_state=sea_state2 *)
          schreib_page_accept(sd1,
                              'bermittelte Daten und Datenbasis waren nicht konsistent!',
                              "Weiter geht's", dunkelrot, p4ac2);
        END;                    (* ELSE sd1.sea_state=sea_state2 *)
      ELSE                      (* IF ist_kennwort_ok(i_chef) *)
        schreib_page_accept(sd1,
                            'Wir haben doch nicht etwa ein Problem mit dem Chef-Kennwort?',
                            'Groer Mist', dunkelrot, p4ac2);
      END;                      (* ELSE ist_kennwort_ok(i_chef) *)
    END act_p7ac1;

  PROCEDURE act_p7ac2;
    BEGIN                       (* PROCEDURE act_p7ac2 *)
      (*
      Der nicht-OK-Button auf page07 wurde gedrckt. Nachdem das season-
      File im Wartungsmodus ist, der Administrator aber nichts weiter
      machen will/kann, lassen wir es mit einer schnden Bemerkung gut sein:
      *)
      schreib_page_accept(sd1,
                          'Ohne weitere Wartung der Datanbasis geht leider gar nichts!',
                          'Ok, dann halt weiter', dunkelrot, p4ac2);
    END act_p7ac2;

  PROCEDURE analyse_layout_and_react(VAR sd: sd_rec_typ; VAR ok: BOOLEAN;
                                     VAR text: ARRAY OF CHAR);
    VAR
      i, j, i_start, k:         INTEGER;
      court_index:              INTEGER;
      ungleich:                 BOOLEAN;

    BEGIN                       (* PROCEDURE analyse_layout_and_react *)
      WITH sd DO
        ok:=TRUE;
        Assign('ok!', text);

        (*
        Hier bernehmen wir die neu angekommenen 'Zeilenberschriften'.
        Wir testen dabei gleich, ob der Chef eine nderung am Wochentag
        vorgenommen hat, die Daten im season-File also anders sind, als
        die Daten, die der Client schickt.
        *)
        ungleich:=FALSE;
        i_start:=max_basic_param_anz;
        FOR i:=0 TO zeil_anz-1 DO
          WITH input[i+i_start] DO
            IF wochentag[i]<>value THEN
              wochentag[i]:=value;
              ungleich:=TRUE;
            END;                (* IF wochentag[i]<>value *)
          END;                  (* WITH input[... *)
        END;                    (* FOR i *)

        (*
        Falls nicht alle Wochentage gleich geblieben sind, werden
        wir die gesamte Courtbelegung rcksetzen.
        *)
        IF ungleich THEN
          reset_court_belegung(sd);
        END;                    (* IF ungleich *)

        (*
        Eventuelle nderungen am Platznamen sind uns Wurscht. Hier
        gehen wir davon aus, da u.U. eine Rechtschreibkorrektur
        stattfinden hat sollen. Im Gegensatz zum Wochentag (und zur
        anschlieend zu behandelnden Uhrzeit) mu hier direkt ein
        Text eingegeben werden und da knnte eben mal ein Rechtschreib-
        fehler aufgetreten sein, den man ohne gravierende Folgen
        berichtigen knnen sollte.
        *)
        i_start:=max_basic_param_anz+max_zeil_anz;
        FOR i:=0 TO zeil_anz-1 DO
          GetGPMString(court[i], i+i_start);
        END;                    (* FOR i *)

        (*
        Hier bernehmen wir die neu angekommenen Spaltenberschriften.
        Wir testen dabei gleich, ob der Chef eine nderung an der Uhrzeit
        vorgenommen hat, die Daten im season-File also anders sind, als
        die Daten die der Client schickt.
        *)

        ungleich:=FALSE;
        i_start:=max_basic_param_anz+2*max_zeil_anz;
        FOR i:=0 TO spalt_anz-1 DO
          WITH input[i+i_start] DO
            IF uhrzeit[i]<>value THEN
              uhrzeit[i]:=value;
              ungleich:=TRUE;
            END;                (* IF uhrzeit[i]<>value *)
          END;                  (* WITH input[... *)
        END;                    (* FOR i *)

        (*
        Falls nicht alle Uhrzeiten gleich geblieben sind, werden
        wir die gesamte Courtbelegung rcksetzen.
        *)
        IF ungleich THEN
          reset_court_belegung(sd);
        END;                    (* IF ungleich *)

        (*
        Hier bernehmen wir die neu angekommenen Spielpltze.
        *)
        k:=0;

        ungleich:=FALSE;
        FOR i:=0 TO zeil_anz-1 DO
          i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
                   i*max_spalt_anz;
          FOR j:=0 TO spalt_anz-1 DO
            court_index:=2*(i*spalt_anz+j);
            (*
            input[j+i_start].value=1 heit: es ist unser Court.
            *)
            IF input[j+i_start].value=1 THEN
              geschrumpfter_index[k]:=court_index;
              IF uns_court[court_index]<>k THEN
                uns_court[court_index]:=k;
                ungleich:=TRUE;
              END;              (* IF uns_court[court_index]<>k *)
              k:=k+1;

              geschrumpfter_index[k]:=court_index+1;
              IF uns_court[court_index+1]<>k THEN
                uns_court[court_index+1]:=k;
                ungleich:=TRUE;
              END;              (* IF uns_court[court_index+1]<>k *)
              k:=k+1;
            ELSE                (* IF input[... *)
              IF uns_court[court_index]<>-1 THEN
                uns_court[court_index]:=-1;
                ungleich:=TRUE;
              END;              (* IF uns_court[court_index]<>-1 *)

              IF uns_court[court_index+1]<>-1 THEN
                uns_court[court_index+1]:=-1;
                ungleich:=TRUE;
              END;              (* IF uns_court[court_index+1]<>-1 *)
            END;                (* ELSE input[... *)
          END;                  (* FOR j *)
        END;                    (* FOR i *)
        uns_courts_anz:=k DIV 2;

        (*
        Falls nicht alle unsere Courts gleich geblieben sind, werden
        wir die gesamte Courtbelegung rcksetzen.
        *)
        IF ungleich THEN
          reset_court_belegung(sd);
        END;                    (* IF ungleich *)

        sea_state:=sea_state4;
      END;                      (* WITH sd *)
    END analyse_layout_and_react;

  PROCEDURE act_p14ac1;
    VAR
      ok:                       BOOLEAN;
      text:                     String;

    BEGIN                       (* PROCEDURE act_p14ac1 *)
      (*
      Der OK-Button auf page14 wurde gedrckt. Falls das Kennwort nicht OK
      ist, gibt's eine ordentliche Fehlermeldung. Im anderen Fall 
      tun wir hier einen weiteren Schritt in der Wartung des season-Files.
      *)
      IF ist_kennwort_ok(i_chef) THEN
        (*
        Ein (modifziertes) season-File soll abgespeichert werden. Dies
        erlauben wir nur, wenn sea_state momentan den Wert sea_state3
        hat:
        *)
        IF sd1.sea_state=sea_state3 THEN
          (*
          Nun also: vom Client empfangene Daten analysieren und
          verarbeiten:
          *)
          analyse_layout_and_react(sd1, ok, text);
          (*
          Falls keine Probleme bei der Analyse und der anschlieenden
          Reaktion auf evtl. genderte Daten auftraten, wird versucht,
          das neue season-File zu schreiben. Im anderen Fall gibt's
          (wie immer) eine entsprechende Fehlermeldung.
          *)
          IF ok THEN
            IF try_put_season_data(season_name, sd1, 1) THEN
              decide_on_seastate;
            ELSE                (* IF try_put_season_data... *)
              schreib_page_info(sd1,
                                'Daten konnten nicht aktualisiert werden!',
                                'Spter nochmal probieren, ggf. dem Programmierer drohen!',
                                dunkelrot);
            END;                (* ELSE try_put_season_data... *)
          ELSE                  (* IF ok *)
            schreib_page_accept(sd1,
                                text, 'Groer Mist', dunkelrot, p4ac2);
          END;                  (* ELSE ok *)
        ELSE                    (* IF sd1.sea_state=sea_state3 *)
          schreib_page_accept(sd1,
                              'bermittelte Daten und Datenbasis waren nicht konsistent!',
                              "Weiter geht's", dunkelrot, p4ac2);
        END;                    (* ELSE sd1.sea_state=sea_state3 *)
      ELSE                      (* IF ist_kennwort_ok(i_chef) *)
        schreib_page_accept(sd1,
                            'Wir haben doch nicht etwa ein Problem mit dem Chef-Kennwort?',
                            'Groer Mist', dunkelrot, p4ac2);
      END;                      (* ELSE ist_kennwort_ok(i_chef) *)
    END act_p14ac1;

  PROCEDURE act_p14ac2;
    BEGIN                       (* PROCEDURE act_p14ac2 *)
      (*
      Der nicht-OK-Button auf page14 wurde gedrckt. Nachdem das season-
      File im Wartungsmodus ist, der Administrator aber nichts weiter
      machen will/kann, lassen wir es mit einer schnden Bemerkung gut sein:
      *)
      schreib_page_accept(sd1,
                          'Ohne weitere Wartung der Datanbasis geht leider gar nichts!',
                          'Ok, dann halt weiter', dunkelrot, p4ac2);
    END act_p14ac2;

  PROCEDURE analyse_spieler_and_react(VAR sd: sd_rec_typ; VAR ok: BOOLEAN;
                                      VAR text: ARRAY OF CHAR);
    VAR
      i, i_start:               INTEGER;
      str_ptr:                  StrPtrTyp;
      kennwstr:                 String;

    BEGIN                       (* PROCEDURE analyse_spieler_and_react *)
      WITH sd DO
        ok:=TRUE;
        Assign('ok!', text);

        (*
        Hier bernehmen wir die neu angekommenen Spielernamen.
        *)

        i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
                 max_zeil_anz*max_spalt_anz;
        FOR i:=0 TO spieler_anz-1 DO
          GetGPMString(spieler_name[i+ssa], i+i_start);
        END;                    (* FOR i *)

        (*
        Hier bernehmen wir die neu angekommenen Spielerpersdata.
        *)

        i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
                 max_zeil_anz*max_spalt_anz+5*max_spieler_anz+
                 max_wochen_anz;
        FOR i:=0 TO spieler_anz-1 DO
          GetGPMString(spieler_pers_data[i+ssa], i+i_start);
        END;                    (* FOR i *)

        (*
        Hier bernehmen wir die neu angekommenen Spielertypen.
        value=1 heit: es ist ein 14-tgiger Spieler.
        *)

        i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
                 max_zeil_anz*max_spalt_anz+max_spieler_anz;
        FOR i:=0 TO spieler_anz-1 DO
          WITH input[i+i_start] DO
            IF value=1 THEN spieler_art[i+ssa]:=sp_art_14t ELSE
              spieler_art[i+ssa]:=sp_art_woe; END;
          END;                  (* WITH input[... *)
        END;                    (* FOR i *)

        (*
        Hier bernehmen wir die neu angekommenen 'Spieleraktivitten'.
        value=1 heit: Spieler ist aktiv.
        *)

        i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
                 max_zeil_anz*max_spalt_anz+2*max_spieler_anz;
        FOR i:=0 TO spieler_anz-1 DO
          WITH input[i+i_start] DO
            IF value=1 THEN spieler_aktiv[i+ssa]:=sp_aktiv_ja ELSE
              spieler_aktiv[i+ssa]:=sp_aktiv_nein; END;
          END;                  (* WITH input[... *)
        END;                    (* FOR i *)

        (*
        Hier bernehmen wir die neu angekommenen Spielerrnge.
        *)

        i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
                 max_zeil_anz*max_spalt_anz+5*max_spieler_anz+
                 max_wochen_anz+max_spieler_anz;
        FOR i:=0 TO spieler_anz-1 DO
          WITH input[i+i_start] DO
            spieler_rang[i+ssa]:=value;
          END;                  (* WITH input[... *)
        END;                    (* FOR i *)

        (*
        Hier bernehmen wir die neu angekommenen 'Tage voraus'.
        *)

        i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
                 max_zeil_anz*max_spalt_anz+5*max_spieler_anz+
                 max_wochen_anz+2*max_spieler_anz;
        FOR i:=0 TO spieler_anz-1 DO
          WITH input[i+i_start] DO
            max_day_delta[i+ssa]:=value;
          END;                  (* WITH input[... *)
        END;                    (* FOR i *)

        (*
        Hier bernehmen wir neu angekommene Kennwrter, falls beantragt.
        value=1 heit: Eintragung eines Kennworts ist beantragt.
        brigens verzichten wir auf doppelte Eingabe, wie das sonst
        so blich ist, weil wir dem Chef die Kennwrter auch richtig
        anzeigen. Mu er sich halt fr die 5 Minuten in sein un-
        beobachtetes Kmmerlein verdrcken.
        *)

        i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
                 max_zeil_anz*max_spalt_anz+4*max_spieler_anz;
        FOR i:=0 TO spieler_anz-1 DO
          WITH input[i+i_start] DO
            IF value=1 THEN
              (*
              Es soll also ein neues Kennwort eingetragen werden.
              Dazu mssen wir uns erst einmal das entsprechende
              unverschlsselte Kennwort aus dem geeigneten input-
              Parameter besorgen (liegt halt max_spieler_anz
              weiter vorne im Array):
              *)
              GetGPMString(kennwstr, i+i_start-max_spieler_anz);
              str_ptr:=Unix.Crypt(kennwstr, '00');
              spieler_kennwort[i+ssa]:=str_ptr^;
            END;                (* IF value=1 *)
          END;                  (* WITH input[... *)
        END;                    (* FOR i *)

        sea_state:=sea_state5;
      END;                      (* WITH sd *)
    END analyse_spieler_and_react;

  PROCEDURE act_p15ac1;
    VAR
      ok:                       BOOLEAN;
      text:                     String;

    BEGIN                       (* PROCEDURE act_p15ac1 *)
      (*
      Der OK-Button auf page15 wurde gedrckt. Falls das Kennwort nicht OK
      ist, gibt's eine ordentliche Fehlermeldung. Im anderen Fall 
      tun wir hier einen weiteren Schritt in der Wartung des season-Files.
      *)
      IF ist_kennwort_ok(i_chef) THEN
        (*
        Ein (modifziertes) season-File soll abgespeichert werden. Dies
        erlauben wir nur, wenn sea_state momentan den Wert sea_state4
        hat:
        *)
        IF sd1.sea_state=sea_state4 THEN
          (*
          Nun also: vom Client empfangene Daten analysieren und
          verarbeiten:
          *)
          analyse_spieler_and_react(sd1, ok, text);
          (*
          Falls keine Probleme bei der Analyse und der anschlieenden
          Reaktion auf evtl. genderte Daten auftraten, wird versucht,
          das neue season-File zu schreiben. Im anderen Fall gibt's
          (wie immer) eine entsprechende Fehlermeldung.
          *)
          IF ok THEN
            IF try_put_season_data(season_name, sd1, 1) THEN
              decide_on_seastate;
            ELSE                (* IF try_put_season_data... *)
              schreib_page_info(sd1,
                                'Daten konnten nicht aktualisiert werden!',
                                'Spter nochmal probieren, ggf. dem Programmierer drohen!',
                                dunkelrot);
            END;                (* ELSE try_put_season_data... *)
          ELSE                  (* IF ok *)
            schreib_page_accept(sd1,
                                text, 'Groer Mist', dunkelrot, p4ac2);
          END;                  (* ELSE ok *)
        ELSE                    (* IF sd1.sea_state=sea_state4 *)
          schreib_page_accept(sd1,
                              'bermittelte Daten und Datenbasis waren nicht konsistent!',
                              "Weiter geht's", dunkelrot, p4ac2);
        END;                    (* ELSE sd1.sea_state=sea_state4 *)
      ELSE                      (* IF ist_kennwort_ok(i_chef) *)
        schreib_page_accept(sd1,
                            'Wir haben doch nicht etwa ein Problem mit dem Chef-Kennwort?',
                            'Groer Mist', dunkelrot, p4ac2);
      END;                      (* ELSE ist_kennwort_ok(i_chef) *)
    END act_p15ac1;

  PROCEDURE act_p15ac2;
    BEGIN                       (* PROCEDURE act_p15ac2 *)
      (*
      Der nicht-OK-Button auf page15 wurde gedrckt. Nachdem das season-
      File im Wartungsmodus ist, der Administrator aber nichts weiter
      machen will/kann, lassen wir es mit einer schnden Bemerkung gut sein:
      *)
      schreib_page_accept(sd1,
                          'Ohne weitere Wartung der Datanbasis geht leider gar nichts!',
                          'Ok, dann halt weiter', dunkelrot, p4ac2);
    END act_p15ac2;


  PROCEDURE analyse_wochen_and_react(VAR sd: sd_rec_typ; VAR ok: BOOLEAN;
                                     VAR text: ARRAY OF CHAR);
    VAR
      i, i_start:               INTEGER;

    BEGIN                       (* PROCEDURE analyse_wochen_and_react *)
      WITH sd DO
        ok:=TRUE;
        Assign('ok!', text);

        (*
        Hier bernehmen wir die neu angekommenen jahr_wochen_zugriffe.
        *)

        i_start:=max_basic_param_anz+2*max_zeil_anz+max_spalt_anz+
                 max_zeil_anz*max_spalt_anz+5*max_spieler_anz;

        FOR i:=0 TO sd.wochen_anz-1 DO
          WITH input[i+i_start] DO
            jahr_wochen_zugriff[i]:=value;
          END;                  (* WITH input[... *)
        END;                    (* FOR wo_index *)

        sea_state:=sea_state6;
      END;                      (* WITH sd *)
    END analyse_wochen_and_react;

  PROCEDURE act_p16ac1;
    VAR
      ok:                       BOOLEAN;
      text:                     String;

    BEGIN                       (* PROCEDURE act_p16ac1 *)
      (*
      Der OK-Button auf page16 wurde gedrckt. Falls das Kennwort nicht OK
      ist, gibt's eine ordentliche Fehlermeldung. Im anderen Fall 
      tun wir hier einen weiteren Schritt in der Wartung des season-Files.
      *)
      IF ist_kennwort_ok(i_chef) THEN
        (*
        Ein (modifziertes) season-File soll abgespeichert werden. Dies
        erlauben wir nur, wenn sea_state momentan den Wert sea_state5
        hat:
        *)
        IF sd1.sea_state=sea_state5 THEN
          (*
          Nun also: vom Client empfangene Daten analysieren und
          verarbeiten:
          *)
          analyse_wochen_and_react(sd1, ok, text);
          (*
          Falls keine Probleme bei der Analyse und der anschlieenden
          Reaktion auf evtl. genderte Daten auftraten, wird versucht,
          das neue season-File zu schreiben. Im anderen Fall gibt's
          (wie immer) eine entsprechende Fehlermeldung.
          *)
          IF ok THEN
            IF try_put_season_data(season_name, sd1, 1) THEN
              decide_on_seastate;
            ELSE                (* IF try_put_season_data... *)
              schreib_page_info(sd1,
                                'Daten konnten nicht aktualisiert werden!',
                                'Spter nochmal probieren, ggf. dem Programmierer drohen!',
                                dunkelrot);
            END;                (* ELSE try_put_season_data... *)
          ELSE                  (* IF ok *)
            schreib_page_accept(sd1,
                                text, 'Groer Mist', dunkelrot, p4ac2);
          END;                  (* ELSE ok *)
        ELSE                    (* IF sd1.sea_state=sea_state5 *)
          schreib_page_accept(sd1,
                              'bermittelte Daten und Datenbasis waren nicht konsistent!',
                              "Weiter geht's", dunkelrot, p4ac2);
        END;                    (* ELSE sd1.sea_state=sea_state5 *)
      ELSE                      (* IF ist_kennwort_ok(i_chef) *)
        schreib_page_accept(sd1,
                            'Wir haben doch nicht etwa ein Problem mit dem Chef-Kennwort?',
                            'Groer Mist', dunkelrot, p4ac2);
      END;                      (* ELSE ist_kennwort_ok(i_chef) *)
    END act_p16ac1;

  PROCEDURE act_p16ac2;
    BEGIN                       (* PROCEDURE act_p16ac2 *)
      (*
      Der nicht-OK-Button auf page16 wurde gedrckt. Nachdem das season-
      File im Wartungsmodus ist, der Administrator aber nichts weiter
      machen will/kann, lassen wir es mit einer schnden Bemerkung gut sein:
      *)
      schreib_page_accept(sd1,
                          'Ohne weitere Wartung der Datanbasis geht leider gar nichts!',
                          'Ok, dann halt weiter', dunkelrot, p4ac2);
    END act_p16ac2;

  PROCEDURE act_p17ac1;
    BEGIN                       (* PROCEDURE act_p17ac1 *)
      (*
      Der OK-Button auf page17 wurde gedrckt. Falls das Kennwort nicht OK
      ist, gibt's eine ordentliche Fehlermeldung. Im anderen Fall 
      verlassen wir den Wartungsmodus.
      Man beachte, da schreib_page_accept wieder mit p4ac1 aufgerufen wird.
      Durch das Rcksetzen von sd1.sea_state auf sea_state0 befinden wir
      uns dann wieder im Usermodus und mit p4ac1 wird einfach wieder
      page01 dargestellt:
      *)
      IF ist_kennwort_ok(i_chef) THEN
        (*
        Der Wartungsmodus soll verlassen werden. Dies erlauben wir nur,
        wenn sea_state momentan den Wert sea_state6 hat:
        *)
        IF sd1.sea_state=sea_state6 THEN
          (*
          Nun also: sd1.sea_state auf 'Normalwert' bringen, so da
          der normale User wieder ran kommt: 
          *)
          sd1.sea_state:=sea_state0;
          IF try_put_season_data(season_name, sd1, 1) THEN
            schreib_page_accept(sd1,
                                'Damit sind wir wieder im Normalmodus!',
                                "Weiter geht's", dunkelgruen, p4ac1);
          ELSE                  (* IF try_put_season_data... *)
            schreib_page_info(sd1,
                              'Daten konnten nicht aktualisiert werden!',
                              'Spter nochmal probieren, ggf. dem Programmierer drohen!',
                              dunkelrot);
          END;                  (* ELSE try_put_season_data... *)
        ELSE                    (* IF sd1.sea_state=sea_state6 *)
          schreib_page_accept(sd1,
                              'bermittelte Daten und Datenbasis waren nicht konsistent!',
                              "Weiter geht's", dunkelrot, p4ac2);
        END;                    (* ELSE sd1.sea_state=sea_state6 *)
      ELSE                      (* IF ist_kennwort_ok(i_chef) *)
        schreib_page_accept(sd1,
                            'Wir haben doch nicht etwa ein Problem mit dem Chef-Kennwort?',
                            'Groer Mist', dunkelrot, p4ac2);
      END;                      (* ELSE ist_kennwort_ok(i_chef) *)
    END act_p17ac1;

  PROCEDURE act_p17ac2;
    BEGIN                       (* PROCEDURE act_p17ac2 *)
      (*
      Der nicht-OK-Button auf page17 wurde gedrckt. Nachdem also ein
      vollstndiger Wartungszyklus durchlaufen wurde aber der Wartungs-
      modus nicht beendet werden soll, beginnen wir einfach wieder von
      vorne. Dazu stellen wir den sea_state wieder auf sea_state2
      zurck und rufen dann page07 auf. Jedenfalls kann auf diese
      Weise nur der Chef den Wartungsmodus wieder verlassen.
      *)
      sd1.sea_state:=sea_state2;
      IF try_put_season_data(season_name, sd1, 1) THEN
        decide_on_seastate;
      ELSE                      (* IF try_put_season_data... *)
        schreib_page_info(sd1,
                          'Daten konnten nicht aktualisiert werden!',
                          'Spter nochmal probieren, ggf. dem Programmierer drohen!',
                          dunkelrot);
      END;                      (* ELSE try_put_season_data... *)
    END act_p17ac2;

  PROCEDURE act_p22ac1;
    BEGIN                       (* PROCEDURE act_p22ac1 *)
      backup_einspielen(p4ac2);
    END act_p22ac1;

  PROCEDURE act_p22ac2;
    BEGIN                       (* PROCEDURE act_p22ac2 *)
      (*
      Der nicht-OK-Button auf page22 wurde gedrckt. Wird eben
      kein Backup eingespielt. Also fragen wir nach, ob eine neue
      Datenbasis angelegt werden soll.
      *)
      schreib_page06(sd1);
    END act_p22ac2;

  PROCEDURE act_p30ac1;
    BEGIN                       (* PROCEDURE act_p30ac1 *)
      (*
      Der OK-Button auf page30 wurde gedrckt. Es soll also ein Einstieg
      in den (sich im Gange befindlichen) Wartungszyklus erfolgen.

      Falls das Kennwort OK ist, geht's sofort mit decide_on_seastate
      weiter. Klar, die nochmalige Abfrage in decide_on_seastate, ob das
      Chef-Kennwort o.k. ist bruchte man natrlich nicht aber wir haben
      halt so eine bequeme Mglichkeit, gleich die richtige Adminseite
      anzuzeigen, FALLS das Chef-Kennwort o.k. ist.
      
      Im anderen Fall gibt's eine ordentliche Fehlermeldung und es wird
      einfach ber p4ac2 (wieder ber decide_on_seastate) page30 ausgegeben,
      weil nun das Chef-Kennwort halt nicht o.k. ist und decide_on_seastate
      in dem Fall eben page30 ausgibt.
      *)
      IF ist_kennwort_ok(i_chef) THEN
        decide_on_seastate;
      ELSE                      (* IF ist_kennwort_ok(i_chef) *)
        schreib_page_accept(sd1,
                            'Wir haben doch nicht etwa ein Problem mit dem Chef-Kennwort?',
                            'Groer Mist', dunkelrot, p4ac2);
      END;                      (* ELSE ist_kennwort_ok(i_chef) *)
    END act_p30ac1;


  BEGIN                         (* PROCEDURE process_admin_post_action *)
    CASE input[ii04].value OF   (* input[ii04].value ist die action *)
      | p4ac2:
          act_p4ac2;

      | p4ac9:
          act_p4ac9;

      | p6ac1:
          act_p6ac1;

      | p6ac2:
          act_p6ac2;

      | p7ac1:
          act_p7ac1;

      | p7ac2:
          act_p7ac2;

      | p14ac1:
          act_p14ac1;

      | p14ac2:
          act_p14ac2;

      | p15ac1:
          act_p15ac1;

      | p15ac2:
          act_p15ac2;

      | p16ac1:
          act_p16ac1;

      | p16ac2:
          act_p16ac2;

      | p17ac1:
          act_p17ac1;

      | p17ac2:
          act_p17ac2;

      | p22ac1:
          act_p22ac1;

      | p22ac2:
          act_p22ac2;

      | p30ac1:
          act_p30ac1;

      | ELSE
          schreib_page_accept(sd1,
                              'process_admin_post_action: Unerwartete Aktion!',
                              "Weiter geht's", dunkelrot, p4ac2);
    END;                        (* CASE input[ii04].value *)
  END process_admin_post_action;


PROCEDURE process_admin_get_action;
  PROCEDURE act_p0ac1;
    BEGIN                       (* PROCEDURE act_p0ac1 *)
      (*
      Es wurde die Betriebssystem-Werbung gedrckt:
      *)
      schreib_page_sys_info(sd1, p4ac2);
    END act_p0ac1;

  PROCEDURE act_p0ac2;
    BEGIN                       (* PROCEDURE act_p0ac2 *)
      (*
      Es wurde die Webserver-Werbung gedrckt:
      *)
      schreib_page_wsv_info(sd1, p4ac2);
    END act_p0ac2;

  BEGIN                         (* PROCEDURE process_admin_get_action *)
    CASE input[ii04].value OF   (* input[ii04].value ist die action *)
      | p0ac1:
          act_p0ac1;

      | p0ac2:
          act_p0ac2;

      | ELSE
          schreib_page_accept(sd1,
                              'process_admin_get_action: Unerwartete Aktion!',
                              "Weiter geht's", dunkelrot, p4ac2);
    END;                        (* CASE input[ii04].value *)
  END process_admin_get_action;


PROCEDURE process_user_with_season_data;
  BEGIN                         (* PROCEDURE process_user_with_season_data *)
    (*
    Falls char_cnt=0 (das ist bei uns dann der Fall, wenn kein
    posting vorliegt *und* der QUERY_STRING leer ist), wurde das
    Script direkt aufgerufen. Wir werden in diesem Fall mit
    advance_ukw versuchen, schon mal die Anzeige auf die gewnschte
    Woche einzustellen und schlielich mit schreib_page01 die Anzeige
    zu machen. Falls char_cnt<>0, wurde das Script von einem FORM
    (unsere FORMs arbeiten immer mit POST) oder von GET aus
    aufgerufen. Dann wird in process_user_get_action bzw.
    process_user_post_action je nach erhaltenem action code
    weiterverfahren.
    *)
    IF char_cnt=0 THEN
      advance_ukw(sd1);
      schreib_page01(sd1);
    ELSE                        (* IF char_cnt=0 *)
      IF request_ist_post THEN
        process_user_post_action;
      ELSE                      (* IF request_ist_post *)
        process_user_get_action;
      END;                      (* ELSE request_ist_post *)
    END;                        (* ELSE char_cnt=0 *)
 END process_user_with_season_data;


PROCEDURE process_admin_with_season_data;
  BEGIN                         (* PROCEDURE process_admin_with_season_data *)
    (*
    Auch hier wollen wir unterscheiden, ob char_cnt=0 oder nicht:
    *)
    IF char_cnt=0 THEN
      advance_ukw(sd1);
      (*
      Je nach Zustand von sd1.sea_state machen wir beim
      entsprechenden Wartungsvorgang weiter:
      *)
      decide_on_seastate;
    ELSE                        (* IF char_cnt=0 *)
      IF request_ist_post THEN
        process_admin_post_action;
      ELSE                      (* IF request_ist_post *)
        process_admin_get_action;
      END;                      (* ELSE request_ist_post *)
    END;                        (* ELSE char_cnt=0 *)
  END process_admin_with_season_data;


PROCEDURE process_with_season_data;
  BEGIN                         (* PROCEDURE process_with_season_data *)
    (*
    Hinweis: calc_integers wird erst nach dem erfolgreichen Lesen des
    season-Files aufgerufen, da wir in calc_integers einen Rangecheck
    machen wollen, der von den Daten aus dem season-File abhngig ist.
    *)
    init_default_inputs2;
    try_get_or_postings;
    calc_integers;
    check_ukw(sd1);

    (*
    Jetzt ist es an der Zeit, unsere State-Variable zu testen. Normale
    User-Sachen werden nur gemacht, falls sea_state0 vorliegt.
    *)
    IF sd1.sea_state=sea_state0 THEN
      (*
      Der normale User hat das Sagen:
      *)
      process_user_with_season_data;
    ELSE                        (* IF sd1.sea_state=sea_state0 *)
      (*
      Der Administrator hat das Sagen:
      *)
      process_admin_with_season_data;
    END;                        (* ELSE sd1.sea_state=sea_state0 *)
  END process_with_season_data;


PROCEDURE there_is_a_season_file;
  VAR
    text1, text2:               String;
    booldummy:                  BOOLEAN;

  BEGIN                         (* PROCEDURE there_is_a_season_file *)
    (*
    Es ist ein season-File da. Wir versuchen, es zu lesen:
    *)
    IF try_get_season_data(season_name, sd1, text1) THEN
      (*
      Wir wollen in jedem Fall unseren schnen site_counter aktualisieren.
      Egal, ob spter noch eine sinnvolle nderung der Datenbasis
      stattfindet oder nicht, wird nach Inkrementieren des site_counter
      schon mal ein Update gemacht. Weil wir aber wegen dieses
      kleinen Spchens nicht gleich Milliarden Logfiles haben
      wollen, wird die Erzeugung derselben in diesem Falle einfach
      unterdrckt (macht die 0 als letzter Parameter in
      try_put_season_data).
      *)
      sd1.site_counter:=sd1.site_counter+1;
      booldummy:=try_put_season_data(season_name, sd1, 0);
      process_with_season_data;
    ELSE                        (* IF try_get_season_data... *)
      Assign('Datenbasis konnte nicht gelesen werden!', text2);
      Append(text1, text2);
      schreib_page_info(sd1, text2,
                        'Spter nochmal probieren, ggf. dem Programmierer drohen!',
                        dunkelrot);
    END;                        (* ELSE try_get_season_data... *)
  END there_is_a_season_file;


PROCEDURE there_is_no_season_file;
  BEGIN                         (* PROCEDURE there_is_no_season_file *)
    (*
    Es ist kein season-File da. Deshalb geben wir eine Aufforderung
    an den Administrator aus, sich zu entscheiden, ob er ein neues
    anlegen will oder sich doch nicht mehr an sein Kennwort erinnern
    kann. Die Grundinitialisierung ist bereits in reset_season_data
    erfolgt. Dort wurde sea_state=sea_state1 initialisiert, d.h. der
    Administrator hat das Sagen, bis alle Wartungsschritte durchgefhrt
    sind.
    Hinweis: calc_integers wird erst nach init_default_inputs2 aufgerufen,
    da wir in calc_integers einen Rangecheck machen wollen, der u.a. von
    den in init_default_inputs2 gesetzten Werten abhngig ist.
    *)
    init_default_inputs2;
    try_get_or_postings;
    calc_integers;

    (*
    Also: der Administrator hat das Sagen:

    Auch hier wollen wir unterscheiden, ob char_cnt=0 oder nicht:
    *)
    IF char_cnt=0 THEN
      advance_ukw(sd1);
      (*
      Je nach Zustand von sd1.sea_state machen wir beim
      entsprechenden Wartungsvorgang weiter. Hinweis:
      Natrlich kann hier nur gelten: sd1.sea_state=sea_state1,
      weil *kein* season-File da ist. Es wrde also reichen,
      einfach nur schreib_page06(sd1) aufzurufen. Weil wir aber die
      schne Routine decide_on_seastate schon mal haben, verwenden
      wir sie auch:
      *)
      decide_on_seastate;
    ELSE                        (* IF char_cnt=0 *)
      IF request_ist_post THEN
        process_admin_post_action;
      ELSE                      (* IF request_ist_post *)
        process_admin_get_action;
      END;                      (* ELSE request_ist_post *)
    END;                        (* ELSE char_cnt=0 *)
  END there_is_no_season_file;


PROCEDURE start_processing;
  BEGIN                         (* PROCEDURE start_processing *)
    (*
    Ein paar Grundinitialisierungen sind gemacht und das Lockfile steht.
    Jetzt seh'n wir doch mal nach, ob berhaupt ein season-File da ist.
    Falls ja, wird damit gearbeitet, falls nicht, darf der Administrator
    eines anlegen:
    *)
    IF file_existiert(season_name) THEN
      there_is_a_season_file;
    ELSE                        (* IF file_existiert(season_name) *)
      there_is_no_season_file;
    END;                        (* ELSE file_existiert(season_name) *)
  END start_processing;


PROCEDURE process_old_lock_post_action;
  PROCEDURE act_p0ac1;
    BEGIN                       (* PROCEDURE act_p0ac1 *)
      (*
      Es wurde die Betriebssystem-Werbung gedrckt:
      *)
      schreib_page_sys_info(sd1, p4ac9);
    END act_p0ac1;

  PROCEDURE act_p0ac2;
    BEGIN                       (* PROCEDURE act_p0ac2 *)
      (*
      Es wurde die Webserver-Werbung gedrckt:
      *)
      schreib_page_wsv_info(sd1, p4ac9);
    END act_p0ac2;

  PROCEDURE act_p4ac9;
    BEGIN                       (* PROCEDURE act_p4ac9 *)
      (*
      Die Seite zum Lschen eines alten Lockfiles anzeigen. Kann auch sein,
      da wir in calc_integers ein Problem hatten aber gleichzeitig
      ein altes Lockfile vorliegt und deshalb hier landeten.
      *)
      schreib_page23(sd1);
    END act_p4ac9;

  PROCEDURE act_p23ac1;
    VAR
      geloescht:                BOOLEAN;

    BEGIN                       (* PROCEDURE act_p23ac1 *)
      (*
      Der OK-Button auf page23 wurde gedrckt. Es soll also ein
      altes Lockfile gelscht werden. Nur der Chef oder die Chefin
      drfen das. Falls das Kennwort nicht OK ist, gibt's eine
      ordentliche Fehlermeldung. Im anderen Fall wird das Lockfile
      gelscht. Anschlieend probieren wir's mit einem Neustart.
      *)
      IF (ist_kennwort_ok(i_chefin) OR ist_kennwort_ok(i_chef)) THEN
        geloescht:=Unix.Unlink(lock_name);
        IF geloescht THEN
          schreib_page_accept(sd1,
                            'Altes Lockfile wurde erfolgreich gelscht!',
                            "Weiter geht's", dunkelgruen, p4ac9);
        ELSE                    (* IF geloescht *)
          schreib_page_accept(sd1,
                              'Altes Lockfile konnte immer noch nicht gelscht werden!',
                              'Groer Mist', dunkelrot, p4ac9);
        END;                    (* ELSE geloescht *)
      ELSE                      (* IF (ist_kennwort_ok(i_chefin)... *)
        schreib_page_accept(sd1,
                            'Wir haben doch nicht etwa ein Problem mit dem ChefIn-Kennwort?',
                            'Groer Mist', dunkelrot, p4ac9);
      END;                      (* ELSE (ist_kennwort_ok(i_chefin)... *)
    END act_p23ac1;

  PROCEDURE act_p23ac2;
    BEGIN                       (* PROCEDURE act_p23ac2 *)
      (*
      Der nicht-OK-Button auf page23 wurde gedrckt. Wird das
      Lockfile eben nicht gelscht. Allerdings kommen wir nicht
      sehr weit damit...
      *)
      schreib_page_accept(sd1,
                          'Solange das alte Lockfile steht, geht leider gar nichts!',
                          'Ok, dann halt nochmal', dunkelrot, p4ac9);
    END act_p23ac2;

  BEGIN                         (* PROCEDURE process_old_lock_post_action *)
    CASE input[ii04].value OF   (* input[ii04].value ist die action *)
      | p0ac1:
          act_p0ac1;

      | p0ac2:
          act_p0ac2;

      | p4ac9:
          act_p4ac9;

      | p23ac1:
          act_p23ac1;

      | p23ac2:
          act_p23ac2;

      | ELSE
          schreib_page_accept(sd1,
                              'process_old_lock_post_action: Unerwartete Aktion!',
                              "Weiter geht's", dunkelrot, p4ac9);
    END;                        (* CASE input[ii04].value *)
  END process_old_lock_post_action;


PROCEDURE process_old_lock_get_action;
  PROCEDURE act_p0ac1;
    BEGIN                       (* PROCEDURE act_p0ac1 *)
      (*
      Es wurde die Betriebssystem-Werbung gedrckt:
      *)
      schreib_page_sys_info(sd1, p4ac9);
    END act_p0ac1;

  PROCEDURE act_p0ac2;
    BEGIN                       (* PROCEDURE act_p0ac2 *)
      (*
      Es wurde die Webserver-Werbung gedrckt:
      *)
      schreib_page_wsv_info(sd1, p4ac9);
    END act_p0ac2;

  BEGIN                         (* PROCEDURE process_old_lock_get_action *)
    CASE input[ii04].value OF   (* input[ii04].value ist die action *)
      | p0ac1:
          act_p0ac1;

      | p0ac2:
          act_p0ac2;

      | ELSE
          schreib_page_info(sd1,
                            'process_old_lock_get_action: Unerwartete Aktion!',
                            'Ggf. dem Programmierer drohen!', dunkelrot);
    END;                        (* CASE input[ii04].value *)
  END process_old_lock_get_action;


PROCEDURE process_old_lock;
  VAR
    text1:                      String;
    booldummy:                  BOOLEAN;

  BEGIN                         (* PROCEDURE process_old_lock *)
    (*
    Falls char_cnt=0 (das ist bei uns dann der Fall, wenn kein
    POSTing vorliegt *und* der QUERY_STRING leer ist), wurde das
    Script direkt aufgerufen. Wir werden in diesem Fall direkt
    zur Lschpage fr's Lockfile gehen. Falls char_cnt<>0, wurde
    das Script von einem FORM (unsere FORMs arbeiten immer mit POST)
    oder von GET aus aufgerufen. Dann wird in process_old_lock_post_action
    bzw. process_old_lock_get_action je nach erhaltenem action code
    weiterverfahren. Ganz zu Beginn mssen wir aber noch den zweiten
    Teil der Inputinitialisierungen machen und vor allem die 'POSTings'
    bzw. 'GETtings' entgegennehmen.
    *)
    (*
    Es kann an dieser Stelle brigens nicht schaden, einen Leseversuch
    fr die season_data zu machen. Nachdem ein altes Lockfile
    da ist, kann sowieso keiner eine neue Datenbasis schreiben
    und fr uns sind die Daten ggf. ganz ntzlich beim bergang
    in den Normalmodus, um dort nicht irgendwelche blden out-of-range
    Fehler zu bekommen.
    *)
    booldummy:=try_get_season_data(season_name, sd1, text1);
    init_default_inputs2;
    try_get_or_postings;
    calc_integers;
    IF char_cnt=0 THEN
      schreib_page23(sd1);
    ELSE                        (* IF char_cnt=0 *)
      IF request_ist_post THEN
        process_old_lock_post_action;
      ELSE                      (* IF request_ist_post *)
        process_old_lock_get_action;
      END;                      (* ELSE request_ist_post *)
    END;                        (* ELSE char_cnt=0 *)
 END process_old_lock;


PROCEDURE try_create_lock;
  CONST
    lock_file_age_max=          20;

  VAR
    uhrzeit:                    CARDINAL;
    lock_time:                  CARDINAL;
    lock_ok:                    BOOLEAN;

  PROCEDURE kein_uraltes_lockfile_da;
    BEGIN                       (* PROCEDURE kein_uraltes_lockfile_da *)
      IF create_lock2() THEN
        start_processing;
        try_delete_lock;
      ELSE                      (* IF create_lock2() *)
        schreib_page_accept(sd1,
                            'Es konnte kein neues Lockfile angelegt werden!',
                            'Nochmal', dunkelrot, p4ac9);
      END;                      (* ELSE create_lock2() *)
    END kein_uraltes_lockfile_da;

  BEGIN                         (* PROCEDURE try_create_lock *)
    (*
    Nun versuchen wir also, ein Lockfile anzulegen. Zuerst sehen wir
    aber nach, ob nicht evtl. ein uraltes bereits rumliegt. Sollte
    dies der Fall sein, mssen wir uns erst mal um dieses kmmern.
    *)
    IF file_existiert(lock_name) THEN
      (*
      Es ist ein Lockfile da. Mal sehen, ob es ein altes ist.
      *)
      (*
      Unix.ModifyTime(lock_name, lock_time, lock_ok);
      *)
      lock_ok:=FALSE;
      lock_time:=0;
      Unix.ModifyTime(lock_time, lock_ok, lock_name);
      IF lock_ok THEN
        uhrzeit:=Unix.Time();
        IF ((uhrzeit-lock_time) > lock_file_age_max) THEN
          (*
          Lockfile ist zu alt, also mssen wir uns darum kmmern:
          *)
          process_old_lock;
        ELSE                    (* IF ((uhrzeit-lock_time) > lock_file_age_max) *)
          kein_uraltes_lockfile_da;
        END;                    (* ELSE ((uhrzeit-lock_time) > lock_file_age_max) *)
      ELSE                      (* IF lock_ok *)
        schreib_page_info(sd1,
                          'Alter des Lockfiles konnte nicht ermittelt werden!',
                          'Spter nochmal probieren, ggf. dem Programmierer drohen!',
                          dunkelrot);
      END;                      (* ELSE lock_ok *)
    ELSE                        (* IF file_existiert(lock_name) *)
      kein_uraltes_lockfile_da;
    END;                        (* ELSE file_existiert(lock_name) *)
  END try_create_lock;


PROCEDURE terminate1;
  BEGIN                         (* PROCEDURE terminate1 *)
    IF hlog_ist_offen THEN
      StreamFile.Close(cid_log);
    END;                        (* IF hlog_ist_offen *)
    (*
    Nachsehen, ob grundstzlich E-Mails zu senden sind und dies
    bei Bedarf dann auch tun:
    *)
    IF email_info.ob_emails_senden THEN
      schreib_ggf_email(email_info);
    END;                        (* IF email_info.ob_emails_senden *)
  END terminate1;


BEGIN                           (* MODULE squash1 *)
  init1;
  try_create_lock;
  terminate1;
END squash1.

(*

31.01.98:
        Wir machen ein paar Tests fr unser Squash-Projekt

01.02.98:
        Cont..

02.02.98:
        Die ersten Tests sind ganz gut angelaufen. Wir erzeugen momentan
        ein HTML-Dokument, welches im wesentlichen einfach eine Tabelle
        darstellt. Die einzelnen Tabelleneintrge enthalten entweder
        einfach nur einen Text (Uhrzeiten, Wochentage, nicht von uns
        belegte Courts) oder sind mit Text (welcher Court?) und
        einem Submit-Button ausgestattet.

        Hier erst ein paar grundstzliche Gedanken und berlegungen zur
        Gesamtstrategie der Squash-Tabelle:
        Es wird eine Datenbasis in Form eines Files geben, die den
        Belegungszustand aller Courts fr eine komplette Spielsaison
        darstellt. Der Initialzustand ist natrlich der, da alle
        Courts frei sind. Ziel ist nun einfach, da (berechtigte)
        Surfer den Inhalt dieser Datenbasis nach bestimmten Regeln
        verndern knnen. Genau dies soll mit Hilfe dieses CGI-
        Programmes erfolgen. Wir werden also nicht n verschiedene
        kleine Helferlein einrichten, sondern nur dieses eine Programm.
        Die vom Programm ausgegebenen HTML-Seiten hngen dabei zum
        einen natrlich von der aktuellen Datenbasis ab und zum
        anderen aber auch von eventuellen Eingaben, die der Benutzer
        mittels diverser Submit-Buttons im Laufe seiner Sitzung
        zum Programm zurckschickt. Wir wissen: Aufruf des Progamms
        mittels eines einfachen Links bergibt _keine_ Eingabewerte
        vom Benutzer an das Programm. Das Programm erkennt dies und
        reagiert lediglich mit der Ausgabe der Belegung fr die
        aktuelle Woche (falls wir uns im Usermodus befinden; mehr
        dazu aber spter). Drckt der Benutzer nun einen Button, um
        etwa einen freien Court zu belegen, wird als ACTION wieder
        genau nur dieses Programm aufgerufen, nun aber mit einigen
        Zusatzinformationen, die in dem Formular enthalten sind.
        Beim momentanen Stand der Dinge gibt es fr jede Zelle der
        Tabelle ein eigenes Formular. Der einzige fr den Benutzer
        sichtbare Eintrag ist dabei der aktuelle Belegungszustand
        der Zelle. Daneben gibt es einige andere (HIDDEN) Werte
        (etwa die Kalenderwoche oder den Courtindex), die an
        das Programm bergeben werden. Dadurch kann im Programm
        dann entsprechend verfahren werden.

        Die Erzeugung dieser Parameter werden wir so machen:
        wir legen ein Feld von Namens-Strings an. Exakt diese Strings
        werden wir ggf. als INPUT NAME in der HTML-Seite ausgeben.
        Auerdem legen wir ein zweites String-Feld fr die INPUT VALUEs
        an, ggf. ergnzt durch ein CARDINAL-Feld fr ganzzahlige Werte.
        Erfolgt nun durch den Benutzer ein Submit, brauchen wir
        den Input nur auf uns bekannte INPUT NAMEs hin abzuklappern.
        Beim Programmstart werden wir also zunchst das Feld der
        INPUT VALUEs mit bestimmten Voreinstellungen belegen. Erfolgt
        durch den Benutzer _keine_ Eingabe, wird einfach nur die
        aktuelle Tabelle ausgegeben. Ist aber eine Eingabe erfolgt,
        wird als erste Aktion das String-Feld der INPUT NAMEs gem
        der Eingaben des Benutzers aktualisiert und daraufhin wird
        entsprechend das weitere Vorgehen abhngig gemacht.

        'WriteLnCrLf' verwenden, damit auch unter Windoofs die HTML-
        Sourcen schn aussehen.

08.02.98:
        Analyse der Submit NAMEs und VALUEs. Das dritte Feld wird nicht
        ein CARDINAL-Feld sondern ein INTEGER-Feld.

09.02.98:
        Wir werden statt der einzelnen Felder fr die INPUT VALUEs
        nur noch ein Feld fhren, allerdings ein Feld von RECORDs.
        Die einzelnen Felder des RECORD werden sein: Je ein String
        fr NAME und VALUE, ein INTEGER fr VALUE und ein Feld, welches
        angibt, ob es sich beim VALUE um einen INTEGER-VALUE handelt oder
        nicht. Labels etwa haben keinen zugeordneten INTEGER. Damit tun
        wir uns dann bei der automatischen String-->INTEGER-Konversion
        etwas leichter.
        Bisher haben wir 4 INPUT-NAMEs in Gebrauch: label, ukw, unser_court_
        index und court_belegung. Das ist natrlich zu wenig. Als FORM-ACTION
        geben wir ja immer nur dieses Programm hier an. Wir mssen also
        dafr sorgen, da jeder SUBMIT auch wirklich zu einer eindeutigen
        Aktion fhrt. Fr unsere page01 knnten wir etwa 2 verschiedene
        Aktionen unterscheiden:
          
          1. Auswahl der KW
          2. Belegungsnderung in einem der Courts

        Spter kommen mit Sicherheit weitere pages hinzu, die dann
        weitere Unterscheidungen erfordern.

        Wir fhren deshalb einen 5-ten INPUT-NAME ein: action. Wir legen
        dabei etwa fest: die actions 100..199 stammen von page01,
        200..299 von page02 usw. Unsere obigen 2 Aktionen bekommen
        also die actions 101 und 102. Warum wir die 100 nicht
        verwenden, wissen wir nicht so genau, vielleicht brauchen
        wir auch sowas wie eine 0-action pro page, mal sehen.

10.02.98:
        Wir probieren, auf ISO umzusteigen. Erster Schritt war ganz
        iehsi: Give und Take gibt's halt nicht mehr, noch 1 oder 2
        andere Kleinigkeiten und schon lie sich das Programm wieder
        bersetzen und scheint auch zu funktionieren. O.k. wir haben
        auch den Rest nach ISO rbergekriegt mit IMPORTs von STextIO,
        SWholeIO usw.. Luft alles super (trotz lstigem grippalen
        Infekts, der auch heute am Dienstag noch nicht vorbei ist,
        obwohl er sich schon am Samstag angekndigt hatte).

        Completely OFFTOPIC (Nachtrag am 23.05.1998): ich glaube 
        es war zu dieser Zeit, da ich, um den lstigen grippalen
        Infekt zu berwinden u.a. ein bichen im TV herumgezapped habe
        und dabei zum ersten mal Alane von WES und Torn von Natalie
        Imbruglia wahrgenommen habe. Habe mir erst letzthin zwei
        mp3s reingetan. Echt geil.

        Weil wir spter auer Standard I/O auch irgendwelche Files
        lesen und schreiben werden mssen, steigen wir auch noch
        gleich von STextIO, SWholeIO usw. auf TextIO, WholeIO usw.
        um.

11.02.98:
        So, damit wren wir soweit recht zufrieden. An die GPM-Mailing-
        Liste haben wir eine Frage bezglich der Erzeugung von Lockfiles
        gestellt. Mal sehen, ob da was zurck kommt. Wir werden nmlich
        hchstwahrscheinlich mit einem Lockfile arbeiten, um gleichzeitige
        Zugriffe der Spieler handhaben zu knnen. Wir htten uns dafr
        etwa 'StreamFile.Open(cid_1, 'FILENAME', write, res)' ausgesucht.
        Bin mal gespannt.

squash1/12.02.98:
        Also: es ist jetzt an der Zeit, ein paar Gedanken an die Daten-
        struktur unserer Datenbasis zu verlieren. Vor allem wollen wir
        das auch im Hinblick auf eine mglicherweise bers Netz durchzu-
        fhrende Verwaltung der gesamten Applikation tun, d.h. es sollte
        mglicherweise _ohne_ Umprogrammierung mglich sein, z.B. eine
        komplett neue Liste (fr eine weitere Spielsaison) anzulegen, fr
        die die Courtbelegung dann aber auch anders aussehen darf als
        im alten Jahr. Vielleicht haben wir uns da auch zu viel vorgenommen,
        aber wir werden mal sehen.
        Gehen wir zunchst mal nur von _einer_ Spielsaison aus. Dann
        mssen wir also mal berlegen, welche Daten berhaupt in die
        Datenbasis aufgenommen werden mssen. Grundstzlich werden
        die Spielplne immer in einer analogen Form vorliegen, wie
        wir das hier schon gemacht haben: fr verschiedene Spielzeiten
        gibt es verschiedene Spalten und fr die diversen Courts
        gibt es verschiedene Zeilen. Von Saison zu Saison kann sich
        sowohl die Anzahl der Spalten als auch die der Zeilen ndern.
        Diese Gren mssen also auf jeden Fall in der Datenbasis mit
        abgelegt werden. Weiterhin mu festgehalten werden, welche
        Spieler mitmachen und ob es sich um einen wchentlichen oder
        14-tgigen Spieler handelt. Desweiteren mssen wir notieren,
        welche der Courts von uns angemietet sind. Bleiben
        wir bei der bisherigen Durchnumerierung der Courts bzw. der
        'Halbcourts', dann ist dies einfach durch die Angabe der
        entsprechenden Courtindices getan. Auch die Courtbezeichnungen
        werden wir notieren (Court 4, Court 5 usw.), ebenso die Wochentage.
        Dies waren also die (pro Saison) fixen Daten, kommt noch ein
        Datensatz hinzu (weswegen wir die ganze Sache eigentlich tun):
        Die konkrete Courtbelegung pro Woche. Fangen wir also mal an,
        den ganzen Mist ber ein File zu erledigen und nicht, wie
        bisher, fest im Programm kodiert zu haben.
        Aber halt, was heit 'ein File'? Die fixen Sachen mssen zwar
        immer wieder gelesen werden aber nicht geschrieben. Vielleicht
        wre es geschickt, 2 Files zu bentzen, eines fr die fixen
        Sachen und eines fr die Courtbelegung? Ganz kurz zur Abschtzung:
        Wenn, wie bisher gebt, 16 Menschen pro Woche in den Courts
        herumtanzen, brauchen wir einfach 16 Zahlen dafr. Eine
        gesamte Saison kann etwa von Oktober bis Mai dauern, sind also
        grob 30 Wochen. Macht insgesamt also 30*16=480 Zahlen.
        Wir wollen unser Datenfile direkt mit einem Editor lesen
        knnen, d.h. wir werden die Zahlen einfach z.B. mittels
        'WholeIO' aus- und einlesen. Wenn wir, sagen wir 10 Zeichen
        pro Zahl verwenden, hat unsere Datei fr die gesamte Saison
        um die 5 kB.
        Wenn wir nun aber an Performance denken, sollten wir evtl.
        doch nur ein File verwenden, in dem alles drinsteht. Pro
        Saison gibt es dann genau _ein_ File. Unser Programm erwartet
        dabei einen ganz bestimmten Filenamen (z.B. 'season'). So
        werden wir das mal angehen. Damit wir uns nicht mit File-
        positionierungen herumschlagen mssen, werden wir einfach
        jedesmal das komplette File lesen und auch wieder schreiben.
        Wenn sich das spter als ungeil herausstellen sollte, mten
        wir das dann eben ndern.

squash1/13.02.98:
        Supergeile Sache: das Datenfile hat seinen ersten Test bestanden.
        Hat praktisch auf Anhieb funktioniert. Wir knnen ein komplettes
        File schreiben, wenn uns danach zumute ist und sind auch in der
        Lage, alles zu lesen, was wir wollen. Gezieltes Manipulieren mit
        dem Editor bewirkt auch exakt das, was wir uns wnschen.

squash1/14.02.98:
        Die erste Euphorie ist vorbei. Wir mssen wieder ein bichen
        mehr Struktur reinkriegen. Z.B. sollten wir nicht immer die
        gleichen globalen Variablen verwenden, wenn wir ein season-File
        lesen. Vielleicht sollten wir einfach einen RECORD anlegen,
        der genau die Daten des season-Files aufnimmt. Spter mssen
        wir dann bei vom User beantragten Courtbelegungs-nderungen
        eine Kontroll-lesung machen. Fr diese brauchen wir dann
        offenbar einen weiteren RECORD.
        Bemerkung am 26.02.98: ist nicht wahr. Das Script wird natrlich
        nur einmal aufgerufen, d.h. wir mssen auch das season-File
        nur einmal lesen pro Client-Request. Was wir tun mssen, ist,
        dem Client in einem weiteren hidden value den vorherigen Zustand
        mitgeben, damit er uns diesen beim erneuten Request nochmal
        zurckbringt. Jetzt haben wir die Mglichkeit zu testen, ob
        die alte Lesung mit der aktuellen bereinstimmt.

squash1/15.02.98:
        Die hidden values bekommen ein Flag: damit unsere Routine zum
        Schreiben der hidden values nicht immer alle values schreibt,
        merken wir uns die zu schreibenden in einem Flag.

squash1/16.02.98:
        Wir haben ein kleines Problem. Bisher haben wir einfach zuerst
        init1 aufgerufen und mit der dort festgelegten aktuellen KW
        unsere erste page01 dargestellt. Konnte natrlich nur funktionieren,
        wenn die aktuelle KW zufllig innerhalb des erlaubten Bereiches
        lag. Was der erlaubte Bereich ist, knnen wir aber nur aus den
        Daten lesen. Konsequenz: Wir knnen uns in init1 zwar die
        aktuelle KW besorgen, mssen aber sptestens nach Lesen der
        Daten ggf. eine Korrektur fr die aktuell darzustellende KW
        machen. Dies tun wir mit check_ukw.

squash1/18.02.98:
        Hinweis: wenn wir von 'Court' reden, kann damit sowohl der ganze
        Court gemeint sein, in dem 2 Spieler drin sind oder auch nur
        der Platz, den ein Spieler einnimmt. Mu man dem Kontext ent-
        nehmen, was gemeint ist.

squash1/20.02.98:
        Cont.

squash1/21.02.98:
        Wir sind mit unseren 'hidden values' immer noch nicht so ganz
        zufrieden. Die Idee mit dem Flag war schon so einigermaen o.k.,
        aber das ist unbersichtlich. Wir werden es wieder verschwinden
        lassen und dafr noch einen hidden string einfhren, der dann
        die Funktion von input[x].name_strr bernimmt. Auerdem wird
        es einen Parameter 'hidden_anz' geben.
        Erster Anlauf, die Kennwrter zu bentzen. Momentan schreiben
        wir diese ganz ungeniert mit in das season-File. Spter
        mssen wir diese noch verschlsseln, damit keiner was versteht.
        Mglicherweise nehmen wir 'crypt' aus libc, mal sehen.

squash1/23.02.98:
        Cont.

squash1/24.02.98:
        Wir sollten vielleicht in die bentzten Courts nicht jedesmal
        'Court xy' reinschreiben, wenn wir pro Zeile sowieso nur immer
        den gleichen Court haben. Es sollte reichen, den bentzten
        Court beim Wochentag ganz links in der 0-ten Spalte mit unter-
        zubringen.
        Insbesondere fr schreib_td_text_form2 und schreib_td_text_form3
        fhren wir eine PROCEDURE-Variable ein.

squash1/25.02.98:
        So, jetzt scheinen wir endlich verstanden zu haben, wie wir etwa
        'crypt' aus der libc hier einbinden knnen. Mit INTERFACE-Modulen
        haben wir das nicht so recht hingekriegt. Haben wir halt was mit
        einem FOREIGN-Modul probiert und das scheint auch zu funktionieren.
        Super! Erste Tests mit den Kennwrtern sind erfolgreich!

squash1/26.02.98:
        Wir bentigen wahrscheinlich eine globale State-Variable in unserem
        season-File, denn wir sollten wahrscheinlich verschiedene Zustnde
        unterscheiden knnen. Der Normalzustand ist wie bisher:
        das season-File wird gelesen und je nach action wird der Client
        entsprechend bedient. Nun wollen wir das ganze Ding aber ber
        das Netz administrierbar machen. Dazu kann bzw. wird es erforderlich
        sein, da wir mehr als einen Request des Administrators brauchen,
        um ein wirklich schnes neues season-File zu erzeugen. Solange
        der Administrator am Zuge ist, mssen also die normalen User
        ferngehalten werden. Etwa einfach mit einer Antwort: 'es geht nix:
        ich bescheide mich bzw. ich fahre mit Administration fort' oder so.
        Der normale User wird sich bescheiden mssen, weil er das ent-
        sprechende Kennwort nicht wei. Ein potentieller Administrator
        tippt das Kennwort ein und kann weitermachen.
        Uns fllt gerade ein: bevor wir das nun realisieren, sollten wir
        den Lock vielleicht auch beim Lesen des season-Files anlegen.
        Beim Schreiben haben wir u.U. fr kurze Zeit ein ziemlich mieses
        season-File vorliegen. Wenn das einer liest, gibt's natrlich
        ein Problem fr den Client. Das wollen wir ndern.
        Also, das mit dem Lock beim Lesen luft, packen wir das mit der
        State-Variablen an. Diese schreiben wir etwa als allererstes
        in das season-File hinein.

squash1/27.02.98:
        Cont.

squash1/28.02.98:
        Cont.

squash1/01.03.98:
        Cont.

squash1/08.03.98:
        Cont.

squash1/09.03.98:
        Cont.

squash1/14.03.98:
        Wir mssen wieder ein bichen mehr Systematik in die verschiedenen
        darzustellenden Pages bringen. Insbesondere was das automatische
        Erstellen eines Default-season-Files betrifft. Fr Testzwecke hatten
        wir sozusagen eine automatische Sequenz drin: erst wurde bei
        Nichtvorhandensein eines season-Files sofort eines erzeugt,
        allerdings mit sea_state=sea_state1. Ein nochmaliger Aufruf
        des Programms brachte dann die Warnung, da der Administrator
        am Machen sei. Besttigen dieser Meldung hatte dann eine
        unerwartete Aktion in process_admin_action zur Folge. Das
        Besttigen dieser Meldung erst hat dann die bisher einzige
        gltige Aktion in process_admin_action zur Folge, nmlich
        das Rcksetzen des sea_state auf sea_state0, Abspeichern
        des season-Files mit sea_state=sea_state0 und erneutes Anzeigen
        der page01.
        In Zukunft soll nur der Administrator ein neues season-Files
        erzeugen drfen. Natrlich werden wir im Moment auf das Default-
        season-File zurckgreifen. Spter gibt's dann einen schnen
        Dialog zum Erzeugen eines echten season-Files. Im Programm wird
        es zwei Situationen geben, bei denen wir ein neues season-File
        erzeugen werden. Zum einen, wie bisher, wenn gar keines vor-
        handen ist und zum anderen bei den (noch einzufhrenden) er-
        weiterten Funktionen.
        Auf jeden Fall brauchen wir fr den Administrator ein eigenes
        Kennwort. Wir werden dieses, wie auch die Kennwrter fr die
        Spieler, in verschlsselter Form in das season-File mit auf-
        nehmen. Es wird spter die Mglichkeit geben, dieses, wie
        auch die Kennwrter fr die Spieler individuell zu ndern.
        Ganz zu Beginn der Geschichte, wenn wir also noch kein
        season-File haben, wird mit einem Defaultkennwort fr den
        Administrator gearbeitet. Dieses knnen wir ohne Bedenken
        (natrlich wieder in verschlsslter Form) in den Quelltext
        mit aufnehmen.
        Wir bemerken, da wir dafr das Kennwort von Spieler0 hernehmen
        knnen, weil wir dies sowieso nicht brauchen.

squash1/15.03.98:
        Cont.

squash1/16.03.98:
        Die ersten Wartungsschritte laufen schon ganz gut.

squash1/17.03.98:
        Cont.

squash1/18.03.98:
        Cont.

squash1/21.03.98:
        Die Administratorgeschichten den uns im Moment ein wenig an.
        Wir kmmern uns mal lieber wieder ein bichen um die Locking-
        geschichten. Der Einsatz von create_lock und delete_lock ist
        zwar o.k., aber noch nicht so ganz ausgereift. In try_get_season_data
        und try_put_season_data kommen die beiden ganz gut zum Tragen.
        Was wir aber auch bruchten, wre sowas wie ein 'try_modify_season_
        data': Lock anlegen, Daten lesen, Daten modifizieren, Daten
        schreiben, Lock wieder wegnehmen.
        
        Wenn wir ein wenig genauer nachdenken, sehen wir, da wir diese
        drei 'try_xy_season_data' Funktionen sehrwohl brauchen, da wir
        ihnen aber kein create_lock und delete_lock mehr geben werden.
        Bisher versuchen wir als eine der ersten Aktionen im Programm,
        das season-File zu lesen. Im Verlauf des Programms findet dann
        auch u.U. eine Schreibaktion statt, weil sich ein User eintragen
        oder austragen will. Dabei erfolgt bisher die vom User beantragte
        nderung der Datenbasis genau dann, wenn er das richtige Kennwort
        beisteuert.
        
        Nachtrag am 23.05.1998: Hier schweifen wir offenbar vom Thema ab.
        Zunchst geht es darum, ob wir whrend einer Sitzung mehrfach
        oder nur einmal ein Lockfile anlegen. Spter reden wir davon,
        da der Langweiler langweilig vor seiner Kiste hockt und da
        whrend seines langweiligen Sitzens mit der Datenbasis etwas
        passiert. Das sind zwei vllig unterschiedliche Dinge, aber
        wir wissen das.
        
        Ist irgendwie ungeil, weil es z.B. sein kann, da der
        User sich zunchst einmal die aktuelle Datenbasis anzeigen lt
        und dann ewig lang bld vor seiner Kiste rumsitzt, bevor er
        versucht, eine Eintragung zu machen. In der Zwischenzeit hat
        sich vielleicht jemand anders eingetragen, unser Langweiler
        sieht aber immer noch seine alte Anzeige, weil natrlich niemand
        fr einen Refresh auf seinem Schirm gesorgt hat. Jetzt drckt er
        einen der Knpfe, die aber nicht mehr den aktuellen Zustand der
        Datenbasis wiederspiegeln. Was mssen wir nun tun?

squash1/22.03.98:
        Im Moment jedenfalls lesen wir als allererstes wieder die
        aktuelle Datenbasis und machen dann eine fr den Langweiler
        verblffende Aktion: anstatt nach dem neueinzutragenden Spieler
        gefragt zu werden, wird er gefragt, ob Spielerxy wieder aus-
        getragen werden soll. Wahrscheinlich wird er sagen, da dies
        'nicht OK' ist und bekommt anschlieend wenigstens wieder die
        aktuelle Liste angezeigt. Noch unangenehmer wird es, wenn
        zwei Spieler ziemlich gleichzeitig etwa den '(frei)'-Knopf
        drcken, der eine sofort (allerdings erst, nachdem der zweite
        seinen '(frei)'-Knopf gedrckt hat) seine Eintragung macht, der
        andere aber noch wartet, bis der erste seine endgltige Ein-
        tragung gemacht hat. In dieser Situation kann der zweite _ohne_
        das Kennwort des ersten zu kennen, sich einfach ber den
        ersten drberschreiben. Echt ungeil.
        
        Wir mssen also unmittelbar vor einer nderung der Datenbasis nicht
        nur berprfen, wer momentan eingetragen ist, sondern auch ber-
        prfen, ob diese aktuelle Eintragung mit dem bereinstimmt, was
        der User erwartet, was er (der Langweiler) also noch auf seinem
        Schirm sieht. In diesem Zusammenhang sehen wir sofort, da es
        keinen Sinn macht, zu Beginn des Programms schnell die Datenbasis
        zu lesen, den Lock dann wieder frei zu geben und anschlieend
        nochmal lesen, modifizieren und wieder schreiben (mit unserem oben
        erwhnten try_modify_season_data). Weil unser Programm sowieso
        keine langwierigen Schleifen macht, irgenwie auf diverse Inputs
        wartet und nach lngerem Kreisen dann irgendwann mal endet, sondern
        immer in 'einem Rutsch' sofort durchluft, setzen wir einfach
        zu Beginn einen create_lock und ans Ende einen delete_lock und
        sind damit zufrieden. Wir knnen uns dann damit begngen, zu
        Beginn einmal die Datenbasis zu lesen und ggf. im weiteren Verlauf
        eine nderung abzuspeichern.

        Natrlich haben wir nun ein erhhtes Risiko, da mal ein Lockfile
        wegen eines _nicht behebbaren Fehlers_ stehen bleibt, weil
        zwischen create_lock und delete_lock nun wesentlich mehr
        abgeht als vorher. Wenn wir gescheit programmieren, macht uns
        das aber nicht hei.

        Dennoch wollen wir fr den unwahrscheinlichen Fall alter Lock-
        files vorsorgen. Um sie in den Griff zu bekommen, hat uns Robert
        auf die Idee gebracht, nur ein bestimmtes Alter fr Lockfiles zu-
        zulassen. Zu alte Lockfiles werden einfach ignoriert/gelscht.
        Fragt sich nur, was 'zu alt' ist. Im Normalfall existiert ein
        Lockfile nur fr die Dauer des Programmlaufs. Diese Dauer liegt
        somit auf jeden Fall im Bereich von Bruchteilen von Sekunden.
        Was wei ich, wie sich irgendwelche Netzwerktrgheiten aus-
        wirken, auf jeden Fall gehren Lockfiles von sagen wir 10 s 
        oder 20 s Lebensalter auf den Mll. Mal sehen, wie wir das
        realisieren werden.

        Gibt natrlich wieder ein Problem. Falls wir feststellen, da
        wir ein altes Lockfile haben, mssen wir zwischen dem Zeitpunkt,
        an dem wir das (zu groe) Alter feststellen und dem Zeitpunkt,
        an dem wir einfach ein neues Lockfile drberbgeln eigentlich
        wieder verhindern, da andere Prozesse uns dabei stren. Wir
        haben also wieder ein Lockproblem. Da mssen wir nochmal
        grndlich nachdenken...

        Und wahrscheinlich haben wir auch eine Lsung gefunden. Wir
        werden im Falle eines alten Lockfiles lediglich versuchen,
        dieses zu lschen und _nicht_ im selben Programmlauf ein
        neues anzulegen. Das Anlegen eines neuen Lockfiles mu zeitlich
        deutlich verzgert erfolgen. Dies sieht man so: angenommen
        zwei Prozesse stellen gleichzeitig ein altes Lockfile fest.
        Weiter angenommen versuche der erste Prozess, dieses zu lschen
        und ein neues anzulegen, was ihm auch gelingen soll. Dann
        knnte es passieren, da der zweite Prozess das soeben vom
        ersten Proze erzeugte Lockfile lscht und 'erneuert' im
        Glauben, es sei das alte gewesen, das er gesehen hat. Beide
        Prozesse haben also vermeintlich ein Lockfile angelegt und
        wrden nun munter das Arbeiten beginnen. Das darf natrlich
        nicht sein. Wir knnen nicht verhindern, da zwei Prozesse
        gleichzeitig ein altes Lockfile entdecken, aber wir knnen
        verhindern, da der zweite Proze das vom ersten frisch
        angelegte sofort wieder lscht, wenn der gar keines angelegt
        hat. Ganz einfach, oder?

        Doch nicht ganz so einfach. Es knnte ja ein dritter Proze
        dazwischenfunken und unmittelbar nachdem der erste Proze
        das Lockfile gelscht hat, ein neues anlegen. Der zweite
        Proze wrde dann evtl. dieses vom dritten Proze erzeugte
        Lockfile lschen...

squash1/23.03.98:
        Verschieben wir auf spter. Jedenfalls werden wir create_lock
        und delete_lock mal an den Anfang bzw. das Ende des Programms
        stellen, wie oben angedeutet.

squash1/24.03.98:
        'Ich will...'-Button. Es sind zwei verschiedene Chefs zu unter-
        scheiden: der Squash-Chef und der Softwarelieferant (wer ist
        das wohl?). Der Squash-Chef darf Datenbasen umbenennen und auch
        neue anlegen. Evtl. mu er sich auch um die Neuvergabe von
        User-Kennwrtern kmmern. Um alle weitergehenden Aufgaben bzw.
        Probleme mu sich dann der Softwarelieferant kmmern (z.B. wenn
        die Software irgendwo echt klemmt).

squash1/29.03.98:
        'LINUX NOW!' und 'Powered by APACHE' bekommen Links. Am Ende der
        Page wird <ADDRESS> ausgegeben. Weiterer Parameter:
        'court_belegung_alt'. Auerdem haben wir uns endlich mal
        um die alten Lockfiles gekmmert. Die Lsung ist zwar nicht
        ganz astrein, sollte aber in der Praxis funktionieren.

squash1/04.04.98:
        Wenn wir spter mal Lust haben oder wenn wir mit der jetzigen
        Behandlung alter Lockfiles Probleme bekommen, sollte auch
        folgendes mglich sein:  Lschen mittels cron-Job. Wenn wir in
        unserem CGI-Programm alte Lockfiles lschen wollen, liegt die
        Schwierigkeit grundstzlich darin, da wir nicht wissen, in
        welchem zeitlichen Abstand unterschiedliche Prozesse aufgerufen
        werden. Weil unser Vorgang 'bedingtes Lschen eines alten Lock-
        files' leider _keine_ atomare Operation ist, sind wir aber darauf
        angewiesen, da nicht ein zweiter Lschvorgang einen bereits
        ablaufenden strt. Wenn sichergestellt werden kann, da ein
        zweiter Lschvorgang erst gestartet wird, nachdem der erste
        beendet ist, ist auch unser Problem gelst. Mit einem cron-Job
        z.B. wre dies der Fall. Das krzest mgliche Intervall fr
        cron ist eine Minute, d.h. die User wren schlimmstenfalls
        fr eine Minute (plus erlaubtes Alter des Lockfiles) blockiert.
        Das wre in jedem Falle vertretbar.
        Und wir haben es mit einem cron-Job erledigt. Scheint o.k. zu
        sein.
        Letzthin hat uns ein Artikel in der c't einen sehr ntzlichen
        Hinweis gegeben: auch wenn wir mit Select-Buttons arbeiten,
        kann ein bser Hacker ein lokales Formular erstellen und
        uns auf diese Weise unmgliche Werte zurckschicken. berlange
        Strings machen uns keine Probleme, der Append schneidet die
        einfach ab. Anders sieht's aus mit 'out of range' bei INTEGER-
        Werten. Bisher wrde das wahrscheinlich einfach zu einem
        'Nothalt' fhren. Das wollen wir in calc_integers nun ab-
        fangen mit einer ordentlichen Meldung.
        Fr ukw und court_belegung gibt es keine Probleme, aber court_index
        sollten wir auf den geschrumpften Index umstellen, damit wir
        einen schnen Bereich haben. Dazu werden wir uns_court ein
        bichen umdeuten: -1 heit 'nicht unser Court', Indizes von 0
        bis uns_courts_anz-1 ist dann der inverse geschrumpfte Index.

squash1/05.04.98:
        Der 'Ich will...'-Button rgert uns ein bichen. Auerdem
        schalten wir den cron-Job ab, weil er mit jedem Aufruf
        eine Meldung macht. Gibt einen riesigen Mllhaufen in
        /var/log/messages. Vielleicht machen wir einfach eine
        Endlosschleife mit einem kleinen Skript.
        Das mit der Endlosschleife und dem kleinen Skript hat im
        Prinzip funktioniert, aber nachdem wir es im Hintergrund
        gestartet hatten, haben wir es nicht mehr geschafft, es
        wieder anzuhalten. Wir haben deshalb den Sleep-Aufruf
        in das kleine Lockfile-Lsch-Progrmmchen mit aufgenommen
        und nun ist alles wunderbar.
        Auch der 'Ich will...'-Button rgert uns inzwischen nicht
        mehr so stark wie vorher: nach Einfhren der 'Nullaktion'
        (nullac) geben wir nmlich meist gar keinen Submit-Button
        mehr aus, sondern nur wenn wir wirklich einen wollen und
        sind damit sehr zufrieden.

squash1/06.04.98:
        Nochmal der 'Ich will...'-Button. Wir zeigen ihn nur noch
        auf page01 an.

squash1/08.04.98:
        Wenn wir auf page02 oder page03 Probleme mit dem Kennwort
        haben, erscheint eine Accept-Page mit 'Groer Mist'.
        Besttigen dieses Umstandes fhrt aber nicht, wie etwa
        zu erwarten, einfach zu page02 oder page03 zurck, sondern
        zu page01. Das ist etwas verwirrend. Um dies zu ndern,
        mssen wir der Accept-Page nur noch ein bichen mehr
        hidden values mitgeben, damit wir page02 bzw. page03 von der
        Accept-Page aus genauso aufrufen knnen, wie das von page01
        aus mglich ist. Namentlich mssen wir von page02 bzw. page03
        zustzlich noch unser_court_index und court_belegung_alt
        mit zur Accept-Page schleppen, um nach Akzeptieren der Accept-
        Page wieder zu page02 bzw. page03 zurckkehren zu knnen.

squash1/10.04.98:
        Vorlufig letzter cleanup fr page02, page03, den 'Groer Mist'-
        Button und die Fehlermeldungen bei falschem Kennwort und
        wenn sich die Spieler gegenseitig in die Quere kommen (d.h.,
        wenn der eine dem anderen den Platz wegschnappt und so).
        Wir mssen mal langsam damit beginnen, den 'Ich will...'-Button
        nicht nur als Dummy dastehen zu haben.
        Nebenbemerkung: Wir sehen, da unser Programm langsam aber
        stetig grer wird. Insbesondere kommen laufend neue action codes
        und auch neue schreib_page<xy>-PROCEDUREs hinzu. Eigentlich
        wre es schn, da eine ordentliche Gruppierung drinzuhaben.
        Um dies zu erreichen, mten wir aber bei Einschieben eines
        neuen action codes oder bei Einfhren einer neuen
        schreib_page<xy>-PROCEDURE ggf. etliche bereits vorhandene
        Sachen verschieben. Dies ist uns aber zu fehlertrchtig und
        zu aufwendig. Wir werden daher einfach laufend neue Eintrge
        erzeugen und mssen dann halt auf eine etwas grere ber-
        sichtlichkeit verzichten.
        Endlich knnen die Kennwrter gendert werden. War straight
        forward.

squash1/12.04.98:
        Die Links fr 'LINUX NOW!' und 'Powered by APACHE' werden
        gendert. Grund: auch fr diese beiden Pages wollen wir
        unseren schnen Header und (aktuellen) Trailer haben. Wir
        htten also einfach zwei weitere FORMs verwenden knnen und
        als Submit-Button jeweils das kleine Image nehmen knnen.
        Images als Submit-Button verursachen aber bei nichtgrafischen
        Browsern evtl. Probleme. Also machen wir einen kleinen Trick:
        wir legen fr squash1.cgi zustzlich zwei (symbolische
        File-)Links an: z.B. squash1a.cgi und squash1b.cgi. Diese
        verwenden wir einfach als Hyperlinks fr 'LINUX NOW!' und
        'Powered by APACHE'. Was wir dann im Programm hier als eine
        der ersten Aktionen tun mssen, ist lediglich nachzusehen,
        wie das Programm aufgerufen wurde (mit GetArg aus Module
        ProgArgs) und je nach Programmaufruf, das ganz normale
        Processing durchzufhren oder die 'LINUX NOW!'- bzw. die
        'Powered by APACHE'-Info anzuzeigen.

squash1/13.04.98:
        REQUEST_URI in show_client_info. Programmquelle ausgeben. Aber
        das ist doch nicht so einfach, weil der Browser natrlich irgendwas
        draus macht, nur nicht einfach den Text anzeigt, logisch. Also
        nochmal nachdenken.

squash1/15.04.98:
        Zum Ausgeben der Programmquelle reicht es evtl., einfach alle
        '<' und '>' durch '&lt;' bzw. '&gt;' zu ersetzen. Nein,
        reicht doch nicht ganz. Die '&' machen uns auch Probleme
        (htten wir gleich grndlich nachgelesen, wre uns das
        sofort aufgefallen).
        Im brigen bemerken wir, da das Layout auf verschiedenen
        Browsern doch recht unterschiedlich aussieht. Dem sollten wir
        auch mal nachgehen. Als erstes fllt uns dabei der aswedit
        ein, mit dem wir zumindest mal die Syntax berprfen knnen.
        Und wir sehen sofort, da wir einige Syntaxfehler drin haben
        (z.B. Headings innerhalb der Table). Das mssen wir also
        zuallererst mal ndern, bevor wir ber irgendwelche Browser
        schimpfen.
        Was wir auch noch mal berdenken mssen, ist das Handling
        fr 'LINUX NOW!' und 'Powered by APACHE'. Es wre doch ganz
        praktisch, wenn es auf den entsprechenden Seiten einen
        Accept-Button gbe. Allerdings haben wir hier das Problem,
        da z.B. die aktuelle KW nicht mehr bekannt ist, weil wir
        durch unseren Supertrick mit den symbolischen File-Links
        diese Information verloren haben. Mal sehen, ob sich da
        was machen lt.

squash1/18.04.98:
        CONTENT_LENGTH in show_client_info.
        Ein bichen mit get_postings spielen, weil wir evtl. je nach
        REQUEST_METHOD (GET oder POST) die Daten ber den QUERY_STRING
        bzw. ber stdin beziehen wollen. Soll dann get_or_postings
        heien. Wir werden dabei process_user_action in
        process_user_get_action und process_user_post_action auf-
        spalten. Analog fr process_admin_action.

squash1/19.04.98:
        Unterscheidung zwischen GET und POST klappt einwandfrei.
        Allerdings mssen wir nun insbesondere den gesamten Ablauf
        fr die Administratorgeschichten nochmal berdenken.
        Zum einen haben wir in die 'LINUX NOW!'- bzw. in die
        'Powered by APACHE'-Page nun doch einen Accept-Button
        eingebaut. Momantan fhrt der fr den Administrator zu
        einer unerwarteten Aktion. Zum anderen sollten wir die
        diversen Administrationssschritte etwas besser absichern.
        hnlich wie wir das fr den User gemacht haben, sollten wir
        uns auch beim Administrator unmittelbar _vor_ einer gewnschten
        nderung der Datenbasis davon berzeugen, da der Schritt
        auch zulssig ist. Dazu reicht es nicht, lediglich das
        Admin-Kennwort abzufragen. Wir mssen auch berprfen, ob
        die gewnschte Aktion mit dem aktuellen sea_state vereinbar
        ist. Also: Das Erstellen einer neuen Datenbasis erfolgt, wie
        schon weiter oben erwhnt, in mehreren Schritten. Diese
        mssen in einer bestimmten Reihenfolge stattfinden (erst
        ein Dummyfile erzeugen, dann globale Sachen regeln (wieviele
        Spieler, Spalten usw.), dann z.B. Spielernamen definieren usw.).
        Wir gehen nicht von einer Bswilligkeit des Administrators aus,
        aber wir mssen Unflle vermeiden, die z.B. beim Bentzen des
        Back-Buttons im Browser entstehen knnten. Dadurch wre es evtl.
        mglich, einen frheren Schritt nochmal auszufhren, obwohl
        schon ein neuerer stattgefunden hat. Dies wollen wir vermeiden.

        schreib_td_text_form2 und schreib_td_text_form3 verschwinden
        wieder, ebenso die zugehrige PROCEDURE-Variable und der
        PROCEDURE-Typ.

squash1/21.04.98:
        Kommentar bezglich Kennwrter und Testbetrieb gendert.

squash1/25.04.98:
        table2 auf page01 mit 'Zwischenrndern' versehen. Wir sehen:
        es ist viel geiler, nicht irgendwelche 'Zwischenrnder' ein-
        zubauen, sondern innerhalb der Tabledata etwa einen Paragraph
        zwischenzuschieben. Werden wir machen. Allerdings wird sich dabei
        die Numerierung der Courts ein wenig ndern. Bisher hat der linke
        obere Court die Nummer 0, die rechten Nachbarn aufsteigende
        Nummern 1, 2 usw.. Nach dem 'Rechtsauen' kommt der erste
        Court in der neuen Zeile. Da wir ab jetzt 2 Spieler in ein
        Kstchen malen, wird es im Prinzip so hnlich aussehen:

        -------------------------
        |   0   |   2   |   4   |
        |       |       |       |
        |   1   |   3   |   5   |
        -------------------------
        |   6   |   8   |  10   |
        |       |       |       |
        |   7   |   9   |  11   |
        -------------------------

squash1/02.05.98:
        Ein bichen Kosmetik.
        Beobachtung: Programmquelle ansehen dauert ziemlich lange. Das
        bedeutet auch, da unser Lockfile ziemlich lange rumsteht. Ist
        eigentlich unpraktisch, vor allem, weil wir weiter oben davon
        ausgegangen waren, da unsere Lockfiles nur wenige Bruchteile
        von Sekunden leben wrden. Vielleicht sollten wir das Lockfile
        in diesem speziellen Fall schon eher wieder lschen. Aber
        was wir heute beobachtet haben, ist beunruhigend. Es ist uns
        gelungen, durch etwa gleichzeitiges Anschauen der Programmquelle
        ein Lockfile stehen zu lassen! Fr Diagnosezwecke wird eine
        PROCEDURE create_lock2 eingerichtet, die nicht jeweils eine
        Sekunde schlft, bis der nchste Versuch gemacht wird, das
        Lockfile anzulegen, sondern die dies dauernd versucht und
        zwischendurch immer wieder auf die Uhr schaut. Mal sehen, ob
        wir daraus irgendwie schlauer werden.
        Vielleicht gibt es ja doch Probleme mit StreamFile.Open beim
        Anlegen von Lockfiles. Aus der GPM-Mailingliste hatte sich
        im brigen kein Schwein gemeldet.
        Die Sache scheint wesentlich einfacher zu sein:
        Unterbricht man die Datenbertragung im Browser mit dem
        Stop-Button, bleibt das Lockfile garantiert stehen. Daran
        hatten wir bisher nicht gedacht. Wahrscheinlich luft das
        Programm dann auf einen Fehler auf (gebrochene Pfeife oder
        sowas in der Art) und rumt dann natrlich sein Lockfile
        nicht mehr weg. Das mssen wir auf jeden Fall korrigieren.

squash1/03.05.98:
        Und es war tatschlich so: Drcken des Stop-Buttons im Browser
        whrend einer Datenbertragung fhrt zu vorzeitigem Programm-
        abbruch. Interessanterweise ist die Fehlermeldung auf stderr
        abhngig davon, ob ein oder zwei (vielleicht auch mehrere)
        Browserfenster offen sind. Bei einem Fenster kommt:
        'Command terminated by signal 13' (das ist unsere gebrochene
        Pfeife (SIGPIPE)), bei mehr als einem Fenster sehen wir:
        'StdDevice.StdDevice_TextWrite: Unable to write to file
        Command exited with non-zero status 1'.
        In jedem Fall mssen wir also im Fehlerfall eine eigene
        Fehlerbehandlungsroutine einsetzen. Es scheint aber leider,
        als sei dies mit GPM _nicht_ mglich. In der Doku lesen wir
        zwar was von Exceptions, in der Realitt finden wir aber
        keine entsprechenden Module. Vielleicht machen wir einen
        letzten Anlauf bei der Mailingliste und sollten uns aber
        ansonsten doch mal darauf besinnen, unser Programm etwa
        nach OBERON zu portieren. Mit oo2c htten wir auch einen
        akzeptablen Kandidaten. Im Moment jedenfalls werden wir
        als Notlsung das Lockfile ganz schnell wieder lschen.

squash1/14.05.98:
        Die Mailingliste hat uns auch nicht viel weiter gebracht.
        Zwar hat uns K John Gough von der QUT eine Anregung
        gegeben, etwas mit 'atexit' zu machen, aber das hat z.B.
        das Signal 13 auch nicht auf unsere Routine umbiegen
        knnen.

squash1/16.05.98:
        Ein erneuter Anlauf in der Mailingliste hat nun wahrschein-
        lich die Erleuchtung gebracht. Geoffrey Elgey konnte die
        Probleme mit John's Antwort besttigen und hat uns ganz
        klar (was wir auch schon vermutet hatten) auf 'signal'
        hingewiesen. Damit werden wir's demnchst mal probieren.
        Aber vorher wollen wir dem Wunsch eines armen Users ent-
        sprechen, der aus der Squashpage nicht mehr herausgefunden
        hatte. Er bekommt ein paar externe Links.
        delete_lock wird auf try_delete_lock umbenannt.
        Auerdem wird ein ganz wichtiger weiterer Link eingebaut:
        Ein Link auf eine lokale Kopie meiner Internethomepage.

squash1/17.05.98:
        Bevor wir uns nun mit signal beschftigen, versuchen wir
        endlich mal die Zeit ein bichen besser in den Griff zu
        kriegen. Bisher haben wir im season-File zwar die Anzahl der
        Wochen abgelegt (wir wissen also, wie lange die Saison dauert),
        haben aber noch nirgends vermerkt, zu welchem Zeitpunkt
        die Saison tatschlich beginnt. Dies mssen wir nachholen.
        Wahrscheinlich werden wir die globale Variable season_start
        nennen oder so und meinen damit die KW, in der unsere neue
        Saison beginnt. Wir mssen nur noch festlegen, was wir damit
        genau meinen. Vielleicht zhlen wir die Wochen, die uns
        UNIXtime liefert, also die Anzahl verflossener Wochen seit
        dem 01.01.1970 oder wir nehmen die Julian Day Number als
        Basis und leiten davon die Julian Week Number ab?
        Eigentlich wrde uns die UNIXtime reichen. Hier htten wir
        TimeToStructTime zum Konvertieren von cardinals zur structured
        time, aber wir finden keine inverse Routine zum Konvertieren
        von der structured time zu einem cardinal. Zum selber Ausdenken
        sind wir zu faul. Deshalb nehmen wir wahrscheinlich einfach die
        bei http://quasar.as.utexas.edu/BillInfo gefundenen Rezepte zum
        Umwandeln zwischen der Julian Day Number und der structured
        time her.

squash1/21.05.1998:
        Wahrscheinlich werden wir doch selbst was ausdenken zum
        Invertieren von TimeToStructTime. Aber bevor wir dies tun,
        kommt nun endlich unsere Signalbehandlung. Geht wieder nicht,
        wie wir uns das dachten. Bei manuellem Programmaufruf
        werden alle gewnschten Signale wunschgem abgefangen
        durch unsere schne Routine. Wenn das Programm aber vom
        Webserver aus aufgerufen wird, sehen wir pltzlich kein
        Signal mehr.

squash1/22.05.1998:
        Zunchst haben wir an irgendwelche Gemeinheiten des Apache
        gedacht (da der etwa einfach SIGKILL schickt oder so),
        das scheint aber nicht der Fall zu sein. Vielmehr liegt
        es mglicherweise am Signalhandling von Linux. In der
        man page zu signal(2) steht nmlich:

        Unlike BSD systems, signals under Linux are reset to their
        default behavior when raised.

        Es scheint nmlich einen Unterschied zu geben, ob in der
        PROCEDURE CaughtSignal der Signalhandler sofort oder erst
        nach Ausgabe der Meldung neu aufgestzt wird. Mal sehen,
        was wir da machen. Insofern wrde das Bild dann zusammen-
        passen. Wenn wir nach Eintreffen des Signals auch nur ganz
        kurz herumtrdeln, kann ein neues Signal, welches uns noch
        _vor_ dem Neuaufsetzen des Signalhandlers erreicht, natrlich
        _nicht_ von unserer Routine bearbeitet werden. Damit htten
        wir dann den Salat.
        Irgendwo in der Beschreibung zum Apache war was gestanden,
        da sigaction besser sei als signal. Ob das fr uns auch
        irgendwie interessant ist, wissen wir noch nicht, mal sehen.

squash1/23.05.1998:
        Bei nochmaligem Hinsehen glauben wir nun endlich, die Sache
        im Griff zu haben. Bei unseren Tests hatten wir innerhalb
        CaughtSignal Testausgaben auf cid_out gemacht. War natrlich
        extrem ungeil, weil CaughtSignal ja gerade wegen gebrochener
        Pfeife aufgerufen worden ist. Wir wollen keine Entschuldigung
        bringen, aber wir hatten das Beispiel von Geoffrey Elgey
        _ohne zu denken_ bernommen. Bereits dort waren nmlich die
        Testausgaben eingebaut. Nach Entfernen derselbigen scheint
        nun alles o.k. zu sein.

squash1/24.05.1998:
        RaiseSignal kommt mit rein. try_my_cat und try_my_cat2
        werden etwas modifiziert, so da wir eine deutliche Geschwin-
        digkeitssteigerung bekommen.

squash1/26.05.1998:
        WriteLnCrLf noch etwas beschleunigen.

squash1/01.06.1998:
        Wir haben ein wenig mit gmtime, localtime und mktime herumgespielt.
        Scheint auch nicht besser zu sein, als TimeToStructTime aus der
        GPM-Library und unser Eigenprodukt (StructTimeToTime). O.k., wir
        haben wieder ein wenig hinzugelernt, wie wir Funktionen aus der
        libc in GPM einbinden knnen, aber dabei wollen wir es im 
        ersten Anlauf auch bewenden lassen. Es hat sich ein kleiner
        cleanup von Ctv1 ergeben und For4 heit nun Unix. In Unix
        lassen wir die eben erwhnten Neuerungen stehen, obwohl wir
        sie momentan nicht bentzen werden.
        Wie werden wir also global die neuen Zeitgeschichten einbringen?
        Die weiter oben erwhnte Variable season_start wird wahrscheinlich
        in Einheiten der UNIX Week Number gezhlt, d.h. z.B. vom 05.01.1970
        bis 11.01.1970 hatte sie den Wert 1. Der User darf/mu fr den
        gewnschten Saisonstart Tag, Monat und Jahr eingeben, intern
        wird aber die UWN abgelegt.
        Im sd_rec_typ ndert sich der Typ des wochentag von str_arr_zeil_typ
        auf int_arr_zeil_typ.

squash1/02.06.1998:
        Fr's erste haben wir nun endlich vernnftige Zeitgeschichten
        drin: Die Kalenderwochen werden ordentlich mitgezhlt und
        dargestellt, auch dort, wo wir bisher nur einen Datumsdummy
        (dd.mm.yyyy) hatten, steht nun ein richtiges Datum. Der
        season_start ist implementiert und wir sind im Moment
        sehr zufrieden. Natrlich fehlen noch ein paar Kleinigkeiten:
        Es gibt noch _keine_ Sekretrin, die Spieler heien immer noch
        Spieler1, Spieler2 usw. und nicht wie normale Menschen, Eintrag-
        ungen sind noch zu jedem beliebigen Zeitpunkt mglich (also nicht
        erst nach 9 Uhr bis maximal einschlielich bernchste KW), ein
        Spieler kann beliebig oft pro Woche eingetragen sein, sogar zweimal
        im gleichen Court, fr Gastspieler ist noch gar nichts vorgesehen,
        die Administration lt noch arg zu Wnschen brig.
        Das alles ist uns aber momentan so ziemlich Wurscht, weil das
        nur Kleinigkeiten sind :-)

squash1/03.06.1998:
        Wir sollten nochmal ganz genau nachdenken ber die Unterschiede
        zwischen GMT (UTC) und lokaler Zeit. Grundstzlich scheint
        die Umwandlung zwischen (Unix-)sekunden und etwa Wochentagen,
        Monaten usw. zu funktionieren, aber uns sind die Zusammenhnge
        doch noch nicht 100%-ig klar. Etwa so: die GMT betrgt 23 Uhr 30
        am 31.12., die lokale Zeit bei uns ist dann aber schon 0 Uhr 30
        am 01.01., d.h. GMT und lokale Zeit haben nicht nur einen
        unterschiedlichen Kalendertag (und auch unterschiedlichen
        Kalendermonat), sondern gehren evtl. auch unterschiedlichen
        Wochen an. Wie gesagt, es scheint momentan o.k., der einzige
        Moment, an dem wir das aktuelle Datum brauchen werden, ist
        wenn entschieden werden mu, ob die gewnschte Ein-/Austragung
        gemacht werden kann. Das aktuelle Datum von UNIXtime ist offenbar
        die UTC, wir mssen unsere Entscheidung aber nach lokaler Zeit
        treffen (etwa: vor 9 Uhr geht noch nichts mit bernchster
        Woche). Also mal abwarten...

squash1/04.06.1998:
        Wir geben dem Volk mal wieder eine neue Spielversion und tun
        dabei so, als wrde die Saison in der Woche 05.-11. Oktober 1998
        beginnen und 30 Wochen dauern. Auerdem verwenden wir mal zur
        Abwechslung richtige Namen anstatt Spieler1, Spieler2 usw..

squash1/09.06.1998:
        Cont.

squash1/11.06.1998:
        Wir mssen '(frei)', (Auswahl)', 'Admin' und 'Sekri' etwas
        geschickter verwalten. Ist o.k.. Solange der User noch keine
        Auswahl getroffen hat, wird er sowohl beim Dialog zum Kennwort-
        ndern als auch beim Dialog zum Spielereintrag wieder auf die
        Abfrageseite zurckgeworfen (mu er eben echt was auswhlen
        oder 'nicht OK' geben). Sidenote: in den Court eingetragen
        werden knnen alle Spieler und auch (ber den Umweg des Austragens
        eines Spielers) der '(frei)', nicht aber die (Auswahl), der Admin
        und die Sekri. Kennwortnderung ist mglich fr alle Spieler,
        den Admin und die Sekri, nicht aber fr den '(frei)' und die (Auswahl).
        Die letzteren beiden haben nur zufllig ein Kennwort bekommen,
        das sie nicht brauchen (siehe bei init_spieler), deshalb lassen
        wir es auch nicht ndern.

squash1/12.06.1998:
        Ein paar Umbenennungen bei den Datumsgeschichten. Fngt schon
        an bei der JDN. Diese wird aus einem Record vom Typ DateTime
        berechnet. Allerdings werden nur die Felder year, month und
        day verwendet. Offensichtlich erhalten wir dadurch eine _lokale_
        JDN und _nicht_ die UNIX JDN. Denn wenn z.B. die UNIX-Uhr auf
        23 Uhr 30 zeigt, sehen wir auf der lokalen Uhr schon 0 Uhr 30
        (aber haben dafr natrlich eine zone von -60). Jedenfalls
        bringt unsere JDN fr diesen Zeitpunkt bereits einen Tag
        weiter heraus, als wenn wir year, month und day der UNIX-Uhr
        verwendet htten. Unser JDN wird daher LJDN genannt (L fr
        lokal).

squash1/14.06.1998:
        Wir sind mit der GPM TimeToStructTime nicht ganz zufrieden, weil
        die immer eine lokale Zeit generiert. Wir wollen aber eine
        strukturierte GMT haben. Deshalb werden wir wohl doch
        GmTime aus Unix bemhen mssen. Die neue PROCEDURE wird dann
        TimeToGmStructTime heien.
        Mal probieren, ob wir Doppeleintragungen abwenden knnen.
        Aber vorher ein bichen cleanup mit schreib_reihe2, schreib_reihe5
        usw. die an verschiedenen Stellen praktisch identisch definiert
        sind. So, fr heute ist Schlu. Sind an dieser Stelle noch
        nicht fertig. Das nchste mal...

squash1/15.06.1998:
        Cont cleanup.

squash1/21.06.1998:
        Cont cleanup. Alle schreib_reihe<i> sind verschwunden.
        Wieder ist uns was anderes eingefallen, bevor wir versuchen,
        Doppeleintragungen zu vermeiden: die Datenstruktur fr
        die Courts etwas modifizieren. Momantan stehen im season-File
          1. berflssige Zahlen ber die Courtbelegeung drin. Namentlich
             betrifft das uns_courts_anz und geschrumpfter_index. Es wird
             neben einem geraden Index immer auch der ungerade mit
             notiert. Ist natrlich nicht ntig.
          2. geschrumpfter_index ist eine lineare Angabe ber die
             belegten Courts. Es wre bersichtlicher, etwa direkt
             eine Matrixangabe zu verwenden. Der erste Index etwa
             wrde die Zeile, der zweite die Spalte angeben.
        berhaupt scheint die gesamte Tabelle reichlich kompliziert.
        Es gibt einen court_belegung_typ, einen uns_court_typ und
        einen geschrumpfter_index_typ. Sollte es nicht mglich sein,
        stattdessen nur _ein_ Feld zu bentzen? Eine Belegung mit -1
        z.B. wrde den Court als _nicht_ unseren Court markieren, Werte
        ab 0 htten die bisherige Bedeutung. Um zu speichern, welche
        Courts von uns belegt sind, wird einfach ein Zeile/Spalte-Paar
        abgelegt, fertig.

squash1/22.06.1998:
        Die eben erwhnte Schrumpfung scheint nicht mglich.

squash1/23.06.1998:
        Wenigstens haben wir die uns_courts_anz halbiert. Der Rest
        bleibt zunchst mal gleich.

squash1/24.06.1998:
        Endlich gehen wir das Thema der Doppeleintragungen an.

squash1/27.06.1998:
        Cont.

squash1/04.07.1998:
        Wir befinden uns gerade in Pretoria auf einer Dienstreise. Nachdem
        es um halb sieben drauen schon stockfinster ist und wir morgen
        (am Sonntag) sowieso wieder den ganzen Tag auf Achse sind
        (irgendeinen Markt anschauen, Schlittschuhlaufen und was wei ich
        noch), setzen wir uns lieber ein bichen an die Kiste und basteln
        z.B. hier ein wenig weiter.
        Am 24.06.1998 haben wir in act_p2ac1 nun endlich eine Manahme
        gegen unerwnschte Mehrfacheintragungen eingebaut. Allerdings
        mssen wir nun nochmal genau ber dieses Thema nachdenken. Hier
        also ein paar Gedanken zum Thema (und evtl. auch ein paar
        Abschweifungen):
        Erstens sollten etwa in der aktuellen Woche Mehrfacheintragungen
        durchaus erlaubt sein, wenn sonst eh kein Schwein spielen will.
        Zweitens berlegen wir, ob wir nicht die Sekri an dieser Stelle
        mit ins Spiel bringen sollten. Vielleicht sollte sie sozusagen
        eine Allmacht haben und im Notfall eine Eintragung machen knnen,
        wenn dies fr den normalen Spieler nicht erlaubt ist. Natrlich
        sollte auch die Sekri nicht die Vergangenheit verndern drfen.
        Wie die ganze Sache im Zusammanhang mit Gastspielen zu behandeln
        ist, mssen wir auch noch berlegen. Weiterhin werden wir der
        Sekri natrlich auch das Recht der Austragung geben mssen.
        Wie wir das mit Weihnachten handhaben, ist auch noch nicht so
        recht klar. Da sind nmlich Eintragungen (und dementsprechend
        Austragungen) nicht nur bis einschlielich bernchste KW
        mglich, sondern z.B. schon 3 oder 4 Wochen im Voraus. Evtl.
        mssen wir da wirklich mit einer Tabelle arbeiten.
        Grundstzlich soll fr jeden ein lesendes Durchblttern der gesamten
        Saison mglich sein. Die Vergangenheit soll niemand verndern
        knnen, die Sekri darf beliebig weit in die Zukunft greifen,
        der normale Spieler wird durch die evtl. noch einzufhrende
        'Zukunftstabelle' eingeschrnkt werden. Die Sekri sollte in der
        Zukunft beliebige (Mehrfach)eintragungen machen drfen.
        Das bedeutet, da wir bei einer gewnschten Ein- oder Austragung
        mittels page01 unterscheiden mssen, ob die Gegenwart bzw.
        Zukunft oder die Vergangenheit verndert werden soll. Bei
        Zugriff auf die Vergangenheit sollten wir anstatt der Ein-
        bzw. Austragungsseite nur einen bummer ausgeben, da eben nichts
        geht. Bei Zugriff auf die Zukunft zeigen wir die Ein- bzw. Aus-
        tragungsseite.  Erst hier wird dann entschieden: die Sekri darf,
        der normale User wird ggf. abgewiesen. Der Administrator hlt sich
        im brigen aus diesen ganzen Geschichten vornehm heraus. Er ist
        fr grere Dinge auserwhlt: etwa eine komplett neue Tabelle
        anlegen oder evtl. gewisse formale nderungen an der Tabelle
        vornehmen, wie z.B. Rechtschreibnderungen an den Spielernamen
        oder nderungen in anderen (sonst fixen) Texten vornehmen. Mit
        niederen Ein- oder Austragungsfunktionen hat der Administrator
        nichts zu tun.
        Als erstes haben wir nun also Geschichtsflschungen verhindert!

squash1/07.07.1998:
        Zumindest versehentliche Geschichtsflschungen sind momentan
        nicht mglich, weil wir lediglich auf page01 eine entsprechende
        Abfrage eingebaut haben. Ein bser Hacker kann aber immer noch
        seine eigene HTML-Seite bauen und dann Eintrgungen machen.
        Auch das wollen wir verhindern. Nicht, weil die Squasher bse
        Menschen sind, sondern weil wir ein akademisches Interesse
        am Schlieen von Sicherheitslchern haben.
        Auch der Hacker kann nun keine Geschichtsflschungen mehr
        vornehmen.
        Die Sekri kann nun beliebig viele Eintragungen (in der Zukunft)
        machen, der normale User nur eine. Der normale User kann aber
        Mehrfacheintragungen wieder lschen. Dazu mu er nicht die
        Sekri fragen.

squash1/08.07.1998:
        Cont.

squash1/12.07.1998:
        jahr_wochen_zugriff ist eingefhrt. Dies ist eine Zahl, die
        angibt, wieviele Wochen die aktuelle KW von der zu manipulierenden
        Woche noch entfernt sein darf, damit der User bereits eine
        Eintragung machen darf. Dieser Wert wird fr alle Wochen
        mit 2 vorbesetzt. Im brigen darf der User in der aktuellen
        KW nun 2 Eintragungen machen, in den anderen durch jahr_wochen_zugriff
        bestimmten Wochen eine Eintragung und sonst keine. Auerdem
        geht am Montag erst nach 9.00 Uhr was mit der am weitesten
        in der Zukunft gelegenen Woche.
        Wir bemerken soeben, da Unix.Crypt offenbar nur die ersten
        8 Zeichen des eingegebenen Kennworts verwendet. Ob das gut
        so ist oder nicht, wissen wir momentan nicht.

squash1/13.07.1998:
        Cont.

squash1/21.07.1998:
        Test mit echter UKW anstatt fiktiver. Todo: evtl. sollte die
        Sekri oder der Admin Kennwrter neu vergeben knnen. Ist
        bisher nicht mglich.
        Achtung: wir mssen die Geschichtsflschung noch verfeinern!

squash1/25.07.1998:
        Geschichtsflschung verfeinern. Dazu mssen wir zuerst die
        Uhrzeiten (wie das fr die Wochentage schon vor langer Zeit
        mittels week_str geschehen ist) ber einen weiteren Index laufen
        lassen: hour_str. Machen wir zunchst als Konstante, vielleicht
        spter mal 'ne Funktion...
        Im sd_rec_typ ndert sich der Typ der uhrzeit von str_arr_spalt_typ
        auf int_arr_spalt_typ.

squash1/26.07.1998:
        Cont. Geschichtsflschung verfeinern.

squash1/27.07.1998:
        Die 'Fehlliste' vom 02.06.1998 ist wieder etwas kleiner geworden.
        Nun gilt nur noch: fr Gastspieler ist noch gar nichts vorgesehen,
        die Administration lt noch (arg) zu Wnschen brig. Aber auch
        das werden wir in den Griff bekommen.

squash1/02.08.1998:
        Nebenbei minimales Debugging in act_p4ac5.
        Auch Gste werden nun bercksichtigt. Allerdings drfen diese nur
        durch die Sekri eingetragen werden. Nach einigem Hin und Her haben
        wir uns entschlossen, das season-File fr die Gste um einen
        zustzlichen Eintrag pro Spieler aufzublasen. Das ist zwar
        nicht sehr elegant in Bezug auf die Filegre, aber insgesamt
        erreichen wir dadurch ein etwas bersichtlicheres Handling,
        als wenn wir den Gast irgendwie als Pseudospieler eingefhrt
        htten. Nun gibt's eben einfach ein zustzliches Flag, welches
        besagt, ob ein Gast im Court sitzt oder der Spieler selbst.

squash1/10.08.1998:
        Bis auf die noch ausstehenden Administrationsgeschichten (und
        evtl. vorhandene Bugs) stellt die Version vom 02.08.1998 eine
        brauchbare Lsung dar. Also: Wie soll die Remote-Administration
        nun konkret aussehen? Im Moment haben wir so etwas wie eine
        Mini-Remote-Administration eingebaut und zwar fr den Fall,
        da _kein_ season-File existiert. Der vermeintliche Spieler
        wird in diesem Fall sofort gefragt, ob eine neue Datenbasis
        angelegt werden soll. Natrlich kann nur der Administrator
        (mit seinem Kennwort) dies wirklich tun. Allerdings beschrnkt
        sich die Aktivitt des Administrators im Moment nur auf das
        Eingeben seines Kennworts. Er hat keine Mglichkeit, irgendwie
        auf den Inhalt der Datenbasis Einflu zu nehmen. Genau dies
        wollen wir aber erreichen. Es stellt sich lediglich die Frage,
        zu welchem Zeitpunkt dies am besten geschehen sollte. Mglicher-
        weise sollten wir bereits beim Anlegen einer neuen Datenbasis
        vom Administrator etliche Sachen erfragen. Auerdem knnte es
        Daten geben, die erst im spteren Verlauf gendert werden
        mssen. Es wird also sinnvoll sein, die verschiedenen Daten in
        zwei Gruppen einzuteilen.
        Die eine Gruppe enthlt grundstzliche,
        globale Daten, von denen die gesamte Tabelle abhngt. Dies werden
        im wesentlichen die in init_globals festgelegten Werte sein.
        Anstatt wie bisher nur zu entscheiden, _ob_ eine neue
        Datenbasis mit gewissen in init_globals vorbelegten Daten
        angelegt werden soll, kann er zuknftig diese Daten _vor_
        dem Anlegen eines neuen season-Files (in bestimmten Grenzen)
        selbst bestimmen. Diese Daten knnen spter nicht mehr ver-
        ndert werden. Z.B. macht es keinen Sinn, die Anzahl der
        Zeilen oder Spalten zu ndern und gleichzeig die Tabelle aber
        nicht ndern zu wollen, das geht halt nicht. Auch uns_courts_anz
        sollte gleich zu Beginn festgelegt werden. Dies sollten wir
        aber indirekt ber die Tabelle machen: der Administrator sollte
        die komplette Tabelle vor sich sehen und die angemieteten
        Courts anklicken knnen. Das Anlegen eines season-Files
        wird also in mehreren Schritten erfolgen und erst am Ende
        erhlt der normale Spieler wieder Zugang. Auf dem Weg dorthin
        kann das season-File durchaus ein fr den normalen Spieler nicht
        vorgesehenes Aussehen haben.
        Die andere Gruppe enthlt im wesentlichen die Spielernamen.
        Wahrscheinlich sollten wir aber auch diese bereits beim Anlegen
        des season-Files durch den Administrator erzeugen/modifizieren
        lassen. Die Frage ist nmlich, ob es Sinn macht, dem
        Administrator spter etwa unter 'ich will...' mehr machen
        zu lassen, als eine Kopie des aktuellen season-Files zu
        erzeugen und es ggf. zu lschen, damit er anschlieend
        ein neues anlegen kann. Was wir mit Schreibfehlern in
        Spielernamen machen, werden wir noch entscheiden mssen.
        Hinweis: schreib_page06, schreib_page07 und schreib_page13
        unterscheiden sich nur geringfgig voneinander. Vielleicht
        sollten wir aus konomischen Grnden eine einzige PROCEDURE
        daraus machen, mal sehen.

squash1/11.08.1998:
        Wir mssen max_param_anz erhhen, um noch mehr Parameter
        vom Client entgegennehmen zu knnen. Bisher hat jeder INPUT-
        Parameter eine feste Bedeutung. Etwa 0 fr 'label', 1 fr
        'ukw' usw.. Knnen wir auch weiterhin evtl. beibehalten,
        mssen uns nur Gedanken machen, ob wir nicht ein paar sparen
        knnten, weil ja diverse Sachen mittels verschiedener pages
        eigegeben werden sollen. 

squash1/15.08.1998:
        Nein, im ersten Anlauf werden wir die INPUT-Parameter nicht
        mehrfach belegen, weil das einfacher zu machen ist.

squash1/16.08.1998:
        Cont.

squash1/17.08.1998:
        Ein bichen Aufrumen in init_season_data und get_season_data.
        init_season_data wird auf default_season_data umgetauft.
        Dafr wird es zustzlich ein reset_season_data geben, das eher
        einen grundstzlichen Reset der Saisondaten vornimmt, welcher
        sowohl bei Abweseneit als auch bei Anwsenheit eines season-Files
        bentigt wird.

squash1/18.08.1998:
        Cont. Diverse min/max-Werte sind noch pessimal.

squash1/20.08.1998:
        Cont.

squash1/22.08.1998:
        Cont. In check_ukw bzw. advance_ukw wird nicht nur auf berlauf,
        sondern auch auf Unterlauf geprft. In analyse_globals_and_react
        prfen wir schon mal, ob neue Basisparameter gewnscht werden.
        Mssen wir noch etwas ausbauen.

squash1/23.08.1998:
        In schreib_erste_reihe in schreib_page1_table1 werden wir zum
        Spa zwei weitere Buttons einfhren: einen zum direkten
        Ansteuern der ersten Spielwoche und einen fr die letzte.
        default_season_data wurde wieder weitestgehend abgespeckt.
        Vielleicht werden wir in Zukunft wieder darauf verzichten
        knnen und nur noch ein, sagen wir, modify_season_data
        einsetzen, welches wir aufrufen, falls der Administrator
        etwas an den globalen (Basis-)daten gendert hat.

squash1/26.08.1998:
        Zustzlicher Testhinweis in berschrift.
        Auf Anregung eines langjhrigen Spielers hin werden wir 'Admin'
        in 'Chef' umtaufen. Betreffender Spieler hatte eine Verwechs-
        lungsgefahr etwa mit 'Armin' gesehen. Wir werden aber nicht
        alle _admin_-Stellen in _chef_ umwandeln. Es soll gengen,
        wenn die fr den User sichtbaren Sachen gendert werden.
        Eben erwhnter Spieler hat auch bemerkt, da es beim ndern
        des Kennworts sehr leicht passieren kann, da man versehentlich
        _keine_ Eintragung, d.h. zweimal den Nullstring als neues
        Kennwort eingibt und fortan sozusagen ohne Kennwort arbeiten
        kann. Dies werden wir in Zukunft abgfangen. Das Kennwort
        darf nicht aus dem Leerstring bestehen.

squash1/29.08.1998:
        Die Eingabe globaler Daten sieht soweit ganz gut aus. Die
        uns_courts_anz ist allerdings noch nicht editierbar, weil
        diese zuknftig als Nebenprodukt beim Festlegen unserer
        Courts anfallen wird. Fragt sich also, wie wir weiter
        vorgehen werden. Z.B. heien die Spaltenberschriften
        momentan alle 'keine Zeit' und die 'Zeilenberschriften'
        enthalten 'kein Tag' und 'kein Court'. Wir knnten diese
        beiden Sachen gemeinsam mit der Festlegung unserer Courts
        in _einer_ neuen page eingeben. Vielleicht sollten wir
        aber mehrere kleine Tasks draus machen, d.h. z.B. die
        nchste page nach Eingabe der globalen Daten (page07)
        knnte nach den 'Zeilenberschriften' fragen, die ber-
        nchste nach den Spaltenberschriften.
        So haben wir's auch gemacht: page14 ist fr die
        'Zeilenberschriften' und page15 fr die Spaltenberschriften
        zustndig. Falls sich brigens jemand fragt, warum
        'Zeilenberschriften' mit Anfhrungszeichen und
        Spaltenberschriften ohne daherkommen, ganz eifach:
        fr die Spalten ist es eine echte berschrift, fr die
        Zeilen eigentlich eine 'Nebenschrift', weil sie neben und
        nicht ber der Zeile steht.

squash1/31.08.1998:
        Also versuchen wir, unsere Courts festzulegen. Dazu werden
        wir page16 einfhren. Wie beschlossen, werden wir also
        eine ganze Menge neue input-Werte definieren mssen, nmlich
        max_zeil_anz*max_spalt_anz Stck.
        Scheint auch zu funktionieren. Evtl. werden wir spter aber
        doch wieder _eine_ page verwenden anstatt dreier verschiedener,
        um die Zeilen, Spalten und unsere Courts zu definieren. Dies
        sollte auch keine Probleme machen, weil wir sowieso schon
        lauter _verschiedene_ input-Parameter verwenden. Mal sehen.

squash1/01.09.1998:
        Schon wieder hat uns ein minimaler grippaler Infekt heim-
        gesucht. Ganz hnlich zum 10.02.98 war es auch heute am
        Dienstag nocht nichts mit Arbeiten. Vielleicht geht dafr
        aber hier ein bichen was vorwrts. Also: Das mit der _einen_
        page fr Zeilen, Spalten und unsere Courts scheint o.k.. Haben
        wir kurzfristig einfach in page16 mit eingebaut. Wir werden
        also page14 und page15 wieder zurckbauen und spter dann
        die Spieler drannehmen.
        page14 und page15 sind verschwunden, page16 heit nun page14
        und es herrscht allgemeine Zufriedenheit.
        Anstatt des radio-Buttons haben wir in page14 nun also eine
        checkbox genommen, ist viel geiler.
        Nun also zu den Spielern. Sobald spieler_anz feststeht,
        knnen / mssen folgende Informationen bereitgestellt werden:
        Spielername, wchentlich / 14-tgig, Kennwort. Beim Anlegen
        einer (neuen) Datenbasis mssen diese Informationen
        tatschlich alle irgendwie neu eingegeben werden. D.h.
        wir mssen eine Mglichkeit vorsehen, etwa in einer weiteren
        page (vielleicht page15), diese Sachen eingeben zu knnen.
        Spter, wenn also bereits eine Datenbasis existiert, kann es
        passieren, da wir etwa eine Rechtschreibkorrektur an einem
        Namen vornehmen mssen, oder irgendeinem Schlaumeier ein
        neues Kennwort verpassen mssen, weil er etwa sein altes
        vergessen hat. Alle anderen Spieler sollten davon aber nicht
        betroffen sein. Weil wir nicht die Kennwrter selbst, sondern
        lediglich deren crypt-ische Erscheinung in die Datenbasis
        aufnehmen, knnen wir die aktuell gltigen Kennwrter der
        Spieler _nicht_ ermitteln oder irgendwie anzeigen, also z.B.
        so: alle Informationen lesen, anzeigen, ggf. editieren und
        alles wieder abspeichern. Die Vergabe eines Kennworts an einen
        Spieler durch den Chef kann also nur unter Unkenntniss des
        alten Kennworts erfolgen (im Gegensatz zur Neuvergabe des eigenen
        Kennworts durch den Spieler oder den Chef bzw. die Chefin selbst).
        Wir brauchen daher in jedem Fall die Mglichkeit, etwa das Kennwort
        der Spieler auch _nicht_ ndern zu knnen, falls bereits eine
        Datenbasis vorhanden ist. Wir werden das ganz einfach so machen:
        Die page zur Eingabe von Spielername, wchentlich / 14-tgig
        und Kennwort wird eine weitere checkbox dafr bekommen, ob
        tatschlich ein neues Kennwort vergeben werden soll. Voreinstellung
        ist, da _kein_ neues Kennwort vergeben wird. Klingt das nicht gut?
        brigens: default_season_data fliegt ganz raus.
        Scheint alles (vllig berraschenderweise) geklappt zu haben.
        Was evtl. noch zu tun wre: jahr_wochen_zugriff ebenfalls
        editierbar machen. Und natrlich: wir haben noch kein
        Handling zum Erstellen von Backups oder Kopieren von
        season-Files. Und ein bichen mssen wir das ganze bisher
        existierende Zeug nochmal auf Herz und Nieren prfen,
        ob's auch keinen rger gibt, wenn der Chef eine Kleinigkeit
        ndert, was dann mit den alten Daten passiert oder ob
        wir evtl. doch noch ein bichen nachhelfen mssen.
        Mal sehen, ob's mit dem jahr_wochen_zugriff auch so einfach
        geht. Ja, das geht auch so einfach! Schlu fr heute.

squash1/02.09.1998:
        Test geht zuende, jetzt machen wir Ernst.
        Am Ende des Wartungszyklus wird gefragt, ob der Wartungsmodus
        wieder verlassen werden soll, wenn nicht, geht's nochmal
        von vorne los.

squash1/03.09.1998:
        Die Sekri heit in Zukunft Chefin. Fr die durchzufhrenden
        Codenderungen gelten hnliche Argumente wie beim Chef.

squash1/04.09.1998:
        Nicht so viele Kennwortabfragen fr den Chef und ein paar 
        weitere Kleinigkeiten. Scheint aber etwas komplizierter, als
        wir gedacht haben. Also erst mal abwarten...

squash1/13.09.1998:
        Offenbar gibt es eine weitere Nebenbedingung fr mgliche
        Eintragungen: ab Donnerstag 9.00 Uhr ist eine weitere
        Eintragung fr die darauffolgende Woche mglich. Hatten
        wir bisher nicht bercksichtigt. Ist aber noch nicht ganz
        klar, ob das tatschlich implementiert wird, denn die
        Chefin freut sich bestimmt ber den einen oder anderen Anruf.

squash1/16.09.1998:
        Es gibt einen kleinen Schnheitsfehler, der nicht einmal so
        klein ist. Wenn man freiwillig in den Wartungsmodus umgeschaltet
        hat, wird es i.a. passieren, da der im season-File eingetragene
        Saisonstart bereits _vor_ dem aktuellen Datum liegt. Dies ist
        noch nicht wirklich schlimm, das eigentliche Problem liegt
        darin, da wir als frhest mglichen Saisonstart immer das
        aktuelle Datum nehmen. Das ist natrlich Schwachsinn. Fr den
        Fall, da kein season-File da ist, geht das ja in Ordnung, im
        anderen Fall aber nicht! Wir sollten daher als minimal erlaubten
        Saisonstart etwa das Minimum der beiden Werte aktuelles
        Datum oder Wert aus dem season-File (falls vorhanden) nehmen.
        Ein bichen sonstiges Debugging, insbesondere was die ukwa und
        deren Umfeld angeht.

squash1/17.09.1998:
        In analyse_globals_and_react nochmal genau prfen, welche
        Sachen zurckgesetzt werden mssen, falls sich Basisdaten
        gendert haben. Analog in analyse_layout_and_react.

squash1/20.09.1998:
        Ein paar Schnheitsreparaturen.

squash1/27.09.1998:
        Offenbar haben wir den kleinen Schnheitsfehler am 16.09.1998
        nicht in vollem Umfang erkannt. Uns macht immer noch der
        minimal erlaubte Saisonstart Probleme. Weil wir den Saisonstart
        in Jahr und KW aufteilen, bekommen wir i.a. fr die KW einen
        minimal erlaubten Startwert von ungleich 1. Damit ist es
        aber z.B. nicht nur ausgeschlossen, im 'mimimalen' Jahr die KW
        1 zu verwenden, sondern generell. Das ist natrlich voll bld.
        Die ganze Sache haben wir uns eigentlich nur eingebrockt, weil
        wir nicht erlauben wollten, eine neue Saison anzulegen, die
        schon in der Vergangenheit beginnt. In der Tat macht eine
        solche neue 'alte' Saison wenig Sinn, weil kein Mensch je
        eine Eintragung in der Vergangenheit machen kann. Aber vielleicht
        mogeln wir uns aus dem momentanen Eingabe-Dilemma einfach
        dadurch heraus, da wir eben beliebige Startzeiten fr eine
        neue Saison erlauben. Ja, vielleicht knnten wir ganz clevere
        Dinge machen: erst das Startjahr abfragen und mit dieser
        Kenntnis dann den Eingabebereich fr die Startwoche festlegen.
        Oder vielleicht gar etwas mit Javascript oder Java. Dies
        wollen wir uns aber im Moment alles nicht antun. Und daher
        werden wir wohl beliebige Saisonstarts erlauben.

squash1/09.10.1998:
        Roland bemngelt ungeschickte Fehlermeldungen im Wartungsmodus.

squash1/10.10.1998:
        'Unerwartete Aktionen' auch etwas benutzerfreundlicher behandeln.
        Dies gilt aber nicht fr process_admin_get_action und
        process_user_get_action, denn wenn hier eine falsche Aktion
        ankommt, wurde im URL explizit gehackt und das wollen wir
        nicht untersttzen.
        Was wir evtl. tatschlich noch nachbessern sollten, ist
        die Mglichkeit, sich bereits am Donnerstag ab 9.00 Uhr fr
        die darauffolgende Woche nochmal einzutragen. Der Brauni
        hatte damit erhebliche Probleme (vielleicht hatte er die
        Telefonnummer der Chefin vergessen oder was).
        Minimales Debugging: der User konnte sich nicht zu seinem
        Gast hinzutragen. Wurde berichtigt.

squash1/11.10.1998:
        Ein bichen weitere Kosmetik. Insbesondere bekommt der
        Wartungsmodus ein 'Progressmeter', so da im Wartungsmodus
        zum einen jederzeit ersichtlich ist, da wir uns in selbigem
        befinden und zum zweiten klar ist, welcher der mglichen
        Wartungsschritte gerade angesagt ist.

squash1/15.10.1998:
        Gibt wieder mal nderungswnsche: nachdem im wirklichen Leben
        bis zu einem bestimmten Zeitpunkt nicht belegte Courts an das
        Sportcenter zurckgegeben werden, sollten diese auch als solche
        gekennzeichnet werden, damit nicht irgendein Loser noch versucht,
        sich dort einzutragen. Wir haben ein bichen herumgepatcht, sind
        aber nicht so recht zufrieden damit. Vielleicht wre es am
        einfachsten, wenn auch nicht sehr elegant, der Chef wrde
        einfach einen weiteren Spieler anlegen und diesen einfach
        im verkauften Court zweimal eintragen. h, das mte ggf. die
        Chefin machen, weil nur sie sich beliebig oft eintragen kann.
        Bei der Gelegenheit: warum soll eigentlich der Chef selbst
        keine Ein- bzw. Austragungen machen drfen? Ehrlich gesagt,
        wir wissen es nicht mehr so recht. Wahrscheinlich war es
        nur so, da er sich einfach mit derart niederen Ttigkeiten
        nicht abgeben sollte. Um aus obiger Bedrngnis herauszukommen,
        werden wir das nun ndern. In Zukunft werden also sowohl der
        Chef als auch die Chefin beliebige Ein- bzw. Austragungen
        vornehmen drfen.

squash1/18.10.1998:
        Vielleicht stellen wir das Programm hier eines Tages mal ins
        Netz. Damit die Installation fr den unbedarften neuen Benutzer
        mglichst einfach und bersichtlich vonstatten geht, mssen wir
        noch ein bichen feilen. Neben einem kleinen README, das wir
        ggf. auch in Englisch verfassen sollten, betrifft das vor allem
        das Handling von (File-)Pfaden. Es ist klar, da nicht jeder
        Benutzer die squash_base bei '/home/rudolf/lern/www/squash'
        liegen hat! Um in der Sprache des 'apache' zu reden, mssen
        wir uns also Gedanken ber die 'DocumentRoot' bzw. einen 
        geeigneten 'Alias' und auch ber einen geeigneten 'ScriptAlias'
        machen. Anstatt eine squash_base fest einzuprogrammieren,
        sollten wir lieber mit Umgebungsvariablen arbeiten. Dadurch
        sollte dann auch ein Betrieb _ohne_ Neucompilierung mglich
        sein, falls die Menschen mit GPM nicht so sehr befreundet sind.

squash1/19.10.1998:
        Haben die doch echt einen Bug in schreib_wann_und_wo entdeckt.
        An geeigneter Stelle wurde der relative Wochentag zweimal zum
        Wochenbeginn addiert. Aus Di, 3.11. wurde Di, 4.11., aus Mi,
        4.11. wurde Mi, 6.11. usw.. Sehr peinlich.

squash1/22.10.1998:
        vor_9_donnerstag wurde falsch berechnet. Sieht jetzt besser aus.
        Auerdem gibt's einen Sinneswandel: der Spieler darf jetzt selbst
        einen Gast eintragen, da ist nicht mehr einer der Chefs ntig.
        Was noch zu tun bleibt: genau festlegen, wie oft der Spieler
        selbst bzw. der Gast in der aktuellen bzw. ab Donnerstag 9.00 Uhr
        in der kommenden Woche eingetragen werden darf/soll.

squash1/25.10.1998:
        Bevor wir das mit den Eintragungen klren, wird noch ein bichen
        aufgerumt in Bezug auf die einfachere Installation.
        count_oft wird in count_oft_selbst und count_oft_gast aufgeteilt.

squash1/26.10.1998:
        Natrlich gibt es schon wieder Sonderwnsche: manche Menschen
        knnen sich nicht merken, wann Eintragungen mglich sind. Sie
        wollen es aber auch nicht ausprobieren, sondern sie wollen einen
        netten kleinen Hinweis mglichst in Nhe der berschrift haben,
        der ihnen etwa sagt: Ersteintragung mglich in KWx1, KWx2,
        Zweit-/Gasteintragung in KWy1, KWy2. Ist natrlich mal wieder
        nicht so ganz einfach zu realisieren, weil insbesondere die
        Frage nach der Ersteintragung nur entschieden werden kann,
        nachdem alle zuknftigen Wochen, die nicht weiter als
        max_jahr_wochen_zugriff entfernt liegen, auf ihren Wert fr
        jahr_wochen_zugriff hin untersucht worden sind.

squash1/04.11.1998:
        Cont.

squash1/07.11.1998:
        Cont. page08 erhlt eine weitere Funktion: Webserver Logfile
        ansehen.

squash1/08.11.1998:
        TextIO.ReadString scheint ein 0FFH im File als endOfInput
        zu interpretieren. Ist uns in try_my_cat2 aufgefallen. Das
        wollen wir natrlich nicht.

squash1/05.12.1998:
        try_my_cat2 verschwindet zugunsten von try_my_cat_raw.
        Damit knnen wir nun den Bug in TextIO.ReadString umgehen!
        Ein paar uralte Leichen rausschmeien, die eh keiner mehr
        braucht: create_lock2, schreib_th_text und so.
        Es gibt wieder nur noch eine cat-Routine: try_my_cat.
        ber den Parameter 'mode' lt sich angeben, ob nur kleine
        (CrLf) Ersetzungen gemacht werden oder ob etwas grndlicher
        gearbeitet wird.

squash1/06.12.1998:
        Noch ein bichen an try_my_cat feilen.

squash1/13.12.1998:
        Die Chat-/Newsecke vorantreiben. Nebenbei: die Indizes fr
        input als Konstante definieren und nicht mehr immediate in
        den Programmtext als reine Zahlen hinschreiben.

squash1/17.12.1998:
        Cont.

squash1/18.12.1998:
        Wir sind mit der Chat-/Newsecke noch nicht so ganz zufrieden.
        Weil der vom User einzugebende Text, wie alle anderen Eingaben
        auch, ber ein Element des input-Arrays verarbeitet wird, werden
        berschssige Zeichen, die nicht mehr im 'value_strr' Platz haben,
        einfach ignoriert. Das ist nicht gut so. Insbesondere kriegt der
        Autor, falls er nicht nochmal die Chat-/Newsecke aufruft, keiner-
        lei Hinweis auf die unerwnschte 'Datenreduktion'. Eine sehr
        einfache Notlsung wre z.B. die Stringlnge fr alle 'value_strr'
        zu erhhen. Dies lst das Problem aber nicht prinzipiell und
        ist wegen Resourcenverschwendung nicht anzustreben. Mglich
        wre auch, fr die Chat-/Newsecke einen Sonderfall zu definieren,
        etwa indem wir ein zweites input-Array anlegen, diesmal aber
        mit greren Strings. Dies gefllt uns aber auch nicht besonders.
        Vielleicht mssen wir ja tatschlich mit Pointern und dynamischer
        Speicherzuteilung fr die 'value_strr' arbeiten. Mal sehen, ob
        daraus was werden kann.

squash1/19.12.1998:
        Das mit den Pointern fr die 'value_strr' ist nicht so einfach.
        Im Gegensatz zu C knnen wir bei GPM den Stringroutinen nicht
        einfach einen Pointer auf ein Zeichenfeld (unbestimmter Lnge)
        zur Bearbeitung desselben geben. Macht nichts, denken wir uns,
        tricksen wir ein bichen mit ADDRESS und so und schieben den
        Routinen einfach einen gengend groen Stringtyp unter, wohl-
        wissend, da wir durchaus sehr wenig Speicher mit ALLOCATE
        erhalten haben. Wenn die terminierende Null noch innerhalb
        unseres erhaltenen Speichers liegt, sollte es dann auch keine
        Probleme geben. Aber: es kommt anders. Obwohl wir nirgends
        versuchen, in verbotene Bereiche zu schreiben, machen uns z.B.
        Length oder WriteString einen Strich durch die Rechnung. Das
        ist nicht schn. Da mssen wir erst wieder mal nachdenken.

squash1/20.12.1998:
        Zu bld: wie es aussieht, gibt es in GPM keine Mglichkeit,
        mit C-Strings beliebiger Lnge umzugehen. Zumindest knnen wir
        keine solche Mglichkeit entdecken. Es ist zwar mit ALLOCATE
        mglich, eine bestimmte Menge Speicher zu reservieren und man
        bekommt auch einen Pointer vom Typ ADDRESS auf den Beginn des
        angeforderten Speichers zurck, aber dann fangen die Probleme
        schon an. Auf den Speicher zugreifen kann man nur ber eine
        gescheite Pointervariable, die _nicht_ vom Typ ADDRESS ist.
        Nachdem es aber keinen Typ gibt, der direkt auf eine unbestimmte
        Zahl von Bytes zeigt, mu man sich fr irgend einen ent-
        scheiden. Weiter oben hatten wir versucht, einen Stringtyp
        mit groer Feldlnge zu verwenden und waren auf die erwhnten
        Probleme gestoen. Also gibt es nur folgende Mglichkeiten:
        entweder wir nehmen einen Typ, der nur auf _ein_ Byte/Zeichen
        zeigt und steigen hinab zu den systemnahen Routinen ADDADR
        und Konsorten, um unseren allozierten Speicher zu durchlaufen
        oder wir machen gleich was mit einer verketteten Liste ganz
        ohne Lowlevel-Tricks. Die verkettete Liste ist programmier-
        technisch sicher die sauberste Lsung, erscheint aber ein
        bichen klobig, schner wre da sicher eine lineare Anordnung
        ohne knstliche Unterteilung in irgendwelche Substrings.
        Wozu wir uns entscheiden werden, ist noch nicht klar.
        Unabhngig von dieser Entscheidung werden wir aber zwei
        Zugriffsfunktionen zum Schreiben eines normalen GPM-Strings
        in unsere (noch zu definierende) Struktur und zum Lesen aus
        derselben in einen normalen GPM-String kreieren (etwa
        PutGPMString und GetGPMString).
        So, PutGPMString und GetGPMString sind eingerichtet. Momentan
        schreiben bzw. lesen sie noch wie gehabt, aber das wird sich
        bald ndern.

squash1/21.12.1998:
        Hat sich gendert: wir machen's mit einer verketteten Liste.
        Minimales Debugging. Zu get_or_postings gesellt sich
        try_get_or_postings. Damit fangen wir zu groe Eingaben
        ab. Hat konkret den einzigen Sinn das unntig aufgeblhte
        Gelabere eines Chatters abzuwehren. D.h. besser: wir sind
        so hflich und weisen die Quasselstrippe auch noch darauf
        hin, da sie zu viel Text eingeben wollte und schneiden
        den Rest nicht einfach stillschweigend ab.
        Was wir vielleicht noch tun sollten: das chat-File nicht
        beliebig anschwellen lassen. Dazu werden wir in put_chat_data
        nach der Niederschrift der neuen Mitteilung nicht einfach
        ungeprft das komplette alte chat-File hinten anhngen,
        sondern nur eine maximale Zeichenzahl. Was wei ich, vielleicht
        100kB oder 200kB oder sowas. O.k., haben wir auch erledigt.

squash1/18.01.1999:
        Ein paar Kleinigkeiten: 'Ich will...was neues' wieder zurck-
        bauen. In der 'KW-Table' die angezeigte Woche highlighten.
        Doch einen extra Chat-Button einfhren. In page08 setzen wir
        den Chat einfach nur auf Kommentar, d.h. p8ac8 wird _nicht_
        wieder gelscht. Man wei ja nie... Auerdem verfeinern wir
        die Sache mit der Geschichtsflschung. Anstatt den Leuten
        einen Anschi zu verpassen, wenn sie dmmlicherweise an der
        Vergangenheit herumhantieren, wre es doch deutlich besser,
        gleich gar keinen Button anzubieten. Das ist zwar fr den
        Langweiler immer noch nicht 100%-ig mglich, weil er seinen
        Schirm ewig nicht updatet, aber doch schon ein groer Schritt
        nach vorne. Auch try_my_cat erfhrt eine kleine Verbesserung:
        im mode 2 wird nicht sofort bei Erreichen der erlaubten
        Zeichenzahl ein CRLF gegeben, sondern wir warten noch bis zum
        nchsten Space (oder eol). Dadurch vermeiden wir ein Zerstckeln
        von Wrtern.

squash1/19.01.1999:
        Wieder Kosmetik.

squash1/30.01.1999:
        Leute beschweren sich, da ihr gesamter eingegebener Chattext
        verloren ist, wenn etwa das Kennwort falsch eingegeben wurde.
        Natrlich haben diese Menschen noch nie was vom Back-Button
        des Browsers gehrt. Wir knnten also in diesem Fall einfach
        einen Hinweis ausgeben, doch bitte den Back-Button des
        Browsers zu bentzen. Diesmal wollen wir uns aber den Luxus
        leisten, den Chattext als 'hidden value' an den Browser zurck-
        zuschicken. Dazu mssen wir hvr etwas umdefinieren. Bisher
        enthielt hvr einen String fr den Namen und einen Integer fr
        der Wert. Der Wert wird jetzt auch zu einem String. Im brigen
        brauchen wir nicht max_param_anz Stck 'hidden values', sondern
        wesentlich weniger, z.B. maximal 5 Stck. Deshalb knnen wir uns
        mit der Stringlnge fr den 'val' auch ganz bequem aus der
        Affre ziehen, indem wir diese einfach als ARRAY von max_hv_anz
        Stck Strings vom Typ String_lang definieren werden. Natrlich
        ist auch das noch Verschwendung. Mit 5 'hidden values', die
        jeweils langlen Zeichen lang sein drfen fr den 'val' und
        auerdem noch den 'nam' als String fhren, haben wir locker
        um die 25K verbraten. Momentan sind wir aber wie schon so
        oft, einfach zu faul, auch hier was dynamisches einzurichten.
        Worauf wir aufpassen mssen: wir drfen den Inhalt des
        betreffenden input-Wertes nicht einfach als hidden value
        wieder ausgeben, da wir ggf. HTML-Steuerzeichen ('<', '>' usw.)
        in die entsprechenden &-tokens umwandeln mssen. Vielleicht
        sollte dies erst put_hidden_values tun.
        Nur zum Spa: Sollte beim ndern des Kennworts das neue Kennwort
        gleich dem alten sein, dann geben wir eine kleine Scherzboldmeldung
        aus.

squash1/31.01.1999:
        Das mit den HTML-Steuerzeichen mssen wir uns nochmal genau
        ansehen. Und wir sehen: in lies_parameter_zuende wandeln wir
        alles, was vom User kommt sofort in echte Strings um. In dieser
        Form werden die Daten auch im input-Array gespeichert.
        Alles, was wir tun mssen, ist lediglich bei der Ausgabe
        darauf achten, da wir nicht versehentlich HTML-Steuerzeichen
        erzeugen. Und zwar gilt dies sowohl fr die Voreinstellung
        der Textarea als auch fr die 'hidden values'. put_amp_string
        erledigt dies fr uns. Wir haben dies mit etlichen Browsern
        getestet und fr gut befunden. Das einzige, was uns dabei
        negativ aufgefallen ist: der alte IE 3.03 unter Windoofs
        lt es nicht zu, die Textarea mit ber 2k Zeichen vorzube-
        legen, d.h. obwohl wir ihm die 5k Mll zurckschicken, die er
        soeben geschickt hat, zeigt er anschlieend nur etwa 2k davon an.
        Das ist natrlich bedauerlich. Htten wir etwa doch die noble
        Idee nicht realisieren sollen und gleich nur den Back-Button
        vorschlagen sollen? Da sagen wir klar: nein. Ein bichen weiter
        oben hatten wir eh das Problem der Platzverschwendung. Wir
        werden einfach langlen von 5001 auf 2001 reduzieren und haben
        damit alle mglichen Fliegen mit einer Klappe erschlagen.
        Mssen die Leute halt mehr als eine Mitteilung machen, wenn
        sie wirklich viel zu sagen haben.
        Als nchstes wollen wir uns doch endlich mal um die alphabetische
        Reihenfolge der Spieler kmmern, insbesondere im Zusammanhang
        mit der Vergrerung der Spielerliste im Laufe der Saison.
        In diesem Zusammenhang werden wir wohl auch das 'aktiv-Flag'
        einfhren, welches angibt, ob sich ein Spieler momentan
        berhaupt eintragen darf oder nicht. Dieses bentigen wir,
        um alte, nicht mehr spielende Spieler noch anzeigen zu knnen,
        auch wenn sie keine neuen Eintragungen mehr machen drfen.
        Nebenbei fhren wir endlich eine Versionskennung des
        season-Files ein.
        Also, wie soll das laufen mit aktiven und nicht aktiven
        Spielern? Am besten einfach so: ein aktiver Spieler ist
        genau das, was bisher ein Spieler war. Er kann sich selbst
        ein und austragen, die Chefs knnen das. Falls er ein 14-
        ttiger Spieler ist, wird das bercksichtigt. Ein nicht
        aktiver Spieler zhlt, als ob er nicht da ist. Weder er
        noch die Chefs knnen ihn aus- oder eintragen. Falls er
        ein 14-tgiger Spieler ist, spielt das keine Rolle, d.h.,
        um die Gesamtzahl der 14-tgigen zu bestimmen, zhlt er
        nicht mit. Der einzige Zweck der Inaktivitt besteht darin,
        da er in alten Aufzeichnungen erscheinen kann, da man
        also sieht, er hat einmal gespielt. Man wird also zualler-
        erst zusehen, da er nicht mehr im Auswahlmen erscheint
        und falls dies einem Hacker doch gelingen sollte, werden
        wir bei der Entgegennahme der Clientanforderung auf jeden
        Fall eine Prfung machen.
        Weil wir nicht zu streng sein wollen, soll der nicht aktive
        Spieler aber jederzeit sein Kennwort ndern knnen drfen.
        schreib_select_button ist etwas zu speziell. Wir wollen
        es nur noch verwenden, um ein Array von Strings und ein
        zugehriges Array etwa von INTEGERs als Select-Button
        auszugeben. Das String-Array und das INTEGER-Array werden
        wir vorher erzeugen. Das kommt uns nicht nur fr die
        alphabetische Sortierung zugute, sondern auch fr die
        gezielte Weglassung von nicht aktiven Spielern etwa bei
        Ein- bzw. Austragung im Court. Wohingegen die Kennwort-
        nderung ja erlaubt sein sollte.

squash1/01.02.1999:
        Scheint wieder mal alles zu laufen soweit. Was momentan
        noch fehlt, ist die alphabetische Sortierung der Spieler
        im Select-Button. Da hat's doch verschiedene Sortieralgo-
        rithmen gegeben (Bubble, Quick und was wei ich noch)?
        Wir haben uns nicht viel Zeit genommen und ganz schnell
        was programmiert: von vorne bis hinten nach dem Minimum
        suchen und dieses mit dem vordersten Eintrag austauschen.
        Anschlieend beim zweiten Platz weitermachen usw.. Falls
        wir spter mal Lust haben, wird da was ganz tolles gemacht,
        ganz sicher.
        Was eigentlich noch ntig ist: den '(abbestellt)' irgendwie
        gesondert behandeln. Bisher taucht er nmlich an unmglichen
        Stellen auf: beim Chatten und beim Kennwort ndern z.B..
        Was auch nicht schlecht wre: die Select-Buttons irgendwie
        von der IP-Nummer des Clients abhngig machen. Normalerweise
        haben nmlich laut Aussage vom Bauers Hansi die Rechner,
        obwohl sie mit DHCP arbeiten, doch immer wieder die gleiche
        IP-Nummer (wird irgendwie von der Ethernetadresse der Netz-
        karte abgeleitet). Wir knnten also z.B. dann, wenn jemand
        eine Eintragung macht, die IP-Nummer lesen und als weitere
        Information beim Spieler, der sich soeben eingetragen hat,
        ablegen. Grundstzlich knnen wir dann also vor dem
        Erzeugen der Select-Buttons einfach erst mal nachsehen, ob
        die IP-Nummer eines Clients irgendeinem Spieler zugeordnet
        ist und diesen dann ganz vorne hin stellen oder ihn gleich
        als 'SELECTED' markieren. Natrlich sitzt nicht immer jeder
        vor seinem eigenen Rechner oder manche Leute tragen andere
        mit ein, d.h. die Zuordnung von Spieler zu IP-Nummer ist
        nicht ein-eindeutig. Das sollte uns aber Wurscht sein,
        zumindest die stetigen Menschen werden sich ber die neue
        Bequemlichkeit freuen.

squash1/03.02.1999:
        Als erstes versuchen wir also, den '(abbestellt)' zu den
        Spezialspielern zu tun. Vielleicht brauchen wir spter
        noch weitere Spezialspieler (etwa einen 'Besucher', der
        beim Chatten mitmachen kann). Wir werden also einfach mal
        Platz fr 10 weitere Spezialspieler machen, damit wir
        beim manuellen Umstellen des season-Files nicht so leicht
        Fehler machen werden (mssen dann nmlich alle IDs uppen).
        Ein (anonymer) Besucher kann nun auch chatten.
        Und schlielich scheint auch das mit der IP-Nummer des
        Clients und dem 'SELECTED' zu klappen.

squash1/04.02.1999:
        Chat-berschrift im Chat-Text mit IP-Nummer verzieren.
        Vorschlag: falls nicht i_auswahl selected ist, vielleicht
        '(Auswahl)' gar nicht mehr anbieten, weil dann ziemlich
        sicher sowieso schon der richtige Punkt 'SELECTED' ist.
        Beim Chatten wird wieder eine leere Textarea angeboten,
        dafr gibt's eine Fehlermeldung, falls kein eigener Text
        eingegeben wird. Versehentliche Fehlbedienungen, also einfach
        mal schnell ein leeres Posting wegschicken geht jetzt nicht
        mehr so leicht. Natrlich gilt ein Space oder Return als
        Text (den man nicht sieht), d.h., wer sich extrem bld
        anstellt, schaffts doch wieder, sich zu outen.

squash1/06.02.1999:
        Der Chef sollte die Spieleranzahl nicht verkleinern knnen.
        Ggf. werden wir ihm spter mal erlauben, die komplette Saison
        zu lschen bzw. zu sichern, aber wir wollen vermeiden, da (z.B.
        versehentlich) Spieler gelscht werden.

squash1/07.02.1999:
        Das Handling der INPUT-Parameter ist nicht ganz glcklich.
        Zunchst wird in init_default_inputs1 eine Grundinitialisierung
        vorgenommen. Daraufhin werden in try_get_or_postings ggf. neue
        INPUT-Strings eingelesen. Nach Lesen des season-Files wird dann
        in init_default_inputs2 ggf. eine Korrektur von min-/max-
        Werten vorgenommen, die mitunter von den Werten des
        season-Files abhngig ist. Im spteren Verlauf des Programms
        wird dann in calc_integers eine Umwandlung aller INPUT-Strings
        in echte INTEGER-Werte vorgenommen und zwar natrlich nur fr
        die Werte, fr die ob_integ=1 gilt, aber eben fr _alle_
        INPUT-Strings, also auch die, die nicht explizit in
        try_get_or_postings empfangen wurden. Bei dieser Gelegenheit
        wird auf min/max geprft.
        Wollten wir nun in init_default_inputs2 z.B. einen min-Wert
        anheben, bekommen wir Probleme: den min-Wert alleine ndern
        haut nicht hin, weil dann der value ggf. zu niedrig ist,
        den wir in init_default_inputs1 gewhlt hatten. Wenn nmlich
        in try_get_or_postings der betreffende INPUT-Wert nicht
        vorhanden war, wird er auch nicht verndert. D.h. aber,
        wir mssen, wenn wir in init_default_inputs2 einen min-Wert
        anheben, auch gleichzeitig den value mit anheben. Dies ist
        aber extrem ungeil fr den Fall, da der betreffende INPUT-
        Wert in try_get_or_postings bergeben wurde. Wir wrden in
        diesem Falle einfach die Eingabe des Users wieder berschreiben.
        Lsung: die Reihenfolge der Aufrufe ndern. Anstatt:

        1. init_default_inputs1
        2. try_get_or_postings
        3. try_get_season_data
        4. init_default_inputs2
        5. calc_integers

        whlen wir:

        1. init_default_inputs1
        2. try_get_season_data
        3. init_default_inputs2
        4. try_get_or_postings
        5. calc_integers

        Nun knnen wir in init_default_inputs2 nach Belieben min-Werte
        und values umbelegen (wie uns das die season-Daten empfehlen),
        so da wir in calc_integers _kein_ Problem damit htten, falls
        try_get_or_postings keinen neuen INPUT-Wert liefert und fangen
        aber dennoch unerwnschte Eingaben in try_get_or_postings ab.

squash1/08.02.1999:
        Wartung: der Chef bekommt nach Eintritt in den Wartungsmodus
        sein altes Kennwort immer wieder angeboten, damit er es nicht
        jedesmal neu eintippen mu.
        Funktioniert auch prima, aber jetzt haben wir einen neuen
        Angriffspunkt fr Hacker. Nachdem das Chef-Kennwort im
        Klartext zum Browser zurckgeschickt wird, kann man dieses
        jederzeit in der Page-Source anschauen, auch wenn es im
        Browserfenster selbst mit '*' verschleiert ist. D.h. wenn
        der Chef seinen Rechner verlt und ein anderer herum-
        schnffelt, knnte er u.U. das Chef-Kennwort aussphen.
        Dies knnen wir nur vermeiden, indem wir das neue Feature
        wieder entfernen oder irgendwie dafr sorgen, da der
        Back-Button alte Seiten nicht mehr anzeigt.
        Kleine Ungereimtheit: das Setzen von remote_addr_index in
        get_spieler ist nicht ganz optimal. Wenn wir z.B. beim
        erstbesten Index stehenbleiben, kann es passieren, da
        bei der spteren Generierung des Select-Buttons doch nicht
        der gewnschte Eintrag 'SELECTED' ist. Das passiert z.B. so:
        Sollten z.B. der Chef und ein beliebiger Spieler die gleiche
        IP-Nummer haben, dann wird remote_addr_index auf den Chef
        zeigen, weil dieser (zufllig) ganz vorne steht. Spter
        wird etwa beim Eintragen eines Spielers der Chef gar nicht
        in den Select-Button einbezogen, remote_addr_index hat
        also gar kein Matching fr die auszugebenden Eintrge.
        Es wird also nicht der Spieler, sondern die (Auswahl)
        selected. Das ist zwar alles nicht sehr schlimm, aber
        wir werden dennoch versuchen, die Situation zu verbessern.
        Dazu wird es ntig sein, nicht bereits in get_spieler
        den remote_addr_index versuchen zu bestimmen, sondern
        erst kurz vor Ausgabe des Select-Buttons.
        Die Verwaltung der Datenbasis mu noch etwas abgerundet
        werden. Unter 'Ich will...' haben wir bereits den schnen
        Punkt 'Einen Wartungszyklus durchfhren'. Was noch fehlt,
        ist, die bestehende Datenbasis etwa ganz lschen zu knnen.
        Na gut, wre nicht ganz so schlimm, im Wartungszyklus knnte
        man die Basisdaten ziemlich kappen, so da dies beinahe einem
        Neustart gleichkommt. Was aber rgerlicher ist: wir haben
        bisher keine Mglichkeit, ein Backup der aktuellen Datenbasis
        zu machen, geschweige denn ein altes Backup wieder einzuspielen.
        Gut, wir haben einen cron-Job laufen, der tglich ein Backup
        durchfhrt. Darauf hat aber der Chef keinen Zugriff.
        Naja, wenn wir ehrlich sind, haben alte Backups normaler-
        weise keinen sehr groen Nutzen. Das einzige, was evtl.
        interessant wre, sind die Spielerdefinitionen, die man
        sich einfach nochmal holen knnte fr eine neue Saison.
        Dies ist aber jetzt schon der Fall. Der Chef kann nmlich
        die Spieleranzahl nicht mehr verkleinern, d.h. im Wartungszyklus
        kann alles mgliche verndert werden, nur die Spielerdaten
        bleiben bis in alle Ewigkeit erhalten. Dies ist zunchst
        kein sehr groes Problem, aber wir sollten dem Chef doch
        wenigstens eine (wenn auch radikale) Mglichkeit geben, auch
        die Spielerdaten wieder zu lschen, und wenn's durch das
        Lschen des season-Files geschieht. Natrlich wre es
        elegant, dem Chef beim bergang zu einer neuen Saison
        noch mehr Mglichkeiten an die Hand zu geben und nicht einfach
        nur die Wahl zwischen: alte Spielerdaten bernehmen und ggf.
        ein paar neue hinzufgen oder alle Spielerdaten lschen und
        komplett neue anlegen. Z.B. eben: gezielt bestimmte Spieler
        bernehmen. Wenn uns wirklich sehr langweilig sein sollte,
        knnen wir ja auch das mal in Betracht ziehen. Momentan
        aber haben wir dazu wirklich kein Lust.
        Im Moment also fhren wir nur einen weiteren Punkt ein:
        'Datenbasis lschen+Backup anlegen'. Damit wird die aktuelle
        Datenbasis einfach auf einen 'Backupnamen' umgelinkt.
        Soweit wieder mal ois ok. Das Wiedereinspielen von Backups
        verkneifen wir uns im Augenblick.

squash1/09.02.1999:
        Compare aus Strings sagt, Strings sind gleich, auch wenn sie
        nicht gleich lang sind, aber der eine vollstndig im 'Anfang'
        des anderen enthalten ist, z.B. so: 'abcde'='abcdefg' ist eine
        wahre Aussage. Das finden wir komisch. Daher gibt's einen
        Wrapper: CompareRS. Fr Stringgleichheit mu auch die
        Stringlnge gleich sein.

squash1/19.02.1999:
        Wir haben das Wiedereinspielen von Backups nicht vergessen,
        sondern nur etwas vertagt. Als kleine Vorarbeit dazu mssen
        wir vor allem ein wenig ber das Chef-Kennwort nachdenken.
        Wie hinlnglich bekannt, sind die Kennwrter in verschlsselter
        Form im season-File gespeichert. Alle, d.h. auch die Chefs
        knnen ihre Defaultkennwrter ndern. In einem alten wieder-
        einzulesenden season-File knnen also ggf. Kennwrter stehen,
        an die sich kein Schwein mehr erinnern kann. Wir mten also
        wenigstens dem neuen Chef die Mglichkeit geben, sich ein
        neues Kennwort zu verpassen, _ohne_ das alte zu wissen.
        Natrlich geht das nicht so, da er gar keines eingeben
        mu, um ein neues zu bekommen, sonst knnte das ja jeder
        machen. Also sollte er mindestens das Default-Chef-Kennwort
        eingeben mssen. Dann knnen wir aber auch gleich hergehen
        und dem Chef unmittelbar nach dem Wiedereinspielen eines Backups
        sein Default-Kennwort geben (und ihn ggf. darauf hinweisen,
        da ab jetzt wieder/noch das Default-Chef-Kennwort gilt). Wenn
        er sich dann ein anderes wnscht, mu er es einfach nur wie
        gehabt ndern. So werden wir das machen. Aber auch ber das
        Kennwort der Chefin mssen wir etwas nachdenken. Der Chef wird
        also mit oben erwhnter Vorgehensweise nach dem Wiedereinspielen
        eines Backups wieder voll handlungsfhig sein. Insbesondere
        kann er also auch vergelichen Spielern bei Bedarf neue
        Kennwrter zuteilen. Einzig die Chefin steht ggf. im Regen
        (stand sie im brigen bisher auch schon, genauso wie der
        Chef selbst, falls er _sein_ Kennwort vergessen htte).
        Natrlich kann man argumentieren insbesondere die Chefs
        mssen halt ihre Kennwrter durch Mundpropaganda an in Frage
        kommende Nachfolger weitergeben, aber das finden wir langweilig.
        Im brigen ist es auch bisher etwas umstndlich, will der
        Chef das Kennwort eines Spielers ndern. Dies ist nicht
        etwa unter 'Ich will... -> Kennwort ndern' mglich, weil
        dort nur jeder sein eigenes Kennwort ndern kann (falls er
        sein altes richtig eingibt). Nein, der Chef mu einen kompletten
        Wartungszyklus durchfhren und auf der entsprechenden Seite
        das Kennwort des Spielers eintragen. Damit also dies etwas
        bequemer wird und der Chef auch das Kennwort der Chefin
        ndern kann, werden wir unter 'Ich will... -> Kennwort ndern'
        die nderung auch dann durchfhren, wenn als bisheriges
        Kennwort das des Chefs eingegeben wird.

squash1/20.02.1999:
        Cont.

squash1/28.02.1999:
        Im Rahmen einer Portierung auf freeBSD haben wir Probleme mit
        dem Lockfile. Es bleibt nach Drcken des STOP-Buttons nmlich
        stehen. Dort gibt es auch andere Probleme, es scheint nmlich
        nur GET aber nicht POST als REQUEST_METHOD zu funktionieren.
        Wahrscheinlich ist das aber ein muc-spezifisches Problem.
        Jedenfalls werden wir init_signals und init_ausstieg innerhalb
        init1 noch vor get_umgebung aufrufen, damit unser Signalhandler
        schon mglichst frh einsatzbereit ist.

squash1/03.03.1999:
        Heute werfen wir 4 linux-spezifische Signale raus, damit auf
        freeBSD auch alles glatt geht.

squash1/04.03.1999:
        Ein bichen mit Cache-Control spielen. Arbeitet aber noch nicht
        so ganz nach Wunsch.

squash1/07.03.1999:
        Wir haben uns beim W3C ein bichen schlau gemacht und sind
        nun praktisch zufrieden. Unser alter Netscape (1.12) scheint
        unsere dynamisch erzeugten Seiten nach Beenden des Browsers
        sowieso aus seinem Cache wieder zu entfernen. Statische Seiten
        bleiben allerdings im Cache drin. Wie er diese Unterscheidung
        macht, ist nicht klar. Offenbar gibt es aber irgendeine
        Information, vielleicht die Fileendung oder was wei ich.
        Wird schon irgendeine dubiose Heuristik im Spiel sein. Jeden-
        falls sind unsere Daten in jedem Fall nach Beenden des Browsers
        wieder verschwunden. Allerdings scheint es keine Mglchkeit zu
        geben, das Cachen der Information von Anfang an zu unterbinden.
        Unser neuerer Netscape (4.03) ist da schon deutlich kooperativer.
        Mit 'Pragma: no-cache' wird tatschlich gar nichts in den
        Cache geschrieben. Naja, jedenfalls werden wir ab sofort fr den
        Wartungszyklus sowohl ein 'Pragma: no-cache' als auch ein
        'Expires: "schon immer"' als META in den HTML-HEAD mit auf-
        nehmen. Das gibt zwar keine absolute Sicherheit, aber wir
        haben immerhin eine weitere kleine Barriere gegen den Hacker
        aufgebaut.
        Wir beginnen, den Punkt 'Backup wieder einspielen' zu
        realisieren.

squash1/18.03.1999:
        Cont.

squash1/20.03.1999:
        Cont.

squash1/21.03.1999:
        Endlich haben wir 'opendir', 'readdir' und 'closedir' aus der
        libc importiert. Weil wir aber wieder mal zu faul sind, was
        dynamisches zu machen, gibt's fr die Filenamen im data-Directory
        nur ein Feld konstanter Lnge. Dann knnen wir auch ganz
        bequem mit sortiere_selection und co. arbeiten.

squash1/04.04.1999:
        Das mit der festen Lnge fr die Directory-Geschichten gefllt
        uns doch nicht. Damit's nicht einen totalen Verhau gibt,
        werden wir zunchst mal die bestehenden selection-Arrays
        dynamisieren und dann fr die Directory-Geschichten mit
        heranziehen. Vorher machen wir aber mal wieder ein Backup,
        auch wenn diese Version hier keinen endgltigen Auslieferungs-
        zustand hat.
        Also: anstatt der Felder selection_int und selection_str,
        die wir bisher verwenden, kommt doch eine verkettete Liste
        zum Einsatz. Es sollte eine Verkettung nach vorne gengen.
        Als Recordfelder wird es also einen String, einen INTEGER und
        einen Pointer geben. Ob wir irgendwo (auer im NIL des Pointers
        des letzten belegten Records) die Listenlnge festhalten, ist
        noch nicht klar.
        berraschenderweise scheint der Umbau auf die Liste sofort
        geklappt zu haben, mssen wir noch etwas genauer testen.

squash1/07.04.1999:
        Testen.

squash1/08.04.1999:
        Debuggen.

squash1/11.04.1999:
        Vom Usermode aus scheint das Einlesen von alten Backupfiles
        inzwischen zu funktionieren. Was noch aussteht, ist also
        bei Nichtvorhandensein eines season-Files nicht nur den
        Dialog zum Erzeugen einer neuen Datenbasis anzubieten, sondern
        auch das Einlesen eines alten Backupfiles, falls es eines
        (oder mehrere davon) gibt.

squash1/12.04.1999:
        Also, wie soll das gehen? Falls keine aktuelle Datenbasis
        vorhanden ist, sehen wir zuerst nach, ob es irgendwelche
        Backups gibt. Falls ja, sollten wir anbieten, ob von diesen
        eines als aktuelle Datenbasis bernommen werden soll. Wird
        eines bernommen, ist die Sache erledigt. Wenn nicht, sollte
        gefragt werden, ob eine neue angelegt werden soll. Wird mit
        'ja' geantwortet, kommt der ganz normale Wartungszyklus in
        Gang. Wird mit 'nein' geantwortet, kommt eine blde Bemerkung
        und das Spiel beginnt nochmal von vorne.
        Und wieder mal scheint alles ganz prima geklappt zu haben, wir
        sind stolz auf uns. Es scheint ja fast, als wren wir mit
        dem Tool rundum zufrieden. Nein, eine Kleinigkeit wollen wir
        evtl. noch ndern. 'Rudolf's *Internet* Homepage bewundern'
        sollten wir wieder wegnehmen und mit unter 'Schnell weg von hier'
        einreihen.

squash1/14.04.1999:
        Auf der 'Ich will...'-Seite wird 'Alte Datenbasis von Backup
        einlesen' nur angezeigt, falls auch wirklich wenigstens ein
        Backup da ist.

squash1/18.04.1999:
        Auf der 'Ich will...'-Seite wird der explizite Weg zu
        Rudolf's Internet Homepage wieder weggenommen. Wird dafr
        in 'Schnell weg von hier' mit aufgenommen. p8ac5 war
        dafr verantwortlich, bleibt vorerst mal drin aber inaktiv.

squash1/19.04.1999:
        Kosmetik. Wir betrachten die Sache damit zunchst als im
        wesentlichen abgeschlossen. Wenn wieder mal ganz viel Zeit
        sein sollte, knnten wir das mit dem Lockfile nochmal
        berdenken. Gibt nmlich flock(2). Wenn wir das richtig
        verstanden haben, geht ein ggf. gesetzter Lock bei Prozess-
        ende sowieso wieder weg, d.h. wir bruchten evtl. die
        Verkrampfung mit 'del_alt_lock' nicht. Momentan aber
        ist uns das Wurscht.

squash1/25.04.1999:
        Einem Kollegen hat der Hinweis zur  Erst-, Zweit-, Gasteintragung
        auf page01 nicht so recht gefallen. Zwischen den KW-Angaben
        seien keine Trennzeichen vorhanden. Recht hat er.

squash1/15.05.1999:
        Diverse kleine Kosmetiken bezglich Default-Chef-Kennwort.

squash1/06.07.1999:
        Nochmal kleine Kosmetik bezglich Default-Chef-Kennwort.

squash1/23.08.1999:
        Diverse nderungen: Wer auf der 'Ich will...'-Seite erst
        der Meinung war, ein Kennwort ndern zu wollen und dann doch
        keines ndern will, wird nach Drcken des nicht-OK-Buttons
        wieder auf die 'Ich will...'-Seite zurckgeworfen. Dies scheint
        zwar zunchst irgendwie logisch, da nmlich das 'nicht-OK'
        einfach wieder an den Ausganspunkt zurckfhrt, ist in der
        Praxis aber lstig. Meistens wird man bei einem Sinneswandel
        eben nicht gleich eine andere 'Ich will...'-Aktion machen
        wollen, sondern gleich zur Hauptseite zurckkehren wollen.
        Dies werden wir dann ab jetzt auch honorieren. Gleiches soll
        gelten fr page13 (Durchfhrung eines Wartungszyklus), page20
        (Lschen der Datenbasis) und page21 (Einlesen einer Datenbasis).
        Ein anderes Thema sind die Select-Buttons auf page09 (nderung
        eines Kennworts) und auf page19 (Chat-/Newsecke). Bisher werden
        hier u.a. alle Spieler angezeigt, auch die nicht aktiven.
        Tatschlich ist das doof. Will ein nicht aktiver Spieler
        chatten, kann er dies als Besucher (ohne Kennwort) tun und
        im brigen kann er sowieso nichts weiter machen, d.h. er
        braucht berhaupt kein Kennwort, auch kein neues. Der nicht
        aktive Spieler wird aber nach wie vor in der Datenbasis
        gefhrt und knnte (vom Chef) jederzeit wieder in den aktiven
        Status angehoben werden (innerhalb des Wartungszyklus).
        Danach taucht er dann wieder ganz normal in allen
        Select-Buttons auf, wie alle anderen Spieler auch.

squash1/17.10.1999:
        Wir mssen das Logging verbesseren, bzw. berhaupt erst einmal
        einfhren. Bisher besteht Logging lediglich aus dem, was
        im Webserver Logfile vorhanden ist. Das ist uns zu wenig.
        Anla fr den neuen Anlauf ist eine krzlich aufgetretene
        Ungereimtheit bei der Ein- bzw. (unerwarteten) Austragung
        eines Spielers. Es konnte auch nach etlichen (telefonischen)
        Gesprchen mit verschiedenen Beteiligten kein so rechtes
        Licht in die Angelegenheit gebracht werden. Ein Spieler
        hatte sich zuletzt als 'eingetragen' gewhnt, durch irgend
        eine Aktion wurde er jedoch wieder ausgetragen. Es konnte
        anschlieend nicht mehr festgestellt werden, ob der Spieler
        durch technisches Versagen oder einen Bedienerfehler aus
        der Tabelle gestrichen worden war. Wir erinnern uns, da
        manche Browser lieber den Cache-Inhalt als die aktuellen
        Daten anzeigen aber eigentlich sollten wir dieses Problem
        im Griff haben. Andererseits waren die Aussagen der Chefin
        und der Inhalt des Webserver Logfiles nicht so ganz konsistent.
        Wir vermuten (knnen das aber, wie schon dargelegt, im
        Moment nicht nachvollziehen / beweisen) daher eher, da
        ein Bedienerfehler vorliegt.

        Zunchst mssen wir uns aber erst mal wieder mit dem gesamten
        Programmablauf vertraut machen, um zu sehen, an welchen
        Stellen im Programm wir am besten was mitprotokollieren.

        Beim Schreiben/Lesen des season-Files muten wir unbedingt
        auf ein sauberes Locking achten: es durfte immer nur ein
        User entweder mit Schreiben oder Lesen beschftigt sein,
        da es sonst zu irreparablen Inkonsistenzen der Datenbasis
        gekommen wre. Bei unserem neuen Logfile ist das theoretisch
        nicht mehr so kritisch. Wir knnten also auf das Locking
        verzichten und einfach in das Logfile schreiben. Im
        schlimmsten Fall kme dann halt ein etwas wirres Logfile
        dabei heraus, aber der Progammablauf, der ja vom Logfile
        unanhngig ist, wrde dadurch nicht gestrt. Wir sind aber
        der Ansicht, da dies nicht sauber ist und entscheiden
        uns daher, das Logfile, was das Locking betrifft, genau
        so zu behandeln wie das season-File. Erstens brauchen wir
        dann nichts zu denken und zweitens sind eigentlich sowieso
        nur die Flle wirklich wichtig, in denen eine nderung am
        season-File vorgenommen wird und das ist sowieso nur im
        'gelockten' Zustand mglich. Wir sind, wie gesagt, noch am
        berlegen, was wir alles mitprotokollieren werden. In jedem
        Fall werden dies die Aktionen sein, welche das season-File
        verndern, wahrscheinlich aber auch mglichst viele andere.

squash1/18.10.1999:
        Natrlich werden wir gleich bertreiben: damit's hinterher
        wirklich einfach ist, jeden Spielstand nochmal einsehen
        zu knnen, sollten wir tatschlich jedesmal beim Abspeichern
        des season-Files den alten Stand retten oder noch einfacher
        bei jedem Schreibvorgang gleichzeitig ein Log-season-File
        mit erzeugen. Dann gibt's auch kein langwieriges Nachdenken
        beim ersten Schreiben, wenn noch kein altes File da ist.
        Wir schtzen ab: bei 30 Wochen Spieldauer und 6 Courts knnen
        also 30*6*2=360 Eintragungen gemacht werden. Keine Ahnung,
        wie oft sich Leute auch wieder austragen oder wie oft etwa ein
        Kennwort gendert wird. Nehmen wir einfach mal an, wir htten
        z.B. 400 nderungen. Die typische Gre des season-Files
        betrgt im Moment gut 5 kByte. Damit kmen wir auf etwa 2MByte
        reine 'season-File-Daten'. Das sollte vertretbar sein.
        Die Maximalzahl von Log-season-Files (max_log_sea_file_anz)
        begrenzen wir also einfach mal auf 1000. Damit knnen von
        dieser Seite her schon mal nicht wesentlich mehr als gut
        5 MByte Daten entstehen.

        Damit wir nicht durcheinander kommen, werden wir fr die
        Logging-Geschichten ein weiteres Directory einrichten:
        'data/logs'.

        Der geschickteste Ort fr das (zustzliche) Abspeichern
        des Log-season-Files wird in try_put_season_data sein.

squash1/24.10.1999:
        Kleine Lcke bei den Log-season-Files: nachdem der Name
        nur bis Sekunden unterscheiden kann, die User aber locker
        in krzeren Abstnden Requests versenden knnen, besteht
        momentan die Gefahr, da ein bereits bestehendes File
        berschrieben wird. Dem mssen wir irgendwie entgegen-
        wirken. Nachdem die im Log-season-File-Namen kodierte
        Zeit wichtig ist, wollen wir sie auch beibehalten. Natrlich
        knnte man argumentieren, da die creation time sowieso
        schon bekannt ist und wir sie nicht nochmal im Filenamen
        kodieren mssen, aber man wei ja nie. Dann htte man
        die Log-season-Files einfach durchnummerieren knnen.
        Wir werden daher also die Zeit im Log-season-File-Namen
        beibehalten und zustzlich einen Suffix anhngen, der
        alle in der gleichen Sekunde erzeugten Files unterscheidet.
        Stellt sich die Frage, wie gro dieser Suffix sein mu.
        Die theoretische Obergrenze ist einfach durch die maximal
        erlaubte Zahl an Log-season-Files gegeben: max_log_sea_file_anz.
        Es ist wahrscheinlich praktisch nicht mglich, in einer
        Sekunde z.B. 1000 Log-season-Files anzulegen aber zumindest
        sind wir mit dieser Lsung auf der theoretisch sicheren
        Seite. Damit wir mglichst wenig denken mssen (scheint,
        als ob uns das Denken keinen Spa macht, denn weiter
        oben hatten wir schon hnliche Probleme mit dem Denken),
        gehen wir so vor:
        1. neuen Log-season-File-Namen mit Suffix 0 generieren
        2. falls Name schon existiert, Suffix inkrementieren
        3. testen, ob wir nun mehr Glck haben
        4. wenn ja, File erzeugen, wenn nein, zurck zu 2.
        Das sieht so ein bichen (und ist es auch tatschlich)
        nach probieren aus und kostet auch ein bichen Zeit,
        aber nachdem wir diesen Vorgang eher selten erwarten,
        knnen wir uns das locker leisten.

        Im brigen fhren wir create_lock2 wieder ein. Mit create_lock
        konnten wir sowieso nur maximal einen Request pro Sekunde
        bedienen, d.h. der ganze Ballast mit Suffix fr den
        Log-season-File-Namen wre sowieso fr die Katz gewesen.
        Kann sein, da create_lock wegen des sleep ein wenig
        resourcensparender war aber nur ein Request pro Sekunde
        gefiel uns auch nicht besonders.

squash1/31.10.1999:
        Peinlich: ein berflssiger Space (' ') in LUWNToLesbar.
        Machen wir weg.

squash1/01.11.1999:
        Logging ein bichen weiter verfolgen. Nebenbei fllt ein
        kleines Denkproblem in get_or_postings auf: wir hatten uns
        bei GET einfach darauf verlassen, da schne NAME/VALUE-
        Paare daherkommen, mit '=' getrennt. Das ist natrlich
        bei manueller Eingabe eines URL berhaupt nicht gewhrleistet.
        Insbesondere warten wir ggf. ewig auf das '='. Das ist
        extrem mies. Mglicherweise ist/war dies auch eine der
        Ursachen fr unsere Probleme mit freeBSD auf colin.muc.de.
        Also wieder zum Logging. Wir haben ein bichen nachgedacht,
        was wann wo zu protokollieren wre. Eine Mglichkeit wre,
        erst ein paar generelle Sachen (REMOTE_ADDR, REQUEST_METHOD usw.)
        und dann an allen mglichen und unmglichen Stellen im Programm
        (abhngig vom Programmablauf) jeweils ein kleines Schnipselchen
        Logging-Information auf ein globales Logfile auszugeben. Damit
        sollte dann eine nachtrgliche Verfolgung der Aktivitten
        theoretisch mglich sein. Vielleicht ist aber folgendes
        geschickter: einfach alles mitschreiben, was vom User ankommt
        und was wir ihm anschlieend hinschicken. Bleibt noch zu
        berlegen, ob wir das alles in _ein_ groes File schreiben
        oder lieber viele kleine nehmen. Wenn wir daran denken, etwa
        einfach einen HTTP-Browser zum Betrachten der Loggings zu
        verwenden, sind vielleicht viele kleine Files besser.
        D.h. es wird pro User-Request jeweils ein neues Logfile
        angelegt, in dem zunchst sowas wie aus show_client_info
        drinsteht und anschlieend der komplette HTTP-Output, den
        wir dem User zurckschicken. Damit sollten wir das perfekte
        Logging erreicht haben. Gibt nur einen kleinen Schnheits-
        fehler: die geheimen Sachen vom User stehen anschlieend
        in (ggf. ffentlich lesbaren) Dateien drin. Dies gefllt uns
        nicht besonders. Mglicherweise werden wir die geheimen Sachen
        einfach explizit _nicht_ mit protokollieren, denn anhand
        des HTTP-Outputs sollten wir ohnehin erkennen, wie die
        Reaktion auf die geheimen Sachen war. Oder einfach: wir
        wenden auf die geheimen Sachen schon mal den crypt an und
        geben dies dann aus. Ist natrlich auch nicht ganz optimal,
        wenn die verschlsselten Sachen offen liegen, aber das ist
        uns Wurscht.
        So, das klingt alles recht gut, aber es ist doch eine
        Menge Arbeit. Insbesondere das Abspeichern des HTTP-Outputs.
        Bisher wird einmal zu Beginn des Programms die cid_out
        auf den StdOutChan gelegt und danach wird an allen
        mglichen Stellen irgendwas dorthin ausgegeben. Irgend-
        wie mssen wir zusehen, da die meisten Ausgaben
        zustzlich in ein Logfile wandern. 'Die meisten' und
        nicht alle deshalb, weil manche Ausgaben recht lnglich
        sein knnen (das Anschauen der Programmquelle z.B.) und
        diesen ganzen Mll mssen wir ja nun wirklich nicht auch
        noch in irgend welche Logfiles schreiben.

squash1/07.11.1999:
        Das Abspeichern der Log-season-Files wird im gelockten
        Zustand gemacht, weil, wie oben schon dargelegt, das
        Schreiben eines Log-season-Files unmittelbar vor dem
        Schreiben des normalen season-Files stattfindet und wir
        uns zu diesem Moment im gelockten Zustand befinden.
        Genau aus diesem Grund war es auch mglich, erst in
        aller Ruhe einen noch nicht bentzten Namen fr das
        Log-season-File zu suchen und anschlieend ein File
        mit diesem Namen als neues Log-season-File aufzumachen,
        _ohne_ befrchten zu mssen, da in der Zwischenzeit
        ein anderer User ganz schnell ein File gleichen Namens
        angelegt haben knnte. Aber auch falls wir nicht im
        gelockten Zustand wren, htten wir kein riesiges
        Problem. Wir drften dann halt nicht erst testen, ob
        ein File schon da ist und dann versuchen ein neues
        File azulegen, falls keines da war, sondern wir mten
        versuchen, unmittelbar ein neues File zu ffnen (geht
        ja als atomare Operation, d.h. wenn wir das Flag 'old'
        nicht explizit angeben beim ffnen eines Files, gelingt
        das ffnen eben nur dann, wenn wir allein das neue
        File anlegen konnten) und mit diesem geffneten File
        anschlieend arbeiten. Dazu mten wir halt z.B.
        put_season_data geringfgig modifizieren, und zwar so,
        da wir die Channel ID des (bereits offenen) Files
        bergeben und nicht den Namen eines zu ffnenden Files.

        Wir wollen die Logfiles, welche die Ausgaben auf cid_out
        protokollieren mit Log-html-Files bezeichnen, weil wir
        hier im wesentlichen einfach den HTML-Output unseres
        Programms, welchen wir zum User schicken, zustzlich
        in ein File schreiben. Beim Anlegen dieser Log-html-Files
        mssen wir so vorgehen, wie eben fr den nicht gelockten
        Zustand besprochen, denn wir sehen, da in try_create_lock
        z.B. schreib_page_info aufgerufen wird gerade fr den
        Fall, da der Lock nicht angelegt werden konnte. Auch
        in diesem Fall wollen wir natrlich ein Log-html-File
        erzeugen.

squash1/08.11.1999:
        Cont.

squash1/11.11.1999:
        Wir haben inzwischen etwas mehr Infrastruktur zum
        Erzeugen der Log-html-Files geschaffen. try_open_hlog_channel
        sollte nun in jedem Fall einen geffneten Channel
        zurckgeben, auf welchen wir unseren HTML-Output
        schreiben wollen. Was jetzt noch zu tun bleibt, ist
        diesen HTML-Output nun auch tatschlich nicht nur
        auf cid_out sondern auch auf cid_log auszugeben.

        Bleibt also noch zu entscheiden, wie wir das konkret
        machen werden. An irgend einer Stelle mssen wir den
        Programmcode erweitern. Es scheint, als ob die Idee
        nicht so ganz optimal war, die cid_out als Parameter
        in alle schreib_pagexy-PROCEDUREs einzubauen. Zum einen
        gibt es jede Menge Aufrufe von schreib_page_accept und
        schreib_page_info, welche wir nun fr cid_log ein
        zweites Mal hischreiben mten. Da ist es doch
        besser, die beiden Ausgaben in den PROCEDUREs selbst
        zu machen und nur _einen_ Aufruf hinzuschreiben.
        Auerdem gibt es ein paar schreib_pagexy-PROCEDUREs,
        bei denen wir auf den Log-Channel nicht alles hinschreiben
        wollen, wie weiter ober schon bemerkt. Wir kommen also
        nicht umhin, an den schreib_pagexy-PROCEDUREs sowieso
        individuelle nderungen zu machen. Das bedeutet am Ende
        also, da wir den Parameter der Typs ChanId wieder aus
        den schreib_pagexy-PROCEDUREs verbannen werden und ihn
        lokal anlegen mssen. In den meisten Fllen werden
        wir dann innerhalb der schreib_pagexy-PROCEDUREs erst
        eine Ausgabe auf cid_log und dann eine identische auf
        cid_out machen, in einigen Fllen wird die Ausgabe
        auf cid_log, wie gesagt, etwas verkrzt sein.

        Spahalber fhren wir ein globales Flag ein, welches
        uns angibt, ob berhaupt Logging stattfinden soll.

squash1/13.11.1999:
        Es ist geschafft. Bis auf ein paar kleinere Ergnzungen
        steht das Logging. Im brigen knnen wir das Logging fr
        die Log-season-Files und die Log-html-Files getrennt
        enabeln. Nochmal zur Abschtzung des bentigten Speicher-
        platzes: die Log-html-Files (page01 z.B.) sind gut 10 kB
        gro. Manche sind auch kleiner. Fr ein Log-season-File
        wird Joe average User durchaus 3 bis 4 mal rumdrcken,
        d.h. die Maximalzahl der Log-html-Files sollten wir auch
        etwa 3 bis 4 mal grer machen als die Maximalzahl der
        Log-season-Files. Bei sagen wir 1000 erlaubten
        Log-season-Files (welche, wie gesagt z.B. jeweils etwa
        5 kB haben, also 5 MB total) htten wir dann bei
        3000 Log-html-Files nochmal 30 MB. Ein ganz anderes
        Thema ist die Systembelastung beim Durchsuchen groer
        Directories. Es scheint, als ob wir damit keine Probleme
        haben. Zumindest gilt dies fr get_all_pref_nam bzw.
        anzahl_pref_files, welches wir aufrufen, um die Zahl
        bereits vorhandener Log-Files zu ermitteln. Ebenso scheint
        das Anlegen weiterer Files in groen Directories kein
        Problem zu sein. Wir knnen also bei der flachen
        Struktur bleiben.

squash1/14.11.1999:
        Einziges Problem ist offenbar sortiere_selection, weil
        die ziemlich primitiv gemacht ist. Das betrifft aber eher
        die Backupfiles als die Logfiles. Wenn mal groe Langeweile
        herrscht, knnen wir sortiere_selection ja etwas aufpeppen.

squash1/15.11.1999:
        Luft alles prima aber natrlich gibt's immer noch was
        zu verbessern. show_client_info1 zeigt z.B. noch zu viel an.
        Jetz nicht mehr.
        In log_parameter sollten wir bei den geheimen Sachen nicht
        einfach die verschlsselten Kennwrter hinschreiben (die
        versteht doch eh keiner), sondern wir werden versuchen,
        sie irgend jemandem zuzuordnen.
        Nochmal Kosmetik: (Spieler oder ChefIn-)Kennwort:
        Bemerkung: vielleicht sollten wir beim Logging evtl. doch
        nicht alles in ein Directory schreiben, sondern z.B.
        wenigstens eine weitere Zwischenebene einschieben. Also
        alle Files eines Tages jeweils in ein Directory?

squash1/18.11.1999:
        Also werden wir auch 'mkdir' aus der libc hereinholen. Im
        Moment haben wir aber erst 'unix' vorbereitet. Spahalber
        haben wir dort auch noch 'rmdir' mit aufgenommen. Ob wir
        es hier brauchen werden, ist aber eher zweifelhaft.

squash1/19.11.1999:
        Und noch was ganz anderes fllt uns heute auf: es ist
        gar nicht wahr, da sich jeder Spieler unter einer
        individuellen IP-Adresse zeigt. Leute, die hinter einem
        Proxy oder Feuerwall oder wie die Dinger heien, sitzen,
        erscheinen alle unter der gleichen IP-Adresse. Ist dann
        natrlich ungeil, denen eine vllig unpassend vorbelegte
        selection anzubieten. Wenn wir die individuell vorbelegte
        selection nicht generell wieder abschaffen wollen (und
        das wollen wir nicht), mssen wir uns was einfallen lassen.
        Ganz einfach: wir schaffen den Postfix 'alt' fr bereits
        existierende alte Matchings bei der IP-Adresse wieder ab.
        Stattdessen schreiben wir in jedem Fall die unverflschte
        IP-Adresse des Clients auf. Bei der Wahl der selection
        bieten wir dann nur fr den Fall, da es genau _eine_
        passende IP-Adresse gibt, eine individuelle selection
        an, in allen anderen Fllen kommt die (Auswahl) dran.
        Ist eigentlich ganz einfach, denn wenn _kein_ Matching da
        ist, gibt es einfach keinen Spieler, den wir anbieten
        knnten und wenn mehr als einer da ist, wollen wir keinen
        bevorzugen. Htten wir auch schon frher drauf kommen
        knnen.

squash1/20.11.1999:
        Cont.

squash1/21.11.1999:
        Fr die Log-html-Files haben wir nun eine zustzliche
        Directory-Zwischenebene eingefhrt. Fr die Log-season-Files
        werden wir dies im Moment nicht tun, weil das wesentlich
        weniger sind. Entsprechend sind auch die Konstanten
        max_log_sea_file_anz und max_log_htm_file_anz zu interpretieren:
        es ist dies die maximale Zahl Log-Files, die im aktuellen
        Directory erlaubt ist. D.h. max_log_sea_file_anz gibt dann
        tatschlich die maximale Gesamtzahl von Log-season-Files an,
        weil es hier nur _ein_ Directory gibt. max_log_htm_file_anz
        ist entsprechend ebenfalls die maximale Zahl Log-Files, die
        im aktuellen Directory erlaubt ist, wobei wir aber fr jeden
        Tag ein anderes aktuelles Directory haben. Die Erfahrung
        mu zeigen, welcher Wert fr max_log_htm_file_anz optimal
        ist. Weil das ganze Ding sowieso nur dazu dient, den Extrem-
        fall abzufangen, knnen wir bestimmt mal bei 500 beginnen.
        O.k., wenn irgend ein Bldmann das tatschlich ausschpft,
        htten wir an einem Tag bei den erwhnten 10 kB pro
        Log-html-File maximal 5 MB html-Logs rumliegen. Mssen
        wir mal ein bichen beobachten. Im brigen haben wir gesehen,
        da sich ein 'getarrtes' Directory mit Log-html-Files mittels
        bzip2 locker um einen Faktor 100 (ja, hundert) schrumpfen
        lt. Wenn wir also nicht jeden Tag unsere Logs berprfen
        und damit evtl. unbemerkt riesige Datenmengen erzeugen lassen,
        knnten wir auch ganz einfach einen cron-Job beauftragen, die
        Log-html-Files des Vortages zur 'tarren' und mit bzip2 zu
        schrumpfen. Mal sehen...

squash1/01.01.2000:
        Es gab Beschwerden, da Ersteintragungen, die mehr als 2
        Wochen im Voraus gettigt weden knnen, nicht gengend
        deutlich angekndigt worden seien. Es gibt zwar einen Hinweis
        ber Erst-, Zweit-, Gasteintragungen, der erscheint aber
        in nicht besonders groen Lettern. Wir knnen versuchen,
        die Darstellung zu 'verdeutlichen', falls mehr als 2
        Wochen im Voraus was gehen sollte.

squash1/07.10.2000:
        Nachdem in der Firma inzwischen INTERNET an den Arbeitspltzen
        verfgbar ist und wir auch externe Spieler nicht mehr aus-
        schlieen wollen, denken wir wieder mal ber eine Implementierung
        beim Provider nach. Es gibt allerdings ein paar Punkte, die
        uns das Leben evtl. schwer machen knnten, bzw. wo wir
        zumindest ein bichen nachdenken mssen:
        
        o       wird  bei muc.de immer noch freeBSD eingesetzt, damit
                wir auch weiterhin GPM verwenden knnen?
                
        o       kriegen wir das wieder hin mit dem cgi-migen
                compilieren und so?

        o       hat freeBSD nun 'crypt' oder nicht, arbeitet es
                identisch zu dem auf Linux?

        o       bei muc.de hatte der Rechner mit dem Webserver irgendwie
                NFS-migen Zugriff auf unsere Files, insbesondere auch
                auf das Lockfile. Das knnte zu Problemen fhren.

squash1/08.10.2000:
        Ja, es luft immer noch freeBSD, ja wir haben sofort wieder
        cgi-mig compiliert, ja es gibt crypt (ob es identisch zu
        Linux arbeitet, wissen wir noch nicht) aber wir haben
        wieder unseren Hnger bei REQUEST_METHOD = POST. Das ist
        nicht schn.

        Wie wir herausgefunden haben, macht offenbar ReadChar aus
        TextIO Probleme beim Lesen des letzten Zeichens von cid_in.
        Irgendwie schmiert die Kiste dabei ab. Wenn wir nur bis
        zum vorletzten Zeichen lesen, passiert dies nicht. Allerdings
        fehlt dieses Zeichen dann natrlich spter und es gibt halt
        entsprechende Fehlermeldungen. Wir haben probiert, anstatt
        mit ReadChar einmal mit ReadRestLine zu arbeiten. Dies
        hat aber auch nicht funktioniert. Wahrscheinlich gibt's
        halt irgendein darunterliegendes IO-Problem, das wir hier
        nicht lsen knnen. Als voll primitiver Workaround fllt
        uns z.B. ein, da wir bei allen POSTings immer mindestens
        ein Zeichen mehr schicken, als ntig und dieses dann einfach
        nicht lesen. Mal sehen, ob das hinhaut. Wir mssen dabei
        natrlich hoffen, da der Browser das neue Anhngsel auch
        wirklich am Ende postet (, falls wir es ans Ende hinstellen)
        und nicht schon vorher. Vielleicht ist das auch irgendwo
        festgelegt, da jeder Browser dies so machen soll, aber wir
        wissen das nicht. Jedenfalls scheint mein 4.03-er Netscape
        und der 4.0-er MSIE dies so zu machen.

squash1/29.10.2000:
        Zum Test erste Spalte in der ersten Zeile voll grell markieren.

squash1/02.12.2000:
        Die grelle Markierung vom 29.10.2000 ist wieder weg.

        Es steht mglicherweise nun doch der Einsatz auf muc.de
        bevor. Zu den Fragen vom 07.10.2000 ist u.a. zu sagen,
        da 'crypt' auf freeBSD und Linux anscheinend identisch
        arbeitet. Die Frage mit dem NFS-migen Filezugriff und
        ggf. daraus resultierenden Problemen mit dem Lockfile
        kann noch nicht geklrt werden. Wir verdrngen dies im
        Moment einfach mal. Worum wir uns aber kmmern mssen,
        ist das alte Lockfile. Unter Linux haben wir da bis jetzt
        del_alt_lock laufen. Wer wei, ob wir auf freeBSD auch
        einen derartigen Dauerprozess haben knnen und uns die
        Mnner nicht pltzlich alles abschalten. Vielleicht
        knnte man im Gegensatz zu bisher, wo del_alt_lock in irgend
        einem rc-Script beim Booten des Rechners gestartet wird,
        auch sofort zu Beginn unseres CGI-Programms del_alt_lock
        starten, falls es nicht bereits luft. Mglicherweise
        knnte man aber auch hier nicht vllig ausschlieen, da
        am Ende mehr als ein del_alt_lock aufgerufen wrde und
        damit htten wir uns wieder (zumindest rein theoretisch)
        die alten Problme eingehandelt, wie wir sie schon ganz
        am Anfang mit dem Lockfile hatten. Andererseits knnte
        man sich auch vorstellen, da bei Existenz eines alten
        Lockfiles anstatt der resignierenden Aussage, da kein
        neues Lockfile angelegt werden konnte, eine Aufforderung
        bzw. Frage an den Chef oder die Chefin erscheint, eben
        dieses alte Lockfile zu lschen. Damit wrde dann wirklich
        nur einmal das alte Lockfile gelscht (also gut, der
        Chef und die Chefin mten sich halt absprechen) und
        wir wren zufrieden. Der Nachteil hier ist natrlich,
        da berhaupt ein Mensch eingreifen mu, aber wie gesagt,
        nachdem nicht klar ist, ob das mit dem 'Dauerprozess'
        bei muc.de auch wirklich luft, werden wir es wohl mit
        der Chef/Chefin-Methode probieren. Abgesehen davon ist
        mir auf Linux bisher kein Fall bekannt, wo del_alt_lock
        wirklich eingreifen hat mssen. Wenn bei muc.de auch so
        selten ein Lockfile stehen bleibt, dann kann in so einem
        Fall der Chef/die Chefin schon mal eingreifen mssen.
        
squash1/03.12.2000:
        Wir starten mal einfach damit, auf der 'Ich will...'-Seite
        eine weitere Aktion einzubauen: 'Altes Lockfile lschen'.
        Dies macht zwar im Ernstfall an dieser Stelle nicht so viel
        Sinn, weil wir im Falle der Anwesenheit eines alten
        Lockfiles gleich gar nicht bis hierher kommen, aber
        wir knnen schon mal ein bichen ben. Auerdem ist
        p8ac5  momentan sowieso frei (damit hatten wir frher mal
        Rudolf's *Internet* Homepage bewundert). Im 'Ernsfall'
        wird dann gleich die Seite zum Lschen des alten
        Lockfiles angezeigt, ohne den Umweg ber die ''Ich will...'-
        Seite.
        
squash1/04.12.2000:
        Das mit dem p8ac5 war ein Schmarrn, machen wir wieder
        rckgngig. Wir fhren eine extra Behandlung fr den
        alten Lock ein: process_old_lock. Damit sind wir zunchst
        mal ganz zufrieden. Ein paar ganz schnelle Tests verlaufen
        zur vollen Zufriedenheit. Falls pltzlich ein altes
        Lockfile dasteht, ist es immer mglich, es mit dem
        ChefIn-Kennwort zu lschen. Anschlieend geht's dann
        wieder normal weiter. Wir werden diese Version squash1.mod103
        nennen und sie fr freeBSD angepat auf muc.de stellen.
        
squash1/06.12.2000:
        SMTP wieder wegnehmen aus schreib_page_trailer.
        
squash1/23.01.2001:
        Nachdem wir die Squashpage inzwischen auf muc betreiben,
        sollte es auch mglich sein, bei bestimmten Anlssen/
        Aktionen Infomails an die Spieler zu verschicken. Natrlich
        wird sich dadurch wieder mal das Format der Datenbasis
        ndern (weil wir z.B. eine gltige E-Mailadresse irgendwo
        speichern mssen) aber das macht uns ja nichts.
        Das einfachste wird sein, die libc-Funktion 'system()' zu
        verwenden. Mal sehen, wie schnell das geht.
        Ja und das hat ganz prima geklappt, nur die Datenbasis
        haben wir noch nicht auf Vordermann gebracht fr unsere
        E-Mail-Adressen. Mal sehen, wie wir das einbauen werden.
        Auch das war wieder ganz iehsi. Mssen wir also nur noch
        die echte Datenbasis umschreiben (gibt's leider kein
        Tool dafr) und schon sind wir fertig.
        Nebenbemerkungen:
        1.      Beim Compilieren auf dose2 bekommen wir pltzlich
                eine Meldung der Form:

                DGEN: Error: Hash table overflow
                Retrying with -B10000

                Dann geht's zwar weiter, ist aber irgendwie ungeil.

        2.      Wir sollten vielleicht einen globalen Schalter
                einbauen, der das Versenden von Mails generell
                erlaubt/verbietet, sonst mssen wir immer alle
                E-Mail-Adressen aus der Datenbasis lschen, falls
                wir hier ein bichen experimentieren wollen.

        3.      Wir hatten vor einiger Zeit mal die Idee, die
                Farbe des '...chatten'-Buttons immer nur so lange
                konstant zu lassen, bis ein neuer Beitrag gemacht
                wurde. Dadurch sollte dann bei lngerer Chat-
                Inaktivitt sofort durch die Farbnderung die
                Neugierde geweckt werden. Vielleicht sollten wir
                dazu einfach einen globalen Counter einfhren, der
                einfach in der Datenbasis mitgefhrt wird und
                bei jedem neuen Chat-Beitrag inkrementiert wird.
                Die Farbe des '...chatten'-Buttons werden wir dann
                in geeigneter Weise von diesem Counter ableiten.
        
squash1/24.01.2001:
        Weil's so schn ist, knnten wir neben dem '...chatten'-
        Counter einen weiteren Counter einbauen, der berhaupt
        bei jedem Aufruf der Seite inkrementiert wird. Ist einfach
        ein Spa. Ja aber ein teuerer Spa, jedenfalls was die
        Logfiles betrifft, wenn wir das so handhaben wie bisher.
        Vielleicht schreiben wir ja auch in Zukunft nur dann ein
        (season-)Logfile, wenn wirklich eine Ein- oder Austragung
        stattgefunden hat und nicht, wenn nur was gelesen wurde?
        Ja, scheint alles zu laufen, wie geplant.
        Aber: natrlich gibt's auf muc wieder Probleme. Irgendwie
        schickt der zwar Mails, aber der Browser bleibt ewig hngen.
        Vielleicht sollten wir versuchen, das Versenden der Mail
        ganz ans Ende zu schieben (falls das nicht sowieso schon
        der Fall ist)?
        
squash1/25.01.2001:
        Die Manahme gestern hatte gar nichts gebracht, auer da
        das Programm jetzt hlicher geworden ist. Aber wir haben
        was anderes gemacht: wenn wir SIGCHLD in Ruhe lassen, geht's
        pltzlich auf muc wieder. Naja ist uns auch recht.

        Im brigen gruppieren wir endlich ein bichen um, damit wir
        uns das blde Editieren zwischen Linux und BSD endlich
        sparen. Es geht zwar nicht vllig ohne Editieren, aber
        es sind immerhin nur zwei Kommentarklammern, die versetzt
        werden mssen.
        
squash1/05.02.2001:
        Lockfile nach /tmp/lock_squash, weil es schon wieder mysterise
	Probleme gegeben hat.
        
squash1/14.08.2001:
        Das mit dem Lockfile in /tmp/lock_squash gilt natrlich nur
        auf BSD. Auf Linux bleibt's beim alten. Auch das haben wir
        mit dem Schalter 'ob_linux' automatisiert. Im brigen schalten
        wir defaultmig mal die HTML-Logs ab (hlog_gewuenscht auf FALSE).
        Das spart uns auf muc ein bichen Plattenplatz.
        Wir werden diese Version hier als squash1.mod109 archivieren
        und so auf muc spielen. Mal sehen, ob wir das mit dem Compilieren
        dort wieder auf die Reihe kriegen...
        Nebenbemerkung: mglicherweise weil wir hier im Moment keine
        LAN-Karte mehr drin haben, macht der Name 'dose2' Probleme. Wir
        haben fr die Linux-Version deshalb wieder auf 'localhost'
        umgestellt.
        
squash1/15.08.2001:
        Typo corrected.
        
squash1/31.08.2001:
        Kann sein, da wir am neuen Arbeitsplatz auch unsere tolle
        Squashliste einfhren mssen. Jedenfalls wollen wir uns auf
        einen mglichen Einsatz schon mal vorbereiten. Wenn dann
        nichts draus wird, ist uns das auch Wurscht. Zuerst aber werden
        wir das Umschalten zwischen Linux und BSD mittels ob_linux
        noch etwas vereinfachen. Auerdem bentzen wir auch auf Linux
        das gleiche Lockfile wir auf BSD, nmlich eines unter /tmp.
        
squash1/02.09.2001:
        Die neue Liste wird mglichst wenig nderungen gegenber der
        bisherigen haben, schon vor allem aus Bequemlichkeit. Wir werden
        also versuchen, mit _einem_ Programm auszukommen und nur an
        geeigneten Stellen nderungen bzw. Code zum Unterscheiden der
        beiden Varianten einfgen. Zum Unterscheiden der beiden
        Varianten nehmen wir etwa einfach den Programmnamen her.

        Dummerweise mssen wir dabei unterscheiden zwischen dem
        Namen, den wir in etwaige URLs eintragen, die der Client
        dann also anwhlt und dem Programmnamen, den wir im Programm
        mittels GetArg ermitteln. Ersterer wird durch die Variable
        script_nam reprsentiert. Dabei wird zwischen Linux und BSD
        unterschieden: auf Linux verwenden wir einfach 'squash1', auf
        BSD haben wir 'squash1.cgi', weil die Mnner irgendeine schne
        Endung brauchen, um das Ding als cgi-Script zu erkennen.
        Letzerer, also der mittels GetArg ermittelte Programmname ist
        in unserem Fall nicht identisch mit ersterem, weil wir Links
        und hnlich fiese Tricks einsetzen, um vom URL letztendlich
        auf unser eigentliches Programm zu kommen. Das Compilieren etwa
        der MODULA-Programmquelle 'squash1.mod' mittels gpmake liefert
        (auf Linux und auf BSD) jeweils ein 'squash1', welches wir
        nicht extra umbenennen. GetArg liefert also diesen Namen, auch
        wenn im URL ggf. etwas anderes drinsteht. Genauer gesagt liefert
        GetArg nicht unbedingt genau 'squash1' zurck, sondern ggf. auch
        noch einen vorangestellten Pfad.

        Jedenfalls werden wir nun einfach einen weiteren Programmnamen,
        etwa 'squash1gd' einfhren und damit unsere zweite Tabelle
        bearbeiten. Egal, ob GetArg also nur einen Programmnamen oder
        auch einen vorangestellten Pfad liefert, sollte es eigentlich
        reichen, nur den letzten Buchstaben als Entscheidungshilfe
        heranzuziehen: bei '1' liegt 'squash1' vor und bei 'd' dann
        halt 'squash1gd'. Genauer gesagt, erzeugen wir bei einer '1'
        einen URL, der sich auf 'squash1' bezieht, bei 'd' einen URL,
        der sich auf 'squash1gd' bezieht. Sollte irgend ein Hacker
        etwa vllig andere Sachen eingetippt haben, die aber zufllig
        einen auf '1' oder 'd' endenden Progammnamen ergeben, werden
        wir dies auch wieder nur auf 'squash1' bzw. 'squash1gd' mappen.
        Nein, wir werden momentan sogar 'squash1' als default nehmen
        und 'squash1gd' nur dann erzeugen, falls GetArg einen String
        zurckgibt, der auf 'd' endet. Naja, vielleicht vergleichen
        wir aber auch die letzten paar Buchstaben des von GetArg
        zurckgegebenen Strings etwa komplett mit dem ganzen Scriptnamen
        um zu entscheiden, welche Tabelle wir bearbeiten mssen.
        Ist wahrscheinlich doch ein Schmarrn. Der Hacker mu sowieso
        exakt einen der beiden URLs eingeben, sonst wird unser
        Programm gleich gar nicht aufgerufen. Wenn wir nun unsere
        verschiedenen Programme einfach durch einen kleinen
        zustzlichen Appendix an den Programmnamen unterscheiden,
        sollte es reichen, genau nur auf diesen kleinen Appendix
        hin zu untersuchen.

        O.k., scheint hier auf Linux zunchst alles so zu laufen,
        wie es sollte. Tun wir das also auch mal zu muc hin.

        So ganz nebenbei sind wir auf einen unwichtigen aber deutlichen
        Bug gestoen. Die Zustellung von Mails war schon immer fehlerhaft:
        Falls der ein- oder ausgetragene ein Gast war, wurde das ber-
        haupt nicht bercksichtigt, dafr wurden ein paar sinnlose
        Zuweisungen gemacht, die kein Schwein interessiert haben.
        Sollte jetzt alles so laufen, wie ursprnglich geplant!

        Eigentlich wollten wir versuchen, auch noch die letzte
        manuelle Umstellung zwischen Linux und BSD zu automatisieren.
        Irgendwie das System fragen, auf welcher Maschine wir
        eigentlich sitzen, dazu kommen wir aber heute nicht mehr.
        
squash1/05.09.2001:
        Die eben erwhnte automatische Erkennung, ob wir zuhause oder
        auf muc sind, sollte ganz einfach gehen. In der Umgebung gibt
        es nmlich auf beiden Systemen u.a. die beiden Variablen
        SERVER_NAME und HTTP_HOST. Zuhause ist SERVER_NAME=dose.muc.de
        und HTTP_HOST=localhost, auf muc ist SERVER_NAME=www.muc.de
        und HTTP_HOST=www.muc.de. Nachdem wir ja wirklich nur
        zwischen zuhause und muc unterscheiden wollen, sollte es
        reichen, etwa zu testen, ob HTTP_HOST<>www.muc.de ist.
        Wir knnten jetzt natrlich philosophieren, ob die variable
        ob_linux glcklich gewhlt worden war. Zufllig ist halt
        bei uns Linux identisch mit zuhause und BSD mit muc.
        Eigentlich unterscheiden wir weniger, ob Linux oder BSD
        verwendet wird, als vielmehr, wo was im Filesystem liegt.
        O.k., die Betriebssystem-Bandenwerbung ist dann schon
        eher Linux- bzw. BSD-geprgt. Aber macht nix. Wir behalten
        die Variable ob_linux bei und unterscheiden das ganze anhand
        von HTTP_HOST.

        Ja, das war einfach. Jetzt aber zu einem anderen Thema. Die
        neue Tabelle mu auch Spielzeiten bearbeiten knnen, die _nicht_
        zur vollen Stunde beginnen bzw. enden. Das ist schn bld.
        Am Ende mssen wir wohl intern statt von 0 bis 24 (24 ist
        bisher stunden_anz) von 0 bis zehnmin_anz (144) zhlen, um
        eine Quantisierung von 10 min zu erhalten. Dummerweise sind
        dann die Datenbasen nicht mehr kompatibel, d.h. wir werden
        wohl eine neue sea_version_akt einfhren mssen.
        
squash1/15.09.2001:
        In backup_einspielen zweimal schreib_page_info durch
        schreib_page_accept ersetzen. Ist irgendwie cooler so.
        Dann haben wir noch kleine Bauchschmerzen fr den Fall,
        da ein nicht kompatibles season-File vorliegt. Im Moment
        kommt da nmlich einfach nur ein schreib_page_info. Wir
        haben also ber unser HTTP-Interface KEINE Mglichkeit,
        den beltter etwa vom Chef lschen zu lassen. O.k., im
        Normalfall sollte es auch keine regulre Mglichkeit gegeben
        haben, eine inkompatible Version anzulegen. Wre einfach
        deutlich cooler, wenn wir es trotzdem als Chef lschen
        knnten. Mal sehen. Noch viel schlimmer: ein vllig falsches
        season-File bringt uns offenbar total durcheinander, so
        da nicht einmal mehr eine ordentliche Meldung erscheint.
        Das ist nicht gut.
        
squash1/17.09.2001:
        Das mit dem vllig falschen season-File verschieben wir noch
        ein bichen. Nachdem wir unseren alten Server in der alten
        Firma anscheinend fr die neue Tabelle nochmal aktivieren
        mssen, weil die da kaum Internet haben, mssen wir das mit
        ob_linux und so nochmal berdenken / vereinfachen.
        ob_linux macht http_host_index Platz.
        
squash1/18.09.2001:
        Kleiner faux pas mit den Datenpfaden. Und vielleicht sollten
        wir doch mailto_user und mailto_rechner auch vom HTTP_HOST abhngig
        machen.
        
squash1/21.09.2001:
        Chef und Chefin erhalten tabellenabhngiges Defaultkennwort.
        
squash1/23.09.2001:
        normal_voraus wird ebenfalls tabellenabhngig und dient nicht
        nur dazu, ein eventuelles Enhancement in erst_zweit_gast_eintrag
        zu bestimmen, sondern auch als direkter Defaultwert in
        reset_court_belegung.

        So beim Durchscannen der gesamten alten Kommentare mit zugehrigem
        Herumspielen fllt uns auf: wenn wir auf page07 etwa ungeschickte
        Parameter eingeben, bekommen wir u.U. den Hinweis, da wir zum
        Korrigieren den "Back-Button" des Browsers bettigen sollen.
        Ntzt aber i.a. nichts, weil die Seite irgendwie expired ist.
        Mssen wir verfolgen!
        Ja, die Seite sollte auch _nicht_ gecached sein und dennoch lt
        sie sich mitunter im Quelltext anschauen, etwas ein Browserfehler?
        Die Sache mit dem Back-Button war mglicherweise gut gemeint, wir
        wollen die Seite aber nicht cachen. Daher werden wir aus der
        Info-Page wohl doch eine Accept-Page machen. Und wir sehen:
        die Info-Page wird in calc_integers aufgerufen im Rahmen eines
        abbruch, d.h. page07 ist gar nicht direkt verantwortlich fr
        die Misere.
        O.k. ist behoben das mit dem Back-Button. Gibt jetzt eine
        Accept-Page.

        Dann bemerken wir, da etwa unser uralter Netscape keinen
        HTTP_HOST kennt. Komisch, denn wir dachten, da HTTP_HOST der
        Host ist, auf dem der HTTP-server luft. Auf muc war beispielsweise
        www.muc.de der HTTP_HOST, im Intranet war's z.B. 190.64.6.48 und
        zuhause ist es localhost. HTTP_HOST sollte also doch vom
        Client (=Browser) unabhngig sein! Scheint aber nicht so zu
        sein. Nachdem wir das gesamte Handling jetzt nicht total
        umkrempeln wollen, probieren wir's also doch mit SERVER_NAME,
        denn den sehen wir auch im uralten Netscape. Also wird
        http_host server_name Platz machen.
        
squash1/24.09.2001:
        Das mit dem HTTP_HOST geht mglicherweise so: genau das, was
        man im Browser als Host eingibt, ist der HTTP_HOST. Macht sich
        vor allem bei Hosts mit mehreren IP-Nummern gut. Der Webserver
        bzw. das CGI-Programm kann zunchst nicht riechen, bei welchem
        Loch der Request hereingekommen ist. Das wre aber ganz gnstig,
        um im CGI-Programm schne neue URLs bauen zu knnen, die genau
        wieder diese IP-Nummer verwenden. Wahrscheinlich reden der
        Browser und der Webserver genau ber diesen HTTP_HOST und der
        Webserver stellt ihn dann dem CGI-Programm in der Umgebung zur
        Verfgung. Mglicherweise hatten die uralten Netscape-Mnner
        diese Idee noch nicht gehabt und daher gibt es den HTTP_HOST
        nicht bei Verwendung des uralten Netscapes. Wir werden also
        folgendes tun: wir belassen die Bezeichnung bei server_name
        und werden auch anhand des SERVER_NAME entscheiden, auf
        welcher Kiste wir sitzen. Zur Generierung von neuen URLs
        greifen wir aber auf den HTTP_HOST zurck, vorausgesetzt
        er ist nicht leer. Damit haben wir dann die Fhigkeiten neuerer
        Browser ausgenutzt und falls ein uralter Netscape da ist,
        lassen wir uns im Normalfall auch nicht erschrecken. Lediglich
        falls jemand eben mit dem uralten Netscape eigentlich den
        HTTP_HOST bruchte, hat er Pech, weil das sowieso nicht geht!
        
squash1/25.09.2001:
        berlegungen, das Abbestellen etwas komfortabler zu machen,
        also insbesondere nur noch _einen_ 'Halbcourt' abbestellen zu
        mssen und trotzdem _beide_ Eintrge auf (abbestellt) zu
        setzen. Und ein etwas flexibleres Handling fr Gste.
        Die neue Chefin hat bisher anscheinend fter mal irgend
        welche Gste eingetragen, die nun nicht unbedingt als ihre
        persnlichen Gste erscheinen mssen, sondern einen eigenen
        Namen haben (sollen). Bisher waren wir der Meinung, es knnen
        nur Leute squashen, die von vorneherein in der Datenbasis
        erfat sind. Ausnahme waren Gste, die aber immer eindeutig
        einem 'festen' Spieler zugeordnet werden mssen. ber den
        Gast war dabei nur die Information bekannt, da er Gast ist
        (und eben einem festen Spieler zugeordnet) und nicht etwa sein
        Name. Wir konnten die Datenbasis deshalb so gestalten, da
        wir fr die Courtbelegung nicht etwa irgend welche Spieler-
        oder Gstenamen notieren muten, sondern nur Nummern. Jetzt, mit
        der neuen Forderung, 'wildfremde' Gste auch namentlich erscheinen
        zu lassen, mssen wir ein wenig umdenken. Es wird nach wie vor so
        sein, da sich irgend welche Gste nicht selber eintragen knnen.
        Das mit den 'privaten' Gsten, wie wir das bisher hatten, wird
        auch weiterhin so bleiben, wie es war. Nur werden wir jetzt eben
        zustzlich eine neue Sorte von Gsten, nennen wir sie die
        'offiziellen' Gste, bekommen. Es liegt nahe, die offiziellen
        Gste vom Chef oder der Chefin verwalten zu lassen und von sonst
        niemandem. Damit wir nicht unntig viele zustzliche Dialogfenster
        bekommen, knnten wir evtl. die page02 erweitern. Bisher kann man
        sich dort beim Eintragen entscheiden zwischen sich selber und einem
        Gast. Vielleicht machen wir da nun 3 Mglichkeiten draus:
        selber, ein privater Gast und ein offizieller Gast. Allerdings
        mu dabei klar sein, da Joe average Spieler nur sich selber
        oder einen privaten Gast aber keinen offiziellen, namentlich
        anzugebenden Gast eintragen kann und da der Chef oder die
        Chefin weder sich selbst noch einen privaten, sondern nur einen
        offiziellen Gast eintragen knnen wird. Wie bauen wir also die
        neuen offiziellen Gste in unsere Datenbasis ein? Wahrscheinlich
        werden wir die jahr_court_belegung_gast um eine Mglichkeit
        erweitern: auer 0 (Spieler selbst) und 1 (privater Gast)
        wird es nun zustzlich 2 (offizieller Gast) geben. Den Namen des
        offiziellen Gastes selber schreiben wir einfach dahinter.
        
        Fr das Abbestellen sollte es im brigen Wurscht sein, welche Wahl
        man hier trifft, da sollte nur (abbestellt) zu sehen sein. Im
        Moment kann man aber locker schon mal den Gast abbestellen
        lassen. Ein '(abbestellt) (Gast)' klingt aber irgendwie bld!
        
squash1/04.10.2001:
        Cont.
        
squash1/07.10.2001:
        Cont.
        
squash1/08.10.2001:
        Cont.
        
squash1/10.10.2001:
        Cont.
        
squash1/13.10.2001:
        Endlich sind wir mit den zwei Themen von oben zufrieden:
        (abbestellt) wird immer der komplette Court auf einmal und
        nicht in zwei Hppchen. Ebenso die ggf. ntige Austragung
        des (abbestellt). Ein '(abbestellt) (Gast)' gibt's auch
        nicht mehr! Ebenfalls funktionieren sollte nun die Sache
        mit den offiziellen Gsten: normale Spieler knnen private
        Gste haben, die Chefs knnen offizielle Gste eintragen,
        so, wie wir das oben geplant hatten.

        Als nchste Erweiterung gibt's was schnes neues:
        Die Menschen haben eine Rangliste/Pyramide. Ja, nicht alle
        Squashvereine haben unbedingt eine, aber unsere neue Truppe
        jedenfalls hat eine. Es sollte nicht allzu schwierig sein,
        unser Programm dahingehend zu erweitern. Im einfachsten Fall
        wird es unter 'Ich will...' eine weitere Aktion, z.B.
        'zur Rangliste' geben. Dort wird dann einfach die aktuelle
        Rangliste/Pyramide angezeigt. Als einzige neue Information
        brauchen wir dazu eben den Rang/die Position jedes Spielers.
        Dazu werden wir einfach ein neues Feld etwa vom Typ
        int_arr_spieler_typ in unsere season data aufnehmen (wie
        es z.B. spieler_art oder spieler_aktiv sind) und dieses
        neue Feld ebenfalls ber den Wartungszyklus mit verwalten.
        Spter, wenn wir dann etwas mehr Komfort einbauen wollen,
        knnten wir uns auch eine klickbare Pyramide vorstellen:
        Zuerst klickt man auf den Forderer. Daraufhin erscheint
        eine neue, etwas anders markierte/eingefrbte Pyramide,
        bei der etwa die mglichen Geforderten hervorgehoben sind.
        Ein erneuter Klick auf einen der mglichen Geforderten
        bringt dann einfach ein Fenster, in dem nach dem ChefIn-
        Kennwort gefragt wird. Das war's. Sollte man dann ein
        undo brauchen oder ganz perverse Vertauschungen machen
        wollen, kann dies jederzeit ber den normalen Wartungszyklus
        erfolgen. Fr heute werden wir aber erst mal schlieen.
        Nachtrag am 01.11.2001:
        Das mit dem unterschiedlich frbig Markieren der Pyramide
        machen wir doch nicht. Nachdem die Chefs besser jeden
        Platz gegen jeden austauschen knnen sollen/mssen,
        macht das keinen Sinn. Kann auch prinzipiell nicht gehen,
        weil nach der ersten Umordnung i.a. bestimmte Forderungen
        evtl. nicht mehr mglich wren. Wir hatten aber gesagt,
        da die mglichen Forderungen, die an einem Spieltag
        ausgetragen werden knnen, nur von der bis zum Spieltag
        gltigen (alten) Rangliste abhngen drfen und eben nicht
        von den nderungen, die sich aufgrund der einzelnen
        Spiele am Spieltag ergeben.
        
squash1/14.10.2001:
        Aufbohren der Datenstruktur, um auch den Rang mit zu verwalten
        war einfach: ber den Wartungszyklus kann inzwischen jedem
        Spieler ein beliebiger Rang zugeteilt werden.
        Endlich wird p8ac5 reanimiert fr unsere Rangliste.
        Mssen wir noch ein bichen dran feilen (Code sieht noch
        ein wenig nach Kraut und Rben aus und auch die Darstellung
        im Browser gefllt uns noch nicht so richtig (Hhe der
        Rangliste bzw. der einzelnen Kstchen ist recht gro, aber
        auch die Breite ist nicht in jedem Fall optimal, weil sie
        von der Buchstabenbreite abhngt (natrlich wieder browser-
        abhngig, was sonst), mssen wir also mindestens
        noch Buchstaben zhlen und Fllzeichen einfgen z.B.)), aber
        grundstzlich scheint's wieder mal zu laufen, wie geplant.
        brigens fllt uns gerade auf, da es ja ziemlich leicht
        ist, etwa von Version 1004 auf 1006 upzugraden. Dazu
        mssen wir nur z.B. manuell im season-File zuerst die
        1004 auf 1006 ndern, dann hier im Programm in get_season_data
        (genauer in get_spieler bzw. get_court_belegung) temporr
        das Lesen der neuen Daten auf Kommentar setzen und _einmal_
        die Liste aufrufen. Damit wird dann sofort ein schnes,
        neues File mit upgegradeter Syntax geschrieben.
        
squash1/15.10.2001:
        Cont.
        
squash1/21.10.2001:
        Wir erkennen: die Pyramide lt sich mit Submit-Buttons nicht
        sehr schn realisieren. Irgendwie wird alles zu gro und
        klobig. Im brigen wollen wir im Moment ja auch nur eine
        Anzeige machen, d.h. eine direkte Manipulation durch Klicken
        in die Pyramide ist auch nicht unbedingt ntig, weil wir
        die Verwaltung der Pyramide im Wartungszyklus erledigen
        knnen.
        
squash1/22.10.2001:
        Pyramide auf page08 nur anbieten, wenn wirklich mindestens
        ein aktiver Spieler einen vernnftigen Rang hat.
        Den Body der E-Mail ins Subject nehmen, damit Handyleute
        auch was davon haben.
        
squash1/27.10.2001:
        Nachdem es jetzt also eine Rangliste gibt, werden auch
        Forderungen gespielt und zwar zu ganz normalen Zeiten im
        Court. Man ist sich einig, da zwei Spieler, die eine
        Forderung austragen wollen, auch gemeinsam einen Court
        belegen sollten. Bisher sieht man der Tabelle aber nicht an,
        ob eine Forderung stattfinden soll oder ob die beiden Spieler
        nur zum Spa im Court sind. Es ist daher der Wunsch nach
        einer irgendwie gearteten Kennzeichnung geuert worden.
        Soll etwa so laufen: normales Spiel, also _ohne_ Forderung
        wird wie bisher eingetragen: blarote Frbung. Planen zwei
        Spieler eine Forderung, dann kann grundstzlich jeder von
        beiden einen (gemeinsamen) 'Forderungssatatus' setzen. Bei
        gesetztem 'Forderungssatatus' wird der voll besetzte Court
        etwa dunkelrot gefrbt (neben einer ggf. zustzlich angebrachten
        Textinfo), der halbbesetzte etwa dunkelgelb. Dadurch
        kann dann sofort jeder sehen, da die zwei (oder der eine,
        solange nur ein Spieler im Court sitzt) was spezielles
        vorhaben und sich entsprechend verhalten. Das ganze ist
        als Hinweisfunktion gedacht, d.h. wir werden keine
        weiteren Sicherheitsfunktionen einbauen, z.B. da sich
        nur der geforderte eintragen kann oder hnliches.
        Wir werden also einfach ein Flag pro Court einfhren,
        welches den 'Forderungssatatus' reprsentiert. Im leeren
        Court ist es grundstzlich gelscht. Sowohl der Erst-
        eintrager als auch der Zweiteintrager haben die
        Mglichkeit, dieses Flag nach eigenem Ermessen zu
        setzen oder zu lschen. Dabei bekommt der Ersteintrager
        defaultmig ein gelschtes Flag zu sehen und der
        Zweiteintrager sieht halt den aktellen Stand. Stellt sich
        die Frage, wie wir verfahren wollen, wenn aus einem komplett
        besetzten Court wieder ein Spieler ausgetragen wird.
        Wahrscheinlich mssen wir davon ausgehen, da die
        Forderung zunchst nicht wie geplant stattfinden soll
        (sonst mte sich ja wohl keiner austragen) und wir
        werden das Flag daher in jedem Fall lschen.
        
squash1/28.10.2001:
        Noch ein bichen feilen am 'Forderungssatatus'. Im
        wesentlichen sehen wir zu, da dieser (beim Eintragen
        eines Spielers in den Court) defaultmig erst mal
        rckgesetzt wird und nur dann (vom Client kommend)
        bernommen wird, wenn der Spieler selbst eingetragen
        werden soll _und_ es sich beim Courtnachbarn ebenfalls
        um den Spieler selbst und nicht seinen privaten Gast
        handelt.
        
squash1/30.10.2001:
        Minimaler Bug: Indizes fr Forderung in Verbindung mit
        geschrumpfter_index wurden einfach falsch ermittelt.
        Anstatt geschrumpfter_index[k] htten wir besser gleich
        geschrumpfter_index[2*k] DIV 2 geschrieben, wre irgendwie
        besser gekommen...
        
squash1/01.11.2001:
        Wir bauen in create_lock2 einen sleep ein (htten also
        auch create_lock nehmen knnen). Hintergrund sind mysterise
        Vorgnge bei muc. Da waren offenbar zwei Prozesse 'squash1'
        am durchdrehen und haben ganz ordentlich CPU geschluckt.
        Ein mgliches Problem knnte evtl. das Lockfile gewesen sein.
        Tatschlich ist aber keines stehengeblieben. Jedenfalls ist
        es performance-mig in jedem Fall besser, mit dem sleep
        zu arbeiten, als einfach eine Dauerschleife zu machen.
        O.k., wir sehen an der Programmlogik nichts Verdchtiges,
        aber sicher ist sicher. Vielleicht war auch unser E-Mail-
        experiment von letzthin Schuld. Da hatten wir zunchst ein
        kleines Problem mit korrekter Parameterbergabe an die
        system-Routine zum Absetzen der E-Mail.

        Zur Verwaltung der Rangliste werden wir aus Platzgrnden
        nicht wieder Submit-Buttons, sondern einfache Links einsetzen.
        Die einzigen Links, die wir bisher haben, tauchen in den
        Werbebannern auf. Das Erzeugen der URLs geschieht dort u.a.
        mit gen_get_string. Allerdings arbeiten wir in gen_get_string
        manuell und nicht, wie wir das bei den Formularen mit dem hvr
        tun. Das werden wir zunchst angleichen. Den Record hvr werden
        wir aber nicht umbenennen. Mssen wir uns halt merken, da
        es sich nicht um hidden values handelt.
        
squash1/02.11.2001:
        Ja und die Verwaltung der Rangliste scheint auch zu laufen.
        Ist wieder mal super geil!! Die unbentzten Links haben
        eine andere Farbe als die bentzten, das verwirrt eigentlich
        nur. Und dem forderer sollten wir vielleicht im zweiten
        Ranglisten-Bild eine andere Farbe geben, aber sonst war's das.
        Der forderer hat jetzt eine andere Farbe, aber das mit dem
        bentzten Link ist noch unklar.
        
squash1/03.11.2001:
        Ein paar randommige Verbesserungen, z.B. an verschiedenen
        Stellen convert_to_amp_string einfhren.
        Vorschlag: wenn mal Lust ist, knnten wir die Spieler ihre
        E-Mail-Adressen selber editieren lassen, dann brauchen nicht
        die Chefs sich darum kmmern.
        
squash1/04.11.2001:
        Ja, die Spieler knnen nun ihre E-Mail-Adressen selber editieren.
        Eine andere Kleinigkeit knnten wir evtl. verbessern. Wenn beim
        Eintragen z.B. ein falsches Kennwort eingegeben wird, landet man
        wieder bei der (Auswahl), obwohl man vorher schon eine korrekte
        Auswahl eingegeben hatte. Dies ist lstig. Wir sollten da eine
        Mglichkeit haben, die vorher gemachte Auswahl gleich wieder
        anzuzeigen. Ja und es scheint, als wre das auch i.O..
        
squash1/11.11.2001:
        Mit den jngsten nderungen in schreib_reihe_ok, offenbar
        speziell beim Austausch von belegung_file gegen spieler_index_alt
        haben wir uns einen Bug beim Austragen der Spieler eingehandelt.
        Offenbar mssen wir doch belegung_file belassen und den
        spieler_index_alt zustzlich einfhren. Das sind nmlich doch
        zwei paar verschiedene Dinge.

        Haben doch glatt zwei Spieler versucht, eine Forderung zu
        spielen, obwohl das gem Rangliste berhaupt nich mglich
        war. Haben wir doch nicht fr mglich gehalten, da es ntig
        ist, auch das noch abzufangen. Na gut, soll uns recht sein.
        Gehen wir dabei so vor: der Spieler, der sich als erster
        eintrgt, kann das Forderungsflag in jedem Fall setzen. Damit
        ist dann aber noch nicht klar, ob dieser Spieler fordert
        oder gefordert wird. Ist halt beides denkbar. Wir werden daher
        beides erlauben. Hat dann eben der schnellere Glck. O.k.,
        sinnvollerweise werden die beiden Menschen sowieso vorher
        miteinander ber die Forderung reden. Dann sollte es in der
        Praxis kein Problem geben. Also, nachdem der erste Spieler
        im Court drinsteht, kommt ein zweiter daher. Wir schauen
        uns nun ganz einfach beide momentanen Rnge der Spieler an,
        suchen uns den mit dem greren Rang aus und sehen dann
        nach, ob der den anderen fordern darf. Voll iehsi, oder?
        Die Vorschrift, ob gefordert werden darf oder nicht, ist
        ganz einfach: wenn wir die Spitze der Pyramide als Reihe 1
        bezeichnen, dann darf ein Spieler in Reihe n maximal n-1
        Spieler nach oben hin fordern. Also, ein Spieler am rechten
        Rand einer Reihe darf dann maximal den ganz linken Spieler
        in der gleichen Reihe fordern. Ein Spieler auf irgend einem
        anderen Platz in der Reihe darf in der darber liegenden
        Reihe bis maximal zu dem Spieler fordern, der schrg rechts
        ber ihm steht. Eine Ausnahme wurde festgelegt: von Platz 3
        aus kann man auch den Spieler auf Platz 1 fordern.

        Sprachliche Anmerkung: wer sich ber 'frbig' oder 'weiters'
        wundert, das habe ich von sterreichischen Kollegen gelernt.

        Unerlaubte Forderungen sollten nun nicht mehr mglich sein!

        Wre irgendwie geil, wenn wir auf page01 nicht nur einfach
        'Forderung' hinschreiben wrden, sondern vielleicht sogar
        einen kleinen Pfeil hinmalen knnten, wer nun wen gefordert
        hat. Diese Information mten wir halt einfach mit im
        season-File ablegen. Bisher haben wir das einfach mit 0
        oder 1 in jahr_forderung gespeichert. Nehmen wir halt
        einfach noch 2 und 3 dazu, etwa so: 0: keine Forderung,
        1: noch kein Nachbar da, 2: der obere Spieler im Court
        fordert den unteren, 3: der untere Spieler im Court fordert
        den oberen.
        O.k., scheint erledigt.
        
squash1/12.11.2001:
        Bei den E-Mails noch mitteilen, ob eine Forderung ansteht.
        Ja, war auch mehr als iehsi. Wir brauchen wieder mal eine
        richtige Herausforderung!
        
squash1/14.11.2001:
        Bevor wir neue Herausforderungen suchen, mssen wir aber
        erst mal neu eingebaute Fehler beseitigen: beim Versuch,
        private Gste einzutragen bockt die Software komplett.
        Ja, geil: in trag_ein hatten wir durch die Umstellung
        wegen forderung_moeglich einfach einen Fall vergessen.
        Wir hatten also keinen Programmabsturz, sondern fr den
        Fall, da ein privater Gast eingetragen werden sollte
        einfach weder die Datenbasis aktualisiert noch sonst
        irgend eine Ausgabe gemacht, super!
        
squash1/18.11.2001:
        Es werden berlegungen angestellt, fr jeden Spieler ein
        zustzliches Limit einzufhren, welches festlegt, wie viele
        Tage vorher fr ihn persnlich eine Eintragung berhaupt
        mglich ist. Dieses zustzliche Limit ist fr die Spieler
        gedacht, die keinen Saisonbetrag entrichtet haben aber
        dennoch ganz offiziell in der Liste gefhrt werden, damit
        sie sich eben auch selber eintragen knnen oder etwa in
        der Rangliste auftauchen. Trotzdem sollen sie aber natrlich
        nicht die vollen Vorteile der 'buchenden' Spieler haben
        und sich schon ewig im Voraus eintragen knnen und dabei
        womglich Pltze wegschnappen, die ihnen nicht zustehen.
        Ja, die Chefs knnten sie dann wieder austragen; ja, wenn
        sie kooperativ sind, tragen sie sich erst einen oder zwei
        Tage vor dem Spiel ein. Aber das ist alles recht popelig.
        Da bauen wir lieber eine zustzliche berwachung in die
        Software ein, auf die knnen wir uns verlassen.
        
squash1/21.11.2001:
        max_day_delta=0 heit ab jetzt: keine Beschrnkung.
        
squash1/24.11.2001:
        Ein bichen Kosmetik bei den Gsten.
        
squash1/25.11.2001:
        Eine Chefin ist unzufrieden. Nein, stimmt nicht wirklich,
        sie hat einen vllig legitimen Wunsch geuert:
        sie wte gerne, wieviele Gste im Lauf der Saison
        eingetragen waren/sind, um am Ende die Kassenlage damit
        abgleichen zu knnen. Ja, es wre mglich, manuell alle
        Wochen durchzusehen, nach '(Gast)' Ausschau zu halten
        oder nach unbekannten Namen zu suchen, welche nicht
        in der Liste aufgenommen sind (das knnnen dann also
        nur die offiziellen Gste sein!). Aber das wre ja
        wirklich bescheuert. Fr derart einfache, mechanisierbare
        Aufgaben haben wir uns ja gerade einen Computer angeschafft.
        Wir nehmen gleich noch ein paar andere Daten in die Statistik
        mit auf, weil's so schn war: Anzahl abbestellter Courts und
        Spielhufigkeit der Spieler.
        
squash1/26.11.2001:
        Natrlich war wieder ein kleinerer Bug drin gestern: in
        show_count htten wir wohl eher ein VAR bei text gebraucht.
        
squash1/29.11.2001:
        Cont.
        
squash1/01.12.2001:
        Auf der Statistikseite wollen wir die unter Spielhufigkeit
        genannten Spieler alphabetisch ausgeben. Und das tun wir auch.
        
squash1/02.12.2001:
        Forderungsspiele knnen momentan schon weit im Voraus eingetragen
        werden. Das ist natrlich Bldsinn. Es ist ja so: Die Rangliste
        wird etwa einmal pro Woche auf neuesten Stand gebracht und nicht
        etwa nach jedem einzelnen Forderungsspiel, welches der Forderer
        gewonnen hat. Neue Forderungsspiele zwischen den Spielern knnen
        aufgrund der aktuellen Rangliste geplant werden. Bis ins letzte
        Detail hat sich da wahrscheinlich niemand Gedanken gemacht aber
        in der Praxis ist es bisher so, da ein Spieler zwischen zwei
        'Synchronisationspunkten', d.h. in der Zeit zwischen zwei zeitlich
        benachbarten Ranglisten-Updates maximal an _einem_ Forderungsspiel
        teilnimmt, entweder als Forderer oder als Geforderter. Unter
        diesen Voraussetzungen spielt die Reihenfolge der Forderungsspiele
        und auch deren gegenseitige 'Verzahnung' in der Rangliste keine
        Rolle, was die neue Rangliste angeht: die neue Rangliste hngt
        in eindeutiger Weise nur von der alten Rangliste und den
        (gewonnenen) Forderungsspielen ab, egal in welcher Reihenfolge
        sie gespielt bzw. zum Zeitpunkt des Ranglisten-Updates
        'eingepflegt' wurden. _Nach_ Update der Rangliste sind dann
        aber mglicherweise Forderungsspiele, die _vorher_ noch
        mglich waren, nun nicht mehr mglich. Deshalb drfen wir
        korrekterweise Forderungsspiele nur bis zum nchsten
        Ranglisten-Update zulassen. Forderungsspiele, die spter
        stattfinden sollen, mssen ja von der dann neuen Rangliste
        abhngig gemacht werden und nicht von der aktuellen!

        Gehen wir also der Einfachheit halber von einer wchentlich
        zu aktualisierenden Rangliste aus. Dann gibt es also einen
        Tag in der Woche, in dem das Ranglisten-Update stattfindet.
        Konkret wird bei einer der Gruppen momantan sowieso nur
        an _einem_ Tag der Woche gespielt. Die Ergebnisse der
        Forderungsspiele an diesem Tag werden dann dazu verwendet,
        den Ranglisten-Update durchzufhren. Wir werden als Zeit-
        grenze also etwa Mitternacht des Ranglisten-Update-Tages
        whlen: Die Eintragung eines Forderungsspiels aufgrund der
        aktuellen Rangliste ist nur mglich vom aktuellen Zeitpunkt
        bis um 24.00 Uhr am Tag des nchsten Ranglisten-Updates.
        Dabei darf das Spiel nicht nach 24.00 Uhr zu Ende sein.

        Wir werden zwei Sachen tun: 1. die Checkbox zum Ankreuzen,
        ob es ein Forderungsspiel sein soll, wird einfach nicht
        ausgegeben und 2. um den Hacker abzuwehren, wird dann auch
        eine explizite berprfung bei Empfang des Formulars von
        page02 durchgefhrt.
        
squash1/27.01.2002:
        Die am 02.12.2001 gemachten berlegungen mssen nochmal in
        den Hintergrund treten. Wir wollen zuerst zwei weitere
        Tabellen untersttzen. Die Mnner brauchen nmlich noch
        zwei Tennis-Tabellen. Natrlich wollen wir mglichst
        wenig ndern, aber da wo Tennis drin ist, soll wenigstens
        in der berschrift nicht Squash draufstehen. Die URL ist
        uns momentan Wurscht. Da haben wir keinen Bock, was dran
        zu drehen. Wir sollten versuchen, mglichst viele Daten,
        die von der zu bedienenden Tabelle abhngen, nicht etwa
        im Programmtext hart zu codieren, sondern in das season-File
        mit aufzunehmen. Nicht ins season-File gehren ganz klar
        die verschlsselten Defaultkennwrter fr den Chef und
        die Chefin, weil die auch _ohne_ season-File richtig
        funktionieren mssen. Alles andere sollte eigentlich
        im season-File Platz finden. Mssen wir halt die globals
        etwas erweitern. Als erstes wandert also normal_voraus
        dorthin. Nein, wir werden normal_voraus wieder auf 2
        setzen fr alle Tabellen und es jahr_wochen_zugriff_default
        nennen. Eine individuelle Einstellung fr jede Woche ist
        ja sowieso mglich und damit soll's dann auch gut sein.
        
squash1/28.01.2002:
        Nun, es fllt nebenbei auf, da es natrlich rein theoretisch
        vom Standpunkt der kryptografischen Sicherheit nicht direkt
        als ganz optimal zu bezeichnen ist, wenn wir die ver-
        schlsselten Kennwrter der Chefs hier im Text drin stehen
        haben und eben diesen (Programm-)Text dann irgendwo unter
        'Ich will...' direkt zum Lesen anbieten. Gerade deshalb hat
        man ja wohl die Shadow-Passwrter eingefhrt. Sollen wir das
        echt machen? Prinzipiell wahrscheinlich ja, aber im Moment
        editieren wir einfach ein bichen am Quellfile herum, bevor
        wir es zum Anschauen freigeben. Mssen wir halt vor dem
        Neukompilieren ein bichen aufpassen.
        So nebenbei haben wir also mal auf 4 mgliche Tabellen
        erweitert.
        
squash1/29.01.2002:
        Kleine Korrektur an sd1.show_future_kw. Minimale Kosmetik an
        der Statistikpage.
        
squash1/30.01.2002:
        Nochmal ganz wenig Kosmetik an der Statistikpage. Ein paar Hinweise
        einfgen.
        
squash1/10.02.2002:
        Ein paar Modifikationen bei den Gastbezeichnungen, auch auf
        der Statistikseite.
        
squash1/24.03.2002:
        Der 'HTML parser and pretty printer' tidy vom W3C mosert ein
        bichen rum. Ein bichen tun wir vielleicht dafr aber
        ansonsten wollen wir das Handling der season-Logfiles
        etwas verbessern. Wir wollen nicht mehr alle paar Tage
        manuell auf dem Server aufrumen mssen. Ja o.k., mten
        wir auch nicht. Wir bruchten ja nur etwa max_log_sea_file_anz
        verkleinern. Bisher aber wird, wenn max_log_sea_file_anz
        erreicht ist, nur ein 'Nothalt' gemacht: Ein Default-Log-season-File
        wird angelegt/berschrieben. Eigentlich wre es viel besser,
        die ltesten season-Logfiles wrden jeweils nach /dev/null
        geschoben und die n neuesten bleiben da, so FIFO-artig.
        Ja, und wir haben try_put_log_data dementsprechend gendert.
        max_log_sea_file_anz haben wir ziemlich drastisch von 1000 auf
        17 gesenkt. Hat jemand was gegen 17? Ist doch eine schne Zahl!
        Bei den 4 Tabellen, wie wir momentan verwalten, ergibt das
        etwa 68 Files, das ist doch schon ganz ordentlich!
        Weil's uns gerade einfllt: den Tennismnnern waren 10 Spalten
        evtl. zu wenig. Da haben wir doch einfach max_spalt_anz flugs
        von 10 auf 12 erhht.
        
squash1/07.04.2002:
        Anregungen eines interessierten Spielers:
        1.      auf der Statistikseite wchentlich bzw. 14-tgig spielende
                Spieler auch also solche kennzeichnen.
        2.      'hergeschenkte Pltze', d.h. solche Pltze, die nicht
                abbestellt wurden, die aber dennoch kein Schwein
                gebucht hat, gesondert erwhnen. Nur zur Info: das sind
                die Pltze, die einfach versehentlich oder auch ganz
                bewut nicht abbestellt wurden und also auf ewige
                Zeiten grn leuchten, weil noch komplett frei!!
        
squash1/13.04.2002:
        Manche Leute spielen auch im Sommer Squash. Damit wir dennoch
        bisherige Tabellen nicht bemhen mssen, legen wir einfach eine
        5-te an.
        Ein paar 'squash'-Verweise herausnehmen.
        Nachdem wir also nun schon einige Tabellen haben, knnten wir
        evtl. unter 'Ich will...' auch einen Punkt einfhren, der auf
        die anderen Tabellen verzweigen lt. Nein, viel einfacher:
        bauen wir in page11 mit ein.
        
squash1/14.04.2002:
        Ein bichen an der Statistik herumpfuschen.
        
squash1/17.04.2002:
        Die Tennismnner spielen immer gleich 2 Stunden und wollen
        sich also pro Woche dann auch 2 mal eintragen. Mit den momentanen
        Restriktionen bezglich Erst-, Zweit- bzw. Gasteintragungen klappt
        das dann nicht so recht. Also mssen wir wohl einen Schalter
        einbauen (und in das season-File mit aufnehmen), der zwischen
        der bisherigen strengen Kontrolle und einer noch zu definierenden
        neuen (lascheren) umschaltet. Wie lasch die neue sein soll, wissen
        wir noch nicht. In jedem Fall mu auch erst_zweit_gast_eintrag
        mit bercksichtigt werden.
        So, machen wir vorest mal ganz primitiv. Lasch heit demnach
        wirklich ziemlich lasch, nmlich erst_zweit_gast_eintrag gar nicht
        aufrufen in page01 und eintragungslimit_erreicht in act_p2ac1
        auch nicht mehr. Den Schalter werden wir wohl als ein Bit in
        einen neuen global reintun. Spter sollten wir evtl. doch
        eintragungslimit_erreicht aufrufen aber es modifizieren.
        Ohne eintragungslimit_erreicht kann nmlich jeder normale
        Spieler, wie auch die Chefs, beliebig weit in die Zukunft
        Eintragungen machen und das wollten wir eigentlich nicht!
        
squash1/05.05.2002:
        mittellen von 80 auf 100 erhhen. Zuletzt wurde auf der
        Acceptseite eine Message ber die vom User eingetragene
        E-Mail-Adresse einfach abgeschnitten.
        Kleine Kosmetik auf page11 und anderswo.
        Kommentar zu 'bitleiste' auf page07 eingefgt.
        
squash1/09.05.2002:
        Beim Versenden von E-Mails fllt uns auf: wre doch nicht
        schlecht, wenn ein Spieler nicht nur dann ggf. eine E-Mail
        zugeschickt bekommt, falls ein Nachbar ein- oder ausgetragen
        wird, sondern auch dann, wenn einer der Chefs Umbesetzungen
        vornimmt. Also, das bisherige Verfahren soll natrlich
        beibehalten werden, nur sollten halt an die Spieler mit
        einer eingetragenen E-Mail-Adresse auch Benachrichtigungen
        darber verschickt werden, wenn/da sie von einem der Chefs
        ein- oder ausgetragen worden sind, vllig unabhngig davon,
        ob bereits ein Nachbar da ist oder nicht.
        
squash1/12.05.2002:
        Cont.
        
squash1/25.05.2002:
        Cont.
        
squash1/24.11.2002:
        Ein paar Kleinigkeiten: als erstes brauchen wir eine ber das
        Web-Interface ein- und ausschaltbare zumindest minimale Debugging-
        Mglichkeit. Nach Umstellungen in unserem Intranet luft beim ersten
        Aufruf der Page etwas schief. Wir sehen gleich eine unerwartete
        Aktion. Irgendwie passen GET und POST und die Parameter offenbar
        nicht zusammen. Ist jetzt nicht total schlimm, weil man nach
        Drcken des weiter/ok-Buttons dann schlielich ganz normal
        weiter kommt aber wir wollen das trotzdem analysieren. Am besten
        werden wir das ber die bitleiste machen. Bisher wird einzig bit0
        bentzt, belegen wir jetzt halt zustzlich bit1.

        Dann hatte ein Spieler offenbar gewisse Orientierungsprobleme
        beim Eintragen eines Forderungsspiels. Die bisherige Formulierung
        '...und macht ein Forderungsspiel' bei der Frage wer wirklich
        spielt, war gedeutet worden, als ob der einzutragende Spieler auch
        gleichzeitig der Forderer sei. Dies ist natrlich nicht so, weil
        die Frage, wer wen fordert/fordern kann nur aufgrund der Rangliste
        beantwortet wird/werden kann. Also formulieren wir ein wenig um,
        etwa so: '...dies ist ein Forderungsspiel'.

        Und endlich ndern wir auf vielfachen Wunsch eines Spielers auch
        die Statistik: Wir zhlen nur die wirklich gemachten Spiele,
        d.h. es gelten nur die Eintragungen in der Vergangenheit.
        Auerdem ziehen wir als Sollspielzeit nicht die gesamte Lnge
        der Saison (in Wochen) heran, sondern zhlen nur die Wochen
        von Saisonbeginn bis zum aktuellen Zeitpunkt.

squash1/30.11.2002:
        Noch ein bichen an der Statistik feilen und wie es aussieht,
        sind wir ganz zufrieden damit. Ob es der oben erwhnte Spieler
        auch ist, wissen wir im Moment nicht.

squash1/01.12.2002:
        Typo corrected.

squash1/01.06.2003:
        Ein paar Tests, weil die Mnner bei muc doch echt upgraden. Konkret
        wird der Webserver offenbar von slarti.muc.de nach colin2.muc.de
        umgesiedelt. Unser bisheriges BSD-Binary luft zwar prinizipiell
        noch, aber weil wir wegen der Historie unsere 3 mglichen Server,
        auf denen das cgi hier luft individuell behandeln (wegen Pfaden
        oder dem anzuhngenden .cgi), hat das auf colin2.muc.de zunchst
        nicht vollstndig funktioniert. Am Ende wird die Webpage
        wahrscheinlich nach wie vor unter www.muc.de erreichbar sein, aber
        anstatt slarti.muc.de steht dann halt colin2.muc.de dahinter, so
        da wir eigentlich gar nichts ndern mten. Wir werden aber
        dennoch colin2.muc.de, zumindest temporr bercksichtigen und
        auch ein BSD-Binary erstellen, damit wir beruhigt sind. BTW die
        Mnner bentzen laut Aussage auf colin2 den Apache, d.h. wir
        werden also das Roxen-Logo schon mal gegen das Apache-Logo
        austauschen, interessiert aber eh keinen...
        Nein, wir fhren auch noch SERVER_SOFTWARE ein, damit geht das
        dann auch automatisch. Das konkrete Handling ist aber momentan
        recht umstndlich. Vor allem das mit dem alias fr die icons
        sollten wir uns nochmal genau ansehen...

squash1/30.11.2003:
        Bei unserem Mozilla in der Arbeit beobachten wir mysterise
        Probleme mit Umlauten. Irgendwie haut das mit dem Zeichensatz
        wohl nicht so recht hin. Wir probieren also mal, in den HTML-HEAD
        ein weiteres META reinzutun, welches explizit den korrekten
        Zeichensatz angibt: charset=ISO-8859-1. Mglicherweise reicht
        aber auch schon, in init_http_connection nicht nur Content-type:
        text/html auszugeben, sondern dort auch noch den charset=ISO-8859-1
        reinzutun. Mal sehen.

        Nebenbei korrigieren wir eine kleine Nachlssigkeit in
        welcher_server_name. Zur Ermittlung der SERVER_SOFTWARE wird
        dort u.a. Extract aufgerufen. Allerdings sollten wir Extract
        wohl nicht nach dem Leerstring suchen lassen, sonst bleibt die
        Kiste nmlich stehen. Wenn aber die Umgebungsvariable
        SERVER_SOFTWARE gar nicht da ist, hatten wir genau das Problem.

squash1/30.10.2004:
        Es ist wieder mal Zeit fr ein paar nderungen. Siehe dazu auch
        todo Punkte 6. und 7.. Auerdem brauchen wir eine weitere Tabelle.
        Diesmal sind es die Badminton-Spieler. Geschickterweise haben wir
        die Anzahl der untersttzten Tabellen (bisher zumindest) hart-
        kodiert und nicht ber das Webfrontend editierbar gemacht, was
        soll's...
        Fangen wir also mit der ueberschrift bzw. dem zusatz_heading an.
        Machen wir am besten mit put_amp_string. Um auch in
        'Schnell weg von hier...' eine vernnftige Ansage machen zu knnen,
        mten wir alle season-Files einlesen und dazu sind wir zu faul.
        Es bleibt also bei der mageren Ansage ber 'Tabelle 1,
        Tabelle 2,...' ohne zusatz_heading. Im title tun wir es aber
        logischerweise rein.
        Ja, Dauergste haben nun keine Sollspielzeit mehr und der Gast-
        status wird schon mal bei der Spielerauswahl angezeigt. Zum Spa
        haben wir gleich noch eine Tabelle angehngt. Sind dann also 7.

squash1/20.03.2005:
        Erst mal Nachtrag zur Version vom 17.01.2005. Diese war ntig
        geworden, weil die muc-Mnner nun doch tatschlich mal auf den
        neuen Server umgestellt haben. Allerdings wurde zunchst mal nur
        meine Page umgestellt, die anderen waren davon mglicherweise
        erst mal nicht betroffen. Auslser war, da Kollege Robert mit
        seinem 7.23-er Opera ganz miese Fehlermeldungen bekommen hatte.
        Daraufhin haben mir die muc-Mnner also doch endlich mal die schon
        seit ewigen Zeiten angedetete Umstellung auf colin2 angedroht.
        Diese Umstellung hat dann auch so einigermaen funktioniert aber
        natrlich hat es nun doch unerwartet Probleme gegeben. Es stellte
        sich heraus, da der HTTP_HOST nun doch nicht so, wie bisher
        funktionierte. Lautete pltzlich 'localhost' und das war ungeil.
        Trotz der am 24.09.2001 gemachten Sprche blieb uns nichts anderes
        brig, als den HTTP_HOST wieder direkt vom SERVER_NAME zu bernehmen,
        wie das bei alten Browsern, also bei Length(http_host)=0 der Fall
        war.

        Es gibt eine Anmerkung zum 'Forderungs-Handling'. 

squash1/21.03.2005:
        Cont.
        Bisher wird der 'Forderungsstatus' in jedem Fall wieder gelscht,
        wenn sich einer der beiden Spieler wieder austrgt. Darber hat
        sich einer der Spieler beschwert. Er hat berichtet, da sich ein
        anderer Spieler zunchst zu ihm mit Forderung eingetragen und dann
        aber gleich wieder ausgetragen hatte, weil die Eintragung nur
        irrtmlich geschehen war. Im nchsten Moment hat sich dann ein
        anderer Spieler zu ihm eingetragen, weil der 'Forderungsstatus'
        ja nicht mehr da war. Tatschlich aber htte unser Spieler
        aber lieber eine andere Forderung ausgetragen mit einem dritten
        Spieler. Dies war nun aber nicht mehr mglich, ohne den inzwischen
        neu eingetragenen Spieler explizit wieder zu verjagen. Also haben
        wir beschlossen, da wir wohl den 'Forderungsstatus' nur dann
        wieder lschen, wenn der Nachbar der (frei) ist.
        Nebenbemerkung: wir richten fr die Ermittlung des Courtnachbarn
        eine (kleine) PROCEDURE calc_court_index_nachbar ein, weil wir
        diese Berechnung doch einige Male machen.

squash1/26.10.2005:
        Es wird eine kleine Korrektur beim Handling fr 14-tgige Spieler
        gemacht. Wir hatten uns ja bisher darauf geeinigt, da die Anzahl
        der pro Woche eingetragenen 14-tgigen Spieler nur halb so gro
        sein darf, wie wir insgesamt 14-tgige Spieler haben. Dieses Vorgehen
        hat nun bei einer nicht 100%-igen Courtauslastung (und also ungerader
        Anzahl an 14-tgigen Spielern) zu geringen Verwerfungen gefhrt. Die
        Idee beim bisherigen Modus war ja vor allem die, da die 14-tgigen
        Spieler in keinem Fall durch zu gehuftes Eintragen die wchentlichen
        Spieler irgendwie beeintrchtigen sollten. Falls die Courts zu 100%
        ausgelastet sind, haut das auch alles gut hin. In unserem Fall aber
        hat es genau einen wchentlichen Spieler gegeben und 9 14-tgige.
        Es hat also genau ein 14-tgiger Spieler gefehlt, um die 3 Courts
        voll auszulasten. Oder anders: wenn wir jede Woche 5 (also die
        Hlfte von 10) 14-tgige Spieler spielen lieen, wre auch alles
        o.k.. Nachdem wir aber beim Ermitteln der maximal erlaubten Zahl
        14-tgiger Spieler einfach abgrundet hatten, blieben also mit 9 / 2
        genau 4 14-tgige Spieler brig. Dies ist natrlich ungeil, denn
        mindestens jede zweite Woche mssen in jedem Fall 5 14-tgige Spieler
        spielen (drfen) und das am besten noch OHNE Einmischung der Chefs.
        Was also tun? Am wenigsten Aufwand werden wir haben, wenn wir
        einfach einen halben 14-tgigen Spieler mehr eintragen lassen,
        d.h. wir machen alles genau so wie bisher, nur addieren wir
        zur Gesamtzahl der 14-tgigen Spieler noch 1, bevor wir die
        Division durch 2 machen. Auf diese Weise darf sich also bei 1 oder
        2 14-tgigen Spielern immer einer pro Woche eintragen, bei 3 oder
        4 sind es dann 2 usw.. Damit sind dann zwar die 14-tgigen Spieler
        gegenber den wchentlichen minimal im Vorteil, weil sie sich
        zumindest theoretisch OHNE Genehmigung vom Chef durchschnittlich
        ein bichen fter als 1/2 mal pro Woche eintragen drfen. Aber
        warten wir erst mal ab, ob das irgend einem wchentlichen Spieler
        berhaupt auffllt;-)

squash1/25.02.2007:
        Bei der Badmintontruppe gibt es mit dem Ein- oder besser mit dem
        Austragen kleinere 'Organisationsproblemchen'. Mitunter kommt es
        wohl vor, da sich jemand erst kurz (d.h. wenige Stunden) vor
        Spielbeginn unvermittelt wieder austrgt. Das ist bld fr alle
        anderen. Vor allem mu der Platz bezahlt werden. Der Wunsch ist
        daher, da es bereits etwa einen Tag vor dem Spiel nicht mehr mglich
        sein soll fr den gewhnlichen Spieler, sich wieder auszutragen.
        Wir knnten etwa ganz allgemein den Button schon vorher wegnehmen,
        dann knnten aber auch die Chefs keine 'Notkorrekturen' mehr
        machen, die vielleicht doch noch wnschenswert wren. Wir sollten
        daher versuchen, einfach nur den normalen Spieler abzublocken.
        Mal sehen, ob wir das hinkriegen werden...

squash1/08.08.2007:
        Mit colin2.muc.de gibt's irgendwie Probleme. Ich soll doch statt
        colin2 wieder einfach colin nehmen, mal sehen... Geht natrlich
        nicht so einfach, denn offenbar bekomme ich vom Server die Aussage:
        SERVER_NAME: colin2.muc.de und dann luft aber auf colin2.muc.de
        gar kein Server. Schn bld. Also mssen wir vielleicht, falls
        colin2.muc.de erkannt wird, schnell colin.muc.de draus machen?
        Voll krasser Hack, hehe!

squash1/14.06.2008:
        Die Tennismnner htten gerne, da jeder einzelne Spieler die
        Mglichkeit hat, etwa Telefonnummer oder Spielstrke ffentlich
        bekannt zu machen, damit andere Spieler ggf. auf diese Information
        zugreifen knnen. Das Eintragen dieser Daten geschieht dabei
        freiwillig und der Spieler mu sich darber im Klaren sein, da
        die eingegebene Information dann von allen Menschen auf der Welt
        abgefragt werden kann. Um den Aufwand (wie immer) mglichst
        gering zu halten, haben wir uns berlegt, da wir die gewnschte
        Zusatzinformation etwa dort mit unterbringen knnten, wo bisher
        die E-Mail-Adresse steht, namlich in sd1.spieler_mail. Wir
        benennen sd1.spieler_mail daher erst mal einfach um, etwa in
        sd1.spieler_pers_data und legen mal fest: falls ein Strichpunkt
        vorhanden ist, dient dieser als Trennzeichen zwischen E-Mail und
        den restlichen Angaben, falls keiner da ist, wird der ganz Kse,
        wie bisher auch, einfach nur als E-Mail-Adresse interpretiert.
        Alles, was also nach dem (ersten) Strichpunkt vorhanden ist,
        wird einfach als die gewnschte Zusatzinformation interpretiert
        und z.B. auf der Statistikseite mit ausgegeben. Mssen wir nur
        nochmal nachsehen, denn dort werden, wie es aussieht, nicht alle
        Spieler ausgegeben, sondern nur die, die mindestens einmal gespielt
        haben. Mssen wir dann halt ndern...

        Nebenbei rein prophylaktisch mittellen nochmal erhhen, diesmal
        von 100 auf 180.

        brigens konnten wir das ganze ohne nderung von sea_version_akt
        (Version des season-Files) durchziehen, d.h. wir mssen nicht
        groartige Filekonvertierungen der season-Files machen, sondern
        sollten einfach in der Lage sein, die neue Programmversion auf die
        alten Daten loszulassen und alles sollte wunderbar funktionieren!

squash1/15.06.2008:
        Vielleicht sichern wir die Statistikseite doch mit einem Kennwort
        ab. Das ist dann zwar nur so gut, wie das schwchste Kennwort des
        nachlssigsten Spielers aber zumindest hat es einen gewissen
        Symbolcharakter...
        Mal sehen, wo wir da am besten ein wenig spicken knnen, damit wir
        das optimal hinkriegen...

squash1/17.09.2008:
        Wieder mal wnschen die Tennismnner ein kleines Enhancement: auf
        der Statistikseite soll nicht nur die bis zum jetzigen Zeitpunkt
        ermittelte Spielhufigkeit der Spieler zu sehen sein, sondern auch,
        wie oft der jeweilige Spieler in der gesamten Saison eingetragen
        ist. Machen wir das. Noch haben wir Debuggen mit localhost aktiv.
        Wir mssen noch ein bisschen testen und dann werden wir offiziell
        freigeben. Dies hier wird schon mal squash1.mod161.

squash1/22.09.2008:
        Wir hatten vergessen, das Datum zu aktualisieren.

squash1/26.05.2009:
        Die Tennismnner hatten wieder mal neue Begehrlichkeiten. Man
        will eine kleine (optionale) Aufweichung fr die Eintragung. Es
        soll nach wie vor so sein, dass sich der Spieler erst n Wochen
        vor dem Spiel eintragen kann aber er soll sich beliebig oft
        eintragen knnen. Mal sehen... und: semilasch ist das Wort des Tages!

squash1/28.10.2009:
        kurzlen ist mit 20 zu kurz fr lange Namen. Die einfachste
        Lsung fr uns ist, statt 20 einen etwas hheren Wert zu nehmen.
        Wird schon gut gehen...

squash1/29.08.2010:
        mailto_rechner auf muc.de statt dose.muc.de voreinstellen.

squash1/10.10.2010:
        Wir wollen aus akademischen Grnden doch noch ein wenig am
        Datenschutz feilen. Es ist nmlich bisher so, dass whrend des
        Wartungszyklus die ganze Welt mitlesen kann, was der Chef grade
        so treibt. O.k. die Kennwrter kann man nicht sehen aber z.B.
        die 'Persdata' auf page15 sind ohne Probleme einsehbar (bis der
        Chef halt zur nchsten Seite weitergeschaltet hat). Das wollen wir
        ndern. process_admin_with_season_data ist da wohl der beste
        Ort, wo wir da eingreifen sollten.

        Wir nehmen in schreib_reihe_not_ok auch mal den ii05 (geheim1)
        mit hin. Dadurch knnen wir eine kleine 'annouyance' fr den Chef
        vermeiden: wenn er sich am Ende des Wartungszyklus entscheidet, doch
        nochmal einen zu machen, dann ging bisher das Kennwort verloren und
        man musste es nochmal eingeben. Mit der nderung ist das jetzt
        nicht mehr ntig. Hoffentlich gibt es damit keine unerwnschten
        Sicherheitsporbleme an anderer Stelle!

        Ein paar mal fter decide_on_seastate aufrufen, anstatt direkt
        schreib_pagexy. Damit sollten wir dann an zentraler Stellt (eben
        in decide_on_seastate) entscheiden knnen, ob wir wirklich die
        entsprechende Adminseite aufrufen (weil das Kennwort passt) oder
        eben nicht.

        O.k., geht so ein bisschen aber im Moment kommt noch:
        process_admin_post_action: Unerwartete Aktion!
        Ist aber klar, da mssen wir noch nachbessern.
        So, ist schon besser aber immer noch nicht so ganz optimal.

squash1/15.10.2010:
        Natrlich sollte unser Programm noch ein bisschen wachsen und
        anscheinend stoen wir da an eine neue Grenze:

        ## compiling squash1.mod ...

        **** gp.rts: arithmetic overflow in module M2InOut at line 204 ****
        #gpmake: bad exit code from gpm
        Aborting ... 

        Mglicherweise knnen wir nicht mehr alles in einem Sourcefile
        halten und mssen echt was auslagern (womglich in irgendwelche
        Module!). Ob das vielleicht deshalb MODULA heit???

        Das ist jetzt bld, weil wir uns um eine schne Modularitt im
        wesentlichen keine Gedanken gemacht haben. Aber wahrscheinlich mssen
        wir das echt so machen, wie damals bei IEC6. Da mussten wir schon
        relativ bald mehrere Module anlegen. Mist aber auch!

        Nein, es war viel eifacher: beim Anlegen der neuen PROCEDURE act_p30ac1
        hatten wir bei der 'END-Klammer' noch act_p13ac1 stehen lassen und
        das hat uns der GPM bel genommen.

squash1/17.10.2010:
        Bevor wir wieder 'offiziell' gehen, testen wir noch ein wenig. Und
        machen an der einen oder anderen Stelle noch ein paar Korrekturen.

squash1/27.02.2011:
        Wenn man die Page zum ersten Mal aufruft, wird ja mit advance_ukw
        schon mal versucht, die ukw gem show_future_kw zu setzen. Wir
        erlauben im Moment Werte von 0 bis 8 fr show_future_kw. Wenn also
        show_future_kw z.B. den Wert 0 hat, dann wird in jedem Fall die
        aktuelle KW angezeigt. Axel hat sich nun gewnscht, dass speziell
        fr den Fall show_future_kw=0 nur dann wirklich die aktuelle KW
        angezeigt wird, wenn in der aktuellen Woche nicht schon alle Spiele
        gelaufen sind. D.h., wenn kein Button mehr zum Drcken da ist, dann
        will er haben, dass ggf. (d.h., wenn berhaupt noch eine folgt)
        die folgende KW angezeigt wird. Der Wunsch ist insofern sinnvoll,
        wenn man annimmt, dass sich der normale Spieler erst mal nicht mehr
        fr die nicht mehr zu ndernde Vergangenheit interessiert, sondern
        ggf. halt irgendwelche Eintragungen ndern will. Fr Informations-
        zwecke muss es natrlich nach wie vor mglich sein, alle Wochen
        durchzublttern und das wird auch so sein. Nur eben beim ersten
        Aufruf der Seite, wenn also char_cnt=0 ist, schalten wir dann also
        ggf. auf die nchste Woche um.

        Wenn wir die Software schon mal anfassen, bereinigen wir bei der
        Gelegenheit einen kleinen Schnheitsfehler. Wir geben einige Male
        den Text aus: 'Zurck zur Startseite'. Das ndern wir auf:
        'Zurck zum Spielbelegungsplan'.

        Wir sehen jetzt erst, dass es da wohl ein Problem bei den Log-season-
        Files gibt. Da hatten wir uns ja ganz tolle Sachen ausgedacht mit so
        einer Art Fifo, dass wir nur maximal max_log_sea_file_anz Logfiles
        da haben. Offenbar haben wir da beim Lschen von alten Files nicht
        ganz aufgepasst, denn das allerlteste bleibt offenbar ewig stehen.
        Wir fangen mit dem Lschen nmlich erst beim zweitltesten an und
        das ist natrlich bld. Mal sehen, ob wir das richten knnen...

        Ja, das war jetzt kein groes Problem, einfach ein
                sortiere_selection(sel_rec_typ_ptr, 0, hwi-1);
        gegen ein
                sortiere_selection(sel_rec_typ_ptr, 1, hwi);
        ausgetauscht. Aber jetzt sehen wir, dass wir, wenn der Suffix voll
        ausgeschpt ist, einfach den Nuller berschreiben. O.k. das ganze
        ist dann eher eine akademische Fragestellung aber wenn wir schon
        mal dabei sind, knnten wir ja versuchen, das gleich ordentlich zu
        machen. In der Wirklichkeit sollte letzteres Problem allerdings
        praktisch nicht vorkommen, denn da geht es darum, dass wir innerhalb
        einer Sekunde mehr als max_log_sea_file_anz Logfiles bekommen.
        Aufgefallen ist das, weil wir fr Testzwecke die Zeit halt angehalten
        haben (indem wir zeitagm auf einen festen Wert gesetzt hatten).

        Das ging dann so: das Lschen des ltesten Logfiles hat geklappt, d.h.
        der Index 0 war dann weg. Beim Anlegen des neuen Logfiles haben wir
        dann natrlich wieder bei Index 0 angefangen. Normalerweise wre das
        dann auch kein Problem, denn wenn mehr als eine Sekunde vergangen ist,
        dann ist der Filename bis zum Suffix hin (= 'Basename' fr das
        Log-season-File) ja neu und sozusagen noch nie dagewesen, sodass wir
        in jedem Fall bei 0 anfangen knnen.

        Nein, werden wir doch erst mal nicht machen. Nur bei extrem groer
        akademischer Lust wre das angezeigt und die haben wir hier im Moment
        nicht. Keine wirklich groe Sache aber ein bisschen Arbeit halt.
        Man knnte z.B. in try_put_log_data nach dem Lschen der alten Files
        einfach erst mal bis an das Ende von sel_rec_typ_ptr gehen und dann
        testen, ob der 'Basename' des neu anzulegenden Files schon bekannt
        ist, also die ersten 19 Zeichen vergleichen. Falls das der Fall ist,
        knnte man sich die letzten 4 Zeichen holen, diesen String dann in
        einen CARDINAL umwandeln und versuchen, ein Logfile mit einem um
        1 erhhten Index anzulegen. Falls der letzte 'Basename' in der
        'Selection' nicht identisch zum neuen 'Basename' wre, knnte man
        einfach Index 0 nehmen.

squash1/06.03.2011:
        So ist das halt, wenn man Erbsenzhler ist (oder werden will).
        Hatten wir soeben noch getnt, dass wir die akademische bung mit
        den Logfiles wegen Unlust nicht machen wollen. Das ist aber am
        Ende doch nicht wirklich gut. Also werden wir das doch mal angehen.
        So und das scheint jetzt auch alles zu laufen.

squash1/07.08.2011:
        Die muc-Mnner hatten einen totalen Servercrash. Jetzt haben sie
        einen komplett neuen Rechner hingestellt. Aber wie es aussieht,
        sagen da jetzt sowohl HTTP_HOST als auch SERVER_NAME nur noch
        'localhost' und das ist total ungeil. Als Quickfix probieren
        wir also einfach mal hart codiert den www.dose.muc.de aus.

squash1/16.04.2017:
        Der Firefox schimpft, wenn man Kennwrter ber http eingibt.
        Also mssen wir https machen. Die muc-Mnner kmmern sich auf
        ihrer Seite darum und um Zertifikate und so Zeugs. Wir mssten
        halt http durch https ersetzen. Die muc-Mnner, namentlich der
        Armin Gruner meint aber, ich sollte gleich https:// und die
        www.dose.muc.de weglassen und nur noch relativ arbeiten.
        Also probieren wir das mal. Vorher machen wir aber mal aus

        script_nam_prog1=             'squash1';

        ein

        script_nam_prog1=             'squash2';

        frs Testen.

squash1/17.04.2017:
        Erste Tests sind gut gelaufen, d.h. wir wagen jetzt mal den
        Schritt zum 'Produktivsystem'. script_nam_prog1 bekommt wieder
        'squash1'. Ansonsten haben wir jetzt tatschlich nur an 3
        Stellen im Programm die erwhnten 'Weglassungen' gemacht.
        Wir haben gesehen, dass vereinzelt in auskommentierten Stellen
        noch ein http zu sehen ist. Das war wohl irgendwie fr Debugging
        gedacht. Da haben wir jetzt erst mal nichts verndert. Msste
        man sich konkret nochmal ansehen, falls das wieder aktiviert
        werden sollte.

squash1/27.05.2018:
        Wir bringen auf der Chat-Seite einen Hinweis an, dass die IP-
        Adresse im Chat erscheint. Feiglinge knnen dann davon absehen,
        ihren Mll abzuladen!

squash1/30.09.2018:
        Wir bemerken, dass die Logos, d.h. unsere 'Bandenwerbung' irgendwie
        nicht mehr so richtig funktioniert. Das Bildchen fr den Apache
        schaut so ein bisschen merkwrdig aus und fr FREEBSD sehen wir
        gar kein Bildchen mehr. Wenn wir in .html-data die icons komplett
        umbenennen, sehen wir gar keinen Unterschied. Was ist denn das?

squash1/01.10.2018:
        Wahrscheinlich haben die muc-Mnner neuerdings einen alias fr die
        icons. Probieren wir mal my_icons statt icons. Wir tauschen einfach
        berall icons gegen my_icons aus. Wir blicken das nicht mehr so genau,
        was wir uns damals so im Detail gedacht haben. Meist schreiben wir
        <IMG SRC="icons/..." aber dann auch <IMG SRC="/squash/icons/..."
        Vielleicht hatten wir die icons auf den unterschiedlichen Systemen
        halt einfach an unterschiedlicher Stelle. Inzwischen luft das Zeug
        ja eigentlich nur noch auf www.dose.muc.de. Aber da kmmern wir uns
        jetzt nicht weiter drum. Und ja, jetzt geht die Shize wieder!

squash1/18.10.2020:
        Wir machen eine kleine Fingerbung: bei den Hinweisen ob, bzw. wann
        Eintragungen mglich sind, schreiben wir bisher hin:

        ... *eintragung mglich in KW ...

        Heute ist uns beim Lesen dieses Hinweises aufgefallen, dass man diese
        Aussage auch falsch verstehen knnte, wenn man wollte. Man sollte hier
        'in' besser durch 'fr' ersetzen. Mit 'in' knnte man 'notfalls' auch
        meinen, welche KW grad sein muss, um sich berhaupt irgendwie eintragen
        zu knnen, dass man also erst die genannte(n) KW(s) abwarten muss,
        bevor man berhaupt mal beginnen kann, irgend eine Eintragung zu
        machen. Mit 'fr' sollte klar sein, dass gemeint ist, fr welche KW
        (in der Zukunft) der Spieler eingetragen werden soll. Und ja, es ist
        ja offensichtlich, dass der Vorgang des Eintragens JETZT passieren
        soll, weil der Benutzer ja eben jetzt die Eintragung machen will.
        Aber durch das 'in' htte er evtl. lesen knnen, dass er das Eintragen
        eben jetzt grad nicht machen kann, sondern erst zu den genannten
        Zeiten.
        Das Ganze ist natrlich ziemlich extreme Haarspalterei aber ein
        ganz kleines bisschen verstndlicher sollte das 'fr' dann doch sein
        als das 'in'. Aber vor allem knnen wir damit wieder mal ben, wie
        das Erstellen einer neuen Programmversion geht. Haben wir ja schon
        2 Jahre lang nicht mehr gemacht. Nachdem wir die Dinge seit geraumer
        Zeit sowieso nur noch in einer VMware-Box verwalten, ist das auch
        ntig, denn sonst vergisst man die ganze Shize vielleicht im Lauf der
        Zeit einfach;-)

squash1/24.03.2023:
        Beginn Portierung GPM nach GM2.

squash1/25.03.2023:
        Vielleicht sollten wir hier wenigstens ein paar 'zusammenfassende'
        Worte zur gestern erwhnten 'Portierung GPM nach GM2' hinterlassen.

        Der wichtigste Anlass fr die Portierung weg von dem 32-Bit-Programm,
        welches wir mit dem GPM erhalten, ist schon bei der Festlegung der
        folgenden Konstante zu sehen:

        max_season_start_jahr=        2036

        Nachdem wir (mittels UNIXtime) als Zeitbasis die Anzahl der Sekunden
        seit dem 01.01.1970 verwenden und diese Zahl aber auf 32-Bit-Systemen
        halt nur durch 32 Bit reprsentiert wird (von time_t ist die Rede),
        laufen wir zwanglos in das 'Jahr-2038-Problem'. In der man page zu
        time(2) auf Linux ist zu lesen:

        > Applications intended to run after 2038 should use ABIs with time_t
        > wider than 32 bits

        Genau aus diesem Grund hatten wir 'schon immer' die Konstante
        max_season_start_jahr eben auf 2036 gelegt und damit halt sicher
        gestellt, dass die letzte 'problemlose' Saison von 2036 auf
        2037 stattfinden kann. Spter knnen die Leute dann halt keinen
        Sport mehr machen;-)

        Ja, wir verwenden intern einen CARDINAL. Der wrde noch einige
        Jahre weiter gehen aber der Systemaufruf liefert halt wohl nur
        einen 31-Bit-Wert zurck, zumindest sagen die ja, man soll nach
        2038 halt mehr als die 32 Bit nehmen. Wir htten es jetzt durch
        irgend welche Verrenkungen vielleicht schon geschafft, auch mit
        dem 32-Bit-Programm irgendwie an die 64-Bit-Zeit zu kommen aber
        das ist ein Kees! Da ist die Portierung auf GM2 (und damit dann
        halt automatisch auf unsere neuen 64-Bit-Systeme) die schnere
        Lsung. Ob wir dann tatschlich intern weg mssen von dem CARDINAL,
        knnen wir ja immer noch berlegen. Im ersten Anlauf kommen wir
        mit dem CARDINAL dann ja auf nochmal etwa weitere (2038 - 1970) =
        68 Jahre. D.h. der CARDINAL wrde dann endgltig berlaufen etwa
        im Jahr 2106. Damit knnten wir ja eigentlich leben. Aber mal
        sehen ob wir dann intern andere Probleme bekmen und doch auf
        grere Zahlen umsteigen mssen.

        Ein 'Nebenaspekt' der Portierung ist, dass wir den GPM nur mit
        einer lteren libc verwenden knnen. Wir hatten dann lange Zeit ein
        altes 'lfs_squash' in einer VMware-Box am Laufen, um dort zu
        compilieren. Inzwischen haben wir erkannt, dass man auch mit einem
        chroot was machen kann. Trotzdem entsteht dann aber 'nur' ein
        Linux-Binary. Die Mnner bei muc, wo das Ding ja vor allem laufen
        soll, haben aber ein FreeBSD und damit da berhaupt was geht, haben
        die dort irgend welche Linux-Kompatibilitts-Bibliotheken
        eingerichtet. Damit geht das dann alles aber so richtig schn ist
        das nicht.

        Unser Glck ist, dass die GNU-Mnner seit Kurzem an einem MODULA 2
        fr die GNU Compiler Collection arbeiten und genau damit sollten wir
        dann unsere Portierung machen knnen. Die Vorstellung wre dann, dass
        wir unser Programm dann wahlweise unter Linux oder BSD bersetzen
        knnnen und damit alle Probleme gleichzeitig gelst haben.

        Die 'Portierungs-Strategie' sieht so aus: wir haben im Programm im
        Moment noch etliche Nicht-ISO-Sachen drin. Gemeinsame Basis zwischen
        GPM und GM2 kann aber nur ISO sein. Daher versuchen wir in einem
        ersten Schritt, alle Nicht-ISO-Sachen auf ISO bzw. auf was Eigenes
        umzuschreiben. In einem zweiten Schritt werden dann GM2-spezifische
        Anpassungen gemacht. Letztere sollten aber sehr berschaubar
        ausfallen.

        Bei einer ersten Durchsicht haben wir im Moment diese Nicht-ISO-IMPORTe
        identifiziert::

        AsciiTime:
                TimeToStructTime
        ProgArgs:
                ArgNumber, EnvironString, GetArg, UNIXtime
        UxProcesses:
                Sleep
        UxFiles:
                Delete, ModifyTime
  
        Wir haben ein kleines extra port_test.mod gemacht, mit dem wir
        zunchst die betreffenden Dinge von Nicht-ISO weg bringen wollen.
        Wenn wir dann der Meinung sind, wir haben einen adquaten Ersatz
        gebaut, versuchen wir, ihn hier einzufgen.

        Kleine Nebenbemerkung: wir haben oben bei der PROCEDURE LJDN einen
        Verweis auf folgenden Link drin:

        http://www.pip.dknet.dk/~c-t/calendar.html

        Allerdings mussten wir feststellen, dass es diese Seite nicht mehr
        gibt. Also hat uns der Google gesagt, dass der Mann jetzt hier sein
        sollte mit seinem Kalender:

        https://www.tondering.dk/claus/cal/julperiod.php#julianday

        Dort mussten wir aber feststellen, dass sich unsere Codierung und
        die Informationen auf der neuen Seite auf den ersten Blick nicht
        ganz gleichen. Im Endeffekt, verwenden wir hier

        (306*m+5) DIV 10

        auf der neuen Seite steht aber im Prinzip das hier:

        (306*m+4) DIV 10

        Ohne lang zu zgern, gabs eine E-Mail an claus@tondering.dk,
        wie das jetzt zu verstehen sei. Und tatschlich konnte er uns
        berzeugen, dass die beiden Formeln aufs Gleiche rauskommen.
        Wenn man nmlich genau hinschaut, dann wird ja hinten der DIV 10
        gemacht und da ist es dann bei ganzzahligen Werten von m Wurscht,
        ob dort +4 oder +5 steht.

        Wir wollen auf jeden Fall mit ISO arbeiten aber es ist natrlich
        GPM-ISO nicht voll ident zu GM2-ISO. D.h., wir knnen nur die
        Sachen auf ISO umstellen, die sowohl in GPM als auch in GM2 bei
        ISO drin sind (Evtl. wird sich aber auch herausstellen, dass wir
        gar nichts auf ISO umschreiben knnen, sondern alles selber machen
        mssen). Denn wir wollen, nachdem wir nderungen hier
        gemacht haben, ja auf jeden Fall erst mal immer noch GPM
        verwenden knnen. Der EnvironString z.B. ist in gar keinem ISO aber
        er wre im GM2-PIM drin. Das ntzt uns dann aber nichts, d.h.
        da mssen wir wohl ber die libc gehen und getenv(3) bemhen.
        Ganz analog mssen wir halt alle anderen Sachen auch angehen.

        Nebenbemerkung: das mit den diversen Zeiten, wie speziell mit zeitagm
        oder zeitalc ist im Moment nicht mehr so ganz prsent. Die Namen
        sollen ja bedeuten: zeitagm: 'Zeit aktuell Gm' und zeitalc:
        'Zeit aktuell local'. In schreib_page_trailer() geben wir ja
        ganz entspannt die zeitagm aus. Tatschlich sehen wir im Trailer
        dann aber die korrekte lokale Zeit angezeigt. Das ist doch mehr als
        merkwrden! Beispielsweise steht im Trailer:

        26.03.2023, Zeit: 20:50:27

        Wenn wir das Debugging einschalten, dann wird u.a. nochmal angezeigt:

        zeitagm: 26.03.2023, Zeit: 20:50:27
        zeitalc: 26.03.2023, Zeit: 22:50:27

        Das sieht auf den ersten Blick doch irgendwie merkwrdig aus aber
        die ganze Shize hat doch bisher einwandfrei funktioniert?!
        O.k., bei etwas genauerem Hinsehen bemerken wir, dass wir den
        String nach 'zeitagm:' ermitteln mittels TimeToStructTime aus
        AsciiTime. Da kommt aber als Ergebnis ja anscheinend direkt die
        lokale Zeit raus. D.h., die Zeile ist eigentlich ziemlich
        verwirrend geschrieben. Es wird zwar aufgrund von zeitagm etwas
        ausgegeben. Aber das Ausgegebene ist eben nicht die GM-Zeit,
        sondern die lokale Zeit. Wie das dann mit zeitalc zusammemhngt,
        ist damit aber immer noch nicht wirklich klar! Sachen hatten wir
        uns damals ausgedacht!

        O.k., das alles kann uns jetzt im Rahmen der Portierung eigentlich
        Wurscht sein, wenns funktioniert aber so richtig befriedigend ist
        das nicht.

        Der erste Anlauf bei der Portierung wird also auf jeden Fall sein,
        dass wir KEINE funktionellen nderungen verursachen wollen. Dann
        sollte das ja alles so weiterlaufen wie bisher. Aber wenn wir dann
        doch noch einen ruhigen Moment finden sollten, dann mssten wir uns
        den ganzen Kess eigentlich schon nochmal im Detail ansehen!

squash1/27.03.2023:
        Nachdem wir in port_test.mod anscheinend einen selber gebauten
        Ersatz fr TimeToStructTime gefunden / gebaut haben, bauen wir
        den halt schon einfach mal hier ein: TimeToLcStructTime().

squash1/28.03.2023:
        Auch ArgNumber und GetArg sind wir los! Haben wir in port_test.mod
        ein Test_progargs gebaut und von dort ein bisschen abgeschrieben.
        Zu frh gefreut, ein GetArg steht noch in der Gegend rum, Mist!
        Doch nochmal nachdenken. Ist erledigt. Im brigen hatten wir,
        was die Bentzung der ProgramArgs aus ISO betrifft, hier ein
        bisschen gespickt:

        https://groups.google.com/g/comp.lang.modula2/c/LH22EDvgfvE/m/mvugw04N3QwJ

        Ausgangspunkt unserer Suche war hier:

        https://freepages.modula2.org/index.html
        https://freepages.modula2.org/m2faq.html#faq11

        Ob das wirklich ntig gewesen wre mit dem Beispiel, keine Ahnung
        aber die Beschreibung im def-File war ein bisschen dnn, ein
        Beispiel und wenn es noch so einfach sein mag, hat da schnell
        weiter geholfen.

squash1/29.03.2023:
        In show_client_info2 auch mit ReadToken hantieren.
        EnvironString durch Unix.GetEnv ersetzen.
        UNIXtime durch Unix.Time ersetzen.

squash1/30.03.2023:
        UxFiles.ModifyTime durch Unix.ModifyTime ersetzen.
        UxFiles.Delete durch Unix.Unlink ersetzen.

squash1/31.03.2023:
        UxFiles.Sleep durch Unix.Sleep ersetzen.
        Damit sollten wir erst mal alle Nicht-ISO-IMPORTe eliminiert haben.

squash1/02.04.2023:
        Das Interface zu C ist bei GM2 doch etwas anders als bei GPM, vor
        allem bei Strings bzw. den offenen Feldern mssen wir 'nachlegen'.

squash1/03.04.2023:
        Wir modifizieren einige der 'Unix.<xy>-Aufrufe' ein bisschen. Vor
        allem schreiben wir in Unix.def gelegentlich die drei Punkterl in
        die Parameterliste (...), damit wir da eine ordentliche C-bergabe
        bekommen.

squash1/04.04.2023:
        Weiter Debuggen.

squash1/05.04.2023:
        Wir machen doch gewisse Fortschritte: nachdem wir in unix.c bei
        Unix_GmTime und Unix_LocalTime ein size_t gegen unsigned int
        ausgetauscht haben und das ReadInt aus WholeIO gegen was selber
        Geschriebenes ersetzt haben, schauts jetzt schon deutlich besser
        aus! In get_globals z.B. hat der erste ReadInt den Wert noch
        korrekt gelesen aber schon der folgende ReadInt hat irgendwie
        totalen Bldsinn gemacht. Wir haben dann sozusagen 'selber'
        erst mit ReadToken den String gelesen und ihn dann mit StrToInt
        umgewandelt. Danach sahs deutlich besser aus!

        In PutGPMString haben wir halt den Workaround mit der lokalen
        Variablen fr die Stringlnge drin, damit das berhaupt geht.

        Dann gibts aber noch ein Problem: unter bestimmten Bedingungen
        liest der ReadString ein Zeichen zu wenig aus dem season-File.
        Wenn man dann einen Dummy-Read einbaut fr die Kommentarzeile
        vorher und nicht nur einfach ein SkipLine macht, dann geht das
        auch wieder. Das Ganze ist in get_season_data zu beobachten.

        Als weitere kleine rgerlichkeit sehen wir, dass
        der WriteInt anscheinend immer ein Vorzeichen vor die Zahlen
        malt. Das wollen wir natrlich nicht. Knnen wir sicher selber
        was machen aber warum machen die Mnner das? Ist das so in der
        ISO festgelegt? Warum hatten das dann die GPM-Mnner nicht auch
        so drin?

squash1/06.04.2023:
        Es werden eingefhrt: MyWriteInt und MyIntToStr. Damit knnen
        wir die nicht gewnschten '+' am Anfang der Zahl vermeiden.

squash1/11.04.2023:
        In put_chat_data und try_my_cat unseren (eigenen) Datentyp
        BYTE ([0..0FFH]) zugunsten von CHAR doch wieder verwerfen. Bei
        GM2 belegen die Felder dieses Basistyps nmlich nicht nur ein
        Byte, wie das bei GPM der Fall war und wie man sich das evtl.
        denken knnte, sondern jeweils 8 Bytes. Wenn man ein solches
        Feld dann zum Einlesen etwa bei RawRead nimmt, dann hat man
        nur Zugriff auf jedes achte Zeichen aus dem eingelesenen
        Datenstrom und das kommt dann natrlich gar nicht gut. Wenn
        man hingegen CHAR nimmt, dann verhalten sich GPM und GM2 wieder
        ident und das machen wir dann also auch.

        Wir benennen eol in linefeed um.

squash1/12.04.2023:
        Die GPM- und GM2-Mnner sind sich nicht so ganz einig, wann
        bei RawRead das ReadResult endOfInput sein soll. Da wnscht man
        sich z.B. eine bestimmte Menge Bytes, die roh gelesen werden
        sollen und wenn gengend viele Bytes da sind und auch sonst nichts
        schief luft, dann kommt auch genau die gewnschte Menge an
        Bytes zurck. Am Ende des Stroms wird es im Allgemeinen natrlich
        passieren, dass weniger da sind als gewnscht und ganz
        grundstzlich ist wohl nicht so ganz klar, ab auch zwischendrin
        mal weniger kommen drfen als gewnscht, auch wenn noch mehr
        da sein sollten. Das Ding heit dann vielleicht 'short read'.
        Jedenfalls ist es nun so, dass bei GPM KEIN endOfInput gegeben
        wird, falls man sich dem Ende des Stroms nhert und weniger
        Bytes zurckkommen als gewnscht, bei GM2 kommt in diesem Fall
        aber endOfInput, obwohl ja zwar nicht alle gewnschten aber
        zumindest ein paar gekommen sind. Das Ganze ist mglicherweise
        von der ISO auch nicht so ganz konsequent durchdacht. Wenn bei
        GM2 am Ende des Stroms jetzt also endOfInput kommt, dann fragt
        man sich, ob die Bytes, die angekommen sind, vielleicht doch
        auch allRight waren. Man erfhrt es aber nicht. Bei GPM sagen
        die in dem Fall allRight, man wei aber in dem Moment noch nicht,
        ob jetzt das letzte Byte des Stroms gelesen wurde oder ob doch
        nur ein 'short read' vorliegt. Bei GPM geht man also wohl davon
        aus, dass es auch einen 'short read' geben knnte und vielleicht
        schliet GM2 diesen eben aus. Ist aber alles so ein bisschen
        Spekulation. Was machen wir? Unsere Software soll in beiden
        Fllen funktionieren. Und da mssen wir halt zur Entscheidung,
        ob wir mit dem Lesen endgltig durch sind und also vom Strom
        nichts mehr zu erwarten ist, sowohl das ReadResult als auch
        das Verhltnis von gewnschten zu tatschlich erhaltenen Bytes
        betrachten. Immer dann, wenn mehr als 0 Bytes angekommen sind,
        mssen wir diese natrlich verarbeiten, auch wenn das ReadResult
        endOfInput sagen wrde. Das endOfInput sagt dann lediglich aus,
        dass in der Zukunft nichts mehr zu holen ist, es bedeutet aber
        nicht, dass wir die grad noch erhaltenen Bytes verwerfen drfen.
        Wir knnen uns, falls es doch einen 'short read' geben sollte,
        so wie das bei GPM wohl noch fr mglich gehalten wird, nicht
        darauf verlassen, dass der Strom zuende ist, allein weil wir
        0 Bytes erhalten haben, obwohl wir mehr als 0 gewnscht hatten.
        Da gilt dann nur das endOfInput als zuverlssiger Indikator.
        Wir werden also sagen: keine weiteren Leseversuche werden
        gemacht, wenn beim aktuellen Leseaufruf 0 Bytes angekommen sind
        UND endOfInput angezeigt wird.

        put_chat_data rgert uns bei GM2. Da scheint ein SeqFile.OpenAppend
        in Wirklichkeit nicht zu appenden, sondern doch einfach von vorne
        zu schreiben. Vielleicht knnen wir das Problem umschiffen:

        Als erste Aktion schreiben wir ja den neuen Spruch ins tmp-File,
        wie beschrieben und schlieen dies dann aber nach dem Schreiben,
        nur um es anschlieend mit SeqFile.OpenAppend wieder zu ffnen,
        falls ein chat-File da ist. Das ist ja auch Kees. Machen wirs
        halt erst zu, nachdem wir den Inhalt des potentiellen chat-Files
        im Anschluss geschrieben haben. Aber da gibts jetzt auch wieder
        Probleme. Vielleicht geht das mit dem RawWrite jetzt nicht.

        Ja, so scheints zu sein. Wir knnen aber das tmp-File mit raw
        aufmachen, dann geht was aber dann mssen wir den aktuellen
        Chat-Beitrag auch ber RawWrite ins tmp-File schreiben. Da
        gehen dann die 'normalen' Sachen wir WriteString und so nicht
        mehr. Das ist doch alles eine Kacke!

squash1/13.04.2023:
        Wir wollen jetzt nicht mit system() arbeiten und evtl. einfach
        cat bemhen oder so aber wir mssen die Shize doch nochmal
        umstellen. Den neu eingegebenen Kommentar schreiben wir in ein
        File chat_new. Da kann dann bereits ein File chat da sein oder
        nicht, das ist uns egal. Aber in einem zweiten Schritt machen wir
        einfach ein weiteres File auf, etwa chat_tmp, in das wir der Reihe
        nach mit RawWrite erst den Inhalt von chat_new und dann, falls
        vorhanden, den Inhalt von chat schreiben. Am Ende lschen wir
        chat_new und chat wieder und benennen chat_tmp um nach chat.
        Das sollte dann sowohl mit GPM als auch mit GM2 laufen.
        Und ja, das scheint jetzt soweit mit GPM und GM2 zu laufen.

squash1/19.05.2023:
        Die GM2-Mnner haben die grbsten Fehler beseitigt. Wir werden
        daher unsere Workarounds zumindest teilweise wieder rckbauen.
        Wir beginnen damit, dass Delete aus Strings wieder geht und
        knnen daher in PutGPMString unsere Hilfsvariabel 'len' wieder
        weglassen.
        ReadString(cid, dummy_schnur);
        fliegt wieder raus.
        MyReadInt verschwindet wieder.
        MyWriteInt und MyIntToStr verschwinden wieder.

squash1/21.05.2023:
        Wir mssen das 'Wording' etwas verbessern aus
        'kein_altes_lockfile_da' wird 'kein_uraltes_lockfile_da'.

squash1/23.05.2023:

squash1/05.12.2023:
        Versenden von E-Mails ndern: im subject darf nur ASCII stehen.
        Ist im Moment nicht gegeben, z.B. wenn im Namen Umlaute drin stehen.
        So, haben wir umgestellt. Auerdem tun wir sd1.zusatz_heading auch
        noch mit in den E-Mail-body rein. Knnen wir nur hoffen, dass
        der system_string in schreib_ggf_email() nicht doch mal berluft!
*)
